#!/bin/sh
TOPDIR=`pwd`/../../../../
. ${TOPDIR}tools/build_tools/Path.sh
APPS_NAME="busybox"

create_busybox_config()
{
	. ${TOPDIR}tools/build_tools/config.sh
	cp -f gxv3170_busybox_config .config
	chmod u+w .config
	cp -f .config sysdeps/linux/defconfig

	if [ "$GXV31XX_CONFIG_INETD" = "1" ]; then
		echo "CONFIG_INETD=y" >> .config
		echo "# CONFIG_FEATURE_INETD_SUPPORT_BILTIN_ECHO is not set" >> .config
		echo "# CONFIG_FEATURE_INETD_SUPPORT_BILTIN_DISCARD is not set" >> .config
		echo "# CONFIG_FEATURE_INETD_SUPPORT_BILTIN_TIME is not set" >> .config
		echo "# CONFIG_FEATURE_INETD_SUPPORT_BILTIN_DAYTIME is not set" >> .config
		echo "# CONFIG_FEATURE_INETD_SUPPORT_BILTIN_CHARGEN is not set" >> .config
	else
		echo "# CONFIG_INETD is not set" >> .config
	fi
	if [ "$GXV31XX_CONFIG_TELNET_SERVER" = "1" ]; then
		echo "CONFIG_TELNETD=y" >> .config
		echo "# CONFIG_FEATURE_TELNETD_INACTIVE_TIMEOUT is not set" >> .config
		if [ "$GXV31XX_CONFIG_INETD" = "1" ]; then
			echo "CONFIG_FEATURE_TELNETD_INETD=y" >> .config
		else
			echo "# CONFIG_FEATURE_TELNETD_INETD is not set" >> .config
		fi
	else
		#echo "# CONFIG_TELNETD is not set" >> .config
        echo ""
	fi

	if [ "$GXV31XX_CONFIG_DHCP_SERVER" = "1" ]; then
		echo "CONFIG_UDHCPD=y" >> .config
	else
		echo "# CONFIG_UDHCPD is not set" >> .config
	fi

	if [ "$GXV31XX_CONFIG_DHCP_CLIENT" = "1" ]; then
		echo "CONFIG_UDHCPC=y" >> .config
	else
		echo "# CONFIG_UDHCPC is not set" >> .config
	fi

	if [ "$GXV31XX_CONFIG_SYSTEM_LOG" = "1" ]; then
		echo "CONFIG_SYSLOGD=y" >> .config
		echo "CONFIG_FEATURE_ROTATE_LOGFILE=y" >> .config
		echo "CONFIG_FEATURE_REMOTE_LOG=y" >> .config
		echo "CONFIG_FEATURE_IPC_SYSLOG=y" >> .config
		echo "CONFIG_FEATURE_IPC_SYSLOG_BUFFER_SIZE=16" >> .config
		echo "CONFIG_LOGREAD=y" >> .config
		echo "CONFIG_FEATURE_LOGREAD_REDUCED_LOCKING=y" >> .config
		echo "CONFIG_KLOGD=y" >> .config
		echo "CONFIG_LOGGER=y" >> .config
		echo "CONFIG_FEATURE_UDHCP_SYSLOG=y" >> .config

	else
		echo "# CONFIG_SYSLOGD is not set" >> .config
		echo "# CONFIG_LOGGER is not set" >> .config
		echo "# CONFIG_FEATURE_UDHCP_SYSLOG is not set" >> .config
	fi
}

#--------------- main  function ----------------------------

echo "----------------------------------------------------------------------"
echo "-----------------------      build busybox    ------------------------"
echo "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	make clean
	rm -f .config_ok 
	rm -f .config.cmd
	rm -f .config.old
	rm -f .depend
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	create_busybox_config
	#make oldconfig 
	gxv31xx_error_check $?
	echo -n > .config_ok
fi

if [ "$1" = "config_only" ] ; then
	exit 0
fi

make AR=${GXV31XX_AR} AS=${GXV31XX_AS} LD=${GXV31XX_LD} NM=${GXV31XX_NM} CC=${GXV31XX_CC} BUILDCC=${GXV31XX_HOSTCC} GCC=${GXV31XX_CC} CXX=${GXV31XX_CXX} CPP=${GXV31XX_CPP} RANLIB=${GXV31XX_RANLIB} GXV31XX_CFLAGS="${GXV31XX_CFLAGS}" GXV31XX_LDFLAGS="${GXV31XX_LDFLAGS}" all
gxv31xx_error_check $? 
exit

make PREFIX=${BUILD_ROOTFS_DIR} install 
gxv31xx_error_check $? 
