#!/bin/sh
TOPDIR=`pwd`/../../../../
. ${TOPDIR}tools/build_tools/Path.sh
APPS_NAME="busybox"

GS_CONFIG_DHCP_CLIENT=1
GS_CONFIG_SYSTEM_LOG=1

create_busybox_config()
{
	. ${TOPDIR}tools/build_tools/config.sh
	cp -f gxw4200_busybox_config .config
	chmod u+w .config
	cp -f .config sysdeps/linux/defconfig

	if [ "$GS_CONFIG_INETD" = "1" ]; then
		echo "CONFIG_INETD=y" >> .config
		echo "# CONFIG_FEATURE_INETD_SUPPORT_BILTIN_ECHO is not set" >> .config
		echo "# CONFIG_FEATURE_INETD_SUPPORT_BILTIN_DISCARD is not set" >> .config
		echo "# CONFIG_FEATURE_INETD_SUPPORT_BILTIN_TIME is not set" >> .config
		echo "# CONFIG_FEATURE_INETD_SUPPORT_BILTIN_DAYTIME is not set" >> .config
		echo "# CONFIG_FEATURE_INETD_SUPPORT_BILTIN_CHARGEN is not set" >> .config
	else
		echo "# CONFIG_INETD is not set" >> .config
	fi
	if [ "$GS_CONFIG_TELNET_SERVER" = "1" ]; then
		echo "CONFIG_TELNETD=y" >> .config
		echo "# CONFIG_FEATURE_TELNETD_INACTIVE_TIMEOUT is not set" >> .config
		if [ "$GS_CONFIG_INETD" = "1" ]; then
			echo "CONFIG_FEATURE_TELNETD_INETD=y" >> .config
		else
			echo "# CONFIG_FEATURE_TELNETD_INETD is not set" >> .config
		fi
	else
		#echo "# CONFIG_TELNETD is not set" >> .config
        echo ""
	fi

	if [ "$GS_CONFIG_DHCP_SERVER" = "1" ]; then
		echo "CONFIG_UDHCPD=y" >> .config
	else
		echo "# CONFIG_UDHCPD is not set" >> .config
	fi

	if [ "$GS_CONFIG_DHCP_CLIENT" = "1" ]; then
		echo "CONFIG_UDHCPC=y" >> .config
	else
		echo "# CONFIG_UDHCPC is not set" >> .config
	fi

	if [ "$GS_CONFIG_SYSTEM_LOG" = "1" ]; then
		echo "CONFIG_SYSLOGD=y" >> .config
		echo "CONFIG_FEATURE_ROTATE_LOGFILE=y" >> .config
		echo "CONFIG_FEATURE_REMOTE_LOG=y" >> .config
		echo "CONFIG_FEATURE_IPC_SYSLOG=y" >> .config
		echo "CONFIG_FEATURE_IPC_SYSLOG_BUFFER_SIZE=16" >> .config
		echo "CONFIG_LOGREAD=y" >> .config
		echo "CONFIG_FEATURE_LOGREAD_REDUCED_LOCKING=y" >> .config
		echo "CONFIG_KLOGD=y" >> .config
		echo "CONFIG_LOGGER=y" >> .config
		echo "CONFIG_FEATURE_UDHCP_SYSLOG=y" >> .config
	    echo "CONFIG_FEATURE_UDHCP_DEBUG=y" >> .config

	else
		echo "# CONFIG_SYSLOGD is not set" >> .config
		echo "# CONFIG_LOGGER is not set" >> .config
		echo "# CONFIG_FEATURE_UDHCP_SYSLOG is not set" >> .config
	fi
}

#--------------- main  function ----------------------------

echo "----------------------------------------------------------------------"
echo "-----------------------      build busybox    ------------------------"
echo "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	make clean
	rm -f .config_ok 
	rm -f .config.cmd
	rm -f .config.old
	rm -f .depend
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	create_busybox_config
	#make oldconfig 
	gs_error_check $?
	echo -n > .config_ok
fi

if [ "$1" = "config_only" ] ; then
	exit 0
fi

make -j8 AR=${GS_AR} AS=${GS_AS} LD=${GS_LD} NM=${GS_NM} CC=${GS_CC} BUILDCC=${GS_HOSTCC} GCC=${GS_CC} CXX=${GS_CXX} CPP=${GS_CPP} RANLIB=${GS_RANLIB} GS_CFLAGS="${GS_CFLAGS}" GS_LDFLAGS="${GS_LDFLAGS}" BUILD_PRODUCT=gxw42xx all
gs_error_check $? 
exit

make PREFIX=${BUILD_ROOTFS_DIR} install 
gs_error_check $? 
