/* dhcpc.h */
#ifndef _DHCPC_H
#define _DHCPC_H

#define DEFAULT_SCRIPT  "/usr/share/udhcpc/default.script"

/* allow libbb_udhcp.h to redefine DEFAULT_SCRIPT */
#include "libbb_udhcp.h"

#define INIT_SELECTING	0
#define REQUESTING	1
#define BOUND		2
#define RENEWING	3
#define REBINDING	4
#define INIT_REBOOT	5
#define RENEW_REQUESTED 6
#define RELEASED	7
#define INFORM		8

/*Information for option 125*/
struct device_info {
	char opt_code ;
	unsigned char opt_len ;
	uint32_t pen ;
	unsigned char data_len ;
	char *ManufacturerOUI ;
	unsigned char oui_len ;
	char SerialNumber[128] ;
	unsigned char sn_len ;
	char *ProductClass ;
	unsigned char pc_len ;
	char *string ;
};

struct client_config_t {
	char foreground;		/* Do not fork */
	char quit_after_lease;		/* Quit after obtaining lease */
	char release_on_quit;		/* perform release on quit */
	char abort_if_no_lease;		/* Abort if no lease */
	char background_if_no_lease;	/* Fork to background if no lease */
	char *interface;		/* The name of the interface to use */
	char *pidfile;			/* Optionally store the process ID */
	char *script;			/* User script to run at dhcp events */
	uint8_t *clientid;		/* Optional client id to use */
    uint8_t *vendorclass;   /* Optional vendor class-id to use */
	uint8_t *hostname;		/* Optional hostname to use */
	int ifindex;			/* Index number of the interface to use */
	uint8_t arp[6];			/* Our arp address */
	uint8_t opt_mask[256 / 8];      /* Bitmask of options to send (-O option) */
	struct device_info Device ;     /* Device Info */
};

extern struct client_config_t client_config;


#endif
