#!/bin/sh
TOPDIR=`pwd`/../../../../
. ${TOPDIR}tools/build_tools/Path.sh
APPS_NAME="busybox"

create_busybox_config()
{
    cp gxw_recovery_config .config
}

#--------------- main  function ----------------------------

echo "----------------------------------------------------------------------"
echo "-----------------------      build busybox    ------------------------"
echo "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	make clean
	rm -f .config_ok 
	rm -f .config.cmd
	rm -f .config.old
	rm -f .depend
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	create_busybox_config
	#make oldconfig 
	gs_error_check $?
	echo -n > .config_ok
fi

if [ "$1" = "config_only" ] ; then
	exit 0
fi

#make AR=${GS_AR} AS=${GS_AS} LD=${GS_LD} NM=${GS_NM} CC=${GS_CC} BUILDCC=${GS_HOSTCC} GCC=${GS_CC} CXX=${GS_CXX} CPP=${GS_CPP} RANLIB=${GS_RANLIB} GS_CFLAGS="${GS_CFLAGS}" GS_LDFLAGS="${GS_LDFLAGS}" all
make V=1 CROSS_COMPILE=${CROSS_COMPILER_PREFIX}
gs_error_check $? 
exit

make PREFIX=${BUILD_ROOTFS_DIR} install 
gs_error_check $? 
