#!/bin/sh

CUR_DIR="`pwd`"
TOPDIR=${CUR_DIR}/../../../../
. ${TOPDIR}tools/build_tools/Path.sh
APPS_NAME="busybox"
DST_DIR=`pwd`/temp/
BUILD_MENUCONFIG=0

create_busybox_config()
{
    cp gxw_config .config
}

#--------------- main  function ----------------------------

echo "----------------------------------------------------------------------"
echo "-----------------------      build busybox    ------------------------"
echo "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	make clean
	rm -f .config_ok 
	rm -f .config.cmd
	rm -f .config.old
	rm -f .depend
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	create_busybox_config
	#make oldconfig 
	gs_error_check $?
	echo -n > .config_ok
fi

if [ $BUILD_MENUCONFIG -eq 1 ]; then
        make CROSS_COMPILE=mips-linux- menuconfig
        exit 0
fi

if [ "$1" = "config_only" ] ; then
	exit 0
fi

if [ -n "$(grep "CONFIG_LOAD_LIB_DYNAMIC_SUPPORT=y" .config)" ];then
    export CONFIG_LOAD_LIB_DYNAMIC_SUPPORT=y
fi
NVRAM_INCLUDE="${CUR_DIR}/../misc/nvtool/"
OPENSSL_INCLUDE="${CUR_DIR}/../openssl-OpenSSL_1_0_2o/include/"
GS_LIB_DIR="${CUR_DIR}/../../../../../image_build/gxw-build.cvscontrol/gxw_image_build/base/usr/lib/:${CUR_DIR}/../../../../../image_build/gxw-build.cvscontrol/gxw_image_build/base/lib/"
export C_INCLUDE_PATH=${NVRAM_INCLUDE}:${OPENSSL_INCLUDE}:${C_INCLUDE_PATH}
export LIBRARY_PATH=${GS_LIB_DIR}:${LIBRARY_PATH}

#make AR=${GS_AR} AS=${GS_AS} LD=${GS_LD} NM=${GS_NM} CC=${GS_CC} BUILDCC=${GS_HOSTCC} GCC=${GS_CC} CXX=${GS_CXX} CPP=${GS_CPP} RANLIB=${GS_RANLIB} GS_CFLAGS="${GS_CFLAGS}" GS_LDFLAGS="${GS_LDFLAGS}" all
make -j8 V=1 CROSS_COMPILE=${CROSS_COMPILER_PREFIX}
gs_error_check $? 
exit
make PREFIX=${DST_DIR} install CROSS_COMPILE=${CROSS_COMPILER_PREFIX}
gs_error_check $? 
