#!/bin/sh
TOPDIR=`pwd`/../../../../
. ${TOPDIR}tools/build_tools/Path.sh
APPS_NAME="dmalloc"

echo "----------------------------------------------------------------------"
echo "-----------------------    build $APPS_NAME  ------------------------"
echo "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	rm -rf .config_ok
	make distclean
	rm -f missing mkinstalldirs ylwrap depcomp install_sh
	rm -f config.cache
	rm -f config.h.in
	rm -f ltmain.sh
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	AR=${GS_AR} AS=${GS_AS} LD=${GS_LD} NM=${GS_NM} CC=${GS_CC}  RANLIB=${GS_RANLIB} BUILDCC=${GS_HOSTCC} CXX=${GS_CXX} OBJCOPY=${GS_OBJCOPY} OBJDUMP=${GS_OBJDUMP} GS_CFLAGS=${GS_CFLAGS} GS_LDFLAGS=${GS_LDFLAGS}  ./configure --host=${HOST} --build=${BUILD} --target=${TARGET} --sysconfdir=/etc --disable-gtk-doc --enable-shlib --enable-cxx --enable-threads

	gs_error_check $? 
	echo -n > .config_ok
fi

if [ "$1" = "config_only" ] ;then
	exit 0
fi

make
gs_error_check $? 

#${GS_STRIP} src/dnrd

#cp -f src/dnrd ${BUILD_ROOTFS_DIR}usr/sbin/
#gs_error_check $? 
