#!/bin/sh
TOPDIR=`pwd`/../../../../
. ${TOPDIR}tools/build_tools/Path.sh
APPS_NAME="haserl-0.8.0"

echo "----------------------------------------------------------------------"
echo "-----------------------      build haserl-0.8.0  ---------------------"
echo "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	rm -rf .config_ok
	make distclean
	rm -f missing mkinstalldirs ylwrap depcomp install_sh
	rm -f config.cache
	rm -f aclocal.m4
	rm -f config.h.in
	rm -f configure
	rm -f ltmain.sh
	find . -name Makefile.in | xargs rm -rf
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	aclocal
	autoheader
	autoconf
	automake --foreign --add-missing
	AR=${HT500_AR} AS=${HT500_AS} LD=${HT500_LD} NM=${HT500_NM} CC=${HT500_CC}  RANLIB=${HT500_RANLIB} BUILDCC=${HT500_HOSTCC} CXX=${HT500_CXX} OBJCOPY=${HT500_OBJCOPY} OBJDUMP=${HT500_OBJDUMP} CFLAGS="${HT500_CFLAGS} -DMAX_UPLOAD_KB=4096" LDFLAGS=${HT500_LDFLAGS} ./configure --host=${HOST} --build=${BUILD} --target=${TARGET} --disable-largefile --disable-nls

	ht500_error_check $? 
	echo -n > .config_ok
fi

if [ "$1" = "config_only" ] ;then
	exit 0
fi

make
ht500_error_check $? 

${HT500_STRIP} src/haserl

cp -f src/haserl ${BUILD_ROOTFS_DIR}usr/bin/
ht500_error_check $? 
