#!/bin/sh

TOPDIR=`pwd`/../../../../
. ${TOPDIR}tools/build_tools/Path.sh
CROSS_COMPILER_PREFIX=mips-linux-
CC=${CROSS_COMPILER_PREFIX}gcc
STRIP=${CROSS_COMPILER_PREFIX}strip

APPS_NAME="haserl-0.9.29"

echo "----------------------------------------------------------------------"
echo "-----------------------      build haserl-0.9.29 ---------------------"
echo "----------------------------------------------------------------------"

BUILD_CLEAN=0
BUILD_CONFIGURE=0
while [ $# -ge 1 ];
do
	case $1 in
	-clean)
		BUILD_CLEAN=1;;
	-configure)
		BUILD_CONFIGURE=1;;
	esac
	shift
done

if [ $BUILD_CLEAN -eq 1 ]; then
	rm -rf .config_ok
	make distclean
	rm -f missing depcomp 
	rm -f aclocal.m4
	rm -f configure
	find . -name Makefile.in | xargs rm -rf
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	aclocal
	autoheader
	autoconf
	automake --foreign --add-missing
	CC=$CC CFLAGS="-DMAX_UPLOAD_KB=4096" ./configure --host=i386-pc-linux-gnu --build=i686-pc-linux-gnu --target=mips-linux- 

	echo -n > .config_ok
fi

if [ "$1" = "config_only" ] ;then
	exit 0
fi

make
gs_error_check $? 

if [ -f src/haserl ]; then
	${GS_STRIP} src/haserl
fi	

