#!/bin/sh
CORES=$((2*$(cat /proc/cpuinfo | grep -c processor)))


TOPDIR=`pwd`/../../../../
. ${TOPDIR}tools/build_tools/Path.sh

CURDIR="`pwd`"

APPS_NAME=`basename $CURDIR`

echo "----------------------------------------------------------------------"
echo "build $APPS_NAME"
echo "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
    make clean
	rm -rf temp_install/*
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	AR=${GS_AR} AS=${GS_AS} LD=${GS_LD} NM=${GS_NM} CC=${GS_CC}  RANLIB=${GS_RANLIB} BUILDCC=${GS_HOSTCC} CXX=${GS_CXX} OBJCOPY=${GS_OBJCOPY} OBJDUMP=${GS_OBJDUMP} GS_CFLAGS=${GS_CFLAGS} GS_LDFLAGS=${GS_LDFLAGS}  ./configure --host=${TARGET} --build=${BUILD} --target=${TARGET} --prefix="${CURDIR}/temp_install" 

	gs_error_check $? 
	echo -n > .config_ok
fi

if [ "$1" = "config_only" ] ;then
	exit 0
fi

make V=99 -j${CORES}
gs_error_check $? 

make install

