/************************************************************************
 *
 * Copyright (c) 2007
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/

#ifndef _IFX_DMA_CORE_H
#define _IFX_DMA_CORE_H

#ifdef CONFIG_INCAIP2 /***************** DMA Configuartion in INCA-IP2 *******************/

#define MAX_DMA_DEVICE_NUM  5   /* max ports connecting to dma */
#define MAX_DMA_CHANNEL_NUM 20  /* max dma channels */

                        /* device_name | max_rx_chan_num | max_tx_chan_num | drop_enable */
#define IFX_DMA_DEVICE_INFO  { {"SW",   4, 4, 0 /*...*/}, \
                               {"DEU",  2, 2, 0 /*...*/}, \
                               {"SSC0", 1, 1, 0 /*...*/}, \
                               {"SSC1", 1, 1, 0 /*...*/}, \
                               {"MCTRL",2, 2, 0 /*...*/} }

                        /*       *dma_dev   | dir  | pri |    irq        | rel_chan_no   */
#define IFX_DMA_CHANNEL_INFO { {&dma_devs[0], DIR_RX, 0, INT_NUM_IM4_IRL0 + 0,  0 /*...*/}, \
                               {&dma_devs[0], DIR_TX, 0, INT_NUM_IM4_IRL0 + 1,  0 /*...*/}, \
                               {&dma_devs[0], DIR_RX, 1, INT_NUM_IM4_IRL0 + 2,  1 /*...*/}, \
                               {&dma_devs[0], DIR_TX, 1, INT_NUM_IM4_IRL0 + 3,  1 /*...*/}, \
                               {&dma_devs[0], DIR_RX, 2, INT_NUM_IM4_IRL0 + 4,  2 /*...*/}, \
                               {&dma_devs[0], DIR_TX, 2, INT_NUM_IM4_IRL0 + 5,  2 /*...*/}, \
                               {&dma_devs[0], DIR_RX, 3, INT_NUM_IM4_IRL0 + 6,  3 /*...*/}, \
                               {&dma_devs[0], DIR_TX, 3, INT_NUM_IM4_IRL0 + 7,  3 /*...*/}, \
                               {&dma_devs[1], DIR_RX, 0, INT_NUM_IM4_IRL0 + 8,  0 /*...*/}, \
                               {&dma_devs[1], DIR_TX, 0, INT_NUM_IM4_IRL0 + 9,  0 /*...*/}, \
                               {&dma_devs[1], DIR_RX, 1, INT_NUM_IM4_IRL0 + 10, 1 /*...*/}, \
                               {&dma_devs[1], DIR_TX, 1, INT_NUM_IM4_IRL0 + 11, 1 /*...*/}, \
                               {&dma_devs[2], DIR_RX, 0, INT_NUM_IM4_IRL0 + 23, 0 /*...*/}, \
                               {&dma_devs[2], DIR_TX, 0, INT_NUM_IM4_IRL0 + 24, 0 /*...*/}, \
                               {&dma_devs[3], DIR_RX, 0, INT_NUM_IM4_IRL0 + 25, 0 /*...*/}, \
                               {&dma_devs[3], DIR_TX, 0, INT_NUM_IM4_IRL0 + 26, 0 /*...*/}, \
                               {&dma_devs[4], DIR_RX, 0, INT_NUM_IM4_IRL0 + 27, 0 /*...*/}, \
                               {&dma_devs[4], DIR_TX, 0, INT_NUM_IM4_IRL0 + 28, 0 /*...*/}, \
                               {&dma_devs[4], DIR_RX, 1, INT_NUM_IM3_IRL0 + 12, 1 /*...*/}, \
                               {&dma_devs[4], DIR_TX, 1, INT_NUM_IM3_IRL0 + 13, 1 /*...*/} }

#elif defined(CONFIG_SVIP) /*************** DMA Configuartion in SuperVIP ****************/

#define MAX_DMA_DEVICE_NUM  9   /* max ports connecting to dma */
#define MAX_DMA_CHANNEL_NUM 24  /* max dma channels */

                        /* device_name | max_rx_chan_num | max_tx_chan_num | drop_enable */
#define IFX_DMA_DEVICE_INFO  { {"SW",    4, 4, 0 /*...*/}, \
                               {"DEU",   1, 1, 0 /*...*/}, \
                               {"SSC0",  1, 1, 0 /*...*/}, \
                               {"SSC1",  1, 1, 0 /*...*/}, \
                               {"MCTRL", 1, 1, 0 /*...*/}, \
                               {"PCM0",  1, 1, 0 /*...*/}, \
                               {"PCM1",  1, 1, 0 /*...*/}, \
                               {"PCM2",  1, 1, 0 /*...*/}, \
                               {"PCM3",  1, 1, 0 /*...*/} }

                             /*  *dma_dev   | dir  | pri |    irq        | rel_chan_no   */
#define IFX_DMA_CHANNEL_INFO { {&dma_devs[0], DIR_RX, 0, INT_NUM_IM4_IRL0 + 0,  0 /*...*/}, \
                               {&dma_devs[0], DIR_TX, 0, INT_NUM_IM4_IRL0 + 1,  0 /*...*/}, \
                               {&dma_devs[0], DIR_RX, 1, INT_NUM_IM4_IRL0 + 2,  1 /*...*/}, \
                               {&dma_devs[0], DIR_TX, 1, INT_NUM_IM4_IRL0 + 3,  1 /*...*/}, \
                               {&dma_devs[0], DIR_RX, 2, INT_NUM_IM4_IRL0 + 4,  2 /*...*/}, \
                               {&dma_devs[0], DIR_TX, 2, INT_NUM_IM4_IRL0 + 5,  2 /*...*/}, \
                               {&dma_devs[0], DIR_RX, 3, INT_NUM_IM4_IRL0 + 6,  3 /*...*/}, \
                               {&dma_devs[0], DIR_TX, 3, INT_NUM_IM4_IRL0 + 7,  3 /*...*/}, \
                               {&dma_devs[1], DIR_RX, 0, INT_NUM_IM4_IRL0 + 8,  0 /*...*/}, \
                               {&dma_devs[1], DIR_TX, 0, INT_NUM_IM4_IRL0 + 9,  0 /*...*/}, \
                               {&dma_devs[2], DIR_RX, 0, INT_NUM_IM4_IRL0 + 10, 0 /*...*/}, \
                               {&dma_devs[2], DIR_TX, 0, INT_NUM_IM4_IRL0 + 11, 0 /*...*/}, \
                               {&dma_devs[3], DIR_RX, 0, INT_NUM_IM4_IRL0 + 12, 0 /*...*/}, \
                               {&dma_devs[3], DIR_TX, 0, INT_NUM_IM4_IRL0 + 13, 0 /*...*/}, \
                               {&dma_devs[4], DIR_RX, 0, INT_NUM_IM4_IRL0 + 14, 0 /*...*/}, \
                               {&dma_devs[4], DIR_TX, 0, INT_NUM_IM4_IRL0 + 15, 0 /*...*/}, \
                               {&dma_devs[5], DIR_RX, 0, INT_NUM_IM4_IRL0 + 16, 0 /*...*/}, \
                               {&dma_devs[5], DIR_TX, 0, INT_NUM_IM4_IRL0 + 17, 0 /*...*/}, \
                               {&dma_devs[6], DIR_RX, 1, INT_NUM_IM3_IRL0 + 18, 0 /*...*/}, \
                               {&dma_devs[6], DIR_TX, 1, INT_NUM_IM3_IRL0 + 19, 0 /*...*/}, \
                               {&dma_devs[7], DIR_RX, 2, INT_NUM_IM4_IRL0 + 20, 0 /*...*/}, \
                               {&dma_devs[7], DIR_TX, 2, INT_NUM_IM4_IRL0 + 21, 0 /*...*/}, \
                               {&dma_devs[8], DIR_RX, 3, INT_NUM_IM4_IRL0 + 22, 0 /*...*/}, \
                               {&dma_devs[8], DIR_TX, 3, INT_NUM_IM4_IRL0 + 23, 0 /*...*/} }
#endif


#define DMA_OWN   1
#define CPU_OWN   0
#define DMA_MAJOR 250

/* Descriptors */
#define DMA_DESC_OWN_CPU		0x0
#define DMA_DESC_OWN_DMA		0x80000000
#define DMA_DESC_CPT_SET		0x40000000
#define DMA_DESC_SOP_SET		0x20000000
#define DMA_DESC_EOP_SET		0x10000000

#define IFX_DMA_CH_ON  1
#define IFX_DMA_CH_OFF 0
#define IFX_DMA_CH_DEFAULT_WEIGHT 100;


#ifdef CONFIG_CPU_LITTLE_ENDIAN

typedef struct rx_desc
{
	union
	{
		struct
		{
			volatile u32 data_length         :16;
			volatile u32 reserve2            :7;
			volatile u32 byte_offset         :2;
			volatile u32 reserve1            :3;
			volatile u32 EoP                 :1;
			volatile u32 SoP                 :1;
			volatile u32 C                   :1;
			volatile u32 OWN                 :1;
		}field;

		volatile u32 word;
	}status;

	volatile u32 Data_Pointer;
}_rx_desc;


typedef struct tx_desc
{
	union
	{
		struct
		{
			volatile u32 data_length         :16;
			volatile u32 reserved            :7;
			volatile u32 byte_offset         :5;
			volatile u32 EoP                 :1;
			volatile u32 SoP                 :1;
			volatile u32 C                   :1;
			volatile u32 OWN                 :1;
		}field;

		volatile u32 word;
	}status;

	volatile u32 Data_Pointer;
}_tx_desc;

#else /* BIG_ENDIAN */

typedef struct rx_desc
{
	union
	{
		struct
		{
			volatile u32 OWN                 	:1;
			volatile u32 C	                 	:1;
			volatile u32 SoP                 	:1;
			volatile u32 EoP	             	:1;
			volatile u32 reserve1             	:3;
			volatile u32 byte_offset	 	    :2;
			volatile u32 reserve2             	:7;
			volatile u32 data_length          	:16;
		}field;

		volatile u32 word;
	}status;

	volatile u32 Data_Pointer;
}_rx_desc;


typedef struct tx_desc
{
	union
	{
		struct
		{
			volatile u32 OWN                 :1;
			volatile u32 C	                 :1;
			volatile u32 SoP                 :1;
			volatile u32 EoP	         :1;
			volatile u32 byte_offset	 :5;
			volatile u32 reserved            :7;
			volatile u32 data_length         :16;
		}field;

		volatile u32 word;
	}status;

	volatile u32 Data_Pointer;
}_tx_desc;

#endif /* CONFIG_CPU_LITTLE_ENDIAN */

#endif

