/******************************************************************************

                            Copyright (c) 2007
                         Infineon Technologies AG
               St. Martin Strasse 53; 81669 Munich, Germany

  Any use of this Software is subject to the conclusion of a respective 
  License Agreement. Without such a License Agreement no rights to the
  Software are granted.

******************************************************************************/


#ifndef __IFX_ASC_H
#define __IFX_ASC_H


/*******************************************************************************
 * ASC
 ******************************************************************************/
typedef struct _ifx_asc_reg {
	volatile unsigned long  clc;  /*  0x00 */
	volatile unsigned long  pisel;  /*  0x04 */
	volatile unsigned long  id;  /*  0x08 */
	volatile unsigned long  reserved0;  /*  0x0c */
	volatile unsigned long  mcon;  /*  0x10 */
	volatile unsigned long  state;  /*  0x14 */
	volatile unsigned long  whbstate;  /*  0x18 */
	volatile unsigned long  reserved1;  /*  0x1c */
	volatile unsigned long  tbuf;  /*  0x20 */
	volatile unsigned long  rbuf;  /*  0x24 */
	volatile unsigned long  reserved2[2];  /*  0x28 */
	volatile unsigned long  abcon;  /*  0x30 */
	volatile unsigned long  abstat;  /*  0x34 */
	volatile unsigned long  whbabcon;  /*  0x38 */
	volatile unsigned long  whbabstat;  /*  0x3C */
	volatile unsigned long  rxfcon;  /*  0x40 */
	volatile unsigned long  txfcon;  /*  0x44 */
	volatile unsigned long  fstat;  /*  0x48 */
	volatile unsigned long  reserved3;  /*  0x4c */
	volatile unsigned long  bg;  /*  0x50 */
	volatile unsigned long  bg_timer;  /*  0x54 */
	volatile unsigned long  fdv;  /*  0x58 */
	volatile unsigned long  pmw;  /*  0x5C */
	volatile unsigned long  modcon;  /*  0x60 */
	volatile unsigned long  modstat;  /*  0x64 */
	volatile unsigned long  reserved4[2];  /*  0x68 */
	volatile unsigned long  sfcc;  /*  0x70 */
	volatile unsigned long  reserved5[3];  /*  0x74 */
	volatile unsigned long  eomcon;  /*  0x80 */
	volatile unsigned long  reserved6[26];  /*  0x84 */
	volatile unsigned long  dma_con;  /*  0xEC */
	volatile unsigned long  reserved7;  /*  0xf0 */
	volatile unsigned long  irnen;  /*  0xF4 */
	volatile unsigned long  irncr;  /*  0xF8 */
	volatile unsigned long  irnicr;  /*  0xFC */
} ifx_asc_reg;

/*******************************************************************************
 * ASC0
 ******************************************************************************/
#define IFX_ASC0_CLC   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x00))
#define IFX_ASC0_ID   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x08))
#define IFX_ASC0_MCON   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x10))
#define IFX_ASC0_STATE   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x14))
#define IFX_ASC0_WHBSTATE   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x18))
#define IFX_ASC0_TBUF   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x20))
#define IFX_ASC0_RBUF   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x24))
#define IFX_ASC0_FSTAT   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x48))
#define IFX_ASC0_PISEL   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x04))
#define IFX_ASC0_RXFCON   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x40))
#define IFX_ASC0_TXFCON   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x44))
#define IFX_ASC0_BG   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x50))
#define IFX_ASC0_BG_TIMER   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x54))
#define IFX_ASC0_FDV   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x58))
#define IFX_ASC0_PMW   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x5C))
#define IFX_ASC0_ABCON   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x30))
#define IFX_ASC0_WHBABCON   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x38))
#define IFX_ASC0_ABSTAT   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x34))
#define IFX_ASC0_WHBABSTAT   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x3C))
#define IFX_ASC0_MODCON   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x60))
#define IFX_ASC0_MODSTAT   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x64))
#define IFX_ASC0_SFCC   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x70))
#define IFX_ASC0_EOMCON   ((volatile unsigned int*)(IFX_ASC0_BASE + 0x80))
#define IFX_ASC0_DMA_CON   ((volatile unsigned int*)(IFX_ASC0_BASE + 0xEC))
#define IFX_ASC0_IRNEN   ((volatile unsigned int*)(IFX_ASC0_BASE + 0xF4))
#define IFX_ASC0_IRNICR   ((volatile unsigned int*)(IFX_ASC0_BASE + 0xFC))
#define IFX_ASC0_IRNCR   ((volatile unsigned int*)(IFX_ASC0_BASE + 0xF8))

/*******************************************************************************
 * ASC1
 ******************************************************************************/
#define IFX_ASC1_CLC   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x00))
#define IFX_ASC1_ID   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x08))
#define IFX_ASC1_MCON   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x10))
#define IFX_ASC1_STATE   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x14))
#define IFX_ASC1_WHBSTATE   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x18))
#define IFX_ASC1_TBUF   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x20))
#define IFX_ASC1_RBUF   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x24))
#define IFX_ASC1_FSTAT   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x48))
#define IFX_ASC1_PISEL   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x04))
#define IFX_ASC1_RXFCON   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x40))
#define IFX_ASC1_TXFCON   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x44))
#define IFX_ASC1_BG   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x50))
#define IFX_ASC1_BG_TIMER   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x54))
#define IFX_ASC1_FDV   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x58))
#define IFX_ASC1_PMW   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x5C))
#define IFX_ASC1_ABCON   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x30))
#define IFX_ASC1_WHBABCON   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x38))
#define IFX_ASC1_ABSTAT   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x34))
#define IFX_ASC1_WHBABSTAT   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x3C))
#define IFX_ASC1_MODCON   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x60))
#define IFX_ASC1_MODSTAT   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x64))
#define IFX_ASC1_SFCC   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x70))
#define IFX_ASC1_EOMCON   ((volatile unsigned int*)(IFX_ASC1_BASE + 0x80))
#define IFX_ASC1_DMA_CON   ((volatile unsigned int*)(IFX_ASC1_BASE + 0xEC))
#define IFX_ASC1_IRNEN   ((volatile unsigned int*)(IFX_ASC1_BASE + 0xF4))
#define IFX_ASC1_IRNICR   ((volatile unsigned int*)(IFX_ASC1_BASE + 0xFC))
#define IFX_ASC1_IRNCR   ((volatile unsigned int*)(IFX_ASC1_BASE + 0xF8))

/*******************************************************************************
 * ASC_CLC Register
 ******************************************************************************/

/* Clock Divider for Sleep Mode (23:16) */
#define IFX_ASC_CLC_SMC   (0xff << 16)
#define IFX_ASC_CLC_SMC_VAL(val)   (((val) & 0xff) << 16)
#define IFX_ASC_CLC_SMC_GET(val)   ((((val) & IFX_ASC_CLC_SMC) >> 16) & 0xff)
#define IFX_ASC_CLC_SMC_SET(reg,val) (reg) = ((reg & ~IFX_ASC_CLC_SMC) | (((val) & 0xff) << 16))
/* Clock Divider for Normal Run Mode (15:8) */
#define IFX_ASC_CLC_RMC   (0xff << 8)
#define IFX_ASC_CLC_RMC_VAL(val)   (((val) & 0xff) << 8)
#define IFX_ASC_CLC_RMC_GET(val)   ((((val) & IFX_ASC_CLC_RMC) >> 8) & 0xff)
#define IFX_ASC_CLC_RMC_SET(reg,val) (reg) = ((reg & ~IFX_ASC_CLC_RMC) | (((val) & 0xff) << 8))
/* Fast Shut-Off Enable Bit (5) */
#define IFX_ASC_CLC_FSOE   (0x1 << 5)
#define IFX_ASC_CLC_FSOE_VAL(val)   (((val) & 0x1) << 5)
#define IFX_ASC_CLC_FSOE_GET(val)   ((((val) & IFX_ASC_CLC_FSOE) >> 5) & 0x1)
#define IFX_ASC_CLC_FSOE_SET(reg,val) (reg) = ((reg & ~IFX_ASC_CLC_FSOE) | (((val) & 0x1) << 5))
/* Suspend Bit Write Enable for OCDS (4) */
#define IFX_ASC_CLC_SBWE   (0x1 << 4)
#define IFX_ASC_CLC_SBWE_VAL(val)   (((val) & 0x1) << 4)
#define IFX_ASC_CLC_SBWE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_CLC_SBWE) | (val) & 1) << 4)
/* External Request Disable (3) */
#define IFX_ASC_CLC_EDIS   (0x1 << 3)
#define IFX_ASC_CLC_EDIS_VAL(val)   (((val) & 0x1) << 3)
#define IFX_ASC_CLC_EDIS_GET(val)   ((((val) & IFX_ASC_CLC_EDIS) >> 3) & 0x1)
#define IFX_ASC_CLC_EDIS_SET(reg,val) (reg) = ((reg & ~IFX_ASC_CLC_EDIS) | (((val) & 0x1) << 3))
/* Suspend Enable Bit for OCDS (2) */
#define IFX_ASC_CLC_SPEN   (0x1 << 2)
#define IFX_ASC_CLC_SPEN_VAL(val)   (((val) & 0x1) << 2)
#define IFX_ASC_CLC_SPEN_GET(val)   ((((val) & IFX_ASC_CLC_SPEN) >> 2) & 0x1)
#define IFX_ASC_CLC_SPEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_CLC_SPEN) | (((val) & 0x1) << 2))
/* Disable Status Bit (1) */
#define IFX_ASC_CLC_DISS   (0x1 << 1)
#define IFX_ASC_CLC_DISS_GET(val)   ((((val) & IFX_ASC_CLC_DISS) >> 1) & 0x1)
/* Disable Request Bit (0) */
#define IFX_ASC_CLC_DISR   (0x1)
#define IFX_ASC_CLC_DISR_VAL(val)   (((val) & 0x1) << 0)
#define IFX_ASC_CLC_DISR_GET(val)   ((((val) & IFX_ASC_CLC_DISR) >> 0) & 0x1)
#define IFX_ASC_CLC_DISR_SET(reg,val) (reg) = ((reg & ~IFX_ASC_CLC_DISR) | (((val) & 0x1) << 0))

/*******************************************************************************
 * ASC_ID Register
 ******************************************************************************/

/* Transmit Path 32 Bits (31) */
#define IFX_ASC_ID_TX32   (0x1 << 31)
#define IFX_ASC_ID_TX32_GET(val)   ((((val) & IFX_ASC_ID_TX32) >> 31) & 0x1)
/* Transmit FIFO Size (29:24) */
#define IFX_ASC_ID_TXFS   (0x3f << 24)
#define IFX_ASC_ID_TXFS_GET(val)   ((((val) & IFX_ASC_ID_TXFS) >> 24) & 0x3f)
/* Receive Path 32 Bits (23) */
#define IFX_ASC_ID_RX32   (0x1 << 23)
#define IFX_ASC_ID_RX32_GET(val)   ((((val) & IFX_ASC_ID_RX32) >> 23) & 0x1)
/* Receive FIFO Size (21:16) */
#define IFX_ASC_ID_RXFS   (0x3f << 16)
#define IFX_ASC_ID_RXFS_GET(val)   ((((val) & IFX_ASC_ID_RXFS) >> 16) & 0x3f)
/* Module ID (15:8) */
#define IFX_ASC_ID_ID   (0xff << 8)
#define IFX_ASC_ID_ID_GET(val)   ((((val) & IFX_ASC_ID_ID) >> 8) & 0xff)
/* Configuration (7) */
#define IFX_ASC_ID_CFG2   (0x1 << 7)
#define IFX_ASC_ID_CFG2_GET(val)   ((((val) & IFX_ASC_ID_CFG2) >> 7) & 0x1)
/* Configuration (6) */
#define IFX_ASC_ID_CFG1   (0x1 << 6)
#define IFX_ASC_ID_CFG1_GET(val)   ((((val) & IFX_ASC_ID_CFG1) >> 6) & 0x1)
/* Configuration (5) */
#define IFX_ASC_ID_CFG0   (0x1 << 5)
#define IFX_ASC_ID_CFG0_GET(val)   ((((val) & IFX_ASC_ID_CFG0) >> 5) & 0x1)
/* Revision (4:0) */
#define IFX_ASC_ID_REV   (0x1f)
#define IFX_ASC_ID_REV_GET(val)   ((((val) & IFX_ASC_ID_REV) >> 0) & 0x1f)

/*******************************************************************************
 * ASC_MCON Register
 ******************************************************************************/

/* Receive Reassembly MSB-aligned (27) */
#define IFX_ASC_MCON_RXMSB   (0x1 << 27)
#define IFX_ASC_MCON_RXMSB_VAL(val)   (((val) & 0x1) << 27)
#define IFX_ASC_MCON_RXMSB_GET(val)   ((((val) & IFX_ASC_MCON_RXMSB) >> 27) & 0x1)
#define IFX_ASC_MCON_RXMSB_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_RXMSB) | (((val) & 0x1) << 27))
/* Transmit Segmentation MSB-aligned (26) */
#define IFX_ASC_MCON_TXMSB   (0x1 << 26)
#define IFX_ASC_MCON_TXMSB_VAL(val)   (((val) & 0x1) << 26)
#define IFX_ASC_MCON_TXMSB_GET(val)   ((((val) & IFX_ASC_MCON_TXMSB) >> 26) & 0x1)
#define IFX_ASC_MCON_TXMSB_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_TXMSB) | (((val) & 0x1) << 26))
/* Receive Inverter Enable (25) */
#define IFX_ASC_MCON_RXINV   (0x1 << 25)
#define IFX_ASC_MCON_RXINV_VAL(val)   (((val) & 0x1) << 25)
#define IFX_ASC_MCON_RXINV_GET(val)   ((((val) & IFX_ASC_MCON_RXINV) >> 25) & 0x1)
#define IFX_ASC_MCON_RXINV_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_RXINV) | (((val) & 0x1) << 25))
/* Transmit Inverter Enable (24) */
#define IFX_ASC_MCON_TXINV   (0x1 << 24)
#define IFX_ASC_MCON_TXINV_VAL(val)   (((val) & 0x1) << 24)
#define IFX_ASC_MCON_TXINV_GET(val)   ((((val) & IFX_ASC_MCON_TXINV) >> 24) & 0x1)
#define IFX_ASC_MCON_TXINV_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_TXINV) | (((val) & 0x1) << 24))
/* Line Break Check Enable (21) */
#define IFX_ASC_MCON_BEN   (0x1 << 21)
#define IFX_ASC_MCON_BEN_VAL(val)   (((val) & 0x1) << 21)
#define IFX_ASC_MCON_BEN_GET(val)   ((((val) & IFX_ASC_MCON_BEN) >> 21) & 0x1)
#define IFX_ASC_MCON_BEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_BEN) | (((val) & 0x1) << 21))
/* Transmit Overrun Check Enable (20) */
#define IFX_ASC_MCON_TOEN   (0x1 << 20)
#define IFX_ASC_MCON_TOEN_VAL(val)   (((val) & 0x1) << 20)
#define IFX_ASC_MCON_TOEN_GET(val)   ((((val) & IFX_ASC_MCON_TOEN) >> 20) & 0x1)
#define IFX_ASC_MCON_TOEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_TOEN) | (((val) & 0x1) << 20))
/* Receive Overrun Check Enable (19) */
#define IFX_ASC_MCON_ROEN   (0x1 << 19)
#define IFX_ASC_MCON_ROEN_VAL(val)   (((val) & 0x1) << 19)
#define IFX_ASC_MCON_ROEN_GET(val)   ((((val) & IFX_ASC_MCON_ROEN) >> 19) & 0x1)
#define IFX_ASC_MCON_ROEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_ROEN) | (((val) & 0x1) << 19))
/* Receive Underrun Check Enable (18) */
#define IFX_ASC_MCON_RUEN   (0x1 << 18)
#define IFX_ASC_MCON_RUEN_VAL(val)   (((val) & 0x1) << 18)
#define IFX_ASC_MCON_RUEN_GET(val)   ((((val) & IFX_ASC_MCON_RUEN) >> 18) & 0x1)
#define IFX_ASC_MCON_RUEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_RUEN) | (((val) & 0x1) << 18))
/* Framing Check Enable (17) */
#define IFX_ASC_MCON_FEN   (0x1 << 17)
#define IFX_ASC_MCON_FEN_VAL(val)   (((val) & 0x1) << 17)
#define IFX_ASC_MCON_FEN_GET(val)   ((((val) & IFX_ASC_MCON_FEN) >> 17) & 0x1)
#define IFX_ASC_MCON_FEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_FEN) | (((val) & 0x1) << 17))
/* Parity Alarm (16) */
#define IFX_ASC_MCON_PAL   (0x1 << 16)
#define IFX_ASC_MCON_PAL_VAL(val)   (((val) & 0x1) << 16)
#define IFX_ASC_MCON_PAL_GET(val)   ((((val) & IFX_ASC_MCON_PAL) >> 16) & 0x1)
#define IFX_ASC_MCON_PAL_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_PAL) | (((val) & 0x1) << 16))
/* Baudrate Generator Run Control Bit (15) */
#define IFX_ASC_MCON_R   (0x1 << 15)
#define IFX_ASC_MCON_R_VAL(val)   (((val) & 0x1) << 15)
#define IFX_ASC_MCON_R_GET(val)   ((((val) & IFX_ASC_MCON_R) >> 15) & 0x1)
#define IFX_ASC_MCON_R_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_R) | (((val) & 0x1) << 15))
/* Automatic Clock On/Off Enabled (14) */
#define IFX_ASC_MCON_ACO   (0x1 << 14)
#define IFX_ASC_MCON_ACO_VAL(val)   (((val) & 0x1) << 14)
#define IFX_ASC_MCON_ACO_GET(val)   ((((val) & IFX_ASC_MCON_ACO) >> 14) & 0x1)
#define IFX_ASC_MCON_ACO_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_ACO) | (((val) & 0x1) << 14))
/* Loopback Mode Enabled (13) */
#define IFX_ASC_MCON_LB   (0x1 << 13)
#define IFX_ASC_MCON_LB_VAL(val)   (((val) & 0x1) << 13)
#define IFX_ASC_MCON_LB_GET(val)   ((((val) & IFX_ASC_MCON_LB) >> 13) & 0x1)
#define IFX_ASC_MCON_LB_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_LB) | (((val) & 0x1) << 13))
/* Echo Mode Enable (12:11) */
#define IFX_ASC_MCON_EM   (0x3 << 11)
#define IFX_ASC_MCON_EM_VAL(val)   (((val) & 0x3) << 11)
#define IFX_ASC_MCON_EM_GET(val)   ((((val) & IFX_ASC_MCON_EM) >> 11) & 0x3)
#define IFX_ASC_MCON_EM_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_EM) | (((val) & 0x3) << 11))
/* External Receive Clock (10) */
#define IFX_ASC_MCON_ERCLK   (0x1 << 10)
#define IFX_ASC_MCON_ERCLK_VAL(val)   (((val) & 0x1) << 10)
#define IFX_ASC_MCON_ERCLK_GET(val)   ((((val) & IFX_ASC_MCON_ERCLK) >> 10) & 0x1)
#define IFX_ASC_MCON_ERCLK_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_ERCLK) | (((val) & 0x1) << 10))
/* Fractional Divider Enable (9) */
#define IFX_ASC_MCON_FDE   (0x1 << 9)
#define IFX_ASC_MCON_FDE_VAL(val)   (((val) & 0x1) << 9)
#define IFX_ASC_MCON_FDE_GET(val)   ((((val) & IFX_ASC_MCON_FDE) >> 9) & 0x1)
#define IFX_ASC_MCON_FDE_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_FDE) | (((val) & 0x1) << 9))
/* Baudrate Selection (8) */
#define IFX_ASC_MCON_BRS   (0x1 << 8)
#define IFX_ASC_MCON_BRS_VAL(val)   (((val) & 0x1) << 8)
#define IFX_ASC_MCON_BRS_GET(val)   ((((val) & IFX_ASC_MCON_BRS) >> 8) & 0x1)
#define IFX_ASC_MCON_BRS_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_BRS) | (((val) & 0x1) << 8))
/* Number of Stop Bits Selection (7) */
#define IFX_ASC_MCON_STP   (0x1 << 7)
#define IFX_ASC_MCON_STP_VAL(val)   (((val) & 0x1) << 7)
#define IFX_ASC_MCON_STP_GET(val)   ((((val) & IFX_ASC_MCON_STP) >> 7) & 0x1)
#define IFX_ASC_MCON_STP_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_STP) | (((val) & 0x1) << 7))
/* Sticky Parity (6) */
#define IFX_ASC_MCON_SP   (0x1 << 6)
#define IFX_ASC_MCON_SP_VAL(val)   (((val) & 0x1) << 6)
#define IFX_ASC_MCON_SP_GET(val)   ((((val) & IFX_ASC_MCON_SP) >> 6) & 0x1)
#define IFX_ASC_MCON_SP_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_SP) | (((val) & 0x1) << 6))
/* Parity Selection (5) */
#define IFX_ASC_MCON_ODD   (0x1 << 5)
#define IFX_ASC_MCON_ODD_GET(val)   ((((val) & IFX_ASC_MCON_ODD) >> 5) & 0x1)
/* Parity Check Enable (4) */
#define IFX_ASC_MCON_PEN   (0x1 << 4)
#define IFX_ASC_MCON_PEN_GET(val)   ((((val) & IFX_ASC_MCON_PEN) >> 4) & 0x1)
/* Word Length Select (3:2) */
#define IFX_ASC_MCON_WLS   (0x3 << 2)
#define IFX_ASC_MCON_WLS_GET(val)   ((((val) & IFX_ASC_MCON_WLS) >> 2) & 0x3)
/* Mode Control (1:0) */
#define IFX_ASC_MCON_M   (0x3)
#define IFX_ASC_MCON_M_VAL(val)   (((val) & 0x3) << 0)
#define IFX_ASC_MCON_M_GET(val)   ((((val) & IFX_ASC_MCON_M) >> 0) & 0x3)
#define IFX_ASC_MCON_M_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MCON_M) | (((val) & 0x3) << 0))

/*******************************************************************************
 * ASC_STATE Register
 ******************************************************************************/

/* Receive End-of-Message (31) */
#define IFX_ASC_STATE_RXEOM   (0x1 << 31)
#define IFX_ASC_STATE_RXEOM_GET(val)   ((((val) & IFX_ASC_STATE_RXEOM) >> 31) & 0x1)
/* Receive Byte Valid (30:28) */
#define IFX_ASC_STATE_RXBV   (0x7 << 28)
#define IFX_ASC_STATE_RXBV_GET(val)   ((((val) & IFX_ASC_STATE_RXBV) >> 28) & 0x7)
/* Transmit End-of-Message (27) */
#define IFX_ASC_STATE_TXEOM   (0x1 << 27)
#define IFX_ASC_STATE_TXEOM_GET(val)   ((((val) & IFX_ASC_STATE_TXEOM) >> 27) & 0x1)
/* Transmit Byte Valid (26:24) */
#define IFX_ASC_STATE_TXBV   (0x7 << 24)
#define IFX_ASC_STATE_TXBV_GET(val)   ((((val) & IFX_ASC_STATE_TXBV) >> 24) & 0x7)
/* Break Error Flag (21) */
#define IFX_ASC_STATE_BE   (0x1 << 21)
#define IFX_ASC_STATE_BE_GET(val)   ((((val) & IFX_ASC_STATE_BE) >> 21) & 0x1)
/* Transmit Overrun Error Flag (20) */
#define IFX_ASC_STATE_TOE   (0x1 << 20)
#define IFX_ASC_STATE_TOE_GET(val)   ((((val) & IFX_ASC_STATE_TOE) >> 20) & 0x1)
/* Receive Overrun Error Flag (19) */
#define IFX_ASC_STATE_ROE   (0x1 << 19)
#define IFX_ASC_STATE_ROE_GET(val)   ((((val) & IFX_ASC_STATE_ROE) >> 19) & 0x1)
/* Receive Underrun Error Flag (18) */
#define IFX_ASC_STATE_RUE   (0x1 << 18)
#define IFX_ASC_STATE_RUE_GET(val)   ((((val) & IFX_ASC_STATE_RUE) >> 18) & 0x1)
/* Framing Error Flag (17) */
#define IFX_ASC_STATE_FE   (0x1 << 17)
#define IFX_ASC_STATE_FE_GET(val)   ((((val) & IFX_ASC_STATE_FE) >> 17) & 0x1)
/* Parity Error Flag (16) */
#define IFX_ASC_STATE_PE   (0x1 << 16)
#define IFX_ASC_STATE_PE_GET(val)   ((((val) & IFX_ASC_STATE_PE) >> 16) & 0x1)
/* Autobaud Detection Activity Bit (3) */
#define IFX_ASC_STATE_AB_ACT   (0x1 << 3)
#define IFX_ASC_STATE_AB_ACT_GET(val)   ((((val) & IFX_ASC_STATE_AB_ACT) >> 3) & 0x1)
/* Receive Path Activity Bit (2) */
#define IFX_ASC_STATE_RX_ACT   (0x1 << 2)
#define IFX_ASC_STATE_RX_ACT_GET(val)   ((((val) & IFX_ASC_STATE_RX_ACT) >> 2) & 0x1)
/* Transmit Path Activity Bit (1) */
#define IFX_ASC_STATE_TX_ACT   (0x1 << 1)
#define IFX_ASC_STATE_TX_ACT_GET(val)   ((((val) & IFX_ASC_STATE_TX_ACT) >> 1) & 0x1)
/* Receiver Enable Bit (0) */
#define IFX_ASC_STATE_REN   (0x1)
#define IFX_ASC_STATE_REN_GET(val)   ((((val) & IFX_ASC_STATE_REN) >> 0) & 0x1)

/*******************************************************************************
 * ASC_WHBSTATE Register
 ******************************************************************************/

/* Set Break Error Flag (13) */
#define IFX_ASC_WHBSTATE_SETBE   (0x1 << 13)
#define IFX_ASC_WHBSTATE_SETBE_VAL(val)   (((val) & 0x1) << 13)
#define IFX_ASC_WHBSTATE_SETBE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_SETBE) | (val) & 1) << 13)
/* Set Transmit Overrun Error Flag (12) */
#define IFX_ASC_WHBSTATE_SETTOE   (0x1 << 12)
#define IFX_ASC_WHBSTATE_SETTOE_VAL(val)   (((val) & 0x1) << 12)
#define IFX_ASC_WHBSTATE_SETTOE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_SETTOE) | (val) & 1) << 12)
/* Set Receive Overrun Error Flag (11) */
#define IFX_ASC_WHBSTATE_SETROE   (0x1 << 11)
#define IFX_ASC_WHBSTATE_SETROE_VAL(val)   (((val) & 0x1) << 11)
#define IFX_ASC_WHBSTATE_SETROE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_SETROE) | (val) & 1) << 11)
/* Set Receive Underrun Error Flag (10) */
#define IFX_ASC_WHBSTATE_SETRUE   (0x1 << 10)
#define IFX_ASC_WHBSTATE_SETRUE_VAL(val)   (((val) & 0x1) << 10)
#define IFX_ASC_WHBSTATE_SETRUE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_SETRUE) | (val) & 1) << 10)
/* Set Framing Error Flag (9) */
#define IFX_ASC_WHBSTATE_SETFE   (0x1 << 9)
#define IFX_ASC_WHBSTATE_SETFE_VAL(val)   (((val) & 0x1) << 9)
#define IFX_ASC_WHBSTATE_SETFE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_SETFE) | (val) & 1) << 9)
/* Set Parity Error Flag (8) */
#define IFX_ASC_WHBSTATE_SETPE   (0x1 << 8)
#define IFX_ASC_WHBSTATE_SETPE_VAL(val)   (((val) & 0x1) << 8)
#define IFX_ASC_WHBSTATE_SETPE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_SETPE) | (val) & 1) << 8)
/* Clear Break Error Flag (7) */
#define IFX_ASC_WHBSTATE_CLRBE   (0x1 << 7)
#define IFX_ASC_WHBSTATE_CLRBE_VAL(val)   (((val) & 0x1) << 7)
#define IFX_ASC_WHBSTATE_CLRBE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_CLRBE) | (val) & 1) << 7)
/* Clear Transmit Overrun Error Flag (6) */
#define IFX_ASC_WHBSTATE_CLRTOE   (0x1 << 6)
#define IFX_ASC_WHBSTATE_CLRTOE_VAL(val)   (((val) & 0x1) << 6)
#define IFX_ASC_WHBSTATE_CLRTOE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_CLRTOE) | (val) & 1) << 6)
/* Clear Receive Overrun Error Flag (5) */
#define IFX_ASC_WHBSTATE_CLRROE   (0x1 << 5)
#define IFX_ASC_WHBSTATE_CLRROE_VAL(val)   (((val) & 0x1) << 5)
#define IFX_ASC_WHBSTATE_CLRROE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_CLRROE) | (val) & 1) << 5)
/* Clear Receive Underrun Error Flag (4) */
#define IFX_ASC_WHBSTATE_CLRRUE   (0x1 << 4)
#define IFX_ASC_WHBSTATE_CLRRUE_VAL(val)   (((val) & 0x1) << 4)
#define IFX_ASC_WHBSTATE_CLRRUE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_CLRRUE) | (val) & 1) << 4)
/* Clear Framing Error Flag (3) */
#define IFX_ASC_WHBSTATE_CLRFE   (0x1 << 3)
#define IFX_ASC_WHBSTATE_CLRFE_VAL(val)   (((val) & 0x1) << 3)
#define IFX_ASC_WHBSTATE_CLRFE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_CLRFE) | (val) & 1) << 3)
/* Clear Parity Error Flag (2) */
#define IFX_ASC_WHBSTATE_CLRPE   (0x1 << 2)
#define IFX_ASC_WHBSTATE_CLRPE_VAL(val)   (((val) & 0x1) << 2)
#define IFX_ASC_WHBSTATE_CLRPE_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_CLRPE) | (val) & 1) << 2)
/* Set Receiver Enable Bit (1) */
#define IFX_ASC_WHBSTATE_SETREN   (0x1 << 1)
#define IFX_ASC_WHBSTATE_SETREN_VAL(val)   (((val) & 0x1) << 1)
#define IFX_ASC_WHBSTATE_SETREN_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_SETREN) | (val) & 1) << 1)
/* Clear Receiver Enable Bit (0) */
#define IFX_ASC_WHBSTATE_CLRREN   (0x1)
#define IFX_ASC_WHBSTATE_CLRREN_VAL(val)   (((val) & 0x1) << 0)
#define IFX_ASC_WHBSTATE_CLRREN_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBSTATE_CLRREN) | (val) & 1) << 0)

/*******************************************************************************
 * ASC_TBUF Register
 ******************************************************************************/

/* Transmit Data Byte 3 (31:24) */
#define IFX_ASC_TBUF_TD3   (0xff << 24)
#define IFX_ASC_TBUF_TD3_VAL(val)   (((val) & 0xff) << 24)
#define IFX_ASC_TBUF_TD3_GET(val)   ((((val) & IFX_ASC_TBUF_TD3) >> 24) & 0xff)
#define IFX_ASC_TBUF_TD3_SET(reg,val) (reg) = ((reg & ~IFX_ASC_TBUF_TD3) | (((val) & 0xff) << 24))
/* Transmit Data Byte 2 (23:16) */
#define IFX_ASC_TBUF_TD2   (0xff << 16)
#define IFX_ASC_TBUF_TD2_VAL(val)   (((val) & 0xff) << 16)
#define IFX_ASC_TBUF_TD2_GET(val)   ((((val) & IFX_ASC_TBUF_TD2) >> 16) & 0xff)
#define IFX_ASC_TBUF_TD2_SET(reg,val) (reg) = ((reg & ~IFX_ASC_TBUF_TD2) | (((val) & 0xff) << 16))
/* Transmit Data Byte 1 (15:8) */
#define IFX_ASC_TBUF_TD1   (0xff << 8)
#define IFX_ASC_TBUF_TD1_VAL(val)   (((val) & 0xff) << 8)
#define IFX_ASC_TBUF_TD1_GET(val)   ((((val) & IFX_ASC_TBUF_TD1) >> 8) & 0xff)
#define IFX_ASC_TBUF_TD1_SET(reg,val) (reg) = ((reg & ~IFX_ASC_TBUF_TD1) | (((val) & 0xff) << 8))
/* Transmit Data Byte 0 (7:0) */
#define IFX_ASC_TBUF_TD0   (0xff)
#define IFX_ASC_TBUF_TD0_VAL(val)   (((val) & 0xff) << 0)
#define IFX_ASC_TBUF_TD0_GET(val)   ((((val) & IFX_ASC_TBUF_TD0) >> 0) & 0xff)
#define IFX_ASC_TBUF_TD0_SET(reg,val) (reg) = ((reg & ~IFX_ASC_TBUF_TD0) | (((val) & 0xff) << 0))

/*******************************************************************************
 * ASC_RBUF Register
 ******************************************************************************/

/* Receive Data Byte 3 (31:24) */
#define IFX_ASC_RBUF_RD3   (0xff << 24)
#define IFX_ASC_RBUF_RD3_GET(val)   ((((val) & IFX_ASC_RBUF_RD3) >> 24) & 0xff)
/* Receive Data Byte 2 (23:16) */
#define IFX_ASC_RBUF_RD2   (0xff << 16)
#define IFX_ASC_RBUF_RD2_GET(val)   ((((val) & IFX_ASC_RBUF_RD2) >> 16) & 0xff)
/* Receive Data Byte 1 (15:8) */
#define IFX_ASC_RBUF_RD1   (0xff << 8)
#define IFX_ASC_RBUF_RD1_GET(val)   ((((val) & IFX_ASC_RBUF_RD1) >> 8) & 0xff)
/* Receive Data Byte 0 (7:0) */
#define IFX_ASC_RBUF_RD0   (0xff)
#define IFX_ASC_RBUF_RD0_GET(val)   ((((val) & IFX_ASC_RBUF_RD0) >> 0) & 0xff)

/*******************************************************************************
 * ASC_FSTAT Register
 ******************************************************************************/

/* Transmit FIFO Free Space (29:24) */
#define IFX_ASC_FSTAT_TXFREE   (0x3f << 24)
#define IFX_ASC_FSTAT_TXFREE_GET(val)   ((((val) & IFX_ASC_FSTAT_TXFREE) >> 24) & 0x3f)
/* Receive FIFO Free Space (21:16) */
#define IFX_ASC_FSTAT_RXFREE   (0x3f << 16)
#define IFX_ASC_FSTAT_RXFREE_GET(val)   ((((val) & IFX_ASC_FSTAT_RXFREE) >> 16) & 0x3f)
/* Transmit FIFO Filling Level (13:8) */
#define IFX_ASC_FSTAT_TXFFL   (0x3f << 8)
#define IFX_ASC_FSTAT_TXFFL_GET(val)   ((((val) & IFX_ASC_FSTAT_TXFFL) >> 8) & 0x3f)
/* Receive FIFO Filling Level (5:0) */
#define IFX_ASC_FSTAT_RXFFL   (0x3f)
#define IFX_ASC_FSTAT_RXFFL_GET(val)   ((((val) & IFX_ASC_FSTAT_RXFFL) >> 0) & 0x3f)

/*******************************************************************************
 * ASC_PISEL Register
 ******************************************************************************/

/* Receiver Input Select (0) */
#define IFX_ASC_PISEL_RIS   (0x1)
#define IFX_ASC_PISEL_RIS_VAL(val)   (((val) & 0x1) << 0)
#define IFX_ASC_PISEL_RIS_GET(val)   ((((val) & IFX_ASC_PISEL_RIS) >> 0) & 0x1)
#define IFX_ASC_PISEL_RIS_SET(reg,val) (reg) = ((reg & ~IFX_ASC_PISEL_RIS) | (((val) & 0x1) << 0))

/*******************************************************************************
 * ASC_RXFCON Register
 ******************************************************************************/

/* Receive FIFO Interrupt Trigger Level (13:8) */
#define IFX_ASC_RXFCON_RXFITL   (0x3f << 8)
#define IFX_ASC_RXFCON_RXFITL_VAL(val)   (((val) & 0x3f) << 8)
#define IFX_ASC_RXFCON_RXFITL_GET(val)   ((((val) & IFX_ASC_RXFCON_RXFITL) >> 8) & 0x3f)
#define IFX_ASC_RXFCON_RXFITL_SET(reg,val) (reg) = ((reg & ~IFX_ASC_RXFCON_RXFITL) | (((val) & 0x3f) << 8))
/* Receive FIFO Flush (1) */
#define IFX_ASC_RXFCON_RXFFLU   (0x1 << 1)
#define IFX_ASC_RXFCON_RXFFLU_VAL(val)   (((val) & 0x1) << 1)
#define IFX_ASC_RXFCON_RXFFLU_SET(reg,val) (reg) = (((reg & ~IFX_ASC_RXFCON_RXFFLU) | (val) & 1) << 1)
/* Receive FIFO Enable (0) */
#define IFX_ASC_RXFCON_RXFEN   (0x1)
#define IFX_ASC_RXFCON_RXFEN_VAL(val)   (((val) & 0x1) << 0)
#define IFX_ASC_RXFCON_RXFEN_GET(val)   ((((val) & IFX_ASC_RXFCON_RXFEN) >> 0) & 0x1)
#define IFX_ASC_RXFCON_RXFEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_RXFCON_RXFEN) | (((val) & 0x1) << 0))

/*******************************************************************************
 * ASC_TXFCON Register
 ******************************************************************************/

/* Transmit FIFO Interrupt Trigger Level (13:8) */
#define IFX_ASC_TXFCON_TXFITL   (0x3f << 8)
#define IFX_ASC_TXFCON_TXFITL_VAL(val)   (((val) & 0x3f) << 8)
#define IFX_ASC_TXFCON_TXFITL_GET(val)   ((((val) & IFX_ASC_TXFCON_TXFITL) >> 8) & 0x3f)
#define IFX_ASC_TXFCON_TXFITL_SET(reg,val) (reg) = ((reg & ~IFX_ASC_TXFCON_TXFITL) | (((val) & 0x3f) << 8))
/* Transmit FIFO Flush (1) */
#define IFX_ASC_TXFCON_TXFFLU   (0x1 << 1)
#define IFX_ASC_TXFCON_TXFFLU_VAL(val)   (((val) & 0x1) << 1)
#define IFX_ASC_TXFCON_TXFFLU_SET(reg,val) (reg) = (((reg & ~IFX_ASC_TXFCON_TXFFLU) | (val) & 1) << 1)
/* Transmit FIFO Enable (0) */
#define IFX_ASC_TXFCON_TXFEN   (0x1)
#define IFX_ASC_TXFCON_TXFEN_VAL(val)   (((val) & 0x1) << 0)
#define IFX_ASC_TXFCON_TXFEN_GET(val)   ((((val) & IFX_ASC_TXFCON_TXFEN) >> 0) & 0x1)
#define IFX_ASC_TXFCON_TXFEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_TXFCON_TXFEN) | (((val) & 0x1) << 0))

/*******************************************************************************
 * ASC_BG Register
 ******************************************************************************/

/* Baudrate Timer Reload Value (12:0) */
#define IFX_ASC_BG_BR_VAL   (0x1fff)
#define IFX_ASC_BG_BR_VAL_GET(val)   ((((val) & IFX_ASC_BG_BR_VAL) >> 0) & 0x1fff)

/*******************************************************************************
 * ASC_BG_TIMER Register
 ******************************************************************************/

/* Baudrate Timer Count Value (12:0) */
#define IFX_ASC_BG_TIMER_BR_VAL   (0x1fff)
#define IFX_ASC_BG_TIMER_BR_VAL_GET(val)   ((((val) & IFX_ASC_BG_TIMER_BR_VAL) >> 0) & 0x1fff)

/*******************************************************************************
 * ASC_FDV Register
 ******************************************************************************/

/* Fractional Divider Register Value (8:0) */
#define IFX_ASC_FDV_FD_VAL   (0x1ff)
#define IFX_ASC_FDV_FD_VAL_VAL(val)   (((val) & 0x1ff) << 0)
#define IFX_ASC_FDV_FD_VAL_GET(val)   ((((val) & IFX_ASC_FDV_FD_VAL) >> 0) & 0x1ff)
#define IFX_ASC_FDV_FD_VAL_SET(reg,val) (reg) = ((reg & ~IFX_ASC_FDV_FD_VAL) | (((val) & 0x1ff) << 0))

/*******************************************************************************
 * ASC_PMW Register
 ******************************************************************************/

/* IrDA Pulse Width Selection (8) */
#define IFX_ASC_PMW_IRPW   (0x1 << 8)
#define IFX_ASC_PMW_IRPW_VAL(val)   (((val) & 0x1) << 8)
#define IFX_ASC_PMW_IRPW_GET(val)   ((((val) & IFX_ASC_PMW_IRPW) >> 8) & 0x1)
#define IFX_ASC_PMW_IRPW_SET(reg,val) (reg) = ((reg & ~IFX_ASC_PMW_IRPW) | (((val) & 0x1) << 8))
/* IrDA Pulse Width Value (7:0) */
#define IFX_ASC_PMW_PW_VAL   (0xff)
#define IFX_ASC_PMW_PW_VAL_VAL(val)   (((val) & 0xff) << 0)
#define IFX_ASC_PMW_PW_VAL_GET(val)   ((((val) & IFX_ASC_PMW_PW_VAL) >> 0) & 0xff)
#define IFX_ASC_PMW_PW_VAL_SET(reg,val) (reg) = ((reg & ~IFX_ASC_PMW_PW_VAL) | (((val) & 0xff) << 0))

/*******************************************************************************
 * ASC_ABCON Register
 ******************************************************************************/

/* First Character of Two-Byte Frame Detected Enable (4) */
#define IFX_ASC_ABCON_FCDETEN   (0x1 << 4)
#define IFX_ASC_ABCON_FCDETEN_VAL(val)   (((val) & 0x1) << 4)
#define IFX_ASC_ABCON_FCDETEN_GET(val)   ((((val) & IFX_ASC_ABCON_FCDETEN) >> 4) & 0x1)
#define IFX_ASC_ABCON_FCDETEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_ABCON_FCDETEN) | (((val) & 0x1) << 4))
/* Autobaud Detection Interrupt Enable (3) */
#define IFX_ASC_ABCON_ABDETEN   (0x1 << 3)
#define IFX_ASC_ABCON_ABDETEN_VAL(val)   (((val) & 0x1) << 3)
#define IFX_ASC_ABCON_ABDETEN_GET(val)   ((((val) & IFX_ASC_ABCON_ABDETEN) >> 3) & 0x1)
#define IFX_ASC_ABCON_ABDETEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_ABCON_ABDETEN) | (((val) & 0x1) << 3))
/* Start of Autobaud Detection Interrupt Enable (2) */
#define IFX_ASC_ABCON_ABSTEN   (0x1 << 2)
#define IFX_ASC_ABCON_ABSTEN_VAL(val)   (((val) & 0x1) << 2)
#define IFX_ASC_ABCON_ABSTEN_GET(val)   ((((val) & IFX_ASC_ABCON_ABSTEN) >> 2) & 0x1)
#define IFX_ASC_ABCON_ABSTEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_ABCON_ABSTEN) | (((val) & 0x1) << 2))
/* Automatic Autobaud Control of STATE.REN (1) */
#define IFX_ASC_ABCON_AUREN   (0x1 << 1)
#define IFX_ASC_ABCON_AUREN_VAL(val)   (((val) & 0x1) << 1)
#define IFX_ASC_ABCON_AUREN_GET(val)   ((((val) & IFX_ASC_ABCON_AUREN) >> 1) & 0x1)
#define IFX_ASC_ABCON_AUREN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_ABCON_AUREN) | (((val) & 0x1) << 1))
/* Autobaud Detection Enable (0) */
#define IFX_ASC_ABCON_ABEN   (0x1)
#define IFX_ASC_ABCON_ABEN_GET(val)   ((((val) & IFX_ASC_ABCON_ABEN) >> 0) & 0x1)

/*******************************************************************************
 * ASC_WHBABCON Register
 ******************************************************************************/

/* Set Autobaud Detection Enable Bit (1) */
#define IFX_ASC_WHBABCON_SETABEN   (0x1 << 1)
#define IFX_ASC_WHBABCON_SETABEN_VAL(val)   (((val) & 0x1) << 1)
#define IFX_ASC_WHBABCON_SETABEN_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABCON_SETABEN) | (val) & 1) << 1)
/* Clear Autobaud Detection Enable Bit (0) */
#define IFX_ASC_WHBABCON_CLRABEN   (0x1)
#define IFX_ASC_WHBABCON_CLRABEN_VAL(val)   (((val) & 0x1) << 0)
#define IFX_ASC_WHBABCON_CLRABEN_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABCON_CLRABEN) | (val) & 1) << 0)

/*******************************************************************************
 * ASC_ABSTAT Register
 ******************************************************************************/

/* Autobaud Detection is Waiting (4) */
#define IFX_ASC_ABSTAT_DETWAIT   (0x1 << 4)
#define IFX_ASC_ABSTAT_DETWAIT_GET(val)   ((((val) & IFX_ASC_ABSTAT_DETWAIT) >> 4) & 0x1)
/* Second Character with Capital Letter Detected (3) */
#define IFX_ASC_ABSTAT_SCCDET   (0x1 << 3)
#define IFX_ASC_ABSTAT_SCCDET_GET(val)   ((((val) & IFX_ASC_ABSTAT_SCCDET) >> 3) & 0x1)
/* Second Character with Small Letter Detected (2) */
#define IFX_ASC_ABSTAT_SCSDET   (0x1 << 2)
#define IFX_ASC_ABSTAT_SCSDET_GET(val)   ((((val) & IFX_ASC_ABSTAT_SCSDET) >> 2) & 0x1)
/* First Character with Capital Letter Detected (1) */
#define IFX_ASC_ABSTAT_FCCDET   (0x1 << 1)
#define IFX_ASC_ABSTAT_FCCDET_GET(val)   ((((val) & IFX_ASC_ABSTAT_FCCDET) >> 1) & 0x1)
/* First Character with Small Letter Detected (0) */
#define IFX_ASC_ABSTAT_FCSDET   (0x1)
#define IFX_ASC_ABSTAT_FCSDET_GET(val)   ((((val) & IFX_ASC_ABSTAT_FCSDET) >> 0) & 0x1)

/*******************************************************************************
 * ASC_WHBABSTAT Register
 ******************************************************************************/

/* Set Autobaud Detection is Waiting Bit (9) */
#define IFX_ASC_WHBABSTAT_SETDETWAIT   (0x1 << 9)
#define IFX_ASC_WHBABSTAT_SETDETWAIT_VAL(val)   (((val) & 0x1) << 9)
#define IFX_ASC_WHBABSTAT_SETDETWAIT_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABSTAT_SETDETWAIT) | (val) & 1) << 9)
/* Clear Autobaud Detection is Waiting Bit (8) */
#define IFX_ASC_WHBABSTAT_CLRDETWAIT   (0x1 << 8)
#define IFX_ASC_WHBABSTAT_CLRDETWAIT_VAL(val)   (((val) & 0x1) << 8)
#define IFX_ASC_WHBABSTAT_CLRDETWAIT_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABSTAT_CLRDETWAIT) | (val) & 1) << 8)
/* Set Second Character with Capital Letter Detected Bit (7) */
#define IFX_ASC_WHBABSTAT_SETSCCDET   (0x1 << 7)
#define IFX_ASC_WHBABSTAT_SETSCCDET_VAL(val)   (((val) & 0x1) << 7)
#define IFX_ASC_WHBABSTAT_SETSCCDET_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABSTAT_SETSCCDET) | (val) & 1) << 7)
/* Clear Second Character with Capital Letter Detected Bit (6) */
#define IFX_ASC_WHBABSTAT_CLRSCCDET   (0x1 << 6)
#define IFX_ASC_WHBABSTAT_CLRSCCDET_VAL(val)   (((val) & 0x1) << 6)
#define IFX_ASC_WHBABSTAT_CLRSCCDET_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABSTAT_CLRSCCDET) | (val) & 1) << 6)
/* Set Second Character with Small Letter Detected Bit (5) */
#define IFX_ASC_WHBABSTAT_SETSCSDET   (0x1 << 5)
#define IFX_ASC_WHBABSTAT_SETSCSDET_VAL(val)   (((val) & 0x1) << 5)
#define IFX_ASC_WHBABSTAT_SETSCSDET_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABSTAT_SETSCSDET) | (val) & 1) << 5)
/* Clear Second Character with Small Letter Detected Bit (4) */
#define IFX_ASC_WHBABSTAT_CLRSCSDET   (0x1 << 4)
#define IFX_ASC_WHBABSTAT_CLRSCSDET_VAL(val)   (((val) & 0x1) << 4)
#define IFX_ASC_WHBABSTAT_CLRSCSDET_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABSTAT_CLRSCSDET) | (val) & 1) << 4)
/* Set First Character with Capital Letter Detected Bit (3) */
#define IFX_ASC_WHBABSTAT_SETFCCDET   (0x1 << 3)
#define IFX_ASC_WHBABSTAT_SETFCCDET_VAL(val)   (((val) & 0x1) << 3)
#define IFX_ASC_WHBABSTAT_SETFCCDET_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABSTAT_SETFCCDET) | (val) & 1) << 3)
/* Clear First Character with Capital Letter Detected Bit (2) */
#define IFX_ASC_WHBABSTAT_CLRFCCDET   (0x1 << 2)
#define IFX_ASC_WHBABSTAT_CLRFCCDET_VAL(val)   (((val) & 0x1) << 2)
#define IFX_ASC_WHBABSTAT_CLRFCCDET_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABSTAT_CLRFCCDET) | (val) & 1) << 2)
/* Set First Character with Small Letter Detected Bit (1) */
#define IFX_ASC_WHBABSTAT_SETFCSDET   (0x1 << 1)
#define IFX_ASC_WHBABSTAT_SETFCSDET_VAL(val)   (((val) & 0x1) << 1)
#define IFX_ASC_WHBABSTAT_SETFCSDET_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABSTAT_SETFCSDET) | (val) & 1) << 1)
/* Clear First Character with Small Letter Detected Bit (0) */
#define IFX_ASC_WHBABSTAT_CLRFCSDET   (0x1)
#define IFX_ASC_WHBABSTAT_CLRFCSDET_VAL(val)   (((val) & 0x1) << 0)
#define IFX_ASC_WHBABSTAT_CLRFCSDET_SET(reg,val) (reg) = (((reg & ~IFX_ASC_WHBABSTAT_CLRFCSDET) | (val) & 1) << 0)

/*******************************************************************************
 * ASC_MODCON Register
 ******************************************************************************/

/* Clear Break Bit (27) */
#define IFX_ASC_MODCON_CLRB   (0x1 << 27)
#define IFX_ASC_MODCON_CLRB_VAL(val)   (((val) & 0x1) << 27)
#define IFX_ASC_MODCON_CLRB_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_CLRB) | (val) & 1) << 27)
/* Set Break Bit (26) */
#define IFX_ASC_MODCON_SETB   (0x1 << 26)
#define IFX_ASC_MODCON_SETB_VAL(val)   (((val) & 0x1) << 26)
#define IFX_ASC_MODCON_SETB_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_SETB) | (val) & 1) << 26)
/* Force XOFF (25) */
#define IFX_ASC_MODCON_FXOFF   (0x1 << 25)
#define IFX_ASC_MODCON_FXOFF_VAL(val)   (((val) & 0x1) << 25)
#define IFX_ASC_MODCON_FXOFF_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_FXOFF) | (val) & 1) << 25)
/* Force XON (24) */
#define IFX_ASC_MODCON_FXON   (0x1 << 24)
#define IFX_ASC_MODCON_FXON_VAL(val)   (((val) & 0x1) << 24)
#define IFX_ASC_MODCON_FXON_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_FXON) | (val) & 1) << 24)
/* Clear OUT2 Bit (23) */
#define IFX_ASC_MODCON_CLROUT2   (0x1 << 23)
#define IFX_ASC_MODCON_CLROUT2_VAL(val)   (((val) & 0x1) << 23)
#define IFX_ASC_MODCON_CLROUT2_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_CLROUT2) | (val) & 1) << 23)
/* Set OUT2 Bit (22) */
#define IFX_ASC_MODCON_SETOUT2   (0x1 << 22)
#define IFX_ASC_MODCON_SETOUT2_VAL(val)   (((val) & 0x1) << 22)
#define IFX_ASC_MODCON_SETOUT2_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_SETOUT2) | (val) & 1) << 22)
/* Clear OUT1 Bit (21) */
#define IFX_ASC_MODCON_CLROUT1   (0x1 << 21)
#define IFX_ASC_MODCON_CLROUT1_VAL(val)   (((val) & 0x1) << 21)
#define IFX_ASC_MODCON_CLROUT1_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_CLROUT1) | (val) & 1) << 21)
/* Set OUT1 Bit (20) */
#define IFX_ASC_MODCON_SETOUT1   (0x1 << 20)
#define IFX_ASC_MODCON_SETOUT1_VAL(val)   (((val) & 0x1) << 20)
#define IFX_ASC_MODCON_SETOUT1_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_SETOUT1) | (val) & 1) << 20)
/* Clear RTS Bit (19) */
#define IFX_ASC_MODCON_CLRRTS   (0x1 << 19)
#define IFX_ASC_MODCON_CLRRTS_VAL(val)   (((val) & 0x1) << 19)
#define IFX_ASC_MODCON_CLRRTS_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_CLRRTS) | (val) & 1) << 19)
/* Set RTS Bit (18) */
#define IFX_ASC_MODCON_SETRTS   (0x1 << 18)
#define IFX_ASC_MODCON_SETRTS_VAL(val)   (((val) & 0x1) << 18)
#define IFX_ASC_MODCON_SETRTS_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_SETRTS) | (val) & 1) << 18)
/* Clear DTR Bit (17) */
#define IFX_ASC_MODCON_CLRDTR   (0x1 << 17)
#define IFX_ASC_MODCON_CLRDTR_VAL(val)   (((val) & 0x1) << 17)
#define IFX_ASC_MODCON_CLRDTR_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_CLRDTR) | (val) & 1) << 17)
/* Set DTR Bit (16) */
#define IFX_ASC_MODCON_SETDTR   (0x1 << 16)
#define IFX_ASC_MODCON_SETDTR_VAL(val)   (((val) & 0x1) << 16)
#define IFX_ASC_MODCON_SETDTR_SET(reg,val) (reg) = (((reg & ~IFX_ASC_MODCON_SETDTR) | (val) & 1) << 16)
/* XON Interrupt Enable (12) */
#define IFX_ASC_MODCON_XONIEN   (0x1 << 12)
#define IFX_ASC_MODCON_XONIEN_VAL(val)   (((val) & 0x1) << 12)
#define IFX_ASC_MODCON_XONIEN_GET(val)   ((((val) & IFX_ASC_MODCON_XONIEN) >> 12) & 0x1)
#define IFX_ASC_MODCON_XONIEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_XONIEN) | (((val) & 0x1) << 12))
/* XOFF Interrupt Enable (12) */
#define IFX_ASC_MODCON_XOFFIEN   (0x1 << 12)
#define IFX_ASC_MODCON_XOFFIEN_VAL(val)   (((val) & 0x1) << 12)
#define IFX_ASC_MODCON_XOFFIEN_GET(val)   ((((val) & IFX_ASC_MODCON_XOFFIEN) >> 12) & 0x1)
#define IFX_ASC_MODCON_XOFFIEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_XOFFIEN) | (((val) & 0x1) << 12))
/* RI Interrupt Enable (11) */
#define IFX_ASC_MODCON_RIIEN   (0x1 << 11)
#define IFX_ASC_MODCON_RIIEN_VAL(val)   (((val) & 0x1) << 11)
#define IFX_ASC_MODCON_RIIEN_GET(val)   ((((val) & IFX_ASC_MODCON_RIIEN) >> 11) & 0x1)
#define IFX_ASC_MODCON_RIIEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_RIIEN) | (((val) & 0x1) << 11))
/* DCD Interrupt Enable (10) */
#define IFX_ASC_MODCON_DCDIEN   (0x1 << 10)
#define IFX_ASC_MODCON_DCDIEN_VAL(val)   (((val) & 0x1) << 10)
#define IFX_ASC_MODCON_DCDIEN_GET(val)   ((((val) & IFX_ASC_MODCON_DCDIEN) >> 10) & 0x1)
#define IFX_ASC_MODCON_DCDIEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_DCDIEN) | (((val) & 0x1) << 10))
/* DSR Interrupt Enable (9) */
#define IFX_ASC_MODCON_DSRIEN   (0x1 << 9)
#define IFX_ASC_MODCON_DSRIEN_VAL(val)   (((val) & 0x1) << 9)
#define IFX_ASC_MODCON_DSRIEN_GET(val)   ((((val) & IFX_ASC_MODCON_DSRIEN) >> 9) & 0x1)
#define IFX_ASC_MODCON_DSRIEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_DSRIEN) | (((val) & 0x1) << 9))
/* CTS Interrupt Enable (8) */
#define IFX_ASC_MODCON_CTSIEN   (0x1 << 8)
#define IFX_ASC_MODCON_CTSIEN_VAL(val)   (((val) & 0x1) << 8)
#define IFX_ASC_MODCON_CTSIEN_GET(val)   ((((val) & IFX_ASC_MODCON_CTSIEN) >> 8) & 0x1)
#define IFX_ASC_MODCON_CTSIEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_CTSIEN) | (((val) & 0x1) << 8))
/* DTR Flow Control (7) */
#define IFX_ASC_MODCON_DTRFC   (0x1 << 7)
#define IFX_ASC_MODCON_DTRFC_VAL(val)   (((val) & 0x1) << 7)
#define IFX_ASC_MODCON_DTRFC_GET(val)   ((((val) & IFX_ASC_MODCON_DTRFC) >> 7) & 0x1)
#define IFX_ASC_MODCON_DTRFC_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_DTRFC) | (((val) & 0x1) << 7))
/* DSR Flow Control (6) */
#define IFX_ASC_MODCON_DSRFC   (0x1 << 6)
#define IFX_ASC_MODCON_DSRFC_VAL(val)   (((val) & 0x1) << 6)
#define IFX_ASC_MODCON_DSRFC_GET(val)   ((((val) & IFX_ASC_MODCON_DSRFC) >> 6) & 0x1)
#define IFX_ASC_MODCON_DSRFC_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_DSRFC) | (((val) & 0x1) << 6))
/* RTS Flow Control (5) */
#define IFX_ASC_MODCON_RTSFC   (0x1 << 5)
#define IFX_ASC_MODCON_RTSFC_VAL(val)   (((val) & 0x1) << 5)
#define IFX_ASC_MODCON_RTSFC_GET(val)   ((((val) & IFX_ASC_MODCON_RTSFC) >> 5) & 0x1)
#define IFX_ASC_MODCON_RTSFC_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_RTSFC) | (((val) & 0x1) << 5))
/* CTS Flow Control (4) */
#define IFX_ASC_MODCON_CTSFC   (0x1 << 4)
#define IFX_ASC_MODCON_CTSFC_VAL(val)   (((val) & 0x1) << 4)
#define IFX_ASC_MODCON_CTSFC_GET(val)   ((((val) & IFX_ASC_MODCON_CTSFC) >> 4) & 0x1)
#define IFX_ASC_MODCON_CTSFC_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_CTSFC) | (((val) & 0x1) << 4))
/* Soft Flow Control Transmit Direction (3:2) */
#define IFX_ASC_MODCON_SFCTX   (0x3 << 2)
#define IFX_ASC_MODCON_SFCTX_VAL(val)   (((val) & 0x3) << 2)
#define IFX_ASC_MODCON_SFCTX_GET(val)   ((((val) & IFX_ASC_MODCON_SFCTX) >> 2) & 0x3)
#define IFX_ASC_MODCON_SFCTX_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_SFCTX) | (((val) & 0x3) << 2))
/* Soft Flow Control Receive Direction (1:0) */
#define IFX_ASC_MODCON_SFCRX   (0x3)
#define IFX_ASC_MODCON_SFCRX_VAL(val)   (((val) & 0x3) << 0)
#define IFX_ASC_MODCON_SFCRX_GET(val)   ((((val) & IFX_ASC_MODCON_SFCRX) >> 0) & 0x3)
#define IFX_ASC_MODCON_SFCRX_SET(reg,val) (reg) = ((reg & ~IFX_ASC_MODCON_SFCRX) | (((val) & 0x3) << 0))

/*******************************************************************************
 * ASC_MODSTAT Register
 ******************************************************************************/

/* Break Out Status (18) */
#define IFX_ASC_MODSTAT_BOUT   (0x1 << 18)
#define IFX_ASC_MODSTAT_BOUT_GET(val)   ((((val) & IFX_ASC_MODSTAT_BOUT) >> 18) & 0x1)
/* OUT2 bit (17) */
#define IFX_ASC_MODSTAT_OUT2   (0x1 << 17)
#define IFX_ASC_MODSTAT_OUT2_GET(val)   ((((val) & IFX_ASC_MODSTAT_OUT2) >> 17) & 0x1)
/* OUT1 bit (16) */
#define IFX_ASC_MODSTAT_OUT1   (0x1 << 16)
#define IFX_ASC_MODSTAT_OUT1_GET(val)   ((((val) & IFX_ASC_MODSTAT_OUT1) >> 16) & 0x1)
/* Delta Receive XOFF (15) */
#define IFX_ASC_MODSTAT_DRXOFF   (0x1 << 15)
#define IFX_ASC_MODSTAT_DRXOFF_GET(val)   ((((val) & IFX_ASC_MODSTAT_DRXOFF) >> 15) & 0x1)
/* Delta Transmit XOFF (14) */
#define IFX_ASC_MODSTAT_DTXOFF   (0x1 << 14)
#define IFX_ASC_MODSTAT_DTXOFF_GET(val)   ((((val) & IFX_ASC_MODSTAT_DTXOFF) >> 14) & 0x1)
/* Reserved (13:12) */
#define IFX_ASC_MODSTAT_RES   (0x3 << 12)
#define IFX_ASC_MODSTAT_RES_GET(val)   ((((val) & IFX_ASC_MODSTAT_RES) >> 12) & 0x3)
/* Delta DCD (11) */
#define IFX_ASC_MODSTAT_DDCD   (0x1 << 11)
#define IFX_ASC_MODSTAT_DDCD_GET(val)   ((((val) & IFX_ASC_MODSTAT_DDCD) >> 11) & 0x1)
/* Trailing Edge RI (10) */
#define IFX_ASC_MODSTAT_TERI   (0x1 << 10)
#define IFX_ASC_MODSTAT_TERI_GET(val)   ((((val) & IFX_ASC_MODSTAT_TERI) >> 10) & 0x1)
/* Delta DSR (9) */
#define IFX_ASC_MODSTAT_DDSR   (0x1 << 9)
#define IFX_ASC_MODSTAT_DDSR_GET(val)   ((((val) & IFX_ASC_MODSTAT_DDSR) >> 9) & 0x1)
/* Delta CTS (8) */
#define IFX_ASC_MODSTAT_DCTS   (0x1 << 8)
#define IFX_ASC_MODSTAT_DCTS_GET(val)   ((((val) & IFX_ASC_MODSTAT_DCTS) >> 8) & 0x1)
/* Receive XOFF (7) */
#define IFX_ASC_MODSTAT_RXXOFF   (0x1 << 7)
#define IFX_ASC_MODSTAT_RXXOFF_GET(val)   ((((val) & IFX_ASC_MODSTAT_RXXOFF) >> 7) & 0x1)
/* Transmit XOFF (6) */
#define IFX_ASC_MODSTAT_TXXOFF   (0x1 << 6)
#define IFX_ASC_MODSTAT_TXXOFF_GET(val)   ((((val) & IFX_ASC_MODSTAT_TXXOFF) >> 6) & 0x1)
/* DTR bit (5) */
#define IFX_ASC_MODSTAT_DTR   (0x1 << 5)
#define IFX_ASC_MODSTAT_DTR_GET(val)   ((((val) & IFX_ASC_MODSTAT_DTR) >> 5) & 0x1)
/* RTS bit (4) */
#define IFX_ASC_MODSTAT_RTS   (0x1 << 4)
#define IFX_ASC_MODSTAT_RTS_GET(val)   ((((val) & IFX_ASC_MODSTAT_RTS) >> 4) & 0x1)
/* DCD bit (3) */
#define IFX_ASC_MODSTAT_DCD   (0x1 << 3)
#define IFX_ASC_MODSTAT_DCD_GET(val)   ((((val) & IFX_ASC_MODSTAT_DCD) >> 3) & 0x1)
/* RI bit (2) */
#define IFX_ASC_MODSTAT_RI   (0x1 << 2)
#define IFX_ASC_MODSTAT_RI_GET(val)   ((((val) & IFX_ASC_MODSTAT_RI) >> 2) & 0x1)
/* DSR bit (1) */
#define IFX_ASC_MODSTAT_DSR   (0x1 << 1)
#define IFX_ASC_MODSTAT_DSR_GET(val)   ((((val) & IFX_ASC_MODSTAT_DSR) >> 1) & 0x1)
/* CTS bit (0) */
#define IFX_ASC_MODSTAT_CTS   (0x1)
#define IFX_ASC_MODSTAT_CTS_GET(val)   ((((val) & IFX_ASC_MODSTAT_CTS) >> 0) & 0x1)

/*******************************************************************************
 * ASC_SFCC Register
 ******************************************************************************/

/* XOFF Character Value (23:16) */
#define IFX_ASC_SFCC_XOFF   (0xff << 16)
#define IFX_ASC_SFCC_XOFF_VAL(val)   (((val) & 0xff) << 16)
#define IFX_ASC_SFCC_XOFF_GET(val)   ((((val) & IFX_ASC_SFCC_XOFF) >> 16) & 0xff)
#define IFX_ASC_SFCC_XOFF_SET(reg,val) (reg) = ((reg & ~IFX_ASC_SFCC_XOFF) | (((val) & 0xff) << 16))
/* XON Character Value (7:0) */
#define IFX_ASC_SFCC_XON   (0xff)
#define IFX_ASC_SFCC_XON_VAL(val)   (((val) & 0xff) << 0)
#define IFX_ASC_SFCC_XON_GET(val)   ((((val) & IFX_ASC_SFCC_XON) >> 0) & 0xff)
#define IFX_ASC_SFCC_XON_SET(reg,val) (reg) = ((reg & ~IFX_ASC_SFCC_XON) | (((val) & 0xff) << 0))

/*******************************************************************************
 * ASC_EOMCON Register
 ******************************************************************************/

/* Delayed Timeout Enable (25) */
#define IFX_ASC_EOMCON_DTEN   (0x1 << 25)
#define IFX_ASC_EOMCON_DTEN_VAL(val)   (((val) & 0x1) << 25)
#define IFX_ASC_EOMCON_DTEN_GET(val)   ((((val) & IFX_ASC_EOMCON_DTEN) >> 25) & 0x1)
#define IFX_ASC_EOMCON_DTEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_EOMCON_DTEN) | (((val) & 0x1) << 25))
/* Timeout EOM Enable (24) */
#define IFX_ASC_EOMCON_TOEN   (0x1 << 24)
#define IFX_ASC_EOMCON_TOEN_VAL(val)   (((val) & 0x1) << 24)
#define IFX_ASC_EOMCON_TOEN_GET(val)   ((((val) & IFX_ASC_EOMCON_TOEN) >> 24) & 0x1)
#define IFX_ASC_EOMCON_TOEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_EOMCON_TOEN) | (((val) & 0x1) << 24))
/* Timeout Counter Reload Value (23:16) */
#define IFX_ASC_EOMCON_TRV   (0xff << 16)
#define IFX_ASC_EOMCON_TRV_VAL(val)   (((val) & 0xff) << 16)
#define IFX_ASC_EOMCON_TRV_GET(val)   ((((val) & IFX_ASC_EOMCON_TRV) >> 16) & 0xff)
#define IFX_ASC_EOMCON_TRV_SET(reg,val) (reg) = ((reg & ~IFX_ASC_EOMCON_TRV) | (((val) & 0xff) << 16))
/* Receive Interrupt Enable (10) */
#define IFX_ASC_EOMCON_RIEN   (0x1 << 10)
#define IFX_ASC_EOMCON_RIEN_VAL(val)   (((val) & 0x1) << 10)
#define IFX_ASC_EOMCON_RIEN_GET(val)   ((((val) & IFX_ASC_EOMCON_RIEN) >> 10) & 0x1)
#define IFX_ASC_EOMCON_RIEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_EOMCON_RIEN) | (((val) & 0x1) << 10))
/* Compare Dont Care (9) */
#define IFX_ASC_EOMCON_CMPDC   (0x1 << 9)
#define IFX_ASC_EOMCON_CMPDC_VAL(val)   (((val) & 0x1) << 9)
#define IFX_ASC_EOMCON_CMPDC_GET(val)   ((((val) & IFX_ASC_EOMCON_CMPDC) >> 9) & 0x1)
#define IFX_ASC_EOMCON_CMPDC_SET(reg,val) (reg) = ((reg & ~IFX_ASC_EOMCON_CMPDC) | (((val) & 0x1) << 9))
/* Compare Enable (8) */
#define IFX_ASC_EOMCON_CMPEN   (0x1 << 8)
#define IFX_ASC_EOMCON_CMPEN_VAL(val)   (((val) & 0x1) << 8)
#define IFX_ASC_EOMCON_CMPEN_GET(val)   ((((val) & IFX_ASC_EOMCON_CMPEN) >> 8) & 0x1)
#define IFX_ASC_EOMCON_CMPEN_SET(reg,val) (reg) = ((reg & ~IFX_ASC_EOMCON_CMPEN) | (((val) & 0x1) << 8))
/* Compare Value (7:0) */
#define IFX_ASC_EOMCON_CMP   (0xff)
#define IFX_ASC_EOMCON_CMP_VAL(val)   (((val) & 0xff) << 0)
#define IFX_ASC_EOMCON_CMP_GET(val)   ((((val) & IFX_ASC_EOMCON_CMP) >> 0) & 0xff)
#define IFX_ASC_EOMCON_CMP_SET(reg,val) (reg) = ((reg & ~IFX_ASC_EOMCON_CMP) | (((val) & 0xff) << 0))

/*******************************************************************************
 * DMA_CON Register
 ******************************************************************************/

/* Receive Class (3:2) */
#define IFX_ASC_DMA_CON_RXCLS   (0x3 << 2)
#define IFX_ASC_DMA_CON_RXCLS_VAL(val)   (((val) & 0x3) << 2)
#define IFX_ASC_DMA_CON_RXCLS_GET(val)   ((((val) & IFX_ASC_DMA_CON_RXCLS) >> 2) & 0x3)
#define IFX_ASC_DMA_CON_RXCLS_SET(reg,val) (reg) = ((reg & ~IFX_ASC_DMA_CON_RXCLS) | (((val) & 0x3) << 2))
/* Transmit Path On (1) */
#define IFX_ASC_DMA_CON_TXON   (0x1 << 1)
#define IFX_ASC_DMA_CON_TXON_VAL(val)   (((val) & 0x1) << 1)
#define IFX_ASC_DMA_CON_TXON_GET(val)   ((((val) & IFX_ASC_DMA_CON_TXON) >> 1) & 0x1)
#define IFX_ASC_DMA_CON_TXON_SET(reg,val) (reg) = ((reg & ~IFX_ASC_DMA_CON_TXON) | (((val) & 0x1) << 1))
/* Receive Path On (0) */
#define IFX_ASC_DMA_CON_RXON   (0x1)
#define IFX_ASC_DMA_CON_RXON_VAL(val)   (((val) & 0x1) << 0)
#define IFX_ASC_DMA_CON_RXON_GET(val)   ((((val) & IFX_ASC_DMA_CON_RXON) >> 0) & 0x1)
#define IFX_ASC_DMA_CON_RXON_SET(reg,val) (reg) = ((reg & ~IFX_ASC_DMA_CON_RXON) | (((val) & 0x1) << 0))

/*******************************************************************************
 * ASC_IRNEN Register
 ******************************************************************************/

/* Soft Flow Control Interrupt Enable (7) */
#define IFX_ASC_IRNEN_SFC   (0x1 << 7)
#define IFX_ASC_IRNEN_SFC_VAL(val)   (((val) & 0x1) << 7)
#define IFX_ASC_IRNEN_SFC_GET(val)   ((((val) & IFX_ASC_IRNEN_SFC) >> 7) & 0x1)
#define IFX_ASC_IRNEN_SFC_SET(reg,val) (reg) = ((reg & ~IFX_ASC_IRNEN_SFC) | (((val) & 0x1) << 7))
/* Modem Status Interrupt Enable (6) */
#define IFX_ASC_IRNEN_MS   (0x1 << 6)
#define IFX_ASC_IRNEN_MS_VAL(val)   (((val) & 0x1) << 6)
#define IFX_ASC_IRNEN_MS_GET(val)   ((((val) & IFX_ASC_IRNEN_MS) >> 6) & 0x1)
#define IFX_ASC_IRNEN_MS_SET(reg,val) (reg) = ((reg & ~IFX_ASC_IRNEN_MS) | (((val) & 0x1) << 6))
/* Autobaud Detection End Interrupt Enable (5) */
#define IFX_ASC_IRNEN_ABDET   (0x1 << 5)
#define IFX_ASC_IRNEN_ABDET_VAL(val)   (((val) & 0x1) << 5)
#define IFX_ASC_IRNEN_ABDET_GET(val)   ((((val) & IFX_ASC_IRNEN_ABDET) >> 5) & 0x1)
#define IFX_ASC_IRNEN_ABDET_SET(reg,val) (reg) = ((reg & ~IFX_ASC_IRNEN_ABDET) | (((val) & 0x1) << 5))
/* Autobaud Detection Start Interrupt Enable (4) */
#define IFX_ASC_IRNEN_ABST   (0x1 << 4)
#define IFX_ASC_IRNEN_ABST_VAL(val)   (((val) & 0x1) << 4)
#define IFX_ASC_IRNEN_ABST_GET(val)   ((((val) & IFX_ASC_IRNEN_ABST) >> 4) & 0x1)
#define IFX_ASC_IRNEN_ABST_SET(reg,val) (reg) = ((reg & ~IFX_ASC_IRNEN_ABST) | (((val) & 0x1) << 4))
/* Transmit Buffer Interrupt Enable (3) */
#define IFX_ASC_IRNEN_TB   (0x1 << 3)
#define IFX_ASC_IRNEN_TB_VAL(val)   (((val) & 0x1) << 3)
#define IFX_ASC_IRNEN_TB_GET(val)   ((((val) & IFX_ASC_IRNEN_TB) >> 3) & 0x1)
#define IFX_ASC_IRNEN_TB_SET(reg,val) (reg) = ((reg & ~IFX_ASC_IRNEN_TB) | (((val) & 0x1) << 3))
/* Error Interrupt Request Enable (2) */
#define IFX_ASC_IRNEN_E   (0x1 << 2)
#define IFX_ASC_IRNEN_E_VAL(val)   (((val) & 0x1) << 2)
#define IFX_ASC_IRNEN_E_GET(val)   ((((val) & IFX_ASC_IRNEN_E) >> 2) & 0x1)
#define IFX_ASC_IRNEN_E_SET(reg,val) (reg) = ((reg & ~IFX_ASC_IRNEN_E) | (((val) & 0x1) << 2))
/* Receive Interrupt Request Enable (1) */
#define IFX_ASC_IRNEN_R   (0x1 << 1)
#define IFX_ASC_IRNEN_R_VAL(val)   (((val) & 0x1) << 1)
#define IFX_ASC_IRNEN_R_GET(val)   ((((val) & IFX_ASC_IRNEN_R) >> 1) & 0x1)
#define IFX_ASC_IRNEN_R_SET(reg,val) (reg) = ((reg & ~IFX_ASC_IRNEN_R) | (((val) & 0x1) << 1))
/* Transmit Interrupt Request Enable (0) */
#define IFX_ASC_IRNEN_T   (0x1)
#define IFX_ASC_IRNEN_T_VAL(val)   (((val) & 0x1) << 0)
#define IFX_ASC_IRNEN_T_GET(val)   ((((val) & IFX_ASC_IRNEN_T) >> 0) & 0x1)
#define IFX_ASC_IRNEN_T_SET(reg,val) (reg) = ((reg & ~IFX_ASC_IRNEN_T) | (((val) & 0x1) << 0))

/*******************************************************************************
 * ASC_IRNICR Register
 ******************************************************************************/

/* Soft Flow Control Interrupt Request (7) */
#define IFX_ASC_IRNICR_SFC   (0x1 << 7)
#define IFX_ASC_IRNICR_SFC_GET(val)   ((((val) & IFX_ASC_IRNICR_SFC) >> 7) & 0x1)
/* Modem Status Interrupt Request (6) */
#define IFX_ASC_IRNICR_MS   (0x1 << 6)
#define IFX_ASC_IRNICR_MS_GET(val)   ((((val) & IFX_ASC_IRNICR_MS) >> 6) & 0x1)
/* Autobaud Detection End Interrupt Request (5) */
#define IFX_ASC_IRNICR_ABDET   (0x1 << 5)
#define IFX_ASC_IRNICR_ABDET_GET(val)   ((((val) & IFX_ASC_IRNICR_ABDET) >> 5) & 0x1)
/* Autobaud Detection Start Interrupt Request (4) */
#define IFX_ASC_IRNICR_ABST   (0x1 << 4)
#define IFX_ASC_IRNICR_ABST_GET(val)   ((((val) & IFX_ASC_IRNICR_ABST) >> 4) & 0x1)
/* Transmit Buffer Interrupt Request (3) */
#define IFX_ASC_IRNICR_TB   (0x1 << 3)
#define IFX_ASC_IRNICR_TB_GET(val)   ((((val) & IFX_ASC_IRNICR_TB) >> 3) & 0x1)
/* Error Interrupt Request (2) */
#define IFX_ASC_IRNICR_E   (0x1 << 2)
#define IFX_ASC_IRNICR_E_GET(val)   ((((val) & IFX_ASC_IRNICR_E) >> 2) & 0x1)
/* Receive Interrupt Request (1) */
#define IFX_ASC_IRNICR_R   (0x1 << 1)
#define IFX_ASC_IRNICR_R_GET(val)   ((((val) & IFX_ASC_IRNICR_R) >> 1) & 0x1)
/* Transmit Interrupt Request (0) */
#define IFX_ASC_IRNICR_T   (0x1)
#define IFX_ASC_IRNICR_T_GET(val)   ((((val) & IFX_ASC_IRNICR_T) >> 0) & 0x1)

/*******************************************************************************
 * ASC_IRNCR Register
 ******************************************************************************/

/* Soft Flow Control Interrupt (7) */
#define IFX_ASC_IRNCR_SFC   (0x1 << 7)
#define IFX_ASC_IRNCR_SFC_GET(val)   ((((val) & IFX_ASC_IRNCR_SFC) >> 7) & 0x1)
/* Modem Status Interrupt (6) */
#define IFX_ASC_IRNCR_MS   (0x1 << 6)
#define IFX_ASC_IRNCR_MS_GET(val)   ((((val) & IFX_ASC_IRNCR_MS) >> 6) & 0x1)
/* Autobaud Detection End Interrupt (5) */
#define IFX_ASC_IRNCR_ABDET   (0x1 << 5)
#define IFX_ASC_IRNCR_ABDET_GET(val)   ((((val) & IFX_ASC_IRNCR_ABDET) >> 5) & 0x1)
/* Autobaud Detection Start Interrupt (4) */
#define IFX_ASC_IRNCR_ABST   (0x1 << 4)
#define IFX_ASC_IRNCR_ABST_GET(val)   ((((val) & IFX_ASC_IRNCR_ABST) >> 4) & 0x1)
/* Transmit Buffer Interrupt (3) */
#define IFX_ASC_IRNCR_TB   (0x1 << 3)
#define IFX_ASC_IRNCR_TB_GET(val)   ((((val) & IFX_ASC_IRNCR_TB) >> 3) & 0x1)
/* Error Interrupt (2) */
#define IFX_ASC_IRNCR_E   (0x1 << 2)
#define IFX_ASC_IRNCR_E_GET(val)   ((((val) & IFX_ASC_IRNCR_E) >> 2) & 0x1)
/* Receive Interrupt (1) */
#define IFX_ASC_IRNCR_R   (0x1 << 1)
#define IFX_ASC_IRNCR_R_GET(val)   ((((val) & IFX_ASC_IRNCR_R) >> 1) & 0x1)
/* Transmit Interrupt (0) */
#define IFX_ASC_IRNCR_T   (0x1)
#define IFX_ASC_IRNCR_T_GET(val)   ((((val) & IFX_ASC_IRNCR_T) >> 0) & 0x1)

#endif /* __IFX_ASC_H */
