/******************************************************************************

                            Copyright (c) 2007
                         Infineon Technologies AG
               St. Martin Strasse 53; 81669 Munich, Germany

  Any use of this Software is subject to the conclusion of a respective 
  License Agreement. Without such a License Agreement no rights to the
  Software are granted.

******************************************************************************/

#ifndef __IFX_BOOT_REG_H
#define __IFX_BOOT_REG_H

#define SPRAM_BOOT_OFFSET    0x0000

/* Offset for CPU1 (both CPUs have same register set) */
#define BOOT_BASE_ADDRESS   (IFX_L2_SPRAM_BASE + SPRAM_BOOT_OFFSET)
#define BOOT_CPU_OFFSET     0x20

#define CFG_CPU_COUNT 6

#ifdef __ASSEMBLY__
#define BOOT_RVEC          (BOOT_BASE_ADDRESS + 0x00)
#define BOOT_NVEC          (BOOT_BASE_ADDRESS + 0x04)
#define BOOT_EVEC          (BOOT_BASE_ADDRESS + 0x08)
#define BOOT_CP0_CAUSE     (BOOT_BASE_ADDRESS + 0x0C)
#define BOOT_CP0_EPC       (BOOT_BASE_ADDRESS + 0x10)
#define BOOT_CP0_EEPC      (BOOT_BASE_ADDRESS + 0x14)
#define BOOT_SIZE          (BOOT_BASE_ADDRESS + 0x18) /* only for CP1 */
#define BOOT_RCU_SR        (BOOT_BASE_ADDRESS + 0x18) /* only for CP0 */
#define BOOT_CFG_STAT      (BOOT_BASE_ADDRESS + 0x1C)

#else
#define BOOT_RVEC(cpu)         (volatile u32*)(BOOT_BASE_ADDRESS + (cpu * BOOT_CPU_OFFSET) + 0x00)
#define BOOT_NVEC(cpu)         (volatile u32*)(BOOT_BASE_ADDRESS + (cpu * BOOT_CPU_OFFSET) + 0x04)
#define BOOT_EVEC(cpu)         (volatile u32*)(BOOT_BASE_ADDRESS + (cpu * BOOT_CPU_OFFSET) + 0x08)
#define BOOT_CP0_STATUS(cpu)   (volatile u32*)(BOOT_BASE_ADDRESS + (cpu * BOOT_CPU_OFFSET) + 0x0C)
#define BOOT_CP0_EPC(cpu)      (volatile u32*)(BOOT_BASE_ADDRESS + (cpu * BOOT_CPU_OFFSET) + 0x10)
#define BOOT_CP0_EEPC(cpu)     (volatile u32*)(BOOT_BASE_ADDRESS + (cpu * BOOT_CPU_OFFSET) + 0x14)
#define BOOT_SIZE(cpu)         (volatile u32*)(BOOT_BASE_ADDRESS + (cpu * BOOT_CPU_OFFSET) + 0x18) /* only for CP1 */
#define BOOT_RCU_SR(cpu)       (volatile u32*)(BOOT_BASE_ADDRESS + (cpu * BOOT_CPU_OFFSET) + 0x18) /* only for CP0 */
#define BOOT_CFG_STAT(cpu)     (volatile u32*)(BOOT_BASE_ADDRESS + (cpu * BOOT_CPU_OFFSET) + 0x1C)
#endif

#endif /* #ifndef __IFX_BOOT_REG_H */
