/******************************************************************************

                            Copyright (c) 2007
                         Infineon Technologies AG
               St. Martin Strasse 53; 81669 Munich, Germany

  Any use of this Software is subject to the conclusion of a respective 
  License Agreement. Without such a License Agreement no rights to the
  Software are granted.

******************************************************************************/
#if 0 /* debug RMi */
#include <linux/config.h>
#endif
#ifdef CONFIG_SVIP
#include <asm/ifx/svip_reg_icu.h>
#endif

#ifndef __IFX_REG_ICU_H
#define __IFX_REG_ICU_H


/*******************************************************************************
 * ICU
 ******************************************************************************/
#define IFX_ICU_IM0_ISR                      ((volatile u32*)(IFX_ICU_BASE+ 0x0000))
#define IFX_ICU_IM0_IER                      ((volatile u32*)(IFX_ICU_BASE+ 0x0008))
#define IFX_ICU_IM0_IOSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x0010))
#define IFX_ICU_IM0_IRSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x0018))
#define IFX_ICU_IM0_IMR                      ((volatile u32*)(IFX_ICU_BASE+ 0x0020))
#define IFX_ICU_IM0_IMR_IID                  (1 << 31)
#define IFX_ICU_IM0_IMR_IN_GET(value)        (((value) >> 0) & ((1 << 5) - 1))
#define IFX_ICU_IM0_IMR_IN_SET(value)        (((( 1 << 5) - 1) & (value)) << 0)
#define IFX_ICU_IM0_IR(value)                (1 << (value))

#define IFX_ICU_IM1_ISR                      ((volatile u32*)(IFX_ICU_BASE+ 0x0028))
#define IFX_ICU_IM1_IER                      ((volatile u32*)(IFX_ICU_BASE+ 0x0030))
#define IFX_ICU_IM1_IOSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x0038))
#define IFX_ICU_IM1_IRSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x0040))
#define IFX_ICU_IM1_IMR                      ((volatile u32*)(IFX_ICU_BASE+ 0x0048))
#define IFX_ICU_IM1_IMR_IID                  (1 << 31)
#define IFX_ICU_IM1_IMR_IN_GET(value)        (((value) >> 0) & ((1 << 5) - 1))
#define IFX_ICU_IM1_IMR_IN_SET(value)        (((( 1 << 5) - 1) & (value)) << 0)
#define IFX_ICU_IM1_IR(value)                (1 << (value))

#define IFX_ICU_IM2_ISR                      ((volatile u32*)(IFX_ICU_BASE+ 0x0050))
#define IFX_ICU_IM2_IER                      ((volatile u32*)(IFX_ICU_BASE+ 0x0058))
#define IFX_ICU_IM2_IOSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x0060))
#define IFX_ICU_IM2_IRSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x0068))
#define IFX_ICU_IM2_IMR                      ((volatile u32*)(IFX_ICU_BASE+ 0x0070))
#define IFX_ICU_IM2_IMR_IID                  (1 << 31)
#define IFX_ICU_IM2_IMR_IN_GET(value)        (((value) >> 0) & ((1 << 5) - 1))
#define IFX_ICU_IM2_IMR_IN_SET(value)        (((( 1 << 5) - 1) & (value)) << 0)
#define IFX_ICU_IM2_IR(value)                (1 << (value))

#define IFX_ICU_IM3_ISR                      ((volatile u32*)(IFX_ICU_BASE+ 0x0078))
#define IFX_ICU_IM3_IER                      ((volatile u32*)(IFX_ICU_BASE+ 0x0080))
#define IFX_ICU_IM3_IOSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x0088))
#define IFX_ICU_IM3_IRSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x0090))
#define IFX_ICU_IM3_IMR                      ((volatile u32*)(IFX_ICU_BASE+ 0x0098))
#define IFX_ICU_IM3_IMR_IID                  (1 << 31)
#define IFX_ICU_IM3_IMR_IN_GET(value)        (((value) >> 0) & ((1 << 5) - 1))
#define IFX_ICU_IM3_IMR_IN_SET(value)        (((( 1 << 5) - 1) & (value)) << 0)
#define IFX_ICU_IM3_IR(value)                (1 << (value))

#define IFX_ICU_IM4_ISR                      ((volatile u32*)(IFX_ICU_BASE+ 0x00A0))
#define IFX_ICU_IM4_IER                      ((volatile u32*)(IFX_ICU_BASE+ 0x00A8))
#define IFX_ICU_IM4_IOSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x00B0))
#define IFX_ICU_IM4_IRSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x00B8))
#define IFX_ICU_IM4_IMR                      ((volatile u32*)(IFX_ICU_BASE+ 0x00C0))
#define IFX_ICU_IM4_IMR_IID                  (1 << 31)
#define IFX_ICU_IM4_IMR_IN_GET(value)        (((value) >> 0) & ((1 << 5) - 1))
#define IFX_ICU_IM4_IMR_IN_SET(value)        (((( 1 << 5) - 1) & (value)) << 0)
#define IFX_ICU_IM4_IR(value)                (1 << (value))

#define IFX_ICU_IM5_ISR                      ((volatile u32*)(IFX_ICU_BASE+ 0x00C8))
#define IFX_ICU_IM5_IER                      ((volatile u32*)(IFX_ICU_BASE+ 0x00D0))
#define IFX_ICU_IM5_IOSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x00D8))
#define IFX_ICU_IM5_IRSR                     ((volatile u32*)(IFX_ICU_BASE+ 0x00E0))
#define IFX_ICU_IM5_IMR                      ((volatile u32*)(IFX_ICU_BASE+ 0x00E8))
#define IFX_ICU_IM5_IMR_IID                  (1 << 31)
#define IFX_ICU_IM5_IMR_IN_GET(value)        (((value) >> 0) & ((1 << 5) - 1))
#define IFX_ICU_IM5_IMR_IN_SET(value)        (((( 1 << 5) - 1) & (value)) << 0)
#define IFX_ICU_IM5_IR(value)                (1 << (value))

#endif /* __IFX_REG_ICU_H */

