/******************************************************************************

                            Copyright (c) 2007
                         Infineon Technologies AG
               St. Martin Strasse 53; 81669 Munich, Germany

  Any use of this Software is subject to the conclusion of a respective 
  License Agreement. Without such a License Agreement no rights to the
  Software are granted.

******************************************************************************/


#ifndef __IFX_REG_MPS_H
#define __IFX_REG_MPS_H


/*******************************************************************************
 * MPS
 ******************************************************************************/
typedef struct _ifx_mps_reg {
	volatile unsigned long  mps_swirn0set;  /*  0x0000 */
	volatile unsigned long  mps_swirn0en;  /*  0x0004 */
	volatile unsigned long  mps_swirn0cr;  /*  0x0008 */
	volatile unsigned long  mps_swirn0icr;  /*  0x000C */
	volatile unsigned long  mps_swirn1set;  /*  0x0010 */
	volatile unsigned long  mps_swirn1en;  /*  0x0014 */
	volatile unsigned long  mps_swirn1cr;  /*  0x0018 */
	volatile unsigned long  mps_swirn1icr;  /*  0x001C */
	volatile unsigned long  mps_swirn2set;  /*  0x0020 */
	volatile unsigned long  mps_swirn2en;  /*  0x0024 */
	volatile unsigned long  mps_swirn2cr;  /*  0x0028 */
	volatile unsigned long  mps_swirn2icr;  /*  0x002C */
	volatile unsigned long  mps_swirn3set;  /*  0x0030 */
	volatile unsigned long  mps_swirn3en;  /*  0x0034 */
	volatile unsigned long  mps_swirn3cr;  /*  0x0038 */
	volatile unsigned long  mps_swirn3icr;  /*  0x003C */
	volatile unsigned long  mps_swirn4set;  /*  0x0040 */
	volatile unsigned long  mps_swirn4en;  /*  0x0044 */
	volatile unsigned long  mps_swirn4cr;  /*  0x0048 */
	volatile unsigned long  mps_swirn4icr;  /*  0x004C */
	volatile unsigned long  mps_swirn5set;  /*  0x0050 */
	volatile unsigned long  mps_swirn5en;  /*  0x0054 */
	volatile unsigned long  mps_swirn5cr;  /*  0x0058 */
	volatile unsigned long  mps_swirn5icr;  /*  0x005C */
	volatile unsigned long  mps_swirn6set;  /*  0x0060 */
	volatile unsigned long  mps_swirn6en;  /*  0x0064 */
	volatile unsigned long  mps_swirn6cr;  /*  0x0068 */
	volatile unsigned long  mps_swirn6icr;  /*  0x006C */
	volatile unsigned long  mps_swirn7set;  /*  0x0070 */
	volatile unsigned long  mps_swirn7en;  /*  0x0074 */
	volatile unsigned long  mps_swirn7cr;  /*  0x0078 */
	volatile unsigned long  mps_swirn7icr;  /*  0x007C */
	volatile unsigned long  mps_swirn8set;  /*  0x0080 */
	volatile unsigned long  mps_swirn8en;  /*  0x0084 */
	volatile unsigned long  mps_swirn8cr;  /*  0x0088 */
	volatile unsigned long  mps_swirn8icr;  /*  0x008C */
} ifx_mps_reg;

/*******************************************************************************
 * MPS
 ******************************************************************************/
/* Multiprocessor Binary Semaphore */
#define IFX_MPS_MBSR0   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0010))
#define IFX_MPS_MBSR1   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0014))
#define IFX_MPS_MBSR2   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0018))
#define IFX_MPS_MBSR3   ((unsigned volatile int*)(IFX_MBS_BASE + 0x001C))
#define IFX_MPS_MBSR4   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0020))
#define IFX_MPS_MBSR5   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0024))
#define IFX_MPS_MBSR6   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0028))
#define IFX_MPS_MBSR7   ((unsigned volatile int*)(IFX_MBS_BASE + 0x002C))
#define IFX_MPS_MBSR8   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0030))
#define IFX_MPS_MBSR9   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0034))
#define IFX_MPS_MBSR10   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0038))
#define IFX_MPS_MBSR11   ((unsigned volatile int*)(IFX_MBS_BASE + 0x003C))
#define IFX_MPS_MBSR12   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0040))
#define IFX_MPS_MBSR13   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0044))
#define IFX_MPS_MBSR14   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0048))
#define IFX_MPS_MBSR15   ((unsigned volatile int*)(IFX_MBS_BASE + 0x004C))
#define IFX_MPS_MBSR16   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0050))
#define IFX_MPS_MBSR17   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0054))
#define IFX_MPS_MBSR18   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0058))
#define IFX_MPS_MBSR19   ((unsigned volatile int*)(IFX_MBS_BASE + 0x005C))
#define IFX_MPS_MBSR20   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0060))
#define IFX_MPS_MBSR21   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0064))
#define IFX_MPS_MBSR22   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0068))
#define IFX_MPS_MBSR23   ((unsigned volatile int*)(IFX_MBS_BASE + 0x006C))
#define IFX_MPS_MBSR24   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0070))
#define IFX_MPS_MBSR25   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0074))
#define IFX_MPS_MBSR26   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0078))
#define IFX_MPS_MBSR27   ((unsigned volatile int*)(IFX_MBS_BASE + 0x007C))
#define IFX_MPS_MBSR28   ((unsigned volatile int*)(IFX_MBS_BASE + 0x0080))

/* Software Interrupt */
#define IFX_MPS_SWIRN0SET   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0000))
#define IFX_MPS_SWIRN0EN   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0004))
#define IFX_MPS_SWIRN0CR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0008))
#define IFX_MPS_SWIRN0ICR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x000C))
#define IFX_MPS_SWIRN1SET   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0010))
#define IFX_MPS_SWIRN1EN   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0014))
#define IFX_MPS_SWIRN1CR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0018))
#define IFX_MPS_SWIRN1ICR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x001C))
#define IFX_MPS_SWIRN2SET   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0020))
#define IFX_MPS_SWIRN2EN   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0024))
#define IFX_MPS_SWIRN2CR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0028))
#define IFX_MPS_SWIRN2ICR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x002C))
#define IFX_MPS_SWIRN3SET   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0030))
#define IFX_MPS_SWIRN3EN   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0034))
#define IFX_MPS_SWIRN3CR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0038))
#define IFX_MPS_SWIRN3ICR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x003C))
#define IFX_MPS_SWIRN4SET   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0040))
#define IFX_MPS_SWIRN4EN   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0044))
#define IFX_MPS_SWIRN4CR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0048))
#define IFX_MPS_SWIRN4ICR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x004C))
#define IFX_MPS_SWIRN5SET   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0050))
#define IFX_MPS_SWIRN5EN   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0054))
#define IFX_MPS_SWIRN5CR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0058))
#define IFX_MPS_SWIRN5ICR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x005C))
#define IFX_MPS_SWIRN6SET   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0060))
#define IFX_MPS_SWIRN6EN   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0064))
#define IFX_MPS_SWIRN6CR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0068))
#define IFX_MPS_SWIRN6ICR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x006C))
#define IFX_MPS_SWIRN7SET   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0070))
#define IFX_MPS_SWIRN7EN   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0074))
#define IFX_MPS_SWIRN7CR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0078))
#define IFX_MPS_SWIRN7ICR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x007C))
#define IFX_MPS_SWIRN8SET   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0080))
#define IFX_MPS_SWIRN8EN   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0084))
#define IFX_MPS_SWIRN8ICR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x008C))
#define IFX_MPS_SWIRN8CR   ((volatile unsigned int*)(IFX_SWINT_BASE + 0x0088))

/*******************************************************************************
 * MPS_SWIRNSET Register
 ******************************************************************************/

/* Software Interrupt Request IR5 (5) */
#define IFX_MPS_SWIRNSET_IR5   (0x1 << 5)
#define IFX_MPS_SWIRNSET_IR5_VAL(val)   (((val) & 0x1) << 5)
#define IFX_MPS_SWIRNSET_IR5_SET(reg,val) (reg) = (((reg & ~IFX_MPS_SWIRNSET_IR5) | (val) & 1) << 5)
/* Software Interrupt Request IR4 (4) */
#define IFX_MPS_SWIRNSET_IR4   (0x1 << 4)
#define IFX_MPS_SWIRNSET_IR4_VAL(val)   (((val) & 0x1) << 4)
#define IFX_MPS_SWIRNSET_IR4_SET(reg,val) (reg) = (((reg & ~IFX_MPS_SWIRNSET_IR4) | (val) & 1) << 4)
/* Software Interrupt Request IR3 (3) */
#define IFX_MPS_SWIRNSET_IR3   (0x1 << 3)
#define IFX_MPS_SWIRNSET_IR3_VAL(val)   (((val) & 0x1) << 3)
#define IFX_MPS_SWIRNSET_IR3_SET(reg,val) (reg) = (((reg & ~IFX_MPS_SWIRNSET_IR3) | (val) & 1) << 3)
/* Software Interrupt Request IR2 (2) */
#define IFX_MPS_SWIRNSET_IR2   (0x1 << 2)
#define IFX_MPS_SWIRNSET_IR2_VAL(val)   (((val) & 0x1) << 2)
#define IFX_MPS_SWIRNSET_IR2_SET(reg,val) (reg) = (((reg & ~IFX_MPS_SWIRNSET_IR2) | (val) & 1) << 2)
/* Software Interrupt Request IR1 (1) */
#define IFX_MPS_SWIRNSET_IR1   (0x1 << 1)
#define IFX_MPS_SWIRNSET_IR1_VAL(val)   (((val) & 0x1) << 1)
#define IFX_MPS_SWIRNSET_IR1_SET(reg,val) (reg) = (((reg & ~IFX_MPS_SWIRNSET_IR1) | (val) & 1) << 1)
/* Software Interrupt Request IR0 (0) */
#define IFX_MPS_SWIRNSET_IR0   (0x1)
#define IFX_MPS_SWIRNSET_IR0_VAL(val)   (((val) & 0x1) << 0)
#define IFX_MPS_SWIRNSET_IR0_SET(reg,val) (reg) = (((reg & ~IFX_MPS_SWIRNSET_IR0) | (val) & 1) << 0)

/*******************************************************************************
 * MPS_SWIRNEN Register
 ******************************************************************************/

/* Software Interrupt Request IR5 (5) */
#define IFX_MPS_SWIRNEN_IR5   (0x1 << 5)
#define IFX_MPS_SWIRNEN_IR5_VAL(val)   (((val) & 0x1) << 5)
#define IFX_MPS_SWIRNEN_IR5_GET(val)   ((((val) & IFX_MPS_SWIRNEN_IR5) >> 5) & 0x1)
#define IFX_MPS_SWIRNEN_IR5_SET(reg,val) (reg) = ((reg & ~IFX_MPS_SWIRNEN_IR5) | (((val) & 0x1) << 5))
/* Software Interrupt Request IR4 (4) */
#define IFX_MPS_SWIRNEN_IR4   (0x1 << 4)
#define IFX_MPS_SWIRNEN_IR4_VAL(val)   (((val) & 0x1) << 4)
#define IFX_MPS_SWIRNEN_IR4_GET(val)   ((((val) & IFX_MPS_SWIRNEN_IR4) >> 4) & 0x1)
#define IFX_MPS_SWIRNEN_IR4_SET(reg,val) (reg) = ((reg & ~IFX_MPS_SWIRNEN_IR4) | (((val) & 0x1) << 4))
/* Software Interrupt Request IR3 (3) */
#define IFX_MPS_SWIRNEN_IR3   (0x1 << 3)
#define IFX_MPS_SWIRNEN_IR3_VAL(val)   (((val) & 0x1) << 3)
#define IFX_MPS_SWIRNEN_IR3_GET(val)   ((((val) & IFX_MPS_SWIRNEN_IR3) >> 3) & 0x1)
#define IFX_MPS_SWIRNEN_IR3_SET(reg,val) (reg) = ((reg & ~IFX_MPS_SWIRNEN_IR3) | (((val) & 0x1) << 3))
/* Software Interrupt Request IR2 (2) */
#define IFX_MPS_SWIRNEN_IR2   (0x1 << 2)
#define IFX_MPS_SWIRNEN_IR2_VAL(val)   (((val) & 0x1) << 2)
#define IFX_MPS_SWIRNEN_IR2_GET(val)   ((((val) & IFX_MPS_SWIRNEN_IR2) >> 2) & 0x1)
#define IFX_MPS_SWIRNEN_IR2_SET(reg,val) (reg) = ((reg & ~IFX_MPS_SWIRNEN_IR2) | (((val) & 0x1) << 2))
/* Software Interrupt Request IR1 (1) */
#define IFX_MPS_SWIRNEN_IR1   (0x1 << 1)
#define IFX_MPS_SWIRNEN_IR1_VAL(val)   (((val) & 0x1) << 1)
#define IFX_MPS_SWIRNEN_IR1_GET(val)   ((((val) & IFX_MPS_SWIRNEN_IR1) >> 1) & 0x1)
#define IFX_MPS_SWIRNEN_IR1_SET(reg,val) (reg) = ((reg & ~IFX_MPS_SWIRNEN_IR1) | (((val) & 0x1) << 1))
/* Software Interrupt Request IR0 (0) */
#define IFX_MPS_SWIRNEN_IR0   (0x1)
#define IFX_MPS_SWIRNEN_IR0_VAL(val)   (((val) & 0x1) << 0)
#define IFX_MPS_SWIRNEN_IR0_GET(val)   ((((val) & IFX_MPS_SWIRNEN_IR0) >> 0) & 0x1)
#define IFX_MPS_SWIRNEN_IR0_SET(reg,val) (reg) = ((reg & ~IFX_MPS_SWIRNEN_IR0) | (((val) & 0x1) << 0))

/*******************************************************************************
 * MPS_SWIRNICR Register
 ******************************************************************************/

/* Software Interrupt Request IR5 (5) */
#define IFX_MPS_SWIRNICR_IR5   (0x1 << 5)
#define IFX_MPS_SWIRNICR_IR5_GET(val)   ((((val) & IFX_MPS_SWIRNICR_IR5) >> 5) & 0x1)
/* Software Interrupt Request IR4 (4) */
#define IFX_MPS_SWIRNICR_IR4   (0x1 << 4)
#define IFX_MPS_SWIRNICR_IR4_GET(val)   ((((val) & IFX_MPS_SWIRNICR_IR4) >> 4) & 0x1)
/* Software Interrupt Request IR3 (3) */
#define IFX_MPS_SWIRNICR_IR3   (0x1 << 3)
#define IFX_MPS_SWIRNICR_IR3_GET(val)   ((((val) & IFX_MPS_SWIRNICR_IR3) >> 3) & 0x1)
/* Software Interrupt Request IR2 (2) */
#define IFX_MPS_SWIRNICR_IR2   (0x1 << 2)
#define IFX_MPS_SWIRNICR_IR2_GET(val)   ((((val) & IFX_MPS_SWIRNICR_IR2) >> 2) & 0x1)
/* Software Interrupt Request IR1 (1) */
#define IFX_MPS_SWIRNICR_IR1   (0x1 << 1)
#define IFX_MPS_SWIRNICR_IR1_GET(val)   ((((val) & IFX_MPS_SWIRNICR_IR1) >> 1) & 0x1)
/* Software Interrupt Request IR0 (0) */
#define IFX_MPS_SWIRNICR_IR0   (0x1)
#define IFX_MPS_SWIRNICR_IR0_GET(val)   ((((val) & IFX_MPS_SWIRNICR_IR0) >> 0) & 0x1)

/*******************************************************************************
 * MPS_SWIRNCR Register
 ******************************************************************************/

/* Software Interrupt Request IR5 (5) */
#define IFX_MPS_SWIRNCR_IR5   (0x1 << 5)
#define IFX_MPS_SWIRNCR_IR5_GET(val)   ((((val) & IFX_MPS_SWIRNCR_IR5) >> 5) & 0x1)
/* Software Interrupt Request IR4 (4) */
#define IFX_MPS_SWIRNCR_IR4   (0x1 << 4)
#define IFX_MPS_SWIRNCR_IR4_GET(val)   ((((val) & IFX_MPS_SWIRNCR_IR4) >> 4) & 0x1)
/* Software Interrupt Request IR3 (3) */
#define IFX_MPS_SWIRNCR_IR3   (0x1 << 3)
#define IFX_MPS_SWIRNCR_IR3_GET(val)   ((((val) & IFX_MPS_SWIRNCR_IR3) >> 3) & 0x1)
/* Software Interrupt Request IR2 (2) */
#define IFX_MPS_SWIRNCR_IR2   (0x1 << 2)
#define IFX_MPS_SWIRNCR_IR2_GET(val)   ((((val) & IFX_MPS_SWIRNCR_IR2) >> 2) & 0x1)
/* Software Interrupt Request IR1 (1) */
#define IFX_MPS_SWIRNCR_IR1   (0x1 << 1)
#define IFX_MPS_SWIRNCR_IR1_GET(val)   ((((val) & IFX_MPS_SWIRNCR_IR1) >> 1) & 0x1)
/* Software Interrupt Request IR0 (0) */
#define IFX_MPS_SWIRNCR_IR0   (0x1)
#define IFX_MPS_SWIRNCR_IR0_GET(val)   ((((val) & IFX_MPS_SWIRNCR_IR0) >> 0) & 0x1)

#endif /* __IFX_REG_MPS_H */

