/******************************************************************************

                            Copyright (c) 2007
                         Infineon Technologies AG
               St. Martin Strasse 53; 81669 Munich, Germany

  Any use of this Software is subject to the conclusion of a respective 
  License Agreement. Without such a License Agreement no rights to the
  Software are granted.

******************************************************************************/


#ifndef __IFX_NMI_H
#define __IFX_NMI_H


#ifndef __ASSEMBLY__
/*******************************************************************************
 * NMI
 ******************************************************************************/
typedef struct _ifx_nmi_reg {
	volatile unsigned long  cr0;  /*  0x0000 */
	volatile unsigned long  cr1;  /*  0x0004 */
	volatile unsigned long  cr2;  /*  0x0008 */
	volatile unsigned long  sr;   /*  0x000C */
} ifx_nmi_reg;

/*******************************************************************************
 * NMI
 ******************************************************************************/
#define IFX_NMI_CR0   ((volatile unsigned int*)(IFX_NMI_BASE + 0x0000))
#define IFX_NMI_CR1   ((volatile unsigned int*)(IFX_NMI_BASE + 0x0004))
#define IFX_NMI_CR2   ((volatile unsigned int*)(IFX_NMI_BASE + 0x0008))
#define IFX_NMI_SR    ((volatile unsigned int*)(IFX_NMI_BASE + 0x000C))

#else

/*******************************************************************************
 * NMI
 ******************************************************************************/
#define IFX_NMI_CR0     (IFX_NMI_BASE + 0x0000)
#define IFX_NMI_CR1     (IFX_NMI_BASE + 0x0004)
#define IFX_NMI_CR2     (IFX_NMI_BASE + 0x0008)
#define IFX_NMI_SR      (IFX_NMI_BASE + 0x000C)

#endif

/*******************************************************************************
 * NMI Status Register
 ******************************************************************************/

/* NMI GPTC */
#define IFX_NMI_SR_NMIGPTC   (0x1 << 1)
#define IFX_NMI_SR_NMIGPTC_GET(val)   ((((val) & IFX_NMI_SR_NMIGPTC) >> 1) & 0x1)
/* NMI External */
#define IFX_NMI_SR_NMIEXT   (0x1)
#define IFX_NMI_SR_NMIEXT_GET(val)   ((((val) & IFX_NMI_SR_NMIEXT) >> 0) & 0x1)


#endif /* __IFX_NMI_H */
