/******************************************************************************

                            Copyright (c) 2007
                         Infineon Technologies AG
               St. Martin Strasse 53; 81669 Munich, Germany

  Any use of this Software is subject to the conclusion of a respective 
  License Agreement. Without such a License Agreement no rights to the
  Software are granted.

******************************************************************************/


#ifndef __IFX_REG_WDT_H
#define __IFX_REG_WDT_H


/*******************************************************************************
 * WDT
 ******************************************************************************/
#define IFX_BIU_WDT_CR   ((volatile unsigned int*)(IFX_WDT_BASE + 0x0000))
#define IFX_BIU_WDT_SR   ((volatile unsigned int*)(IFX_WDT_BASE + 0x0008))

/*******************************************************************************
 * Watchdog Timer Control Register
 ******************************************************************************/
#define IFX_BIU_WDT_CR_GEN               (1 << 31)
#define IFX_BIU_WDT_CR_DSEN              (1 << 30)
#define IFX_BIU_WDT_CR_LPEN              (1 << 29)
#define IFX_BIU_WDT_CR_PWL_GET(value)    (((value) >> 26) & ((1 << 2) - 1))
#define IFX_BIU_WDT_CR_PWL_VAL(value)    (((( 1 << 2) - 1) & (value)) << 26)
#define IFX_BIU_WDT_CR_CLKDIV_GET(value) (((value) >> 24) & ((1 << 2) - 1))
#define IFX_BIU_WDT_CR_CLKDIV_VAL(value) (((( 1 << 2) - 1) & (value)) << 24)
#define IFX_BIU_WDT_CR_PW_GET(value)     (((value) >> 16) & ((1 << 8) - 1))
#define IFX_BIU_WDT_CR_PW_VAL(value)     (((( 1 << 8) - 1) & (value)) << 16)
#define IFX_BIU_WDT_CR_RELOAD_GET(value) (((value) >> 0) & ((1 << 16) - 1))
#define IFX_BIU_WDT_CR_RELOAD_VAL(value) (((( 1 << 16) - 1) & (value)) << 0)

/*******************************************************************************
 * Watchdog Timer Status Register
 ******************************************************************************/
#define IFX_BIU_WDT_SR_EN                (1 << 31)
#define IFX_BIU_WDT_SR_AE                (1 << 30)
#define IFX_BIU_WDT_SR_PRW               (1 << 29)
#define IFX_BIU_WDT_SR_EXP               (1 << 28)
#define IFX_BIU_WDT_SR_PWD               (1 << 27)
#define IFX_BIU_WDT_SR_DS                (1 << 26)
#define IFX_BIU_WDT_SR_VALUE_GET(value)  (((value) >> 0) & ((1 << 16) - 1))
#define IFX_BIU_WDT_SR_VALUE_VAL(value)  (((( 1 << 16) - 1) & (value)) << 0)


#endif /* __IFX_REG_WDT_H */
