/************************************************************************
 *
 * Copyright (c) 2007
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/


/***********************************************************************/
/*  Module      :  DMA register address and bits                       */
/***********************************************************************/

#define IFX_DMA				(KSEG1+0x14104000)
/***********************************************************************/
//ISR
/*
#define DMA_ISR_RDERR			0x20
#define DMA_ISR_CMDCPT			0x10
#define DMA_ISR_CPT			0x8
#define DMA_ISR_DURR			0x4
#define DMA_ISR_EOP			0x2
*/
#define DMA_DESC_BYTEOFF_SHIFT		23

#define DMA_POLLING_ENABLE		0x80000000
#define DMA_POLLING_CNT			0x50	/*minimum 0x10, max 0xfff0*/



/***********************************************************************/
/*  Module      :  Ethernet Switch register address and bits           */
/***********************************************************************/

#define IFX_SWITCH				(KSEG1+0x18000000)

/* PR Base address */
#define PR_BASE		(IFX_SWITCH + 0x00008000)

/* SE Base Address */
#define SE_BASE		(IFX_SWITCH + 0x00009000)

#define PR_CTRL_REG				(PR_BASE + 0x0000)
#define MA_LEARN_REG			(PR_BASE + 0x0004)
#define DST_LOOKUP_REG			(PR_BASE + 0x0008)

#define COS_SEL_REG				(PR_BASE + 0x000c)
#define PRI2_COS_REG			(PR_BASE + 0x0010)
#define UNKNOWN_DEST_REG		(PR_BASE + 0x0014)

#define CPU_ACS_CTRL_REG		(PR_BASE + 0x0018)
#define CPU_ACS_DATA_REG		(PR_BASE + 0x001c)

#define MA_READ_REG				(PR_BASE + 0x0020)
#define TB_CTRL_REG				(PR_BASE + 0x0024)
#define RATE_REG				(PR_BASE + 0x0028)
#define BURST_REG				(PR_BASE + 0x0048)
#define EBURST_REG				(PR_BASE + 0x0068)

#define RULE_SEL_REG			(PR_BASE + 0x0088)

#define GEN_SFT_AGE_STB         (PR_BASE + 0x008C)
#define PR_ISR_REG				(PR_BASE + 0x0090)
#define PR_IMR_REG				(PR_BASE + 0x0094)
#define PR_IPR_REG				(PR_BASE + 0x0098)
//#define BPDU_REG				(PR_BASE + 0x00A4)


/*	Switching Engine Register Description	*/
//#define QLL_CMD_REG				(SE_BASE)
//#define QLL_DATA_REG0			(SE_BASE + 0x0004)
//#define QLL_DATA_REG1			(SE_BASE + 0x0008)

#define VLAN_MIBS_CMD_REG		(SE_BASE + 0x000c)
#define VLAN_MIBS_DATA_REG		(SE_BASE + 0x0010)

#define SD_CMD_REG				(SE_BASE + 0x0014)
#define SD_DATA_REGS0			(SE_BASE + 0x0018)
#define SD_DATA_REGS1			(SE_BASE + 0x001C)
#define SD_DATA_REGS2			(SE_BASE + 0x0020)

#define VLAN_TBL_CMD_REG		(SE_BASE + 0x0024)
#define VLAN_TBL_DATA_REG		(SE_BASE + 0x0028)

//#define FD_TBL_CMD_REG			(SE_BASE + 0x002c)
//#define FD_TBL_DATA_REG			(SE_BASE + 0x0030)

#define SYMM_VLAN_REG			(SE_BASE + 0x0038)
#define PORT_AUTH				(SE_BASE + 0x0048)
#define CPU_LINK_OK_REG	(SE_BASE + 0x0050)
/* #define TRUNK_CTRL_REGS			(SE_BASE + 0x0054)  */
#define MIRROR_PORT_REG			(SE_BASE + 0x0064)

#define ST_PT_REG				(SE_BASE + 0x0068)
#define JUMBO_ENABLE_REG		(SE_BASE + 0x006C)
#define STACK_PORT_REG			(SE_BASE + 0x0074)
#define EG_MON_REG              (SE_BASE + 0x007C)
#define VR_MIB_REG		        (SE_BASE + 0x0080)
//#define QUEUE_CMD_REGS			(SE_BASE + 0x0090)

#define GLOBAL_RX_WM_REG		(SE_BASE + 0x0200)

#define PORT0_RX_WM_REG0		(SE_BASE + 0x021C)
#define PORT1_RX_WM_REG0		(SE_BASE + 0x0220)
#define PORT2_RX_WM_REG0		(SE_BASE + 0x0224)
#define PORT_RX_WM_REGS			PORT0_RX_WM_REG0
//#define PORT_RX_WM_REG0		    (SE_BASE + 0x021C)
//#define PORT_RX_WM_REG1		(SE_BASE + 0x0220)
//#define PORT_RX_WM_REG2		    (SE_BASE + 0x0224)



#define PORT0_TX_WM_REG0		(SE_BASE + 0x0330)
#define PORT1_TX_WM_REG0		(SE_BASE + 0x0338)
#define PORT2_TX_WM_REG0		(SE_BASE + 0x0340)
#define PORT0_TX_WM_REG1		(SE_BASE + 0x0334)
#define PORT1_TX_WM_REG1		(SE_BASE + 0x033C)
#define PORT2_TX_WM_REG1		(SE_BASE + 0x0344)
#define PORT_TX_WM_REGS			PORT0_TX_WM_REG0

//#define QUEUE_STATUS_REGS		(SE_BASE + 0x0400)

#define SE_INT_STS_REG			(SE_BASE + 0x08e0)
#define SE_INT_MSK_REG_RD	    (SE_BASE + 0x08e4)
#define SE_INT_MSK_REG_WR		(SE_BASE + 0x08e8)
#define SE_INT_PRI_REG_RD		(SE_BASE + 0x08ec)
#define SE_INT_PRI_REG_WR		(SE_BASE + 0x08f0)  /* address too be defined*/

/***********************************************************************/
/*  Module      :  Ethernet Switch port related addresses and bits     */
/***********************************************************************/
#define GPORT0_BASE				(KSEG1+0x18006000)
#define GPORT1_BASE				(KSEG1+0x18007000)
#define GPORT2_BASE				(KSEG1+0x1800C000)


#define PAUSE_CTL               (GPORT2_BASE + 0x00B0)

#define PORTREG_BASE GPORT0_BASE

#define SWITCH_P0_GMAC_REG (GPORT0_BASE + 0x0004)
#define SWITCH_P0_GMAC_CTRL (GPORT0_BASE + 0x000C)
#define SWITCH_P0_RTX_INT_STATUS (GPORT0_BASE + 0x0010)
#define SWITCH_P0_RTX_INT_MASK (GPORT0_BASE + 0x0014)
#define SWITCH_P0_INT_PRIORITY (GPORT0_BASE + 0x0018)
#define SWITCH_P0_MDIO_ID_1 (GPORT0_BASE + 0x00A8)

/* #define SWITCH_P0_MDIO_MOD_SEL (GPORT0_BASE + 0x00B4)  */
#define SWITCH_P0_MDIO_ACC_0 (GPORT0_BASE + 0x00B8)
#define SWITCH_P0_RX_CONF (GPORT0_BASE + 0x0400)
#define SWITCH_P0_OFFSET0_REG (GPORT0_BASE + 0x0404)
#define SWITCH_P0_OFFSET1_REG (GPORT0_BASE + 0x0408)
#define SWITCH_P0_PORT_MASK0_REG (GPORT0_BASE + 0x0420)
#define SWITCH_P0_PORT_MASK1_REG (GPORT0_BASE + 0x0424)
#define SWITCH_P0_PORT_MASK2_REG (GPORT0_BASE + 0x0428)
#define SWITCH_P0_PORT_MASK3_REG (GPORT0_BASE + 0x042C)
#define SWITCH_P0_PORT_RULE0_REG (GPORT0_BASE + 0x0430)
#define SWITCH_P0_PORT_RULE1_REG (GPORT0_BASE + 0x0434)
#define SWITCH_P0_PORT_RULE2_REG (GPORT0_BASE + 0x0438)
#define SWITCH_P0_PORT_RULE3_REG (GPORT0_BASE + 0x043C)
#define SWITCH_P0_PORT_IKEY_SEL (GPORT0_BASE + 0x0440)
#define SWITCH_P0_PORT_RX_VLAN_ID (GPORT0_BASE + 0x0450)
#define SWITCH_P0_TX_CONF (GPORT0_BASE + 0x0800)
#define SWITCH_P0_PORT_TX_VLAN_ID (GPORT0_BASE + 0x0804)
#define SWITCH_P0_PORT_MIB_REG_0 (GPORT0_BASE + 0x0C00)
#define SWITCH_P0_GMAC_MIB_REG_0 (GPORT0_BASE + 0x0C54)

#define SWITCH_P1_GMAC_REG (GPORT1_BASE + 0x0004)
#define SWITCH_P1_GMAC_CTRL (GPORT1_BASE + 0x000C)
#define SWITCH_P1_RTX_INT_STATUS (GPORT1_BASE + 0x0010)
#define SWITCH_P1_RTX_INT_MASK (GPORT1_BASE + 0x0014)
#define SWITCH_P1_INT_PRIORITY (GPORT1_BASE + 0x0018)
#define SWITCH_P1_MDIO_ID_1 (GPORT1_BASE + 0x00A8)
#define SWITCH_P1_PAUSE_CTL_1 (GPORT1_BASE + 0x00B0)
/* #define SWITCH_P1_MDIO_MOD_SEL (GPORT1_BASE + 0x00B4)  */
#define SWITCH_P1_MDIO_ACC_0 (GPORT1_BASE + 0x00B8)
#define SWITCH_P1_RX_CONF (GPORT1_BASE + 0x0400)
#define SWITCH_P1_OFFSET0_REG (GPORT1_BASE + 0x0404)
#define SWITCH_P1_OFFSET1_REG (GPORT1_BASE + 0x0408)
#define SWITCH_P1_PORT_MASK0_REG (GPORT1_BASE + 0x0420)
#define SWITCH_P1_PORT_MASK1_REG (GPORT1_BASE + 0x0424)
#define SWITCH_P1_PORT_MASK2_REG (GPORT1_BASE + 0x0428)
#define SWITCH_P1_PORT_MASK3_REG (GPORT1_BASE + 0x042C)
#define SWITCH_P1_PORT_RULE0_REG (GPORT1_BASE + 0x0430)
#define SWITCH_P1_PORT_RULE1_REG (GPORT1_BASE + 0x0434)
#define SWITCH_P1_PORT_RULE2_REG (GPORT1_BASE + 0x0438)
#define SWITCH_P1_PORT_RULE3_REG (GPORT1_BASE + 0x043C)
#define SWITCH_P1_PORT_IKEY_SEL (GPORT1_BASE + 0x0440)
#define SWITCH_P1_PORT_RX_VLAN_ID (GPORT1_BASE + 0x0450)
#define SWITCH_P1_TX_CONF (GPORT1_BASE + 0x0800)
#define SWITCH_P1_PORT_TX_VLAN_ID (GPORT1_BASE + 0x0804)
#define SWITCH_P1_PORT_MIB_REG_0 (GPORT1_BASE + 0x0C00)
#define SWITCH_P1_GMAC_MIB_REG_0 (GPORT1_BASE + 0x0C54)

#define SWITCH_P2_GMAC_REG (GPORT2_BASE + 0x0004)
#define SWITCH_P2_GMAC_CTRL (GPORT2_BASE + 0x000C)
#define SWITCH_P2_RTX_INT_STATUS (GPORT2_BASE + 0x0010)
#define SWITCH_P2_RTX_INT_MASK (GPORT2_BASE + 0x0014)
#define SWITCH_P2_INT_PRIORITY (GPORT2_BASE + 0x0018)
#define SWITCH_P2_MDIO_ID_1 (GPORT2_BASE + 0x00A8)
/*
#define SWITCH_P2_PAUSE_CTL_1 (GPORT2_BASE + 0x00B0)
*/
#define SWITCH_P2_MDIO_MOD_SEL (GPORT2_BASE + 0x00B4)
#define SWITCH_P2_MDIO_ACC_0 (GPORT2_BASE + 0x00B8)
#define SWITCH_P2_RX_CONF (GPORT2_BASE + 0x0400)
#define SWITCH_P2_OFFSET0_REG (GPORT2_BASE + 0x0404)
#define SWITCH_P2_OFFSET1_REG (GPORT2_BASE + 0x0408)
#define SWITCH_P2_PORT_MASK0_REG (GPORT2_BASE + 0x0420)
#define SWITCH_P2_PORT_MASK1_REG (GPORT2_BASE + 0x0424)
#define SWITCH_P2_PORT_MASK2_REG (GPORT2_BASE + 0x0428)
#define SWITCH_P2_PORT_MASK3_REG (GPORT2_BASE + 0x042C)
#define SWITCH_P2_PORT_RULE0_REG (GPORT2_BASE + 0x0430)
#define SWITCH_P2_PORT_RULE1_REG (GPORT2_BASE + 0x0434)
#define SWITCH_P2_PORT_RULE2_REG (GPORT2_BASE + 0x0438)
#define SWITCH_P2_PORT_RULE3_REG (GPORT2_BASE + 0x043C)
#define SWITCH_P2_PORT_IKEY_SEL (GPORT2_BASE + 0x0440)
#define SWITCH_P2_PORT_RX_VLAN_ID (GPORT2_BASE + 0x0450)
#define SWITCH_P2_TX_CONF (GPORT2_BASE + 0x0800)
#define SWITCH_P2_PORT_TX_VLAN_ID (GPORT2_BASE + 0x0804)
#define SWITCH_P2_PORT_MIB_REG_0 (GPORT2_BASE + 0x0C00)
#define SWITCH_P2_GMAC_MIB_REG_0 (GPORT2_BASE + 0x0C54)



#define MDIO_MOD_SEL SWITCH_P2_MDIO_MOD_SEL
#define SWITCH_MDIO_ACC SWITCH_P2_MDIO_ACC_0  /* SWITCH_P0_MDIO_ACC_0 */
#define SWITCH_MDIO_ID SWITCH_P2_MDIO_ID_1
/* #define TX_CONFIG_REG SWITCH_P0_TX_CONF  */

#define SWITCH_PMAC_HD_CTL (GPORT2_BASE + 0x0070)
#define SWITCH_PMAC_SA1 (GPORT2_BASE + 0x0074)
#define SWITCH_PMAC_SA2 (GPORT2_BASE + 0x0078)
#define SWITCH_PMAC_DA1 (GPORT2_BASE + 0x007C)
#define SWITCH_PMAC_DA2 (GPORT2_BASE + 0x0080)
#define SWITCH_PMAC_VLAN (GPORT2_BASE + 0x0084)
#define SWITCH_PMAC_TX_IPG (GPORT2_BASE + 0x0088)
#define SWITCH_PMAC_RX_IPG (GPORT2_BASE + 0x008C)




#ifdef INCAIP2_SW_DEBUG_MSG
#define INCAIP2_SW_DMSG(fmt,args...) printk("%s: " fmt, __FUNCTION__ , ##args)
#else
#define INCAIP2_SW_DMSG(fmt,args...)
#endif

/***********************************************************************/
/*  Module      :  MPS register address and bits                       */
/***********************************************************************/

#define IFX_MPS                          (KSEG1+0x1F101400)
/***********************************************************************/

#define IFX_MPS_CHIPID                       ((volatile u32*)(IFX_MPS + 0x0344))
#define IFX_MPS_CHIPID_VERSION_GET(value)    (((value) >> 28) & ((1 << 4) - 1))
#define IFX_MPS_CHIPID_VERSION_SET(value)    (((( 1 << 4) - 1) & (value)) << 28)
#define IFX_MPS_CHIPID_PARTNUM_GET(value)    (((value) >> 12) & ((1 << 16) - 1))
#define IFX_MPS_CHIPID_PARTNUM_SET(value)    (((( 1 << 16) - 1) & (value)) << 12)
#define IFX_MPS_CHIPID_MANID_GET(value)      (((value) >> 1) & ((1 << 10) - 1))
#define IFX_MPS_CHIPID_MANID_SET(value)      (((( 1 << 10) - 1) & (value)) << 1)
#define IFX_MPS_SUBVER                       ((volatile u32*)(IFX_MPS + 0x0348))


/* voice channel 0 ... 3 interrupt enable register */
#define IFX_MPS_VC0ENR ((volatile u32*)(IFX_MPS + 0x0000))
#define IFX_MPS_VC1ENR ((volatile u32*)(IFX_MPS + 0x0004))
#define IFX_MPS_VC2ENR ((volatile u32*)(IFX_MPS + 0x0008))
#define IFX_MPS_VC3ENR ((volatile u32*)(IFX_MPS + 0x000C))
/* voice channel 0 ... 3 interrupt status read register */
#define IFX_MPS_RVC0SR ((volatile u32*)(IFX_MPS + 0x0010))
#define IFX_MPS_RVC1SR ((volatile u32*)(IFX_MPS + 0x0014))
#define IFX_MPS_RVC2SR ((volatile u32*)(IFX_MPS + 0x0018))
#define IFX_MPS_RVC3SR ((volatile u32*)(IFX_MPS + 0x001C))
/* voice channel 0 ... 3 interrupt status set register */
#define IFX_MPS_SVC0SR ((volatile u32*)(IFX_MPS + 0x0020))
#define IFX_MPS_SVC1SR ((volatile u32*)(IFX_MPS + 0x0024))
#define IFX_MPS_SVC2SR ((volatile u32*)(IFX_MPS + 0x0028))
#define IFX_MPS_SVC3SR ((volatile u32*)(IFX_MPS + 0x002C))
/* voice channel 0 ... 3 interrupt status clear register */
#define IFX_MPS_CVC0SR ((volatile u32*)(IFX_MPS + 0x0030))
#define IFX_MPS_CVC1SR ((volatile u32*)(IFX_MPS + 0x0034))
#define IFX_MPS_CVC2SR ((volatile u32*)(IFX_MPS + 0x0038))
#define IFX_MPS_CVC3SR ((volatile u32*)(IFX_MPS + 0x003C))
/* common status 0 and 1 read register */
#define IFX_MPS_RAD0SR ((volatile u32*)(IFX_MPS + 0x0040))
#define IFX_MPS_RAD1SR ((volatile u32*)(IFX_MPS + 0x0044))
/* common status 0 and 1 set register */
#define IFX_MPS_SAD0SR ((volatile u32*)(IFX_MPS + 0x0048))
#define IFX_MPS_SAD1SR ((volatile u32*)(IFX_MPS + 0x004C))
/* common status 0 and 1 clear register */
#define IFX_MPS_CAD0SR ((volatile u32*)(IFX_MPS + 0x0050))
#define IFX_MPS_CAD1SR ((volatile u32*)(IFX_MPS + 0x0054))
/* common status 0 and 1 enable register */
#define IFX_MPS_AD0ENR ((volatile u32*)(IFX_MPS + 0x0058))
#define IFX_MPS_AD1ENR ((volatile u32*)(IFX_MPS + 0x005C))
/* notification enable register */
#define IFX_MPS_CPU0_NFER ((volatile u32*)(IFX_MPS + 0x0060))
#define IFX_MPS_CPU1_NFER ((volatile u32*)(IFX_MPS + 0x0064))
/* CPU to CPU interrup request register */
#define IFX_MPS_CPU0_2_CPU1_IRR ((volatile u32*)(IFX_MPS + 0x0070))
#define IFX_MPS_CPU0_2_CPU1_IER ((volatile u32*)(IFX_MPS + 0x0074))
/* Global interrupt request and request enable register */
#define IFX_MPS_GIRR ((volatile u32*)(IFX_MPS + 0x0078))
#define IFX_MPS_GIER ((volatile u32*)(IFX_MPS + 0x007C))

#define IFX_MPS_SRAM ((volatile u32*)(IFX_MPS + 0x1000))

#define IFX_MPS_BINSEM0  ((volatile u32*)(IFX_MPS + 0x0100))
#define IFX_MPS_BINSEM1  ((volatile u32*)(IFX_MPS + 0x0104))
#define IFX_MPS_BINSEM2  ((volatile u32*)(IFX_MPS + 0x0108))
#define IFX_MPS_BINSEM3  ((volatile u32*)(IFX_MPS + 0x010C))
#define IFX_MPS_BINSEM4  ((volatile u32*)(IFX_MPS + 0x0110))
#define IFX_MPS_BINSEM5  ((volatile u32*)(IFX_MPS + 0x0114))
#define IFX_MPS_BINSEM6  ((volatile u32*)(IFX_MPS + 0x0118))
#define IFX_MPS_BINSEM7  ((volatile u32*)(IFX_MPS + 0x011C))
#define IFX_MPS_BINSEM8  ((volatile u32*)(IFX_MPS + 0x0120))
#define IFX_MPS_BINSEM9  ((volatile u32*)(IFX_MPS + 0x0124))
#define IFX_MPS_BINSEM10 ((volatile u32*)(IFX_MPS + 0x0128))
#define IFX_MPS_BINSEM11 ((volatile u32*)(IFX_MPS + 0x012C))
#define IFX_MPS_BINSEM12 ((volatile u32*)(IFX_MPS + 0x0130))
#define IFX_MPS_BINSEM13 ((volatile u32*)(IFX_MPS + 0x0134))
#define IFX_MPS_BINSEM14 ((volatile u32*)(IFX_MPS + 0x0138))
#define IFX_MPS_BINSEM15 ((volatile u32*)(IFX_MPS + 0x013C))




/***********************************************************************/
/*  Module       :  ASC0 register address and bits                      */
/***********************************************************************/
#define IFX_ASC0                          (KSEG1+0x1E000400)
/***********************************************************************/

#define IFX_ASC0_TBUF                        ((volatile u32*)(IFX_ASC0 + 0x0020))
#define IFX_ASC0_RBUF                        ((volatile u32*)(IFX_ASC0 + 0x0024))
#define IFX_ASC0_FSTAT                       ((volatile u32*)(IFX_ASC0 + 0x0048))
#define IFX_ASC0_FSTAT_TXFREE_GET(value)     (((value) >> 24) & ((1 << 6) - 1))
#define IFX_ASC0_FSTAT_TXFREE_SET(value)     (((( 1 << 6) - 1) & (value)) << 24)
#define IFX_ASC0_FSTAT_RXFREE_GET(value)     (((value) >> 16) & ((1 << 6) - 1))
#define IFX_ASC0_FSTAT_RXFREE_SET(value)     (((( 1 << 6) - 1) & (value)) << 16)
#define IFX_ASC0_FSTAT_TXFFL_GET(value)      (((value) >> 8) & ((1 << 6) - 1))
#define IFX_ASC0_FSTAT_TXFFL_SET(value)      (((( 1 << 6) - 1) & (value)) << 8)
#define IFX_ASC0_FSTAT_RXFFL_GET(value)      (((value) >> 0) & ((1 << 6) - 1))
#define IFX_ASC0_FSTAT_RXFFL_SET(value)      (((( 1 << 6) - 1) & (value)) << 0)


/***********************************************************************/
/*  Module      :  ASC1 register address and bits                      */
/***********************************************************************/
#define IFX_ASC1                          (KSEG1+0x1E000800)
/***********************************************************************/

#define IFX_ASC1_TBUF                        ((volatile u32*)(IFX_ASC1 + 0x0020))
#define IFX_ASC1_RBUF                        ((volatile u32*)(IFX_ASC1 + 0x0024))
#define IFX_ASC1_FSTAT                       ((volatile u32*)(IFX_ASC1 + 0x0048))
#define IFX_ASC1_FSTAT_TXFREE_GET(value)     (((value) >> 24) & ((1 << 6) - 1))
#define IFX_ASC1_FSTAT_TXFREE_SET(value)     (((( 1 << 6) - 1) & (value)) << 24)
#define IFX_ASC1_FSTAT_RXFREE_GET(value)     (((value) >> 16) & ((1 << 6) - 1))
#define IFX_ASC1_FSTAT_RXFREE_SET(value)     (((( 1 << 6) - 1) & (value)) << 16)
#define IFX_ASC1_FSTAT_TXFFL_GET(value)      (((value) >> 8) & ((1 << 6) - 1))
#define IFX_ASC1_FSTAT_TXFFL_SET(value)      (((( 1 << 6) - 1) & (value)) << 8)
#define IFX_ASC1_FSTAT_RXFFL_GET(value)      (((value) >> 0) & ((1 << 6) - 1))
#define IFX_ASC1_FSTAT_RXFFL_SET(value)      (((( 1 << 6) - 1) & (value)) << 0)



/***********************************************************************/
/*  Module      :  RCU register address and bits                       */
/***********************************************************************/

#define IFX_RCU                          (KSEG1+0x1E001C00)
/***********************************************************************/

/***Reset Request Register***/
#define IFX_RCU_RST_REQ                      ((volatile u32*)(IFX_RCU + 0x0000))
#define IFX_RCU_RST_REQ_CPU0                 (1 << 31)
#define IFX_RCU_RST_REQ_CPU1                 (1 << 30)
#define IFX_RCU_RST_REQ_CPUSUB               (1 << 29)
#define IFX_RCU_RST_REQ_HRST                 (1 << 28)
#define IFX_RCU_RST_REQ_WDT0                 (1 << 27)
#define IFX_RCU_RST_REQ_WDT1                 (1 << 26)
#define IFX_RCU_RST_REQ_CFG_GET(value)       (((value) >> 23) & ((1 << 3) - 1))
#define IFX_RCU_RST_REQ_CFG_SET(value)       (((( 1 << 3) - 1) & (value)) << 23)
#define IFX_RCU_RST_REQ_SWTBOOT              (1 << 22)
#define IFX_RCU_RST_REQ_DMA                  (1 << 21)
#define IFX_RCU_RST_REQ_ETHPHY1              (1 << 20)
#define IFX_RCU_RST_REQ_ETHPHY0              (1 << 19)
#define IFX_RCU_RST_REQ_CPU0_BR              (1 << 18)

#define IFX_RCU_WDTRCR                      ((volatile u32*)(IFX_RCU + 0x0004))
#define IFX_RCU_WDT0RCR_CPU0                (1 << 31)
#define IFX_RCU_WDT0RCR_CPU1                (1 << 30)
#define IFX_RCU_WDT0RCR_CPUSU               (1 << 29)
#define IFX_RCU_WDT0RCR_HRST                (1 << 28)
#define IFX_RCU_WDT1RCR_CPU0                (1 << 27)
#define IFX_RCU_WDT1RCR_CPU1                (1 << 26)
#define IFX_RCU_WDT1RCR_CPUSU               (1 << 24)
#define IFX_RCU_WDT1RCR_HRST                (1 << 23)


/* CPU0, CPU1, CPUSUB, HRST, WDT0, WDT1, DMA, ETHPHY1, ETHPHY0 */
#define IFX_RCU_RST_REQ_ALL                  0xFC380000

/***NMI Status Register***/
#define IFX_RCU_NMISR                        ((volatile u32*)(IFX_RCU + 0x00F4))
#define IFX_RCU_NMISR_NMIEXT                 (1 << 2)
#define IFX_RCU_NMISR_NMIPLL2                (1 << 1)
#define IFX_RCU_NMISR_NMIPLL1                (1 << 0)

/***********************************************************************/
/*  Module      :  WDT register address and bits                       */
/***********************************************************************/

#define IFX_WDT                           (KSEG1+0x1F880000)
/***********************************************************************/

#define IFX_BIU                            IFX_WDT
#define IFX_BIU_FB0_CFG   ((volatile u32*)(IFX_BIU + 0x0310))
#define IFX_BIU_FB1_CFG   ((volatile u32*)(IFX_BIU + 0x0318))

/***Watchdog Timer Control Register ***/
#define IFX_WDT_BIU_WDT_CR                   ((volatile u32*)(IFX_WDT + 0x03F0))
#define IFX_WDT_BIU_WDT_CR_GEN               (1 << 31)
#define IFX_WDT_BIU_WDT_CR_DSEN              (1 << 30)
#define IFX_WDT_BIU_WDT_CR_LPEN              (1 << 29)
#define IFX_WDT_BIU_WDT_CR_PWL_GET(value)    (((value) >> 26) & ((1 << 2) - 1))
#define IFX_WDT_BIU_WDT_CR_PWL_SET(value)    (((( 1 << 2) - 1) & (value)) << 26)
#define IFX_WDT_BIU_WDT_CR_CLKDIV_GET(value) (((value) >> 24) & ((1 << 2) - 1))
#define IFX_WDT_BIU_WDT_CR_CLKDIV_SET(value) (((( 1 << 2) - 1) & (value)) << 24)
#define IFX_WDT_BIU_WDT_CR_PW_GET(value)     (((value) >> 16) & ((1 << 8) - 1))
#define IFX_WDT_BIU_WDT_CR_PW_SET(value)     (((( 1 << 8) - 1) & (value)) << 16)
#define IFX_WDT_BIU_WDT_CR_RELOAD_GET(value) (((value) >> 0) & ((1 << 16) - 1))
#define IFX_WDT_BIU_WDT_CR_RELOAD_SET(value) (((( 1 << 16) - 1) & (value)) << 0)

/***Watchdog Timer Status Register***/
#define IFX_WDT_BIU_WDT_SR                   ((volatile u32*)(IFX_WDT + 0x03F8))
#define IFX_WDT_BIU_WDT_SR_EN                (1 << 31)
#define IFX_WDT_BIU_WDT_SR_AE                (1 << 30)
#define IFX_WDT_BIU_WDT_SR_PRW               (1 << 29)
#define IFX_WDT_BIU_WDT_SR_EXP               (1 << 28)
#define IFX_WDT_BIU_WDT_SR_PWD               (1 << 27)
#define IFX_WDT_BIU_WDT_SR_DS                (1 << 26)
#define IFX_WDT_BIU_WDT_SR_VALUE_GET(value)  (((value) >> 0) & ((1 << 16) - 1))
#define IFX_WDT_BIU_WDT_SR_VALUE_SET(value)  (((( 1 << 16) - 1) & (value)) << 0)

/***********************************************************************/
/*  Module      :  MC register address and bits                        */
/***********************************************************************/

#define IFX_MC                             (KSEG1+0x1F800000)
/***********************************************************************/

#define IFX_MC_ERRCAUSE                      ((volatile u32*)(IFX_MC + 0x0010))
#define IFX_MC_ERRADDR                       ((volatile u32*)(IFX_MC + 0x0020))


/***********************************************************************/
/*  Module      :  PMS register address and bits                       */
/***********************************************************************/

#define IFX_PMS     (KSEG1 + 0x1F100C00)

#define IFX_PMS_PMS_SR				((volatile u32*) (IFX_PMS + 0x0000))
#define IFX_PMS_PMS_SR_ASC1			(1 << 14)
#define IFX_PMS_PMS_SR_ASC0			(1 << 13)
#define IFX_PMS_PMS_GEN				((volatile u32*) (IFX_PMS + 0x0004))
#define IFX_PMS_PMS_GEN_DMA			(1 << 16)
#define IFX_PMS_PMS_GEN_ASC1		(1 << 14)
#define IFX_PMS_PMS_GEN_ASC0		(1 << 13)
#define IFX_PMS_PMS_GEN_SSC1		(1 << 12)
#define IFX_PMS_PMS_GEN_SSC0		(1 << 11)
#define IFX_PMS_PMS_CFG				((volatile u32*) (IFX_PMS + 0x0008))
#define IFX_PMS_PMS_GEN_SSC1		(1 << 12)
#define IFX_PMS_PMS_GEN_SSC0		(1 << 11)

/***********************************************************************/
/*  Module      :  GPIO register address and bits                       */
/***********************************************************************/

#define IFX_GPIO     (KSEG1 + 0x1F102600)

#define IFX_GPIO_POUT		((volatile u32*) (IFX_GPIO + 0x0000))
#define IFX_GPIO_PIN		((volatile u32*) (IFX_GPIO + 0x0004))
#define IFX_GPIO_PDIR		((volatile u32*) (IFX_GPIO + 0x0008))
#define IFX_GPIO_ALTSEL1		((volatile u32*) (IFX_GPIO + 0x000C))
#define IFX_GPIO_ALTSEL2		((volatile u32*) (IFX_GPIO + 0x0010))
#define IFX_GPIO_PSTOFF		((volatile u32*) (IFX_GPIO + 0x0014))
#define IFX_GPIO_POD		((volatile u32*) (IFX_GPIO + 0x0018))
#define IFX_GPIO_PUDEN		((volatile u32*) (IFX_GPIO + 0x001C))
#define IFX_GPIO_PUDSEL		((volatile u32*) (IFX_GPIO + 0x0020))

/***********************************************************************/
/*  Module      :  GPTC register address and bits                       */
/***********************************************************************/

#define IFX_GPTC           (KSEG1 + 0x14100F00)
#define IFX_GPTC_CLC		((volatile u32*) (IFX_GPTC + 0x0000))
#define IFX_GPTC_ID		((volatile u32*) (IFX_GPTC + 0x0008))
#define IFX_GPTC_CON_1A	((volatile u32*) (IFX_GPTC + 0x0010))
#define IFX_GPTC_CON_1B	((volatile u32*) (IFX_GPTC + 0x0014))
#define IFX_GPTC_RUN_1A	((volatile u32*) (IFX_GPTC + 0x0018))
#define IFX_GPTC_RUN_1B	((volatile u32*) (IFX_GPTC + 0x001C))
#define IFX_GPTC_RELOAD_1A	((volatile u32*) (IFX_GPTC + 0x0020))
#define IFX_GPTC_RELOAD_1B	((volatile u32*) (IFX_GPTC + 0x0024))
#define IFX_GPTC_COUNT_1A	((volatile u32*) (IFX_GPTC + 0x0028))
#define IFX_GPTC_COUNT_1B	((volatile u32*) (IFX_GPTC + 0x002C))


#define IFX_GPTC_CON_2A	((volatile u32*) (IFX_GPTC + 0x0030))
#define IFX_GPTC_RUN_2A	((volatile u32*) (IFX_GPTC + 0x0038))
#define IFX_GPTC_RELOAD_2A	((volatile u32*) (IFX_GPTC + 0x0040))
#define IFX_GPTC_COUNT_2A	((volatile u32*) (IFX_GPTC + 0x0048))

#define IFX_GPTC_CON_2B	((volatile u32*) (IFX_GPTC + 0x0034))
#define IFX_GPTC_RUN_2B	((volatile u32*) (IFX_GPTC + 0x003C))
#define IFX_GPTC_RELOAD_2B	((volatile u32*) (IFX_GPTC + 0x0044))
#define IFX_GPTC_COUNT_2B	((volatile u32*) (IFX_GPTC + 0x004C))

#define IFX_GPTC_CON_3A	((volatile u32*) (IFX_GPTC + 0x0050))
#define IFX_GPTC_RUN_3A	((volatile u32*) (IFX_GPTC + 0x0058))
#define IFX_GPTC_RELOAD_3A	((volatile u32*) (IFX_GPTC + 0x0060))
#define IFX_GPTC_COUNT_3A	((volatile u32*) (IFX_GPTC + 0x0068))

#define IFX_GPTC_CON_3B	((volatile u32*) (IFX_GPTC + 0x0054))
#define IFX_GPTC_RUN_3B	((volatile u32*) (IFX_GPTC + 0x005C))
#define IFX_GPTC_RELOAD_3B	((volatile u32*) (IFX_GPTC + 0x0064))
#define IFX_GPTC_COUNT_3B	((volatile u32*) (IFX_GPTC + 0x006C))

#define IFX_GPTC_IRNEN		((volatile u32*) (IFX_GPTC + 0x00F4))
#define IFX_GPTC_IRNICR	((volatile u32*) (IFX_GPTC + 0x00F8)
#define IFX_GPTC_IRNCR		((volatile u32*) (IFX_GPTC + 0x00FC))

/***********************************************************************/
/*  Module      :  EBU register address and bits                       */
/***********************************************************************/

#define IFX_EBU                             (KSEG1+0x14102000)
/***********************************************************************/

#define IFX_EBU_CLC                     ((volatile u32*)(IFX_EBU + 0x0000))
#define IFX_EBU_ID                      ((volatile u32*)(IFX_EBU + 0x0008))
#define IFX_EBU_CON                     ((volatile u32*)(IFX_EBU + 0x0010))
#define IFX_EBU_ADDR_SEL_0              ((volatile u32*)(IFX_EBU + 0x0020))
#define IFX_EBU_ADDR_SEL_1              ((volatile u32*)(IFX_EBU + 0x0024))
#define IFX_EBU_ADDR_SEL_2              ((volatile u32*)(IFX_EBU + 0x0028))
#define IFX_EBU_ADDR_SEL_3              ((volatile u32*)(IFX_EBU + 0x002C))
#define IFX_EBU_CON_0                   ((volatile u32*)(IFX_EBU + 0x0060))
#define IFX_EBU_CON_1                   ((volatile u32*)(IFX_EBU + 0x0064))
#define IFX_EBU_CON_2                   ((volatile u32*)(IFX_EBU + 0x0068))
#define IFX_EBU_CON_3                   ((volatile u32*)(IFX_EBU + 0x006C))

/***********************************************************************/
/*  Module      :  CGU register address and bits                       */
/***********************************************************************/

#define IFX_CGU                          (KSEG1+0x1F100800)
/***********************************************************************/

#define IFX_CGU_PLL2CR                       ((volatile u32*)(IFX_CGU + 0x0008))
#define IFX_CGU_PLL2CR_MIPS0_DIV_GET(value)  (((value) >> 27) & ((1 << 2) - 1))
#define IFX_CGU_FBSCR                        ((volatile u32*)(IFX_CGU + 0x0018))
#define IFX_CGU_FBSCR_LPBSDIV_GET(value)     (((value) >> 6) & ((1 << 2) - 1))
#define IFX_CGU_FBSCR_DIV0_GET(value)        (((value) >> 0) & ((1 << 3) - 1))
#define IFX_CGU_FBSCR_DIV1_GET(value)        (((value) >> 4) & ((1 << 2) - 1))
#define IFX_CGU_FUSE                         ((volatile u32*)(IFX_CGU + 0x0338))
#define IFX_CGU_FUSE_PLL1TCLK_GET(value)     (((value) >> 4) & ((1 << 1) - 1))
#define IFX_CGU_FUSE_PLL2TCLK_GET(value)     (((value) >> 3) & ((1 << 1) - 1))
#define IFX_CGU_FUSE_PLL2FREQ_GET(value)     (((value) >> 1) & ((1 << 2) - 1))
#define IFX_CGU_FUSE_MIPS0DIS_GET(value)     (((value) >> 0) & ((1 << 1) - 1))

