/************************************************************************
 *
 * Copyright (c) 2007
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/

#ifndef _MUX_H
#define _MUX_H

u32 ifx_mux_pwm1_pins(void);
u32 ifx_mux_pwm2_pins(void);
u32 ifx_mux_led_pins(void);
u32 ifx_mux_key_pins(void);
u32 ifx_mux_asc1_pins(void);
u32 ifx_mux_asc0_pins(void);
u32 ifx_mux_ssc_pins(void);
u32 ifx_mux_usb_pins(void);
u32 ifx_mux_clock_out_pins(void);
u32 ifx_mux_rtc_clock_pins(void);
u32 ifx_mux_exin_pins(void);
u32 ifx_mux_gp_pins(int port);
u32 ifx_mux_exin_pin(int exin);

void ifx_mux_init(void);

#define IFX_MUX_BIT_GP0  0x00000001
#define IFX_MUX_BIT_GP1  0x00000002
#define IFX_MUX_BIT_GP2  0x00000004
#define IFX_MUX_BIT_GP3  0x00000008
#define IFX_MUX_BIT_GP4  0x00000010
#define IFX_MUX_BIT_GP5  0x00000020
#define IFX_MUX_BIT_GP6  0x00000040
#define IFX_MUX_BIT_GP7  0x00000080
#define IFX_MUX_BIT_GP8  0x00000100
#define IFX_MUX_BIT_GP9  0x00000200
#define IFX_MUX_BIT_GP10 0x00000400
#define IFX_MUX_BIT_GP11 0x00000800
#define IFX_MUX_BIT_GP12 0x00001000
#define IFX_MUX_BIT_GP13 0x00002000
#define IFX_MUX_BIT_GP14 0x00004000
#define IFX_MUX_BIT_GP15 0x00008000
#define IFX_MUX_BIT_GP16 0x00010000
#define IFX_MUX_BIT_GP17 0x00020000
#define IFX_MUX_BIT_GP18 0x00040000
#define IFX_MUX_BIT_GP19 0x00080000
#define IFX_MUX_BIT_GP20 0x00100000
#define IFX_MUX_BIT_GP21 0x00200000
#define IFX_MUX_BIT_GP22 0x00400000
#define IFX_MUX_BIT_GP23 0x00800000
#define IFX_MUX_BIT_GP24 0x01000000
#define IFX_MUX_BIT_GP25 0x02000000
#define IFX_MUX_BIT_GP26 0x04000000
#define IFX_MUX_BIT_GP27 0x08000000

#define IFX_MUX_BIT_EXINT0  0x00000001
#define IFX_MUX_BIT_EXINT1  0x00000002
#define IFX_MUX_BIT_EXINT2  0x00000004
#define IFX_MUX_BIT_EXINT3  0x00000008
#define IFX_MUX_BIT_EXINT4  0x00000010
#define IFX_MUX_BIT_EXINT5  0x00000020
#define IFX_MUX_BIT_EXINT6  0x00000040
#define IFX_MUX_BIT_EXINT7  0x00000080
#define IFX_MUX_BIT_EXINT8  0x00000100
#define IFX_MUX_BIT_EXINT9  0x00000200
#define IFX_MUX_BIT_EXINT10 0x00000400
#define IFX_MUX_BIT_EXINT11 0x00000800
#define IFX_MUX_BIT_EXINT12 0x00001000
#define IFX_MUX_BIT_EXINT13 0x00002000
#define IFX_MUX_BIT_EXINT14 0x00004000
#define IFX_MUX_BIT_EXINT15 0x00008000
#define IFX_MUX_BIT_EXINT16 0x00010000

#define IFX_MUX_BIT_ALT_CLK1 0x00000001
#define IFX_MUX_BIT_ALT_CLK2 0x00000002

#define IFX_MUX_BIT_EBU_A0  0x00000001
#define IFX_MUX_BIT_EBU_A1  0x00000002
#define IFX_MUX_BIT_EBU_A2  0x00000004
#define IFX_MUX_BIT_EBU_A3  0x00000008
#define IFX_MUX_BIT_EBU_A4  0x00000010
#define IFX_MUX_BIT_EBU_A5  0x00000020
#define IFX_MUX_BIT_EBU_A6  0x00000040
#define IFX_MUX_BIT_EBU_A7  0x00000080
#define IFX_MUX_BIT_EBU_A8  0x00000100
#define IFX_MUX_BIT_EBU_A9  0x00000200
#define IFX_MUX_BIT_EBU_A10 0x00000400
#define IFX_MUX_BIT_EBU_A11 0x00000800

#define IFX_MUX_BIT_EBU_CS0 0x00000001
#define IFX_MUX_BIT_EBU_CS1 0x00000002
#define IFX_MUX_BIT_EBU_CS2 0x00000004
#define IFX_MUX_BIT_EBU_CS3 0x00000008

#define IFX_MUX_BIT_SSC0 0x00000001
#define IFX_MUX_BIT_SSC1 0x00000002

#endif
