/******************************************************************************

                            Copyright (c) 2007
                         Infineon Technologies AG
               St. Martin Strasse 53; 81669 Munich, Germany

  Any use of this Software is subject to the conclusion of a respective 
  License Agreement. Without such a License Agreement no rights to the
  Software are granted.

******************************************************************************/

#ifndef __IFX_SVIP_BASE_REG_H
#define __IFX_SVIP_BASE_REG_H

#ifndef KSEG1
#define KSEG1 0xA0000000
#endif

#define IFX_EBU_SEG1_BASE   (KSEG1 + 0x10000000)
#define IFX_EBU_SEG2_BASE   (KSEG1 + 0x11000000)
#define IFX_EBU_SEG3_BASE   (KSEG1 + 0x12000000)
#define IFX_EBU_SEG4_BASE   (KSEG1 + 0x13000000)
#define IFX_EBU_SEG5_BASE   (KSEG1 + 0x13100000)
#define IFX_BCU0_BASE   (KSEG1 + 0x14100000)
#define IFX_ASC0_BASE   (KSEG1 + 0x14100100)
#define IFX_ASC1_BASE   (KSEG1 + 0x14100200)
#define IFX_SSC0_BASE   (KSEG1 + 0x14100300)
#define IFX_SSC1_BASE   (KSEG1 + 0x14100400)
#define IFX_PORT_P0_BASE     (KSEG1 + 0x14100600)
#define IFX_PORT_P2_BASE     (KSEG1 + 0x14100800)
#define IFX_PORT_P3_BASE     (KSEG1 + 0x14100900)
#define IFX_GPTC_BASE   (KSEG1 + 0x14100F00)
#define IFX_BS_BASE     (KSEG1 + 0x14101200)
#define IFX_PMS_BASE    (KSEG1 + 0x14101300)
#define IFX_TEMP_BASE   (KSEG1 + 0x14101400)
#define IFX_PMON_BASE   (KSEG1 + 0x14101600)
#define IFX_EBU_BASE    (KSEG1 + 0x14102000)
#define IFX_TRNG_BASE   (KSEG1 + 0x14103000)
#define IFX_DEU_BASE    (KSEG1 + 0x14103200)
#define IFX_DMA_BASE    (KSEG1 + 0x14104000)
#define IFX_ICU_BASE    (KSEG1 + 0x14106000)
#define IFX_ICU0_IM5_IM4_IM1_IM0_BASE   (KSEG1 + 0x14106000)
#define IFX_ICU1_IM5_IM4_IM1_IM0_BASE   (KSEG1 + 0x14106100)
#define IFX_ICU2_IM5_IM4_IM1_IM0_BASE   (KSEG1 + 0x14106200)
#define IFX_ICU3_IM5_IM4_IM1_IM0_BASE   (KSEG1 + 0x14106300)
#define IFX_ICU4_IM5_IM4_IM1_IM0_BASE   (KSEG1 + 0x14106400)
#define IFX_SSC2_BASE   (KSEG1 + 0x14108000)
#define IFX_PORT_P1_BASE     (KSEG1 + 0x14108100)
#define IFX_MCD_BASE    (KSEG1 + 0x14108200)
#define IFX_FSCT_BASE   (KSEG1 + 0x14108300)
#define IFX_PCM0_BASE   (KSEG1 + 0x14108400)
#define IFX_PCM1_BASE   (KSEG1 + 0x14108500)
#define IFX_PCM2_BASE   (KSEG1 + 0x14108600)
#define IFX_PCM3_BASE   (KSEG1 + 0x14108700)
#define IFX_ES_BASE     (KSEG1 + 0x18000000)
#define IFX_SYS0_BASE   (KSEG1 + 0x1C000000)
#define IFX_SYS1_BASE   (KSEG1 + 0x1C000800)
#define IFX_NMI_BASE    (KSEG1 + 0x1C000900)
#define IFX_ROM_BASE    (KSEG1 + 0x1F000000)
#define IFX_L2_SPRAM_BASE   (KSEG1 + 0x1F1E8000)
#define IFX_L2_SPRAM_P_BASE     (KSEG1 + 0x1F200000)
#define IFX_L2_SPW0_BASE    (KSEG1 + 0x1F400000)
#define IFX_L2_SPW1_BASE    (KSEG1 + 0x1F420000)
#define IFX_L2_SPW2_BASE    (KSEG1 + 0x1F440000)
#define IFX_L2_SPW3_BASE    (KSEG1 + 0x1F460000)
#define IFX_L2_SPW4_BASE    (KSEG1 + 0x1F480000)
#define IFX_L2_SPW5_BASE    (KSEG1 + 0x1F4A0000)
#define IFX_L2_SPW6_BASE    (KSEG1 + 0x1F4C0000)
#define IFX_L2_SPW7_BASE    (KSEG1 + 0x1F4E0000)
#define IFX_DDR2_BASE   (KSEG1 + 0x1F600000)
#define IFX_DDR2_PHY_BASE   (KSEG1 + 0x1F600400)
#define IFX_DDR2_CR_BASE    (KSEG1 + 0x1F601000)
#define IFX_CPU_SUBSYS_BASE     (KSEG1 + 0x1F602000)
#define IFX_BCU1_BASE   (KSEG1 + 0x1E000000)
#define IFX_SWINT_BASE  (KSEG1 + 0x1E000100)
#define IFX_MBS_BASE    (KSEG1 + 0x1E000200)
#define IFX_SYNC_BASE   (KSEG1 + 0x1E000300)
#define IFX_PORT_P4_BASE     (KSEG1 + 0x1E000400)
#define IFX_STATUS_BASE     (KSEG1 + 0x1E000500)
#define IFX_PMS2_BASE   (KSEG1 + 0x1E001000)
#define IFX_ICU0_IM3_IM2_BASE   (KSEG1 + 0x1E016000)
#define IFX_ICU1_IM3_IM2_BASE   (KSEG1 + 0x1E016100)
#define IFX_ICU2_IM3_IM2_BASE   (KSEG1 + 0x1E016200)
#define IFX_ICU3_IM3_IM2_BASE   (KSEG1 + 0x1E016300)
#define IFX_ICU4_IM3_IM2_BASE   (KSEG1 + 0x1E016400)
#define IFX_ICU5_IM3_IM2_BASE   (KSEG1 + 0x1E016500)
#define IFX_DFE0_BASE   (KSEG1 + 0x1E100000)
#define IFX_DFE1_BASE   (KSEG1 + 0x1E140000)
#define IFX_DFE2_BASE   (KSEG1 + 0x1E180000)
#define IFX_DFE3_BASE   (KSEG1 + 0x1E1C0000)
#define IFX_DFE4_BASE   (KSEG1 + 0x1E200000)
#define IFX_DFE5_BASE   (KSEG1 + 0x1E240000)
#define IFX_DFE6_BASE   (KSEG1 + 0x1E280000)
#define IFX_DFE7_BASE   (KSEG1 + 0x1E2C0000)
#define IFX_LMS0_BASE   (KSEG1 + 0x1E300000)
#define IFX_LMS1_BASE   (KSEG1 + 0x1E340000)
#define IFX_SYS2_BASE   (KSEG1 + 0x1E400000)
#define IFX_SBIU_BASE   (KSEG1 + 0x1F880000)
#define IFX_WDT_BASE    (KSEG1 + 0x1F8803F0)

#endif /* __IFX_SVIP_BASE_REG_H */
