#!/bin/sh

export PATH=$PATH:/opt/uclibc-toolchain/gcc-4.1.2/toolchain-mipseb/bin/
CORES=$(($(cat /proc/cpuinfo | grep -c processor)))

if [ ! -e include/gs_def.h ]; then
    echo "Create symlink for gs_def.h"
    ln -s ../../../../../provision/provision.h include/gs_def.h
fi

if [ "$2" = "clean" ]; then
    make -j${CORES} clean
#    make -j${CORES} mrproper
#    make -j${CORES} distclean
exit
fi
if [ "$1" = "gxw4248" ]; then
    PROD=gxw4248
    diff -q .config defconfig_gxw48 || {
        cp defconfig_gxw48 .config
    }
elif [ "$1" = "gxw4232" ]; then
    PROD=gxw4200
    diff -q .config defconfig_gxw || {
        cp defconfig_gxw .config
    }
elif [ "$1" = "gxw4232_debug" ]; then
    PROD=gxw4232_debug
    diff -q .config defconfig_gxw_debug || {
        cp defconfig_gxw_debug .config
    }
elif [ "$1" = "gxw4232_ATE" ]; then
    PROD=gxw4232_ATE
    diff -q .config defconfig_gxw_ATE || {
        cp defconfig_gxw_ATE .config
    }
elif [ "$1" = "gxw4232_recovery" ]; then
    PROD=gxw4232_recovery
    diff -q .config defconfig_gxw_recovery32 || {
        cp defconfig_gxw_recovery32 .config
    }
elif [ "$1" = "gxw4248_recovery" ]; then
    PROD=gxw4248_recovery
    diff -q .config defconfig_gxw_recovery48 || {
        cp defconfig_gxw_recovery48 .config
    }
else
    echo "unknown prod ID"
    exit
fi
echo "Building kernel for $PROD."

#KBUILD_VERBOSE=1 make gxwImage
make -j${CORES} gxwImage CONFIG_DEBUG_SECTION_MISMATCH=y
#KBUILD_VERBOSE=1 make modules #modules_install
#make modules modules_install

cp -v gxwImage ./core.${PROD}.dev

if [ "$1" = "gxw4232_recovery" ]; then
    cp -v core.${PROD}.dev rcvr.img
    cp -v rcvr.img /tftproot
elif [ "$1" = "gxw4248_recovery" ]; then
    cp -v core.${PROD}.dev rcvr_48.img
else 
    cp -v ./core.${PROD}.dev /opt/tftpboot
fi
