#ifndef __DANUBE_PPE_DEV_H__2005_08_04__11_23__
#define __DANUBE_PPE_DEV_H__2005_08_04__11_23__


/******************************************************************************
       Copyright (c) 2002, Infineon Technologies.  All rights reserved.

                               No Warranty
   Because the program is licensed free of charge, there is no warranty for
   the program, to the extent permitted by applicable law.  Except when
   otherwise stated in writing the copyright holders and/or other parties
   provide the program "as is" without warranty of any kind, either
   expressed or implied, including, but not limited to, the implied
   warranties of merchantability and fitness for a particular purpose. The
   entire risk as to the quality and performance of the program is with
   you.  should the program prove defective, you assume the cost of all
   necessary servicing, repair or correction.

   In no event unless required by applicable law or agreed to in writing
   will any copyright holder, or any other party who may modify and/or
   redistribute the program as permitted above, be liable to you for
   damages, including any general, special, incidental or consequential
   damages arising out of the use or inability to use the program
   (including but not limited to loss of data or data being rendered
   inaccurate or losses sustained by you or third parties or a failure of
   the program to operate with any other programs), even if such holder or
   other party has been advised of the possibility of such damages.
******************************************************************************/


/*
 * ####################################
 *              Definition
 * ####################################
 */

/*
 *  ioctl Command
 */
#define PPE_ATM_IOC_MAGIC       'o'
#define PPE_ATM_MIB_CELL        _IOW(PPE_ATM_IOC_MAGIC, 0, atm_cell_ifEntry_t)
#define PPE_ATM_MIB_AAL5        _IOW(PPE_ATM_IOC_MAGIC, 1, atm_aal5_ifEntry_t)
#define PPE_ATM_MIB_VCC         _IOWR(PPE_ATM_IOC_MAGIC, 2, atm_aal5_vcc_x_t)
#define PPE_ATM_IOC_MAXNR       3


/*
 * ####################################
 *              Data Type
 * ####################################
 */

/*
 *  Data Type Used to Call ioctl
 */
typedef struct {
	int             vpi;
	int             vci;
	atm_aal5_vcc_t  mib_vcc;
} atm_aal5_vcc_x_t;


/*
 * ####################################
 *             Declaration
 * ####################################
 */

#if defined(__KERNEL__)
extern void (*IFX_MEI_set_cell_rate)(int, u32);
extern void DSL_BSP_ATMLedHandler(void);
#endif  //  defined(__KERNEL__)


#endif  //  __DANUBE_PPE_DEV_H__2005_08_04__11_23__
