/*
 * NVRAM locked up variables
 *
 * Copyright 2012, Grandstream Networks, Inc.
 * All Rights Reserved.
 * 
 * THIS SOFTWARE IS OFFERED "AS IS", AND GRANDSTREAM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. GRANDSTREAM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id: lock_values.h,v 1.1 2013/02/07 05:46:48 pradev Exp $
 *
 */

#define MAX_KEY_LEN 32

/* Note: the leading space in the key name is a place holder for calling setacl with different lock flag */
static char l1locked[][MAX_KEY_LEN] = {
/* Primary SIP Proxy Server(P47) */
" 47",
/* SIP Outbound Proxy (P48) */
" 48",
/* Upgrade Transport (P212) */
" 212",
/* Automatic Periodic Provision (P194) */
" 194",
/* Provision Mode (P238) */
" 238",
/* Authenticate Configuration File (P240) */
" 240",
/* Firmware Key (P242) */
" 242",
/* Firmware Path (P192) */
" 192",
/* Firmware Prefix (P232) */
" 232",
/* Firmware Postfix (P233) */
" 233",
/* Configuration Path (P237) */
" 237",
/* Configuration Prefix (P234) */
" 234",
/* Configuration Postfix (P235) */
" 235",
/* Lock Keypad Update (P88) */
" 88",
/* Primary SIP Proxy (profile 2, 3, 4: P747,547,602) */
" 547",
" 747",
" 602",
/* SIP Outbound Proxy (profile 2,3,4: P548, 748, 603) */
" 548",
" 748",
" 603",
/* Failover SIP Server (P967, 987, 997, 998 for profile 1,2,3,4) */
" 967",
" 987",
" 997",
" 998",
/* XML Config File Password */
" 1359",
/* HTTP/HTTPS User Name */
" 1360",
/* HTTP/HTTPS Password */
" 1361",
};

#define L1LOCKED_COUNT (sizeof(l1locked)/MAX_KEY_LEN)

static char l2locked[][MAX_KEY_LEN] = {
" 9997",
" 9998",
" 9999",
};

#define L2LOCKED_COUNT (sizeof(l2locked)/MAX_KEY_LEN)

