#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/select.h>
#include <poll.h>
#include <linux/input.h>
#include <unistd.h>

//a#define GXW_KP_DEVICE                "/dev/gxw42xx_keypad"
#define GXW_KP_DEVICE                "/dev/input/event0"

#define EVENT_LINK                  0x4000
#define EVENT_LINK_ON               (EVENT_LINK | 0x01)
#define EVENT_LINK_OFF              (EVENT_LINK | 0x02)

typedef struct 
{
    unsigned long    event_id;
    unsigned long    timestamp;        /* in ms */
} GXW_INPUT_EVENT, *GXW_INPUT_EVENT_P;

typedef struct 
{
    unsigned long    param;                /* for input/output */
    unsigned long    reserved;
} GXW_KP_IOCTL_PARAM, *GXW_KP_IOCTL_PARAM_P;

/* IOCTL command */
typedef enum
{
    GXW_KP_IOCTL_START = 0,

    C55_IOCTL_END
} GXW_KP_IOCTL_CMD;

struct input_event event;

int main()
{
    int fd_kp;
    int rtn;
    GXW_KP_IOCTL_PARAM param;
    GXW_INPUT_EVENT input;
    fd_set rfds;
    struct timeval tv;
    int rc;
    int running = 1;
    ssize_t size;
    char buf[100];
    int i;

    fd_kp = open( GXW_KP_DEVICE, O_RDWR );
    if ( fd_kp < 0 )
    {   
        printf("cant open keypad device\n");
        return -1; 
    }       
  
    memset(&input, 0, sizeof(input));  

    while ( running )
    {
#if 0
        struct pollfd fdarray[2];

        //prepare( fd );

//        while ( !m_stopped )
        {
            for ( i = 0; i < 2; i++ )
            {
                fdarray[i].fd = -1;
            }
            fdarray[0].fd = 0;
            fdarray[0].events = POLLIN;
            fdarray[1].fd = fd_kp;
            fdarray[1].events = POLLIN;

            if ( poll( fdarray, 2, -1 ) < 0 )
            {
                printf( "keypad_test poll failed\n");
            }
            else
            {
                memset( ( void* ) &input, 0, sizeof( input ) );
                if ( read( fd_kp, &input, sizeof( input ) ) < 0 )
                {
                    printf("keypad_test read hook failed\n" );
                }
                else
                {
                    printf ( " keypad_test read data id = %X ts = %ld \n", input.event_id, input.timestamp );
                }
            }
        }
#else
        FD_ZERO( &rfds );
        tv.tv_sec = 3;
        tv.tv_usec = 0;
        FD_SET( fd_kp, &rfds );

        rc = select( fd_kp + 1, &rfds, NULL, NULL, NULL  );
        if ( rc <= 0 )
        {
            printf( "select failed: %d\n", rc );
            //return -1;
        }

        if ( FD_ISSET( fd_kp, &rfds ) )
        {

            rtn = read(fd_kp, &event, sizeof( struct input_event ) );

//            rtn = read( fd_kp, &input, sizeof(input) );
            if ( rtn < -1 )
            {
                printf( "read event failed: %d\n", rtn );
                return -1;
            }
/*struct input_event {
        struct timeval time;
        unsigned short type;
        unsigned short code;
        unsigned int value;
};
*/

printf(" Got event from %s: type = %d, code = %d, value = %d\n", GXW_KP_DEVICE, event.type, event.code, event.value );

            if ( input.event_id  == EVENT_LINK_ON || input.event_id == EVENT_LINK_OFF )
            {
                printf( "##link event received\n" );
                signal( SIGCHLD, SIG_IGN ); // to get rid of the zombie child process
                pid_t pid = fork();
                if ( pid == 0 ) 
                {
                    // The child process
                    signal( SIGINT, SIG_IGN );
                    char* cmd[2];

                    if (input.event_id  == EVENT_LINK_ON)
                    {
                        cmd[0] = "/etc/init.d/network start";
                        cmd[1] = NULL;
                        if ( execv( "/etc/init.d/network start", cmd ) == -1 )
                            printf("network_change START script call failed\n");
                    }
                    else
                    {
                        cmd[0] = "/etc/init.d/network stop";
                        cmd[1] = NULL;
                        if ( execv( "/etc/init.d/network stop", cmd ) == -1 )
                            printf("network_change STOP script call failed\n");

                    }
                    return;
                }   
                else                
                    printf("WARNING!!! keypad_test fork failed \n" ) ;

            }
            else
                printf( "##unknown event: %lx\n", input.event_id );

        }
#endif
    }

     return 0;
}
