#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "msglib.h"

int notify_setting_change( const char *name, unsigned int group )
{
    int server_qid;
    key_t msgkey;
    admin_msg server_msg;
    int ret;

    /* Generate our IPC key value */
    msgkey = SERVER_MSGQ_KEY;

    /* Open/create the queue */
    if ( ( server_qid = open_queue( msgkey ) ) == -1 )
    {
        //perror( "open_queue" );
        return ( 1 );
    }

    server_msg.mtype = ADMMSG_MSG_DISPATCH_SETTING_CHG_EVT;
    server_msg.user_id = 0;
    server_msg.group = ( char )group;
    //printf("sending message to groups 0x%x\n", server_msg.groups);

    if ( name )
    {
        strncpy( server_msg.mbody, name, ADMIN_EVENT_MSG_LENGTH );
    }

    if ( ( ret = send_message( server_qid, ( struct msgbuf * )&server_msg, sizeof( server_msg ) ) ) != 0 )
    {
        //printf( " send msg error, ret=%d\n", ret );
    }

    return 0;
}

int send_telemetry_message( int argc, char** argv, unsigned int group )
{
    int server_qid;
    key_t msgkey;
    admin_msg server_msg;
    int ret;
    char *tmp;
    int i = 1;
    int length = 55;

    /* Generate our IPC key value */
    msgkey = SERVER_MSGQ_KEY;

    /* Open/create the queue */
    if ( ( server_qid = open_queue( msgkey ) ) == -1 )
    {
        //perror("open_queue");
        return ( 1 );
    }

    server_msg.mtype = ADMMSG_MSG_DISPATCH_SETTING_CHG_EVT;
    server_msg.user_id = 0;
    server_msg.group = ( char )group;

    tmp = server_msg.mbody;
    memset( tmp, 0, ADMIN_EVENT_MSG_LENGTH );
    tmp[0] = strtoll( argv[0], ( char** )NULL, 16 );
    tmp = &tmp[1];

    while ( i < argc )
    {
        tmp[0] = strtoll( argv[i], ( char** )NULL, 16 );
        length--;

        if ( length <= 0 )
        {
            break;
        }

        i++;

        if ( i == argc )
        {
            break;
        }

        tmp = &tmp[1];
        tmp[0] = strlen( argv[i] );
        tmp = &tmp[1];
        strcpy( tmp, argv[i] );
        tmp += strlen( argv[i] );
        i++;
    }

    if ( ( ret = send_message( server_qid, ( struct msgbuf * )&server_msg, sizeof( server_msg ) ) ) != 0 )
    {
        //printf(" send msg error, ret=%d\n", ret);
    }

    return 0;
}

