#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

#ifndef __LIB_MSG_H__
#define __LIB_MSG_H__

#define SERVER_MSGQ_KEY  0x3838a3
#define CONF_CHANGE_GROUP 1
#define EVENT_MSG_LENGTH 60
#define ADMIN_EVENT_MSG_LENGTH 55

#ifdef __cplusplus
extern "C" {
#endif

typedef struct __admin_msg
{
    long         mtype;          /* Message type */
    long         user_id;
    char         mbody[ADMIN_EVENT_MSG_LENGTH];
    char         group;
}
admin_msg;

typedef struct __event_msg
{
    long    mtype;          /* Message type */
    char    mbody[EVENT_MSG_LENGTH];
}
event_msg;

enum ADMMSG_TYPE
{
    ADMMSG_TYPE_ALL = 0,
    ADMMSG_MSG_REGISTER_USER,
    ADMMSG_MSG_DELETE_USER,
    ADMMSG_MSG_DISPATCH_SETTING_CHG_EVT,
    ADMMSG_MSG_DONE_SCRIPTS_EVT,
    ADMMSG_MSG_SERVER_EXIT
};

enum EVTMSG_TYPE
{
    EVTMSG_TYPE_ALL = 0,
    EVTMSG_TYPE_SETTING_CHANGE_NOTIFY,
    EVTMSG_TYPE_DONE_SCRIPTS_EVT,
    EVTMSG_TYPE_RESERVED
};

int open_queue( key_t keyval );
int send_message( int qid, void *qbuf, int size );
int send_message_retry( int qid, void *qbuf, int size, int retries, int* err );
int read_message( int qid, long type, void *qbuf, int size );
int peek_message( int qid, long type );
int remove_queue( int qid );
int get_group( char* group, char* grp );
int scripts_signal( char *group, char *data );

#ifdef __cplusplus
}
#endif

#endif

