#ifndef __TFTP_URL_PROCESS_HEAD__
#define __TFTP_URL_PROCESS_HEAD__

/*prints out the output string in the format 'http://server_address:port/path' or
'https://server_address:port/path'
return 0 if successfull
returns INVALID_ADDRESS if invalid address
returns INVALID_PORT if invalid port
*/
int http_url_process( char *input_str, char *type );

/*prints out the output string in the format 'path server_address port'
return 0 if successfull
returns INVALID_ADDRESS if invalid address
returns INVALID_PORT if invalid port
*/
int tftp_url_process( char *input_str );

/*
extracts server address into server_addr
returns INVALID_ADDRESS if invalid address detected
returns position of end of server_address in input_str
*/
int get_server_address( char *input_str, char *server_addr );

/*extracts port number if it exists into port
returns INVALID_PORT if port number invalid
returns index value of the end of port number in input_str
*/
int get_port( char *input_str, char *port, int position );

/*
extracts path from input_str into path
*/
int get_path( char *input_str, char *path, int position );

/*
Checks if the address is valid
*/
int check_address( char *address_str );

/*checks if the given string has numeric characters only */
int is_numeric( char *input_str );

int check_server_address( char *input_str );

/*
checks if a url is valid(assumed http or https)
*/
int check_url( char *input_str );

/* 
Checks if the netmask is valid
*/
int check_netmask( char *address_str );

/* 
Checks if the ip address is valid
*/
int check_ip_address( char *address_str );

#endif
