/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */
#include <errno.h>
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "grandstream_trap.h"
#include "nvram.h"


/*
 * our initialization routine
 * (to get called, the function name must match init_FILENAME() 
 */
void
init_grandstream_trap(void)
{
    DEBUGMSGTL(("grandstream_trap",
                "initializing (setting callback alarm)\n"));
    
    snmp_alarm_register( 1,     /* seconds */
                         SA_REPEAT,      /* repeat (every 30 seconds). */
                         send_notification,      /* our callback */
                         NULL    /* no callback data needed */
        );
}

void
send_notification( unsigned int clientreg, void *clientarg )
{
    netsnmp_variable_list  *var_list = NULL;
    const oid acosTimedTrap_oid[] = { 1,3,6,1,4,1,42397,5,1,0,5 };
    const oid acosSystemReboot_oid[] = { 1,3,6,1,4,1,42397,5,1,1,1, 0 };
    const oid acosHardwareRevision_oid[] = { 1,3,6,1,4,1,42397,5,1,1,2, 0 };
    const oid acosSoftwareRevision_oid[] = { 1,3,6,1,4,1,42397,5,1,1,3, 0 };
    const oid acosSerialNumber_oid[] = { 1,3,6,1,4,1,42397,5,1,1,4, 0 };
    const oid acosPartNumber_oid[] = { 1,3,6,1,4,1,42397,5,1,1,5, 0 };
    const oid acosTotalSlots_oid[] = { 1,3,6,1,4,1,42397,5,1,1,6, 0 };
    const oid acosTftpFileName_oid[] = { 1,3,6,1,4,1,42397,5,1,13,1, 0 };
    const oid acosTftpServerAddress_oid[] = { 1,3,6,1,4,1,42397,5,1,11,1, 0 };
    const oid acosTftpFailReason_oid[] = { 1,3,6,1,4,1,42397,5,1,11,7, 0 };

    oid objid_snmptrap[] = { 1, 3, 6, 1, 6, 3, 1, 1, 4, 1, 0 };
    size_t objid_snmptrap_len = OID_LENGTH(objid_snmptrap);
  
    int value1 = __LINE__ ;
    char value2[] = "1.X34" ;
    char value3[] = "0.0.9.99.999" ;
    char value4[] = "723923923n2923" ;
    char value5[] = "PN-00234Xerw" ;
    int value6 = __LINE__ ;
    uint32_t value7 = 0xc0a8fef3 ;
    char value8[] = "" ;
    char value9[] = "A_filename" ;

    /*run trap only if Pxxx is set to 1*/
    char *pinterval = nvram_get( "xxx" ) ;
    if( pinterval == NULL || pinterval[0] == 0 )
        return ;
    if( atoi( pinterval ) != 1 )
        return ;
    nvram_set( "xxx", "0" ) ;    

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
        objid_snmptrap, objid_snmptrap_len,
        ASN_OBJECT_ID,
        //acosTimedTrap_oid, sizeof(acosTimedTrap_oid));
        (u_char *)acosTimedTrap_oid,  OID_LENGTH(acosTimedTrap_oid)*sizeof(oid));
    
    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
        acosSystemReboot_oid, OID_LENGTH(acosSystemReboot_oid),
        ASN_INTEGER,
        /* Set an appropriate value for acosSystemReboot */
        (u_char *)&value1, sizeof(value1) ) ;
    snmp_varlist_add_variable(&var_list,
        acosHardwareRevision_oid, OID_LENGTH(acosHardwareRevision_oid),
        ASN_OCTET_STR,
        /* Set an appropriate value for acosHardwareRevision */
        (u_char *)value2, sizeof(value2) ) ;
    snmp_varlist_add_variable(&var_list,
        acosSoftwareRevision_oid, OID_LENGTH(acosSoftwareRevision_oid),
        ASN_OCTET_STR,
        /* Set an appropriate value for acosSoftwareRevision */
        (u_char *)value3, sizeof(value3) ) ;
    snmp_varlist_add_variable(&var_list,
        acosSerialNumber_oid, OID_LENGTH(acosSerialNumber_oid),
        ASN_OCTET_STR,
        /* Set an appropriate value for acosSerialNumber */
        (u_char *)value4, sizeof(value4) ) ;
    snmp_varlist_add_variable(&var_list,
        acosPartNumber_oid, OID_LENGTH(acosPartNumber_oid),
        ASN_OCTET_STR,
        /* Set an appropriate value for acosPartNumber */
        (u_char *)value5, sizeof(value5) ) ;
    snmp_varlist_add_variable(&var_list,
        acosTotalSlots_oid, OID_LENGTH(acosTotalSlots_oid),
        ASN_INTEGER,
        /* Set an appropriate value for acosTotalSlots */
        (u_char *)&value6, sizeof(value6) ) ;
    snmp_varlist_add_variable(&var_list,
        acosTftpFileName_oid, OID_LENGTH(acosTftpFileName_oid),
        ASN_OCTET_STR,
        (u_char *)value9, sizeof(value9) ) ;
    snmp_varlist_add_variable(&var_list,
        acosTftpServerAddress_oid, OID_LENGTH(acosTftpServerAddress_oid),
        ASN_IPADDRESS,
        (u_char *)&value7, sizeof(value7) ) ;
    snmp_varlist_add_variable(&var_list,
        acosTftpFailReason_oid, OID_LENGTH(acosTftpFailReason_oid),
        ASN_OCTET_STR,
        (u_char *)value8, sizeof(value8) ) ;
    

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap( var_list );
    snmp_free_varbind( var_list );

}

extern const oid snmptrap_oid[];
extern const size_t snmptrap_oid_len;

int
send_acosTimedTrap_trap( void )
{
    netsnmp_variable_list  *var_list = NULL;
    const oid acosTimedTrap_oid[] = { 1,3,6,1,4,1,42397,5,1,0,5 };
    const oid acosSystemReboot_oid[] = { 1,3,6,1,4,1,42397,5,1,1,1, 0 };
    const oid acosHardwareRevision_oid[] = { 1,3,6,1,4,1,42397,5,1,1,2, 0 };
    const oid acosSoftwareRevision_oid[] = { 1,3,6,1,4,1,42397,5,1,1,3, 0 };
    const oid acosSerialNumber_oid[] = { 1,3,6,1,4,1,42397,5,1,1,4, 0 };
    const oid acosPartNumber_oid[] = { 1,3,6,1,4,1,42397,5,1,1,5, 0 };
    const oid acosTotalSlots_oid[] = { 1,3,6,1,4,1,42397,5,1,1,6, 0 };
    const oid acosTftpFileName_oid[] = { 1,3,6,1,4,1,42397,5,1,13,1, 0 };
    const oid acosTftpServerAddress_oid[] = { 1,3,6,1,4,1,42397,5,1,11,1, 0 };
    const oid acosTftpFailReason_oid[] = { 1,3,6,1,4,1,42397,5,1,11,7, 0 };

    fprintf( stderr, "%s:%d\n", __FILE__, __LINE__ ) ;
    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
        snmptrap_oid, snmptrap_oid_len,
        ASN_OBJECT_ID,
        acosTimedTrap_oid, sizeof(acosTimedTrap_oid));
    
    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
        acosSystemReboot_oid, OID_LENGTH(acosSystemReboot_oid),
        ASN_INTEGER,
        /* Set an appropriate value for acosSystemReboot */
        NULL, 0);
    snmp_varlist_add_variable(&var_list,
        acosHardwareRevision_oid, OID_LENGTH(acosHardwareRevision_oid),
        ASN_OCTET_STR,
        /* Set an appropriate value for acosHardwareRevision */
        NULL, 0);
    snmp_varlist_add_variable(&var_list,
        acosSoftwareRevision_oid, OID_LENGTH(acosSoftwareRevision_oid),
        ASN_OCTET_STR,
        /* Set an appropriate value for acosSoftwareRevision */
        NULL, 0);
    snmp_varlist_add_variable(&var_list,
        acosSerialNumber_oid, OID_LENGTH(acosSerialNumber_oid),
        ASN_OCTET_STR,
        /* Set an appropriate value for acosSerialNumber */
        NULL, 0);
    snmp_varlist_add_variable(&var_list,
        acosPartNumber_oid, OID_LENGTH(acosPartNumber_oid),
        ASN_OCTET_STR,
        /* Set an appropriate value for acosPartNumber */
        NULL, 0);
    snmp_varlist_add_variable(&var_list,
        acosTotalSlots_oid, OID_LENGTH(acosTotalSlots_oid),
        ASN_INTEGER,
        /* Set an appropriate value for acosTotalSlots */
        NULL, 0);
    snmp_varlist_add_variable(&var_list,
        acosTftpFileName_oid, OID_LENGTH(acosTftpFileName_oid),
        ASN_OCTET_STR,
        /* Set an appropriate value for acosTftpFileName */
        NULL, 0);
    snmp_varlist_add_variable(&var_list,
        acosTftpServerAddress_oid, OID_LENGTH(acosTftpServerAddress_oid),
        ASN_IPADDRESS,
        /* Set an appropriate value for acosTftpServerAddress */
        NULL, 0);
    snmp_varlist_add_variable(&var_list,
        acosTftpFailReason_oid, OID_LENGTH(acosTftpFailReason_oid),
        ASN_OCTET_STR,
        /* Set an appropriate value for acosTftpFailReason */
        NULL, 0);

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap( var_list );
    snmp_free_varbind( var_list );
    return SNMP_ERR_NOERROR;
}

long get_nvram_long( char *name )
{
    long value = 0 ;
    char buffer[256] = { 0 }, *endptr = NULL ;

    nvram_get_safe( name, buffer, 256 ) ;

    if( buffer[0] = 0 )
        return 0 ;
    else
    {
        errno = 0 ;
        value = strtol( buffer, &endptr, 10 ) ;
        if ( (errno == ERANGE && ( value == LONG_MAX ||  value == LONG_MIN))
            || (errno != 0 &&  value == 0))
            return 0 ;
        if (endptr == buffer )
            return 0 ;
    }
    return value ;
}

in_addr_t get_nvram_addr( char *name )
{
    struct in_addr ipaddress ;
    char buffer[256] = { 0 } ;

    nvram_get_safe( name, buffer, 256 ) ;

    if( buffer[0] == 0 )
        return -1 ;

    if( inet_aton( buffer, &ipaddress ) == 0 )
        return -1 ;
    return ipaddress.s_addr ;
}

oid get_nvram_oid( char *name )
{
    char buffer[256] = { 0 } ;

    nvram_get_safe( name, buffer, 256 ) ;

    if( buffer[0] == 0 )
        return ;

    return ;
}
