package grandstream::MIB_NVRAM ;  
use strict ;
use Carp ;

BEGIN {
    use FileHandle ;
    use vars       qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);
    $VERSION     = 1.00;
    @ISA         = qw(Exporter);
    @EXPORT_OK   = qw(&init &get_pvalue);
    use vars      @EXPORT_OK;
}

sub init
{
    our %nvram_hash = () ;
    if( @_ == 0 )
    {
        open FH, "</usr/share/snmp/mibs/gs_mib" 
            or die "Cannot open file\n" ;
    }
    else
    {
        open FH, "<$_[0]" 
            or die "Cannot open $_[0]\n" ;
    }

    while ( <FH> )
    {
        chomp ;
        if( /^\s*(\w+)\s+.*--\s+NVRAM\s+(\w+)\s*$/ )
        {       
            $nvram_hash{$1} = $2 ;
        }
    }
    close FH ;
}

sub get_pvalue
{
    our %nvram_hash ;
    if( @_ > 0 )
    {
        if( exists $nvram_hash{$_[0]} )
        {
            return $nvram_hash{$_[0]} ;
        }
    }
}

1;
