#!/bin/bash

CDIR=`pwd`
TOPDIR=${CDIR}/../../../../
LIBDIR="${TOPDIR}../../gxw42xx/image_build/gxw-build/gxw_image_build/base/usr/lib"
ZLIBDIR=${CDIR}/../zlib-1.2.8/
LZOLIBDIR=${CDIR}/../lzo-2.10
LZ4LIBDIR=${CDIR}/../lz4-1.9.3

GS_CFLAGS="-Os -pipe -mips32r2 -mtune=mips32r2 -funit-at-a-time -fhonour-copts -DEVENT_LOGGER_DEBUG=1 -I${LZOLIBDIR}/include -I${LZ4LIBDIR}/lib"

. ${TOPDIR}tools/build_tools/Path.sh

echo ${TOOLCHAIN_DIR}

if [ ! -f Makefile ]; then
    autoreconf --force --install
    LZ4_LIBS="-L${LIBDIR} -llz4 " \
    LZO_LIBS="-L${LIBDIR} -llzo2 " \
    AR=${GS_AR} AS=${GS_AS} LD=${GS_LD} NM=${GS_NM} CC=${GS_CC}  RANLIB=${GS_RANLIB} BUILDCC=${GS_HOSTCC} \
    CXX=${GS_CXX} OBJCOPY=${GS_OBJCOPY} OBJDUMP=${GS_OBJDUMP} CFLAGS="${GS_CFLAGS}" \
    ./configure --host=mips-linux \
                --disable-plugin-auth-pam \
                --enable-password-save \
                 --prefix=${CDIR}/.install
fi


mkdir .install

#make clean
make
#${STRIP} src/openvpn/openvpn
make install
