#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef struct
{
	char * opt_str;
	int opt_num;
} opt_t;

opt_t options[] =
{
	{ "acs_url", 1 },
	{ "provisioning_code", 2 },
	{ "cwmp_retry_min_wait_int", 3 },
	{ "cwmp_retry_int_mult", 4 },
	{ "core-path", 14 },
	{ "tftp", 66 },
	{ "vlan_id", 132 },
	{ "vlan_qos", 133 }
};

#define NUM_OPTIONS ( sizeof ( options ) / sizeof ( opt_t ) )

opt_t options_125[] =
{
	{ "GatewayManufacturerOUI", 4 },
	{ "GatewaySerialNumber", 5 },
	{ "GatewayProductClass", 6 },
};

#define NUM_OPTIONS_125 ( sizeof ( options_125 ) / sizeof ( opt_t ) )


int extract_125( unsigned char *opt_string )
{
	int i = 0 ;
	int j ;
	int length ;
	int opt_len ;
	int opt_num ;
	char opt_val[256] ;
	unsigned long pen = 0 ;

	for( i = 0 ; i < 4 ; i++ )
	{
		opt_val[i] = opt_string[i] ;
	}
	opt_val[i] = 0 ;
	pen = strtol( opt_val, NULL, 16 ) ;
	length = opt_string[i] + i;
	i++ ;
	for ( ; i < length ; )
	{
		opt_num = opt_string[i++] ;
		opt_len = opt_string[i++] ;
		for ( j = 0; j < NUM_OPTIONS_125; j++ )
		{
			if ( options_125[j].opt_num == opt_num )
			{
				if ( opt_len > sizeof ( opt_val ) )
				{
					fprintf( stderr, "opt_val too long");
					goto out;
				}
				memcpy( opt_val, &opt_string[i], opt_len );
				opt_val[opt_len] = 0;
				printf( "%s %s\n", options_125[j].opt_str, opt_val );
				break;
			}
		}
		i += opt_len;
	}
out:
	free( opt_string );
	return 0 ;
}

//=============================================================================
int
main(
	int argc,
	char ** argv
)
//=============================================================================
{
	unsigned char * opt_string;
	int opt_string_len;
	int i;
	int j;
	int opt_len;
	int opt_num;
	char opt_val[256];

	opt_string = (char *)malloc(1024);
	opt_string_len = fread( opt_string, 1, 1024, stdin );

	if ( opt_string_len < 3 )
	{
		goto out;
	}

	if( argc == 2 && !strcmp( argv[1], "-125" ) )
		return extract_125( opt_string ) ;
		
	for ( i = 0; i < strlen( opt_string ); )
	{
		opt_num = opt_string[i++];
		opt_len = opt_string[i++];
		for ( j = 0; j < NUM_OPTIONS; j++ )
		{
			if ( options[j].opt_num == opt_num )
			{
				if ( opt_len > sizeof ( opt_val ) )
				{
					fprintf( stderr, "opt_val too long");
					goto out;
				}
				memcpy( opt_val, &opt_string[i], opt_len );
				opt_val[opt_len] = 0;
				printf( "%s %s\n", options[j].opt_str, opt_val );
				break;
			}
		}
		i += opt_len;
	}

out:
	free( opt_string );
	return 0;
}

