#!/bin/bash

CDIR=`pwd`
TOPDIR="${CDIR}/../../../../"
BASEDIR="${TOPDIR}../../gxw42xx/image_build/gxw-build.cvscontrol/gxw_image_build/base"
CACHEFILE="mips-linux.cache"
PHDDNS="./src/phddns"
BINDIR="${BASEDIR}/usr/bin/"
LIBDIR="${BASEDIR}/usr/lib/"

GS_CFLAGS="-Os -pipe -mips32r2 -mtune=mips32r2 -funit-at-a-time -fhonour-copts -DEVENT_LOGGER_DEBUG=1"

. ${TOPDIR}tools/build_tools/Path.sh

if [ "$1" = "configure" ];then
	autoreconf --force --install
	# prepare the cache file for cross-compile
	echo ax_cv_cc_builtin_choose_expr=no > ${CACHEFILE}
	echo ax_cv_cc_builtin_types_compatible_p=no >> ${CACHEFILE}
	echo ax_cv_cc_builtin_bswap64=no >> ${CACHEFILE}
	echo ax_cv_cc_bounded_attribute=no >> ${CACHEFILE}
	
	LDFLAGS="-L${LIBDIR}" \
	./configure \
		--host=mips-linux \
		--cache-file=${CACHEFILE} 
fi

make clean && make

${GS_STRIP} ${PHDDNS}
cp -avf ${PHDDNS} ${BINDIR}
