// PHGlobal.h: interface for the CBaseThread class.
//
//////////////////////////////////////////////////////////////////////
/*! \file PHGlobal.h
*  \author skyvense
*  \date   2009-09-14
*  \brief PHDDNS ͻʵ	
*/

#ifndef __PHGLOBAL__H__
#define __PHGLOBAL__H__
#ifndef WIN32
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>
#endif

#ifdef WIN32
#define sleep(x) Sleep(x*1000)
#else
#define INVALID_SOCKET (-1)
#define MAX_PATH	260
#endif

#include "phsocket.h"
#include "pherr.h"

#define MAX_TCP_PACKET_LEN	8192

//! TCPָ
#ifdef OFFICIAL_CLIENT
	#define COMMAND_AUTH	"auth phsrv6\r\n"
#else
	#define COMMAND_AUTH	"auth router6\r\n"
#endif

#define COMMAND_REGI    "regi a"
#define COMMAND_CNFM    "cnfm\r\n"
#define COMMAND_STAT_USER    "stat user\r\n"
#define COMMAND_STAT_DOM     "stat domain\r\n"
#define COMMAND_QUIT    "quit\r\n"

//! ָ
#define UDP_OPCODE_UPDATE_VER2		0x2010
//! 
#define UDP_OPCODE_UPDATE_OK		0x2050
//! ش
#define UDP_OPCODE_UPDATE_ERROR		1000

//! ע¼
#define UDP_OPCODE_LOGOUT			11

//! ִܲС
#define KEEPALIVE_PACKET_LEN	20


//! ת״̬뵽ı
const char *convert_status_code(int nCode);

//! תIPַı
const char *my_inet_ntoa(int ip);
void reverse_byte_order(int *in_array,int arraysize);
//! ṹ
typedef struct  
{
	//! ԻID
	int lChatID;
	//! 
	int lOpCode;
	//! ID
	int lID;
	//! У
	int lSum;
	//! 
	int lReserved;
}DATA_KEEPALIVE;

//! °չṹڷʱIPַ
typedef struct 
{
	DATA_KEEPALIVE keepalive;
	int ip;
}DATA_KEEPALIVE_EXT;

typedef struct __PHGlobal PHGlobal;

	typedef void (*CALLBACK_OnStatusChanged)(PHGlobal*, int status, int data); 
	//! ˺õ״̬
	/*! statusֵܵ
		enum MessageCodes
		{
			okConnected = 0,
			okAuthpassed,
			okDomainListed,
			okDomainsRegistered,
			okKeepAliveRecved,
			okConnecting,
			okRetrievingMisc,
			okRedirecting,
		
		  errorConnectFailed = 0x100,
		  errorSocketInitialFailed,
		  errorAuthFailed,
		  errorDomainListFailed,
		  errorDomainRegisterFailed,
		  errorUpdateTimeout,
		  errorKeepAliveError,
		  errorRetrying,
		  errorAuthBusy,
		  errorStatDetailInfoFailed,

		  okNormal = 0x120,
		  okNoData,
		  okServerER,
		  errorOccupyReconnect,
		};
		У
		1statusΪokDomainsRegisteredʱdataû0(),1(רҵ),2(ҵ)
		2statusΪokKeepAliveRecvedʱdataؿͻIPַʽ
		3£dataһֱΪ0
	*/
	//! ˺õעÿִһ
	typedef void (*CALLBACK_OnDomainRegistered)(PHGlobal*, char *domainName); 
	//! ˺õûϢXMLʽ
	typedef void (*CALLBACK_OnUserInfo)(PHGlobal*, char *userInfo, int length); 
	//! ˺õûϢXMLʽ
	typedef void (*CALLBACK_OnAccountDomainInfo)(PHGlobal*, char *domainInfo, int length); 


//! ȫֱ
struct __PHGlobal {
//basic system info
	//! ǶʽͻϢ4λͻID + 4λ汾
	int clientinfo;
	//! Ƕʽ֤
	int challengekey;

	//! ַ
	char szHost[256];
	//! ˿ڣ6060̶
	short nPort;
	//! û˺
	char szUserID[256];
	//! û
	char szUserPWD[256];
	//! ذ󶨵ַĬգڶʱָ
	char szBindAddress[256];
//run-time controll variables
	//! û
	int nUserType;
	BOOL bTcpUpdateSuccessed;
	char szChallenge[256];
	int nChallengeLen;
	int nChatID,nStartID,nLastResponseID;
	int tmLastResponse;
	int nAddressIndex;
	char szTcpConnectAddress[32];

	int cLastResult;
	int ip;

	int uptime;
	int lasttcptime;

	char szActiveDomains[255][255];

	//! ǰǷҪTCP
	BOOL bNeed_connect;
	//! һηʱ	
	int tmLastSend;

	int m_tcpsocket,m_udpsocket;
	BOOL bBigEndian;

  // ָ룬 c++¼֪ͨ
  void* user_data;

	CALLBACK_OnStatusChanged cbOnStatusChanged;
	CALLBACK_OnDomainRegistered cbOnDomainRegistered;
	CALLBACK_OnUserInfo cbOnUserInfo;
	CALLBACK_OnAccountDomainInfo cbOnAccountDomainInfo;
};

void init_global(PHGlobal *global);
void set_default_callback(PHGlobal *global);

#endif
