#!/bin/bash

CDIR=$(pwd)
TOPDIR=${CDIR}/../../../../
LIBDIR=${TOPDIR}../image_build/gxw-build.cvscontrol/gxw_image_build/base/usr/lib
CACHEFILE="arm-linux.cache"

source ${TOPDIR}tools/build_tools/Path.sh
GS_CFLAGS="-Os -pipe -mips32r2 -mtune=mips32r2 -funit-at-a-time -fhonour-copts -DEVENT_LOGGER_DEBUG=1"

if [ "$1" = "configure" ]; then
    echo ac_cv_linux_vers=2.6.28.8 >  ${CACHEFILE}
    echo ac_cv_func_pcap_datalink_name_to_val=yes >> ${CACHEFILE}

    LDFLAGS=-L${LIBDIR} \
    AR=${GS_AR} AS=${GS_AS} LD=${GS_LD} NM=${GS_NM} CC=${GS_CC}  RANLIB=${GS_RANLIB} BUILDCC=${GS_HOSTCC} \
    CXX=${GS_CXX} OBJCOPY=${GS_OBJCOPY} OBJDUMP=${GS_OBJDUMP} CFLAGS="${GS_CFLAGS} -I${CDIR}/../libpcap-1.0.0" \
    ./configure \
        --host=mips-linux-uclibc \
        --build=x86_64-linux \
        --disable-ipv6 \
        --cache-file=${CACHEFILE}

fi

make clean
make CC=${GS_CC} LD=${GS_LD} LIBDIR=${TOOLCHAIN_DIR}${CROSS_COMPILER_PREFIX}uclibc/lib

cp tcpdump ${LIBDIR}/../bin/
