#!/bin/sh

PATH=/opt/uclibc-toolchain/gcc-4.1.2/toolchain-mipseb/bin/:$PATH
DEST_DIR=`pwd`/temp
CONFIG_FILE=default_gxw42xx

CORES=$(($(cat /proc/cpuinfo | grep -c processor)))
#CORES=1

if [ ! -e include/asm ]; then
	echo "Create symlink for asm-mips"
	ln -s asm-mips/ include/asm
fi

check_status()
{
	if [ "$?" != "0" ]; then
		exit 1
	fi
}

if [ "${1}" = "debug" -o "${2}" = "debug" ]; then
	CONFIG_FILE=default_gxw42xx_debug
	DEST_DIR=`pwd`/temp_debug
else
	CONFIG_FILE=default_gxw42xx
	DEST_DIR=`pwd`/temp
fi

if [ "${1}" = "-clean" ]; then
#	make clean
	make distclean
	exit 0
fi

if [ "${1}" = "-menuconfig" ]; then
	cp ${CONFIG_FILE} .config
	make CROSS=mips-linux- menuconfig
	cp .config ${CONFIG_FILE} .config
	exit 0
fi

diff .config ${CONFIG_FILE} || {
	echo "New configuration"
	make distclean
}

cp ${CONFIG_FILE} .config
make -j${CORES} CROSS=mips-linux-
check_status
cp .config ${CONFIG_FILE}

make PREFIX=$DEST_DIR CROSS=mips-linux- install

#make PREFIX=/opt/uclibc-toolchain/gcc-4.1.2/toolchain-mipseb/ install

#echo Installing uClibc to "/opt/emlix/pnx8181/sysroot"...
#sudo make PREFIX=/opt/emlix/pnx8181/sysroot install
#echo Installing uClibc to "/opt/sysroot"...
#sudo make PREFIX=/opt/sysroot install

