/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */
#include <errno.h>
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "grandstream.h"
#include "nvram.h"

in_addr_t get_nvram_addr( const char *name )
{
    struct in_addr ipaddress ;
    char buffer[256] = { 0 } ;

    nvram_get_safe( name, buffer, 256 ) ;

    if( buffer[0] == 0 )
        return -1 ; 

    if( inet_aton( buffer, &ipaddress ) == 0 )
        return -1 ; 
    return ipaddress.s_addr ;
}

long get_nvram_long( const char *name, int *empty )
{
    long value = 0 ;
    char buffer[256] = { 0 }, *endptr = NULL ;

    nvram_get_safe( name, buffer, 256 ) ;

    if( buffer[0] == 0 )
    {    
        *empty = 1 ;
        return 0 ;
    }    
    else 
    {    
        errno = 0 ;
        value = strtol( buffer, &endptr, 10 ) ;
        if ( (errno == ERANGE && ( value == LONG_MAX ||  value == LONG_MIN))
              || (errno != 0 &&  value == 0))
        {
            *empty = 1 ;
            return 0 ;
        }
        if (endptr == buffer )
        {
            *empty = 1 ;
            return 0 ;
        }
    }    
    return value ;
}

    const oid PartNo_oid[] = { 1,3,6,1,4,1,42397,1,1,1, 0 } ;
    char PartNo_value[256] = { 0 } ;
    char *PartNo_ptr = NULL ;
    const oid networkMode_oid[] = { 1,3,6,1,4,1,42397,1,1,4,1, 0 } ;
    long networkMode_value = 0 ;
    const oid pppoeLink_oid[] = { 1,3,6,1,4,1,42397,1,1,4,2, 0 } ;
    long pppoeLink_value = 0 ;
    const oid natTraversal1_oid[] = { 1,3,6,1,4,1,42397,1,1,4,3, 0 } ;
    long natTraversal1_value = 0 ;
    const oid natTraversal2_oid[] = { 1,3,6,1,4,1,42397,1,1,4,4, 0 } ;
    long natTraversal2_value = 0 ;
    const oid natTraversal3_oid[] = { 1,3,6,1,4,1,42397,1,1,4,5, 0 } ;
    long natTraversal3_value = 0 ;
    const oid natTraversal4_oid[] = { 1,3,6,1,4,1,42397,1,1,4,6, 0 } ;
    long natTraversal4_value = 0 ;
    const oid versionBoot_oid[] = { 1,3,6,1,4,1,42397,1,1,3,1, 0 } ;
    char versionBoot_value[256] = { 0 } ;
    char *versionBoot_ptr = NULL ;
    const oid versionCore_oid[] = { 1,3,6,1,4,1,42397,1,1,3,2, 0 } ;
    char versionCore_value[256] = { 0 } ;
    char *versionCore_ptr = NULL ;
    const oid versionBase_oid[] = { 1,3,6,1,4,1,42397,1,1,3,3, 0 } ;
    char versionBase_value[256] = { 0 } ;
    char *versionBase_ptr = NULL ;
    const oid versionProg_oid[] = { 1,3,6,1,4,1,42397,1,1,3,4, 0 } ;
    char versionProg_value[256] = { 0 } ;
    char *versionProg_ptr = NULL ;
    const oid hookStatus1_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,1, 0 } ;
    char hookStatus1_value[256] = { 0 } ;
    char *hookStatus1_ptr = NULL ;
    const oid hookStatus2_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,2, 0 } ;
    char hookStatus2_value[256] = { 0 } ;
    char *hookStatus2_ptr = NULL ;
    const oid hookStatus3_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,3, 0 } ;
    char hookStatus3_value[256] = { 0 } ;
    char *hookStatus3_ptr = NULL ;
    const oid hookStatus4_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,4, 0 } ;
    char hookStatus4_value[256] = { 0 } ;
    char *hookStatus4_ptr = NULL ;
    const oid hookStatus5_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,5, 0 } ;
    char hookStatus5_value[256] = { 0 } ;
    char *hookStatus5_ptr = NULL ;
    const oid hookStatus6_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,6, 0 } ;
    char hookStatus6_value[256] = { 0 } ;
    char *hookStatus6_ptr = NULL ;
    const oid hookStatus7_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,7, 0 } ;
    char hookStatus7_value[256] = { 0 } ;
    char *hookStatus7_ptr = NULL ;
    const oid hookStatus8_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,8, 0 } ;
    char hookStatus8_value[256] = { 0 } ;
    char *hookStatus8_ptr = NULL ;
    const oid hookStatus9_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,9, 0 } ;
    char hookStatus9_value[256] = { 0 } ;
    char *hookStatus9_ptr = NULL ;
    const oid hookStatus10_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,10, 0 } ;
    char hookStatus10_value[256] = { 0 } ;
    char *hookStatus10_ptr = NULL ;
    const oid hookStatus11_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,11, 0 } ;
    char hookStatus11_value[256] = { 0 } ;
    char *hookStatus11_ptr = NULL ;
    const oid hookStatus12_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,12, 0 } ;
    char hookStatus12_value[256] = { 0 } ;
    char *hookStatus12_ptr = NULL ;
    const oid hookStatus13_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,13, 0 } ;
    char hookStatus13_value[256] = { 0 } ;
    char *hookStatus13_ptr = NULL ;
    const oid hookStatus14_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,14, 0 } ;
    char hookStatus14_value[256] = { 0 } ;
    char *hookStatus14_ptr = NULL ;
    const oid hookStatus15_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,15, 0 } ;
    char hookStatus15_value[256] = { 0 } ;
    char *hookStatus15_ptr = NULL ;
    const oid hookStatus16_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,16, 0 } ;
    char hookStatus16_value[256] = { 0 } ;
    char *hookStatus16_ptr = NULL ;
    const oid hookStatus17_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,17, 0 } ;
    char hookStatus17_value[256] = { 0 } ;
    char *hookStatus17_ptr = NULL ;
    const oid hookStatus18_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,18, 0 } ;
    char hookStatus18_value[256] = { 0 } ;
    char *hookStatus18_ptr = NULL ;
    const oid hookStatus19_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,19, 0 } ;
    char hookStatus19_value[256] = { 0 } ;
    char *hookStatus19_ptr = NULL ;
    const oid hookStatus20_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,20, 0 } ;
    char hookStatus20_value[256] = { 0 } ;
    char *hookStatus20_ptr = NULL ;
    const oid hookStatus21_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,21, 0 } ;
    char hookStatus21_value[256] = { 0 } ;
    char *hookStatus21_ptr = NULL ;
    const oid hookStatus22_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,22, 0 } ;
    char hookStatus22_value[256] = { 0 } ;
    char *hookStatus22_ptr = NULL ;
    const oid hookStatus23_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,23, 0 } ;
    char hookStatus23_value[256] = { 0 } ;
    char *hookStatus23_ptr = NULL ;
    const oid hookStatus24_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,24, 0 } ;
    char hookStatus24_value[256] = { 0 } ;
    char *hookStatus24_ptr = NULL ;
    const oid hookStatus25_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,25, 0 } ;
    char hookStatus25_value[256] = { 0 } ;
    char *hookStatus25_ptr = NULL ;
    const oid hookStatus26_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,26, 0 } ;
    char hookStatus26_value[256] = { 0 } ;
    char *hookStatus26_ptr = NULL ;
    const oid hookStatus27_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,27, 0 } ;
    char hookStatus27_value[256] = { 0 } ;
    char *hookStatus27_ptr = NULL ;
    const oid hookStatus28_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,28, 0 } ;
    char hookStatus28_value[256] = { 0 } ;
    char *hookStatus28_ptr = NULL ;
    const oid hookStatus29_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,29, 0 } ;
    char hookStatus29_value[256] = { 0 } ;
    char *hookStatus29_ptr = NULL ;
    const oid hookStatus30_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,30, 0 } ;
    char hookStatus30_value[256] = { 0 } ;
    char *hookStatus30_ptr = NULL ;
    const oid hookStatus31_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,31, 0 } ;
    char hookStatus31_value[256] = { 0 } ;
    char *hookStatus31_ptr = NULL ;
    const oid hookStatus32_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,32, 0 } ;
    char hookStatus32_value[256] = { 0 } ;
    char *hookStatus32_ptr = NULL ;
    const oid hookStatus33_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,33, 0 } ;
    char hookStatus33_value[256] = { 0 } ;
    char *hookStatus33_ptr = NULL ;
    const oid hookStatus34_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,34, 0 } ;
    char hookStatus34_value[256] = { 0 } ;
    char *hookStatus34_ptr = NULL ;
    const oid hookStatus35_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,35, 0 } ;
    char hookStatus35_value[256] = { 0 } ;
    char *hookStatus35_ptr = NULL ;
    const oid hookStatus36_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,36, 0 } ;
    char hookStatus36_value[256] = { 0 } ;
    char *hookStatus36_ptr = NULL ;
    const oid hookStatus37_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,37, 0 } ;
    char hookStatus37_value[256] = { 0 } ;
    char *hookStatus37_ptr = NULL ;
    const oid hookStatus38_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,38, 0 } ;
    char hookStatus38_value[256] = { 0 } ;
    char *hookStatus38_ptr = NULL ;
    const oid hookStatus39_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,39, 0 } ;
    char hookStatus39_value[256] = { 0 } ;
    char *hookStatus39_ptr = NULL ;
    const oid hookStatus40_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,40, 0 } ;
    char hookStatus40_value[256] = { 0 } ;
    char *hookStatus40_ptr = NULL ;
    const oid hookStatus41_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,41, 0 } ;
    char hookStatus41_value[256] = { 0 } ;
    char *hookStatus41_ptr = NULL ;
    const oid hookStatus42_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,42, 0 } ;
    char hookStatus42_value[256] = { 0 } ;
    char *hookStatus42_ptr = NULL ;
    const oid hookStatus43_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,43, 0 } ;
    char hookStatus43_value[256] = { 0 } ;
    char *hookStatus43_ptr = NULL ;
    const oid hookStatus44_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,44, 0 } ;
    char hookStatus44_value[256] = { 0 } ;
    char *hookStatus44_ptr = NULL ;
    const oid hookStatus45_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,45, 0 } ;
    char hookStatus45_value[256] = { 0 } ;
    char *hookStatus45_ptr = NULL ;
    const oid hookStatus46_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,46, 0 } ;
    char hookStatus46_value[256] = { 0 } ;
    char *hookStatus46_ptr = NULL ;
    const oid hookStatus47_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,47, 0 } ;
    char hookStatus47_value[256] = { 0 } ;
    char *hookStatus47_ptr = NULL ;
    const oid hookStatus48_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,48, 0 } ;
    char hookStatus48_value[256] = { 0 } ;
    char *hookStatus48_ptr = NULL ;
    const oid hookStatus49_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,49, 0 } ;
    char hookStatus49_value[256] = { 0 } ;
    char *hookStatus49_ptr = NULL ;
    const oid hookStatus50_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,50, 0 } ;
    char hookStatus50_value[256] = { 0 } ;
    char *hookStatus50_ptr = NULL ;
    const oid hookStatus51_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,51, 0 } ;
    char hookStatus51_value[256] = { 0 } ;
    char *hookStatus51_ptr = NULL ;
    const oid hookStatus52_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,52, 0 } ;
    char hookStatus52_value[256] = { 0 } ;
    char *hookStatus52_ptr = NULL ;
    const oid hookStatus53_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,53, 0 } ;
    char hookStatus53_value[256] = { 0 } ;
    char *hookStatus53_ptr = NULL ;
    const oid hookStatus54_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,54, 0 } ;
    char hookStatus54_value[256] = { 0 } ;
    char *hookStatus54_ptr = NULL ;
    const oid hookStatus55_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,55, 0 } ;
    char hookStatus55_value[256] = { 0 } ;
    char *hookStatus55_ptr = NULL ;
    const oid hookStatus56_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,56, 0 } ;
    char hookStatus56_value[256] = { 0 } ;
    char *hookStatus56_ptr = NULL ;
    const oid hookStatus57_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,57, 0 } ;
    char hookStatus57_value[256] = { 0 } ;
    char *hookStatus57_ptr = NULL ;
    const oid hookStatus58_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,58, 0 } ;
    char hookStatus58_value[256] = { 0 } ;
    char *hookStatus58_ptr = NULL ;
    const oid hookStatus59_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,59, 0 } ;
    char hookStatus59_value[256] = { 0 } ;
    char *hookStatus59_ptr = NULL ;
    const oid hookStatus60_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,60, 0 } ;
    char hookStatus60_value[256] = { 0 } ;
    char *hookStatus60_ptr = NULL ;
    const oid hookStatus61_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,61, 0 } ;
    char hookStatus61_value[256] = { 0 } ;
    char *hookStatus61_ptr = NULL ;
    const oid hookStatus62_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,62, 0 } ;
    char hookStatus62_value[256] = { 0 } ;
    char *hookStatus62_ptr = NULL ;
    const oid hookStatus63_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,63, 0 } ;
    char hookStatus63_value[256] = { 0 } ;
    char *hookStatus63_ptr = NULL ;
    const oid hookStatus64_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,64, 0 } ;
    char hookStatus64_value[256] = { 0 } ;
    char *hookStatus64_ptr = NULL ;
    const oid hookStatus65_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,65, 0 } ;
    char hookStatus65_value[256] = { 0 } ;
    char *hookStatus65_ptr = NULL ;
    const oid hookStatus66_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,66, 0 } ;
    char hookStatus66_value[256] = { 0 } ;
    char *hookStatus66_ptr = NULL ;
    const oid hookStatus67_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,67, 0 } ;
    char hookStatus67_value[256] = { 0 } ;
    char *hookStatus67_ptr = NULL ;
    const oid hookStatus68_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,68, 0 } ;
    char hookStatus68_value[256] = { 0 } ;
    char *hookStatus68_ptr = NULL ;
    const oid hookStatus69_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,69, 0 } ;
    char hookStatus69_value[256] = { 0 } ;
    char *hookStatus69_ptr = NULL ;
    const oid hookStatus70_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,70, 0 } ;
    char hookStatus70_value[256] = { 0 } ;
    char *hookStatus70_ptr = NULL ;
    const oid hookStatus71_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,71, 0 } ;
    char hookStatus71_value[256] = { 0 } ;
    char *hookStatus71_ptr = NULL ;
    const oid hookStatus72_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,72, 0 } ;
    char hookStatus72_value[256] = { 0 } ;
    char *hookStatus72_ptr = NULL ;
    const oid hookStatus73_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,73, 0 } ;
    char hookStatus73_value[256] = { 0 } ;
    char *hookStatus73_ptr = NULL ;
    const oid hookStatus74_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,74, 0 } ;
    char hookStatus74_value[256] = { 0 } ;
    char *hookStatus74_ptr = NULL ;
    const oid hookStatus75_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,75, 0 } ;
    char hookStatus75_value[256] = { 0 } ;
    char *hookStatus75_ptr = NULL ;
    const oid hookStatus76_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,76, 0 } ;
    char hookStatus76_value[256] = { 0 } ;
    char *hookStatus76_ptr = NULL ;
    const oid hookStatus77_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,77, 0 } ;
    char hookStatus77_value[256] = { 0 } ;
    char *hookStatus77_ptr = NULL ;
    const oid hookStatus78_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,78, 0 } ;
    char hookStatus78_value[256] = { 0 } ;
    char *hookStatus78_ptr = NULL ;
    const oid hookStatus79_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,79, 0 } ;
    char hookStatus79_value[256] = { 0 } ;
    char *hookStatus79_ptr = NULL ;
    const oid hookStatus80_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,80, 0 } ;
    char hookStatus80_value[256] = { 0 } ;
    char *hookStatus80_ptr = NULL ;
    const oid hookStatus81_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,81, 0 } ;
    char hookStatus81_value[256] = { 0 } ;
    char *hookStatus81_ptr = NULL ;
    const oid hookStatus82_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,82, 0 } ;
    char hookStatus82_value[256] = { 0 } ;
    char *hookStatus82_ptr = NULL ;
    const oid hookStatus83_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,83, 0 } ;
    char hookStatus83_value[256] = { 0 } ;
    char *hookStatus83_ptr = NULL ;
    const oid hookStatus84_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,84, 0 } ;
    char hookStatus84_value[256] = { 0 } ;
    char *hookStatus84_ptr = NULL ;
    const oid hookStatus85_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,85, 0 } ;
    char hookStatus85_value[256] = { 0 } ;
    char *hookStatus85_ptr = NULL ;
    const oid hookStatus86_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,86, 0 } ;
    char hookStatus86_value[256] = { 0 } ;
    char *hookStatus86_ptr = NULL ;
    const oid hookStatus87_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,87, 0 } ;
    char hookStatus87_value[256] = { 0 } ;
    char *hookStatus87_ptr = NULL ;
    const oid hookStatus88_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,88, 0 } ;
    char hookStatus88_value[256] = { 0 } ;
    char *hookStatus88_ptr = NULL ;
    const oid hookStatus89_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,89, 0 } ;
    char hookStatus89_value[256] = { 0 } ;
    char *hookStatus89_ptr = NULL ;
    const oid hookStatus90_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,90, 0 } ;
    char hookStatus90_value[256] = { 0 } ;
    char *hookStatus90_ptr = NULL ;
    const oid hookStatus91_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,91, 0 } ;
    char hookStatus91_value[256] = { 0 } ;
    char *hookStatus91_ptr = NULL ;
    const oid hookStatus92_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,92, 0 } ;
    char hookStatus92_value[256] = { 0 } ;
    char *hookStatus92_ptr = NULL ;
    const oid hookStatus93_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,93, 0 } ;
    char hookStatus93_value[256] = { 0 } ;
    char *hookStatus93_ptr = NULL ;
    const oid hookStatus94_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,94, 0 } ;
    char hookStatus94_value[256] = { 0 } ;
    char *hookStatus94_ptr = NULL ;
    const oid hookStatus95_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,95, 0 } ;
    char hookStatus95_value[256] = { 0 } ;
    char *hookStatus95_ptr = NULL ;
    const oid hookStatus96_oid[] = { 1,3,6,1,4,1,42397,1,1,2,1,96, 0 } ;
    char hookStatus96_value[256] = { 0 } ;
    char *hookStatus96_ptr = NULL ;
    const oid regStatus1_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,1, 0 } ;
    char regStatus1_value[256] = { 0 } ;
    char *regStatus1_ptr = NULL ;
    const oid regStatus2_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,2, 0 } ;
    char regStatus2_value[256] = { 0 } ;
    char *regStatus2_ptr = NULL ;
    const oid regStatus3_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,3, 0 } ;
    char regStatus3_value[256] = { 0 } ;
    char *regStatus3_ptr = NULL ;
    const oid regStatus4_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,4, 0 } ;
    char regStatus4_value[256] = { 0 } ;
    char *regStatus4_ptr = NULL ;
    const oid regStatus5_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,5, 0 } ;
    char regStatus5_value[256] = { 0 } ;
    char *regStatus5_ptr = NULL ;
    const oid regStatus6_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,6, 0 } ;
    char regStatus6_value[256] = { 0 } ;
    char *regStatus6_ptr = NULL ;
    const oid regStatus7_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,7, 0 } ;
    char regStatus7_value[256] = { 0 } ;
    char *regStatus7_ptr = NULL ;
    const oid regStatus8_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,8, 0 } ;
    char regStatus8_value[256] = { 0 } ;
    char *regStatus8_ptr = NULL ;
    const oid regStatus9_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,9, 0 } ;
    char regStatus9_value[256] = { 0 } ;
    char *regStatus9_ptr = NULL ;
    const oid regStatus10_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,10, 0 } ;
    char regStatus10_value[256] = { 0 } ;
    char *regStatus10_ptr = NULL ;
    const oid regStatus11_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,11, 0 } ;
    char regStatus11_value[256] = { 0 } ;
    char *regStatus11_ptr = NULL ;
    const oid regStatus12_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,12, 0 } ;
    char regStatus12_value[256] = { 0 } ;
    char *regStatus12_ptr = NULL ;
    const oid regStatus13_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,13, 0 } ;
    char regStatus13_value[256] = { 0 } ;
    char *regStatus13_ptr = NULL ;
    const oid regStatus14_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,14, 0 } ;
    char regStatus14_value[256] = { 0 } ;
    char *regStatus14_ptr = NULL ;
    const oid regStatus15_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,15, 0 } ;
    char regStatus15_value[256] = { 0 } ;
    char *regStatus15_ptr = NULL ;
    const oid regStatus16_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,16, 0 } ;
    char regStatus16_value[256] = { 0 } ;
    char *regStatus16_ptr = NULL ;
    const oid regStatus17_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,17, 0 } ;
    char regStatus17_value[256] = { 0 } ;
    char *regStatus17_ptr = NULL ;
    const oid regStatus18_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,18, 0 } ;
    char regStatus18_value[256] = { 0 } ;
    char *regStatus18_ptr = NULL ;
    const oid regStatus19_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,19, 0 } ;
    char regStatus19_value[256] = { 0 } ;
    char *regStatus19_ptr = NULL ;
    const oid regStatus20_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,20, 0 } ;
    char regStatus20_value[256] = { 0 } ;
    char *regStatus20_ptr = NULL ;
    const oid regStatus21_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,21, 0 } ;
    char regStatus21_value[256] = { 0 } ;
    char *regStatus21_ptr = NULL ;
    const oid regStatus22_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,22, 0 } ;
    char regStatus22_value[256] = { 0 } ;
    char *regStatus22_ptr = NULL ;
    const oid regStatus23_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,23, 0 } ;
    char regStatus23_value[256] = { 0 } ;
    char *regStatus23_ptr = NULL ;
    const oid regStatus24_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,24, 0 } ;
    char regStatus24_value[256] = { 0 } ;
    char *regStatus24_ptr = NULL ;
    const oid regStatus25_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,25, 0 } ;
    char regStatus25_value[256] = { 0 } ;
    char *regStatus25_ptr = NULL ;
    const oid regStatus26_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,26, 0 } ;
    char regStatus26_value[256] = { 0 } ;
    char *regStatus26_ptr = NULL ;
    const oid regStatus27_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,27, 0 } ;
    char regStatus27_value[256] = { 0 } ;
    char *regStatus27_ptr = NULL ;
    const oid regStatus28_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,28, 0 } ;
    char regStatus28_value[256] = { 0 } ;
    char *regStatus28_ptr = NULL ;
    const oid regStatus29_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,29, 0 } ;
    char regStatus29_value[256] = { 0 } ;
    char *regStatus29_ptr = NULL ;
    const oid regStatus30_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,30, 0 } ;
    char regStatus30_value[256] = { 0 } ;
    char *regStatus30_ptr = NULL ;
    const oid regStatus31_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,31, 0 } ;
    char regStatus31_value[256] = { 0 } ;
    char *regStatus31_ptr = NULL ;
    const oid regStatus32_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,32, 0 } ;
    char regStatus32_value[256] = { 0 } ;
    char *regStatus32_ptr = NULL ;
    const oid regStatus33_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,33, 0 } ;
    char regStatus33_value[256] = { 0 } ;
    char *regStatus33_ptr = NULL ;
    const oid regStatus34_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,34, 0 } ;
    char regStatus34_value[256] = { 0 } ;
    char *regStatus34_ptr = NULL ;
    const oid regStatus35_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,35, 0 } ;
    char regStatus35_value[256] = { 0 } ;
    char *regStatus35_ptr = NULL ;
    const oid regStatus36_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,36, 0 } ;
    char regStatus36_value[256] = { 0 } ;
    char *regStatus36_ptr = NULL ;
    const oid regStatus37_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,37, 0 } ;
    char regStatus37_value[256] = { 0 } ;
    char *regStatus37_ptr = NULL ;
    const oid regStatus38_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,38, 0 } ;
    char regStatus38_value[256] = { 0 } ;
    char *regStatus38_ptr = NULL ;
    const oid regStatus39_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,39, 0 } ;
    char regStatus39_value[256] = { 0 } ;
    char *regStatus39_ptr = NULL ;
    const oid regStatus40_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,40, 0 } ;
    char regStatus40_value[256] = { 0 } ;
    char *regStatus40_ptr = NULL ;
    const oid regStatus41_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,41, 0 } ;
    char regStatus41_value[256] = { 0 } ;
    char *regStatus41_ptr = NULL ;
    const oid regStatus42_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,42, 0 } ;
    char regStatus42_value[256] = { 0 } ;
    char *regStatus42_ptr = NULL ;
    const oid regStatus43_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,43, 0 } ;
    char regStatus43_value[256] = { 0 } ;
    char *regStatus43_ptr = NULL ;
    const oid regStatus44_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,44, 0 } ;
    char regStatus44_value[256] = { 0 } ;
    char *regStatus44_ptr = NULL ;
    const oid regStatus45_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,45, 0 } ;
    char regStatus45_value[256] = { 0 } ;
    char *regStatus45_ptr = NULL ;
    const oid regStatus46_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,46, 0 } ;
    char regStatus46_value[256] = { 0 } ;
    char *regStatus46_ptr = NULL ;
    const oid regStatus47_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,47, 0 } ;
    char regStatus47_value[256] = { 0 } ;
    char *regStatus47_ptr = NULL ;
    const oid regStatus48_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,48, 0 } ;
    char regStatus48_value[256] = { 0 } ;
    char *regStatus48_ptr = NULL ;
    const oid regStatus49_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,49, 0 } ;
    char regStatus49_value[256] = { 0 } ;
    char *regStatus49_ptr = NULL ;
    const oid regStatus50_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,50, 0 } ;
    char regStatus50_value[256] = { 0 } ;
    char *regStatus50_ptr = NULL ;
    const oid regStatus51_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,51, 0 } ;
    char regStatus51_value[256] = { 0 } ;
    char *regStatus51_ptr = NULL ;
    const oid regStatus52_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,52, 0 } ;
    char regStatus52_value[256] = { 0 } ;
    char *regStatus52_ptr = NULL ;
    const oid regStatus53_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,53, 0 } ;
    char regStatus53_value[256] = { 0 } ;
    char *regStatus53_ptr = NULL ;
    const oid regStatus54_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,54, 0 } ;
    char regStatus54_value[256] = { 0 } ;
    char *regStatus54_ptr = NULL ;
    const oid regStatus55_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,55, 0 } ;
    char regStatus55_value[256] = { 0 } ;
    char *regStatus55_ptr = NULL ;
    const oid regStatus56_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,56, 0 } ;
    char regStatus56_value[256] = { 0 } ;
    char *regStatus56_ptr = NULL ;
    const oid regStatus57_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,57, 0 } ;
    char regStatus57_value[256] = { 0 } ;
    char *regStatus57_ptr = NULL ;
    const oid regStatus58_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,58, 0 } ;
    char regStatus58_value[256] = { 0 } ;
    char *regStatus58_ptr = NULL ;
    const oid regStatus59_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,59, 0 } ;
    char regStatus59_value[256] = { 0 } ;
    char *regStatus59_ptr = NULL ;
    const oid regStatus60_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,60, 0 } ;
    char regStatus60_value[256] = { 0 } ;
    char *regStatus60_ptr = NULL ;
    const oid regStatus61_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,61, 0 } ;
    char regStatus61_value[256] = { 0 } ;
    char *regStatus61_ptr = NULL ;
    const oid regStatus62_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,62, 0 } ;
    char regStatus62_value[256] = { 0 } ;
    char *regStatus62_ptr = NULL ;
    const oid regStatus63_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,63, 0 } ;
    char regStatus63_value[256] = { 0 } ;
    char *regStatus63_ptr = NULL ;
    const oid regStatus64_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,64, 0 } ;
    char regStatus64_value[256] = { 0 } ;
    char *regStatus64_ptr = NULL ;
    const oid regStatus65_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,65, 0 } ;
    char regStatus65_value[256] = { 0 } ;
    char *regStatus65_ptr = NULL ;
    const oid regStatus66_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,66, 0 } ;
    char regStatus66_value[256] = { 0 } ;
    char *regStatus66_ptr = NULL ;
    const oid regStatus67_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,67, 0 } ;
    char regStatus67_value[256] = { 0 } ;
    char *regStatus67_ptr = NULL ;
    const oid regStatus68_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,68, 0 } ;
    char regStatus68_value[256] = { 0 } ;
    char *regStatus68_ptr = NULL ;
    const oid regStatus69_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,69, 0 } ;
    char regStatus69_value[256] = { 0 } ;
    char *regStatus69_ptr = NULL ;
    const oid regStatus70_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,70, 0 } ;
    char regStatus70_value[256] = { 0 } ;
    char *regStatus70_ptr = NULL ;
    const oid regStatus71_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,71, 0 } ;
    char regStatus71_value[256] = { 0 } ;
    char *regStatus71_ptr = NULL ;
    const oid regStatus72_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,72, 0 } ;
    char regStatus72_value[256] = { 0 } ;
    char *regStatus72_ptr = NULL ;
    const oid regStatus73_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,73, 0 } ;
    char regStatus73_value[256] = { 0 } ;
    char *regStatus73_ptr = NULL ;
    const oid regStatus74_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,74, 0 } ;
    char regStatus74_value[256] = { 0 } ;
    char *regStatus74_ptr = NULL ;
    const oid regStatus75_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,75, 0 } ;
    char regStatus75_value[256] = { 0 } ;
    char *regStatus75_ptr = NULL ;
    const oid regStatus76_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,76, 0 } ;
    char regStatus76_value[256] = { 0 } ;
    char *regStatus76_ptr = NULL ;
    const oid regStatus77_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,77, 0 } ;
    char regStatus77_value[256] = { 0 } ;
    char *regStatus77_ptr = NULL ;
    const oid regStatus78_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,78, 0 } ;
    char regStatus78_value[256] = { 0 } ;
    char *regStatus78_ptr = NULL ;
    const oid regStatus79_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,79, 0 } ;
    char regStatus79_value[256] = { 0 } ;
    char *regStatus79_ptr = NULL ;
    const oid regStatus80_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,80, 0 } ;
    char regStatus80_value[256] = { 0 } ;
    char *regStatus80_ptr = NULL ;
    const oid regStatus81_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,81, 0 } ;
    char regStatus81_value[256] = { 0 } ;
    char *regStatus81_ptr = NULL ;
    const oid regStatus82_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,82, 0 } ;
    char regStatus82_value[256] = { 0 } ;
    char *regStatus82_ptr = NULL ;
    const oid regStatus83_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,83, 0 } ;
    char regStatus83_value[256] = { 0 } ;
    char *regStatus83_ptr = NULL ;
    const oid regStatus84_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,84, 0 } ;
    char regStatus84_value[256] = { 0 } ;
    char *regStatus84_ptr = NULL ;
    const oid regStatus85_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,85, 0 } ;
    char regStatus85_value[256] = { 0 } ;
    char *regStatus85_ptr = NULL ;
    const oid regStatus86_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,86, 0 } ;
    char regStatus86_value[256] = { 0 } ;
    char *regStatus86_ptr = NULL ;
    const oid regStatus87_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,87, 0 } ;
    char regStatus87_value[256] = { 0 } ;
    char *regStatus87_ptr = NULL ;
    const oid regStatus88_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,88, 0 } ;
    char regStatus88_value[256] = { 0 } ;
    char *regStatus88_ptr = NULL ;
    const oid regStatus89_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,89, 0 } ;
    char regStatus89_value[256] = { 0 } ;
    char *regStatus89_ptr = NULL ;
    const oid regStatus90_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,90, 0 } ;
    char regStatus90_value[256] = { 0 } ;
    char *regStatus90_ptr = NULL ;
    const oid regStatus91_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,91, 0 } ;
    char regStatus91_value[256] = { 0 } ;
    char *regStatus91_ptr = NULL ;
    const oid regStatus92_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,92, 0 } ;
    char regStatus92_value[256] = { 0 } ;
    char *regStatus92_ptr = NULL ;
    const oid regStatus93_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,93, 0 } ;
    char regStatus93_value[256] = { 0 } ;
    char *regStatus93_ptr = NULL ;
    const oid regStatus94_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,94, 0 } ;
    char regStatus94_value[256] = { 0 } ;
    char *regStatus94_ptr = NULL ;
    const oid regStatus95_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,95, 0 } ;
    char regStatus95_value[256] = { 0 } ;
    char *regStatus95_ptr = NULL ;
    const oid regStatus96_oid[] = { 1,3,6,1,4,1,42397,1,1,2,2,96, 0 } ;
    char regStatus96_value[256] = { 0 } ;
    char *regStatus96_ptr = NULL ;
    const oid dnd1_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,1, 0 } ;
    long dnd1_value = 0 ;
    const oid dnd2_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,2, 0 } ;
    long dnd2_value = 0 ;
    const oid dnd3_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,3, 0 } ;
    long dnd3_value = 0 ;
    const oid dnd4_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,4, 0 } ;
    long dnd4_value = 0 ;
    const oid dnd5_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,5, 0 } ;
    long dnd5_value = 0 ;
    const oid dnd6_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,6, 0 } ;
    long dnd6_value = 0 ;
    const oid dnd7_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,7, 0 } ;
    long dnd7_value = 0 ;
    const oid dnd8_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,8, 0 } ;
    long dnd8_value = 0 ;
    const oid dnd9_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,9, 0 } ;
    long dnd9_value = 0 ;
    const oid dnd10_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,10, 0 } ;
    long dnd10_value = 0 ;
    const oid dnd11_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,11, 0 } ;
    long dnd11_value = 0 ;
    const oid dnd12_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,12, 0 } ;
    long dnd12_value = 0 ;
    const oid dnd13_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,13, 0 } ;
    long dnd13_value = 0 ;
    const oid dnd14_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,14, 0 } ;
    long dnd14_value = 0 ;
    const oid dnd15_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,15, 0 } ;
    long dnd15_value = 0 ;
    const oid dnd16_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,16, 0 } ;
    long dnd16_value = 0 ;
    const oid dnd17_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,17, 0 } ;
    long dnd17_value = 0 ;
    const oid dnd18_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,18, 0 } ;
    long dnd18_value = 0 ;
    const oid dnd19_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,19, 0 } ;
    long dnd19_value = 0 ;
    const oid dnd20_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,20, 0 } ;
    long dnd20_value = 0 ;
    const oid dnd21_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,21, 0 } ;
    long dnd21_value = 0 ;
    const oid dnd22_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,22, 0 } ;
    long dnd22_value = 0 ;
    const oid dnd23_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,23, 0 } ;
    long dnd23_value = 0 ;
    const oid dnd24_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,24, 0 } ;
    long dnd24_value = 0 ;
    const oid dnd25_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,25, 0 } ;
    long dnd25_value = 0 ;
    const oid dnd26_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,26, 0 } ;
    long dnd26_value = 0 ;
    const oid dnd27_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,27, 0 } ;
    long dnd27_value = 0 ;
    const oid dnd28_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,28, 0 } ;
    long dnd28_value = 0 ;
    const oid dnd29_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,29, 0 } ;
    long dnd29_value = 0 ;
    const oid dnd30_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,30, 0 } ;
    long dnd30_value = 0 ;
    const oid dnd31_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,31, 0 } ;
    long dnd31_value = 0 ;
    const oid dnd32_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,32, 0 } ;
    long dnd32_value = 0 ;
    const oid dnd33_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,33, 0 } ;
    long dnd33_value = 0 ;
    const oid dnd34_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,34, 0 } ;
    long dnd34_value = 0 ;
    const oid dnd35_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,35, 0 } ;
    long dnd35_value = 0 ;
    const oid dnd36_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,36, 0 } ;
    long dnd36_value = 0 ;
    const oid dnd37_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,37, 0 } ;
    long dnd37_value = 0 ;
    const oid dnd38_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,38, 0 } ;
    long dnd38_value = 0 ;
    const oid dnd39_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,39, 0 } ;
    long dnd39_value = 0 ;
    const oid dnd40_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,40, 0 } ;
    long dnd40_value = 0 ;
    const oid dnd41_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,41, 0 } ;
    long dnd41_value = 0 ;
    const oid dnd42_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,42, 0 } ;
    long dnd42_value = 0 ;
    const oid dnd43_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,43, 0 } ;
    long dnd43_value = 0 ;
    const oid dnd44_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,44, 0 } ;
    long dnd44_value = 0 ;
    const oid dnd45_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,45, 0 } ;
    long dnd45_value = 0 ;
    const oid dnd46_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,46, 0 } ;
    long dnd46_value = 0 ;
    const oid dnd47_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,47, 0 } ;
    long dnd47_value = 0 ;
    const oid dnd48_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,48, 0 } ;
    long dnd48_value = 0 ;
    const oid dnd49_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,49, 0 } ;
    long dnd49_value = 0 ;
    const oid dnd50_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,50, 0 } ;
    long dnd50_value = 0 ;
    const oid dnd51_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,51, 0 } ;
    long dnd51_value = 0 ;
    const oid dnd52_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,52, 0 } ;
    long dnd52_value = 0 ;
    const oid dnd53_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,53, 0 } ;
    long dnd53_value = 0 ;
    const oid dnd54_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,54, 0 } ;
    long dnd54_value = 0 ;
    const oid dnd55_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,55, 0 } ;
    long dnd55_value = 0 ;
    const oid dnd56_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,56, 0 } ;
    long dnd56_value = 0 ;
    const oid dnd57_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,57, 0 } ;
    long dnd57_value = 0 ;
    const oid dnd58_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,58, 0 } ;
    long dnd58_value = 0 ;
    const oid dnd59_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,59, 0 } ;
    long dnd59_value = 0 ;
    const oid dnd60_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,60, 0 } ;
    long dnd60_value = 0 ;
    const oid dnd61_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,61, 0 } ;
    long dnd61_value = 0 ;
    const oid dnd62_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,62, 0 } ;
    long dnd62_value = 0 ;
    const oid dnd63_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,63, 0 } ;
    long dnd63_value = 0 ;
    const oid dnd64_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,64, 0 } ;
    long dnd64_value = 0 ;
    const oid dnd65_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,65, 0 } ;
    long dnd65_value = 0 ;
    const oid dnd66_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,66, 0 } ;
    long dnd66_value = 0 ;
    const oid dnd67_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,67, 0 } ;
    long dnd67_value = 0 ;
    const oid dnd68_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,68, 0 } ;
    long dnd68_value = 0 ;
    const oid dnd69_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,69, 0 } ;
    long dnd69_value = 0 ;
    const oid dnd70_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,70, 0 } ;
    long dnd70_value = 0 ;
    const oid dnd71_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,71, 0 } ;
    long dnd71_value = 0 ;
    const oid dnd72_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,72, 0 } ;
    long dnd72_value = 0 ;
    const oid dnd73_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,73, 0 } ;
    long dnd73_value = 0 ;
    const oid dnd74_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,74, 0 } ;
    long dnd74_value = 0 ;
    const oid dnd75_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,75, 0 } ;
    long dnd75_value = 0 ;
    const oid dnd76_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,76, 0 } ;
    long dnd76_value = 0 ;
    const oid dnd77_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,77, 0 } ;
    long dnd77_value = 0 ;
    const oid dnd78_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,78, 0 } ;
    long dnd78_value = 0 ;
    const oid dnd79_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,79, 0 } ;
    long dnd79_value = 0 ;
    const oid dnd80_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,80, 0 } ;
    long dnd80_value = 0 ;
    const oid dnd81_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,81, 0 } ;
    long dnd81_value = 0 ;
    const oid dnd82_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,82, 0 } ;
    long dnd82_value = 0 ;
    const oid dnd83_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,83, 0 } ;
    long dnd83_value = 0 ;
    const oid dnd84_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,84, 0 } ;
    long dnd84_value = 0 ;
    const oid dnd85_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,85, 0 } ;
    long dnd85_value = 0 ;
    const oid dnd86_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,86, 0 } ;
    long dnd86_value = 0 ;
    const oid dnd87_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,87, 0 } ;
    long dnd87_value = 0 ;
    const oid dnd88_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,88, 0 } ;
    long dnd88_value = 0 ;
    const oid dnd89_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,89, 0 } ;
    long dnd89_value = 0 ;
    const oid dnd90_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,90, 0 } ;
    long dnd90_value = 0 ;
    const oid dnd91_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,91, 0 } ;
    long dnd91_value = 0 ;
    const oid dnd92_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,92, 0 } ;
    long dnd92_value = 0 ;
    const oid dnd93_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,93, 0 } ;
    long dnd93_value = 0 ;
    const oid dnd94_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,94, 0 } ;
    long dnd94_value = 0 ;
    const oid dnd95_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,95, 0 } ;
    long dnd95_value = 0 ;
    const oid dnd96_oid[] = { 1,3,6,1,4,1,42397,1,1,2,3,96, 0 } ;
    long dnd96_value = 0 ;
    const oid forward1_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,1, 0 } ;
    char forward1_value[256] = { 0 } ;
    char *forward1_ptr = NULL ;
    const oid forward2_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,2, 0 } ;
    char forward2_value[256] = { 0 } ;
    char *forward2_ptr = NULL ;
    const oid forward3_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,3, 0 } ;
    char forward3_value[256] = { 0 } ;
    char *forward3_ptr = NULL ;
    const oid forward4_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,4, 0 } ;
    char forward4_value[256] = { 0 } ;
    char *forward4_ptr = NULL ;
    const oid forward5_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,5, 0 } ;
    char forward5_value[256] = { 0 } ;
    char *forward5_ptr = NULL ;
    const oid forward6_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,6, 0 } ;
    char forward6_value[256] = { 0 } ;
    char *forward6_ptr = NULL ;
    const oid forward7_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,7, 0 } ;
    char forward7_value[256] = { 0 } ;
    char *forward7_ptr = NULL ;
    const oid forward8_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,8, 0 } ;
    char forward8_value[256] = { 0 } ;
    char *forward8_ptr = NULL ;
    const oid forward9_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,9, 0 } ;
    char forward9_value[256] = { 0 } ;
    char *forward9_ptr = NULL ;
    const oid forward10_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,10, 0 } ;
    char forward10_value[256] = { 0 } ;
    char *forward10_ptr = NULL ;
    const oid forward11_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,11, 0 } ;
    char forward11_value[256] = { 0 } ;
    char *forward11_ptr = NULL ;
    const oid forward12_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,12, 0 } ;
    char forward12_value[256] = { 0 } ;
    char *forward12_ptr = NULL ;
    const oid forward13_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,13, 0 } ;
    char forward13_value[256] = { 0 } ;
    char *forward13_ptr = NULL ;
    const oid forward14_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,14, 0 } ;
    char forward14_value[256] = { 0 } ;
    char *forward14_ptr = NULL ;
    const oid forward15_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,15, 0 } ;
    char forward15_value[256] = { 0 } ;
    char *forward15_ptr = NULL ;
    const oid forward16_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,16, 0 } ;
    char forward16_value[256] = { 0 } ;
    char *forward16_ptr = NULL ;
    const oid forward17_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,17, 0 } ;
    char forward17_value[256] = { 0 } ;
    char *forward17_ptr = NULL ;
    const oid forward18_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,18, 0 } ;
    char forward18_value[256] = { 0 } ;
    char *forward18_ptr = NULL ;
    const oid forward19_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,19, 0 } ;
    char forward19_value[256] = { 0 } ;
    char *forward19_ptr = NULL ;
    const oid forward20_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,20, 0 } ;
    char forward20_value[256] = { 0 } ;
    char *forward20_ptr = NULL ;
    const oid forward21_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,21, 0 } ;
    char forward21_value[256] = { 0 } ;
    char *forward21_ptr = NULL ;
    const oid forward22_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,22, 0 } ;
    char forward22_value[256] = { 0 } ;
    char *forward22_ptr = NULL ;
    const oid forward23_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,23, 0 } ;
    char forward23_value[256] = { 0 } ;
    char *forward23_ptr = NULL ;
    const oid forward24_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,24, 0 } ;
    char forward24_value[256] = { 0 } ;
    char *forward24_ptr = NULL ;
    const oid forward25_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,25, 0 } ;
    char forward25_value[256] = { 0 } ;
    char *forward25_ptr = NULL ;
    const oid forward26_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,26, 0 } ;
    char forward26_value[256] = { 0 } ;
    char *forward26_ptr = NULL ;
    const oid forward27_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,27, 0 } ;
    char forward27_value[256] = { 0 } ;
    char *forward27_ptr = NULL ;
    const oid forward28_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,28, 0 } ;
    char forward28_value[256] = { 0 } ;
    char *forward28_ptr = NULL ;
    const oid forward29_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,29, 0 } ;
    char forward29_value[256] = { 0 } ;
    char *forward29_ptr = NULL ;
    const oid forward30_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,30, 0 } ;
    char forward30_value[256] = { 0 } ;
    char *forward30_ptr = NULL ;
    const oid forward31_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,31, 0 } ;
    char forward31_value[256] = { 0 } ;
    char *forward31_ptr = NULL ;
    const oid forward32_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,32, 0 } ;
    char forward32_value[256] = { 0 } ;
    char *forward32_ptr = NULL ;
    const oid forward33_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,33, 0 } ;
    char forward33_value[256] = { 0 } ;
    char *forward33_ptr = NULL ;
    const oid forward34_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,34, 0 } ;
    char forward34_value[256] = { 0 } ;
    char *forward34_ptr = NULL ;
    const oid forward35_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,35, 0 } ;
    char forward35_value[256] = { 0 } ;
    char *forward35_ptr = NULL ;
    const oid forward36_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,36, 0 } ;
    char forward36_value[256] = { 0 } ;
    char *forward36_ptr = NULL ;
    const oid forward37_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,37, 0 } ;
    char forward37_value[256] = { 0 } ;
    char *forward37_ptr = NULL ;
    const oid forward38_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,38, 0 } ;
    char forward38_value[256] = { 0 } ;
    char *forward38_ptr = NULL ;
    const oid forward39_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,39, 0 } ;
    char forward39_value[256] = { 0 } ;
    char *forward39_ptr = NULL ;
    const oid forward40_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,40, 0 } ;
    char forward40_value[256] = { 0 } ;
    char *forward40_ptr = NULL ;
    const oid forward41_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,41, 0 } ;
    char forward41_value[256] = { 0 } ;
    char *forward41_ptr = NULL ;
    const oid forward42_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,42, 0 } ;
    char forward42_value[256] = { 0 } ;
    char *forward42_ptr = NULL ;
    const oid forward43_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,43, 0 } ;
    char forward43_value[256] = { 0 } ;
    char *forward43_ptr = NULL ;
    const oid forward44_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,44, 0 } ;
    char forward44_value[256] = { 0 } ;
    char *forward44_ptr = NULL ;
    const oid forward45_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,45, 0 } ;
    char forward45_value[256] = { 0 } ;
    char *forward45_ptr = NULL ;
    const oid forward46_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,46, 0 } ;
    char forward46_value[256] = { 0 } ;
    char *forward46_ptr = NULL ;
    const oid forward47_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,47, 0 } ;
    char forward47_value[256] = { 0 } ;
    char *forward47_ptr = NULL ;
    const oid forward48_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,48, 0 } ;
    char forward48_value[256] = { 0 } ;
    char *forward48_ptr = NULL ;
    const oid forward49_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,49, 0 } ;
    char forward49_value[256] = { 0 } ;
    char *forward49_ptr = NULL ;
    const oid forward50_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,50, 0 } ;
    char forward50_value[256] = { 0 } ;
    char *forward50_ptr = NULL ;
    const oid forward51_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,51, 0 } ;
    char forward51_value[256] = { 0 } ;
    char *forward51_ptr = NULL ;
    const oid forward52_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,52, 0 } ;
    char forward52_value[256] = { 0 } ;
    char *forward52_ptr = NULL ;
    const oid forward53_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,53, 0 } ;
    char forward53_value[256] = { 0 } ;
    char *forward53_ptr = NULL ;
    const oid forward54_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,54, 0 } ;
    char forward54_value[256] = { 0 } ;
    char *forward54_ptr = NULL ;
    const oid forward55_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,55, 0 } ;
    char forward55_value[256] = { 0 } ;
    char *forward55_ptr = NULL ;
    const oid forward56_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,56, 0 } ;
    char forward56_value[256] = { 0 } ;
    char *forward56_ptr = NULL ;
    const oid forward57_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,57, 0 } ;
    char forward57_value[256] = { 0 } ;
    char *forward57_ptr = NULL ;
    const oid forward58_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,58, 0 } ;
    char forward58_value[256] = { 0 } ;
    char *forward58_ptr = NULL ;
    const oid forward59_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,59, 0 } ;
    char forward59_value[256] = { 0 } ;
    char *forward59_ptr = NULL ;
    const oid forward60_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,60, 0 } ;
    char forward60_value[256] = { 0 } ;
    char *forward60_ptr = NULL ;
    const oid forward61_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,61, 0 } ;
    char forward61_value[256] = { 0 } ;
    char *forward61_ptr = NULL ;
    const oid forward62_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,62, 0 } ;
    char forward62_value[256] = { 0 } ;
    char *forward62_ptr = NULL ;
    const oid forward63_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,63, 0 } ;
    char forward63_value[256] = { 0 } ;
    char *forward63_ptr = NULL ;
    const oid forward64_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,64, 0 } ;
    char forward64_value[256] = { 0 } ;
    char *forward64_ptr = NULL ;
    const oid forward65_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,65, 0 } ;
    char forward65_value[256] = { 0 } ;
    char *forward65_ptr = NULL ;
    const oid forward66_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,66, 0 } ;
    char forward66_value[256] = { 0 } ;
    char *forward66_ptr = NULL ;
    const oid forward67_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,67, 0 } ;
    char forward67_value[256] = { 0 } ;
    char *forward67_ptr = NULL ;
    const oid forward68_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,68, 0 } ;
    char forward68_value[256] = { 0 } ;
    char *forward68_ptr = NULL ;
    const oid forward69_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,69, 0 } ;
    char forward69_value[256] = { 0 } ;
    char *forward69_ptr = NULL ;
    const oid forward70_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,70, 0 } ;
    char forward70_value[256] = { 0 } ;
    char *forward70_ptr = NULL ;
    const oid forward71_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,71, 0 } ;
    char forward71_value[256] = { 0 } ;
    char *forward71_ptr = NULL ;
    const oid forward72_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,72, 0 } ;
    char forward72_value[256] = { 0 } ;
    char *forward72_ptr = NULL ;
    const oid forward73_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,73, 0 } ;
    char forward73_value[256] = { 0 } ;
    char *forward73_ptr = NULL ;
    const oid forward74_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,74, 0 } ;
    char forward74_value[256] = { 0 } ;
    char *forward74_ptr = NULL ;
    const oid forward75_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,75, 0 } ;
    char forward75_value[256] = { 0 } ;
    char *forward75_ptr = NULL ;
    const oid forward76_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,76, 0 } ;
    char forward76_value[256] = { 0 } ;
    char *forward76_ptr = NULL ;
    const oid forward77_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,77, 0 } ;
    char forward77_value[256] = { 0 } ;
    char *forward77_ptr = NULL ;
    const oid forward78_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,78, 0 } ;
    char forward78_value[256] = { 0 } ;
    char *forward78_ptr = NULL ;
    const oid forward79_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,79, 0 } ;
    char forward79_value[256] = { 0 } ;
    char *forward79_ptr = NULL ;
    const oid forward80_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,80, 0 } ;
    char forward80_value[256] = { 0 } ;
    char *forward80_ptr = NULL ;
    const oid forward81_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,81, 0 } ;
    char forward81_value[256] = { 0 } ;
    char *forward81_ptr = NULL ;
    const oid forward82_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,82, 0 } ;
    char forward82_value[256] = { 0 } ;
    char *forward82_ptr = NULL ;
    const oid forward83_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,83, 0 } ;
    char forward83_value[256] = { 0 } ;
    char *forward83_ptr = NULL ;
    const oid forward84_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,84, 0 } ;
    char forward84_value[256] = { 0 } ;
    char *forward84_ptr = NULL ;
    const oid forward85_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,85, 0 } ;
    char forward85_value[256] = { 0 } ;
    char *forward85_ptr = NULL ;
    const oid forward86_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,86, 0 } ;
    char forward86_value[256] = { 0 } ;
    char *forward86_ptr = NULL ;
    const oid forward87_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,87, 0 } ;
    char forward87_value[256] = { 0 } ;
    char *forward87_ptr = NULL ;
    const oid forward88_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,88, 0 } ;
    char forward88_value[256] = { 0 } ;
    char *forward88_ptr = NULL ;
    const oid forward89_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,89, 0 } ;
    char forward89_value[256] = { 0 } ;
    char *forward89_ptr = NULL ;
    const oid forward90_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,90, 0 } ;
    char forward90_value[256] = { 0 } ;
    char *forward90_ptr = NULL ;
    const oid forward91_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,91, 0 } ;
    char forward91_value[256] = { 0 } ;
    char *forward91_ptr = NULL ;
    const oid forward92_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,92, 0 } ;
    char forward92_value[256] = { 0 } ;
    char *forward92_ptr = NULL ;
    const oid forward93_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,93, 0 } ;
    char forward93_value[256] = { 0 } ;
    char *forward93_ptr = NULL ;
    const oid forward94_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,94, 0 } ;
    char forward94_value[256] = { 0 } ;
    char *forward94_ptr = NULL ;
    const oid forward95_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,95, 0 } ;
    char forward95_value[256] = { 0 } ;
    char *forward95_ptr = NULL ;
    const oid forward96_oid[] = { 1,3,6,1,4,1,42397,1,1,2,4,96, 0 } ;
    char forward96_value[256] = { 0 } ;
    char *forward96_ptr = NULL ;
    const oid busyForward1_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,1, 0 } ;
    char busyForward1_value[256] = { 0 } ;
    char *busyForward1_ptr = NULL ;
    const oid busyForward2_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,2, 0 } ;
    char busyForward2_value[256] = { 0 } ;
    char *busyForward2_ptr = NULL ;
    const oid busyForward3_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,3, 0 } ;
    char busyForward3_value[256] = { 0 } ;
    char *busyForward3_ptr = NULL ;
    const oid busyForward4_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,4, 0 } ;
    char busyForward4_value[256] = { 0 } ;
    char *busyForward4_ptr = NULL ;
    const oid busyForward5_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,5, 0 } ;
    char busyForward5_value[256] = { 0 } ;
    char *busyForward5_ptr = NULL ;
    const oid busyForward6_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,6, 0 } ;
    char busyForward6_value[256] = { 0 } ;
    char *busyForward6_ptr = NULL ;
    const oid busyForward7_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,7, 0 } ;
    char busyForward7_value[256] = { 0 } ;
    char *busyForward7_ptr = NULL ;
    const oid busyForward8_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,8, 0 } ;
    char busyForward8_value[256] = { 0 } ;
    char *busyForward8_ptr = NULL ;
    const oid busyForward9_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,9, 0 } ;
    char busyForward9_value[256] = { 0 } ;
    char *busyForward9_ptr = NULL ;
    const oid busyForward10_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,10, 0 } ;
    char busyForward10_value[256] = { 0 } ;
    char *busyForward10_ptr = NULL ;
    const oid busyForward11_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,11, 0 } ;
    char busyForward11_value[256] = { 0 } ;
    char *busyForward11_ptr = NULL ;
    const oid busyForward12_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,12, 0 } ;
    char busyForward12_value[256] = { 0 } ;
    char *busyForward12_ptr = NULL ;
    const oid busyForward13_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,13, 0 } ;
    char busyForward13_value[256] = { 0 } ;
    char *busyForward13_ptr = NULL ;
    const oid busyForward14_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,14, 0 } ;
    char busyForward14_value[256] = { 0 } ;
    char *busyForward14_ptr = NULL ;
    const oid busyForward15_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,15, 0 } ;
    char busyForward15_value[256] = { 0 } ;
    char *busyForward15_ptr = NULL ;
    const oid busyForward16_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,16, 0 } ;
    char busyForward16_value[256] = { 0 } ;
    char *busyForward16_ptr = NULL ;
    const oid busyForward17_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,17, 0 } ;
    char busyForward17_value[256] = { 0 } ;
    char *busyForward17_ptr = NULL ;
    const oid busyForward18_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,18, 0 } ;
    char busyForward18_value[256] = { 0 } ;
    char *busyForward18_ptr = NULL ;
    const oid busyForward19_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,19, 0 } ;
    char busyForward19_value[256] = { 0 } ;
    char *busyForward19_ptr = NULL ;
    const oid busyForward20_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,20, 0 } ;
    char busyForward20_value[256] = { 0 } ;
    char *busyForward20_ptr = NULL ;
    const oid busyForward21_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,21, 0 } ;
    char busyForward21_value[256] = { 0 } ;
    char *busyForward21_ptr = NULL ;
    const oid busyForward22_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,22, 0 } ;
    char busyForward22_value[256] = { 0 } ;
    char *busyForward22_ptr = NULL ;
    const oid busyForward23_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,23, 0 } ;
    char busyForward23_value[256] = { 0 } ;
    char *busyForward23_ptr = NULL ;
    const oid busyForward24_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,24, 0 } ;
    char busyForward24_value[256] = { 0 } ;
    char *busyForward24_ptr = NULL ;
    const oid busyForward25_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,25, 0 } ;
    char busyForward25_value[256] = { 0 } ;
    char *busyForward25_ptr = NULL ;
    const oid busyForward26_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,26, 0 } ;
    char busyForward26_value[256] = { 0 } ;
    char *busyForward26_ptr = NULL ;
    const oid busyForward27_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,27, 0 } ;
    char busyForward27_value[256] = { 0 } ;
    char *busyForward27_ptr = NULL ;
    const oid busyForward28_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,28, 0 } ;
    char busyForward28_value[256] = { 0 } ;
    char *busyForward28_ptr = NULL ;
    const oid busyForward29_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,29, 0 } ;
    char busyForward29_value[256] = { 0 } ;
    char *busyForward29_ptr = NULL ;
    const oid busyForward30_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,30, 0 } ;
    char busyForward30_value[256] = { 0 } ;
    char *busyForward30_ptr = NULL ;
    const oid busyForward31_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,31, 0 } ;
    char busyForward31_value[256] = { 0 } ;
    char *busyForward31_ptr = NULL ;
    const oid busyForward32_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,32, 0 } ;
    char busyForward32_value[256] = { 0 } ;
    char *busyForward32_ptr = NULL ;
    const oid busyForward33_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,33, 0 } ;
    char busyForward33_value[256] = { 0 } ;
    char *busyForward33_ptr = NULL ;
    const oid busyForward34_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,34, 0 } ;
    char busyForward34_value[256] = { 0 } ;
    char *busyForward34_ptr = NULL ;
    const oid busyForward35_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,35, 0 } ;
    char busyForward35_value[256] = { 0 } ;
    char *busyForward35_ptr = NULL ;
    const oid busyForward36_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,36, 0 } ;
    char busyForward36_value[256] = { 0 } ;
    char *busyForward36_ptr = NULL ;
    const oid busyForward37_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,37, 0 } ;
    char busyForward37_value[256] = { 0 } ;
    char *busyForward37_ptr = NULL ;
    const oid busyForward38_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,38, 0 } ;
    char busyForward38_value[256] = { 0 } ;
    char *busyForward38_ptr = NULL ;
    const oid busyForward39_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,39, 0 } ;
    char busyForward39_value[256] = { 0 } ;
    char *busyForward39_ptr = NULL ;
    const oid busyForward40_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,40, 0 } ;
    char busyForward40_value[256] = { 0 } ;
    char *busyForward40_ptr = NULL ;
    const oid busyForward41_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,41, 0 } ;
    char busyForward41_value[256] = { 0 } ;
    char *busyForward41_ptr = NULL ;
    const oid busyForward42_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,42, 0 } ;
    char busyForward42_value[256] = { 0 } ;
    char *busyForward42_ptr = NULL ;
    const oid busyForward43_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,43, 0 } ;
    char busyForward43_value[256] = { 0 } ;
    char *busyForward43_ptr = NULL ;
    const oid busyForward44_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,44, 0 } ;
    char busyForward44_value[256] = { 0 } ;
    char *busyForward44_ptr = NULL ;
    const oid busyForward45_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,45, 0 } ;
    char busyForward45_value[256] = { 0 } ;
    char *busyForward45_ptr = NULL ;
    const oid busyForward46_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,46, 0 } ;
    char busyForward46_value[256] = { 0 } ;
    char *busyForward46_ptr = NULL ;
    const oid busyForward47_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,47, 0 } ;
    char busyForward47_value[256] = { 0 } ;
    char *busyForward47_ptr = NULL ;
    const oid busyForward48_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,48, 0 } ;
    char busyForward48_value[256] = { 0 } ;
    char *busyForward48_ptr = NULL ;
    const oid busyForward49_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,49, 0 } ;
    char busyForward49_value[256] = { 0 } ;
    char *busyForward49_ptr = NULL ;
    const oid busyForward50_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,50, 0 } ;
    char busyForward50_value[256] = { 0 } ;
    char *busyForward50_ptr = NULL ;
    const oid busyForward51_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,51, 0 } ;
    char busyForward51_value[256] = { 0 } ;
    char *busyForward51_ptr = NULL ;
    const oid busyForward52_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,52, 0 } ;
    char busyForward52_value[256] = { 0 } ;
    char *busyForward52_ptr = NULL ;
    const oid busyForward53_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,53, 0 } ;
    char busyForward53_value[256] = { 0 } ;
    char *busyForward53_ptr = NULL ;
    const oid busyForward54_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,54, 0 } ;
    char busyForward54_value[256] = { 0 } ;
    char *busyForward54_ptr = NULL ;
    const oid busyForward55_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,55, 0 } ;
    char busyForward55_value[256] = { 0 } ;
    char *busyForward55_ptr = NULL ;
    const oid busyForward56_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,56, 0 } ;
    char busyForward56_value[256] = { 0 } ;
    char *busyForward56_ptr = NULL ;
    const oid busyForward57_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,57, 0 } ;
    char busyForward57_value[256] = { 0 } ;
    char *busyForward57_ptr = NULL ;
    const oid busyForward58_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,58, 0 } ;
    char busyForward58_value[256] = { 0 } ;
    char *busyForward58_ptr = NULL ;
    const oid busyForward59_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,59, 0 } ;
    char busyForward59_value[256] = { 0 } ;
    char *busyForward59_ptr = NULL ;
    const oid busyForward60_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,60, 0 } ;
    char busyForward60_value[256] = { 0 } ;
    char *busyForward60_ptr = NULL ;
    const oid busyForward61_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,61, 0 } ;
    char busyForward61_value[256] = { 0 } ;
    char *busyForward61_ptr = NULL ;
    const oid busyForward62_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,62, 0 } ;
    char busyForward62_value[256] = { 0 } ;
    char *busyForward62_ptr = NULL ;
    const oid busyForward63_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,63, 0 } ;
    char busyForward63_value[256] = { 0 } ;
    char *busyForward63_ptr = NULL ;
    const oid busyForward64_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,64, 0 } ;
    char busyForward64_value[256] = { 0 } ;
    char *busyForward64_ptr = NULL ;
    const oid busyForward65_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,65, 0 } ;
    char busyForward65_value[256] = { 0 } ;
    char *busyForward65_ptr = NULL ;
    const oid busyForward66_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,66, 0 } ;
    char busyForward66_value[256] = { 0 } ;
    char *busyForward66_ptr = NULL ;
    const oid busyForward67_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,67, 0 } ;
    char busyForward67_value[256] = { 0 } ;
    char *busyForward67_ptr = NULL ;
    const oid busyForward68_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,68, 0 } ;
    char busyForward68_value[256] = { 0 } ;
    char *busyForward68_ptr = NULL ;
    const oid busyForward69_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,69, 0 } ;
    char busyForward69_value[256] = { 0 } ;
    char *busyForward69_ptr = NULL ;
    const oid busyForward70_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,70, 0 } ;
    char busyForward70_value[256] = { 0 } ;
    char *busyForward70_ptr = NULL ;
    const oid busyForward71_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,71, 0 } ;
    char busyForward71_value[256] = { 0 } ;
    char *busyForward71_ptr = NULL ;
    const oid busyForward72_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,72, 0 } ;
    char busyForward72_value[256] = { 0 } ;
    char *busyForward72_ptr = NULL ;
    const oid busyForward73_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,73, 0 } ;
    char busyForward73_value[256] = { 0 } ;
    char *busyForward73_ptr = NULL ;
    const oid busyForward74_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,74, 0 } ;
    char busyForward74_value[256] = { 0 } ;
    char *busyForward74_ptr = NULL ;
    const oid busyForward75_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,75, 0 } ;
    char busyForward75_value[256] = { 0 } ;
    char *busyForward75_ptr = NULL ;
    const oid busyForward76_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,76, 0 } ;
    char busyForward76_value[256] = { 0 } ;
    char *busyForward76_ptr = NULL ;
    const oid busyForward77_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,77, 0 } ;
    char busyForward77_value[256] = { 0 } ;
    char *busyForward77_ptr = NULL ;
    const oid busyForward78_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,78, 0 } ;
    char busyForward78_value[256] = { 0 } ;
    char *busyForward78_ptr = NULL ;
    const oid busyForward79_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,79, 0 } ;
    char busyForward79_value[256] = { 0 } ;
    char *busyForward79_ptr = NULL ;
    const oid busyForward80_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,80, 0 } ;
    char busyForward80_value[256] = { 0 } ;
    char *busyForward80_ptr = NULL ;
    const oid busyForward81_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,81, 0 } ;
    char busyForward81_value[256] = { 0 } ;
    char *busyForward81_ptr = NULL ;
    const oid busyForward82_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,82, 0 } ;
    char busyForward82_value[256] = { 0 } ;
    char *busyForward82_ptr = NULL ;
    const oid busyForward83_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,83, 0 } ;
    char busyForward83_value[256] = { 0 } ;
    char *busyForward83_ptr = NULL ;
    const oid busyForward84_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,84, 0 } ;
    char busyForward84_value[256] = { 0 } ;
    char *busyForward84_ptr = NULL ;
    const oid busyForward85_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,85, 0 } ;
    char busyForward85_value[256] = { 0 } ;
    char *busyForward85_ptr = NULL ;
    const oid busyForward86_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,86, 0 } ;
    char busyForward86_value[256] = { 0 } ;
    char *busyForward86_ptr = NULL ;
    const oid busyForward87_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,87, 0 } ;
    char busyForward87_value[256] = { 0 } ;
    char *busyForward87_ptr = NULL ;
    const oid busyForward88_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,88, 0 } ;
    char busyForward88_value[256] = { 0 } ;
    char *busyForward88_ptr = NULL ;
    const oid busyForward89_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,89, 0 } ;
    char busyForward89_value[256] = { 0 } ;
    char *busyForward89_ptr = NULL ;
    const oid busyForward90_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,90, 0 } ;
    char busyForward90_value[256] = { 0 } ;
    char *busyForward90_ptr = NULL ;
    const oid busyForward91_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,91, 0 } ;
    char busyForward91_value[256] = { 0 } ;
    char *busyForward91_ptr = NULL ;
    const oid busyForward92_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,92, 0 } ;
    char busyForward92_value[256] = { 0 } ;
    char *busyForward92_ptr = NULL ;
    const oid busyForward93_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,93, 0 } ;
    char busyForward93_value[256] = { 0 } ;
    char *busyForward93_ptr = NULL ;
    const oid busyForward94_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,94, 0 } ;
    char busyForward94_value[256] = { 0 } ;
    char *busyForward94_ptr = NULL ;
    const oid busyForward95_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,95, 0 } ;
    char busyForward95_value[256] = { 0 } ;
    char *busyForward95_ptr = NULL ;
    const oid busyForward96_oid[] = { 1,3,6,1,4,1,42397,1,1,2,5,96, 0 } ;
    char busyForward96_value[256] = { 0 } ;
    char *busyForward96_ptr = NULL ;
    const oid delayedForward1_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,1, 0 } ;
    char delayedForward1_value[256] = { 0 } ;
    char *delayedForward1_ptr = NULL ;
    const oid delayedForward2_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,2, 0 } ;
    char delayedForward2_value[256] = { 0 } ;
    char *delayedForward2_ptr = NULL ;
    const oid delayedForward3_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,3, 0 } ;
    char delayedForward3_value[256] = { 0 } ;
    char *delayedForward3_ptr = NULL ;
    const oid delayedForward4_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,4, 0 } ;
    char delayedForward4_value[256] = { 0 } ;
    char *delayedForward4_ptr = NULL ;
    const oid delayedForward5_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,5, 0 } ;
    char delayedForward5_value[256] = { 0 } ;
    char *delayedForward5_ptr = NULL ;
    const oid delayedForward6_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,6, 0 } ;
    char delayedForward6_value[256] = { 0 } ;
    char *delayedForward6_ptr = NULL ;
    const oid delayedForward7_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,7, 0 } ;
    char delayedForward7_value[256] = { 0 } ;
    char *delayedForward7_ptr = NULL ;
    const oid delayedForward8_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,8, 0 } ;
    char delayedForward8_value[256] = { 0 } ;
    char *delayedForward8_ptr = NULL ;
    const oid delayedForward9_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,9, 0 } ;
    char delayedForward9_value[256] = { 0 } ;
    char *delayedForward9_ptr = NULL ;
    const oid delayedForward10_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,10, 0 } ;
    char delayedForward10_value[256] = { 0 } ;
    char *delayedForward10_ptr = NULL ;
    const oid delayedForward11_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,11, 0 } ;
    char delayedForward11_value[256] = { 0 } ;
    char *delayedForward11_ptr = NULL ;
    const oid delayedForward12_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,12, 0 } ;
    char delayedForward12_value[256] = { 0 } ;
    char *delayedForward12_ptr = NULL ;
    const oid delayedForward13_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,13, 0 } ;
    char delayedForward13_value[256] = { 0 } ;
    char *delayedForward13_ptr = NULL ;
    const oid delayedForward14_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,14, 0 } ;
    char delayedForward14_value[256] = { 0 } ;
    char *delayedForward14_ptr = NULL ;
    const oid delayedForward15_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,15, 0 } ;
    char delayedForward15_value[256] = { 0 } ;
    char *delayedForward15_ptr = NULL ;
    const oid delayedForward16_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,16, 0 } ;
    char delayedForward16_value[256] = { 0 } ;
    char *delayedForward16_ptr = NULL ;
    const oid delayedForward17_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,17, 0 } ;
    char delayedForward17_value[256] = { 0 } ;
    char *delayedForward17_ptr = NULL ;
    const oid delayedForward18_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,18, 0 } ;
    char delayedForward18_value[256] = { 0 } ;
    char *delayedForward18_ptr = NULL ;
    const oid delayedForward19_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,19, 0 } ;
    char delayedForward19_value[256] = { 0 } ;
    char *delayedForward19_ptr = NULL ;
    const oid delayedForward20_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,20, 0 } ;
    char delayedForward20_value[256] = { 0 } ;
    char *delayedForward20_ptr = NULL ;
    const oid delayedForward21_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,21, 0 } ;
    char delayedForward21_value[256] = { 0 } ;
    char *delayedForward21_ptr = NULL ;
    const oid delayedForward22_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,22, 0 } ;
    char delayedForward22_value[256] = { 0 } ;
    char *delayedForward22_ptr = NULL ;
    const oid delayedForward23_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,23, 0 } ;
    char delayedForward23_value[256] = { 0 } ;
    char *delayedForward23_ptr = NULL ;
    const oid delayedForward24_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,24, 0 } ;
    char delayedForward24_value[256] = { 0 } ;
    char *delayedForward24_ptr = NULL ;
    const oid delayedForward25_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,25, 0 } ;
    char delayedForward25_value[256] = { 0 } ;
    char *delayedForward25_ptr = NULL ;
    const oid delayedForward26_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,26, 0 } ;
    char delayedForward26_value[256] = { 0 } ;
    char *delayedForward26_ptr = NULL ;
    const oid delayedForward27_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,27, 0 } ;
    char delayedForward27_value[256] = { 0 } ;
    char *delayedForward27_ptr = NULL ;
    const oid delayedForward28_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,28, 0 } ;
    char delayedForward28_value[256] = { 0 } ;
    char *delayedForward28_ptr = NULL ;
    const oid delayedForward29_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,29, 0 } ;
    char delayedForward29_value[256] = { 0 } ;
    char *delayedForward29_ptr = NULL ;
    const oid delayedForward30_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,30, 0 } ;
    char delayedForward30_value[256] = { 0 } ;
    char *delayedForward30_ptr = NULL ;
    const oid delayedForward31_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,31, 0 } ;
    char delayedForward31_value[256] = { 0 } ;
    char *delayedForward31_ptr = NULL ;
    const oid delayedForward32_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,32, 0 } ;
    char delayedForward32_value[256] = { 0 } ;
    char *delayedForward32_ptr = NULL ;
    const oid delayedForward33_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,33, 0 } ;
    char delayedForward33_value[256] = { 0 } ;
    char *delayedForward33_ptr = NULL ;
    const oid delayedForward34_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,34, 0 } ;
    char delayedForward34_value[256] = { 0 } ;
    char *delayedForward34_ptr = NULL ;
    const oid delayedForward35_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,35, 0 } ;
    char delayedForward35_value[256] = { 0 } ;
    char *delayedForward35_ptr = NULL ;
    const oid delayedForward36_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,36, 0 } ;
    char delayedForward36_value[256] = { 0 } ;
    char *delayedForward36_ptr = NULL ;
    const oid delayedForward37_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,37, 0 } ;
    char delayedForward37_value[256] = { 0 } ;
    char *delayedForward37_ptr = NULL ;
    const oid delayedForward38_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,38, 0 } ;
    char delayedForward38_value[256] = { 0 } ;
    char *delayedForward38_ptr = NULL ;
    const oid delayedForward39_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,39, 0 } ;
    char delayedForward39_value[256] = { 0 } ;
    char *delayedForward39_ptr = NULL ;
    const oid delayedForward40_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,40, 0 } ;
    char delayedForward40_value[256] = { 0 } ;
    char *delayedForward40_ptr = NULL ;
    const oid delayedForward41_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,41, 0 } ;
    char delayedForward41_value[256] = { 0 } ;
    char *delayedForward41_ptr = NULL ;
    const oid delayedForward42_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,42, 0 } ;
    char delayedForward42_value[256] = { 0 } ;
    char *delayedForward42_ptr = NULL ;
    const oid delayedForward43_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,43, 0 } ;
    char delayedForward43_value[256] = { 0 } ;
    char *delayedForward43_ptr = NULL ;
    const oid delayedForward44_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,44, 0 } ;
    char delayedForward44_value[256] = { 0 } ;
    char *delayedForward44_ptr = NULL ;
    const oid delayedForward45_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,45, 0 } ;
    char delayedForward45_value[256] = { 0 } ;
    char *delayedForward45_ptr = NULL ;
    const oid delayedForward46_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,46, 0 } ;
    char delayedForward46_value[256] = { 0 } ;
    char *delayedForward46_ptr = NULL ;
    const oid delayedForward47_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,47, 0 } ;
    char delayedForward47_value[256] = { 0 } ;
    char *delayedForward47_ptr = NULL ;
    const oid delayedForward48_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,48, 0 } ;
    char delayedForward48_value[256] = { 0 } ;
    char *delayedForward48_ptr = NULL ;
    const oid delayedForward49_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,49, 0 } ;
    char delayedForward49_value[256] = { 0 } ;
    char *delayedForward49_ptr = NULL ;
    const oid delayedForward50_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,50, 0 } ;
    char delayedForward50_value[256] = { 0 } ;
    char *delayedForward50_ptr = NULL ;
    const oid delayedForward51_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,51, 0 } ;
    char delayedForward51_value[256] = { 0 } ;
    char *delayedForward51_ptr = NULL ;
    const oid delayedForward52_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,52, 0 } ;
    char delayedForward52_value[256] = { 0 } ;
    char *delayedForward52_ptr = NULL ;
    const oid delayedForward53_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,53, 0 } ;
    char delayedForward53_value[256] = { 0 } ;
    char *delayedForward53_ptr = NULL ;
    const oid delayedForward54_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,54, 0 } ;
    char delayedForward54_value[256] = { 0 } ;
    char *delayedForward54_ptr = NULL ;
    const oid delayedForward55_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,55, 0 } ;
    char delayedForward55_value[256] = { 0 } ;
    char *delayedForward55_ptr = NULL ;
    const oid delayedForward56_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,56, 0 } ;
    char delayedForward56_value[256] = { 0 } ;
    char *delayedForward56_ptr = NULL ;
    const oid delayedForward57_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,57, 0 } ;
    char delayedForward57_value[256] = { 0 } ;
    char *delayedForward57_ptr = NULL ;
    const oid delayedForward58_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,58, 0 } ;
    char delayedForward58_value[256] = { 0 } ;
    char *delayedForward58_ptr = NULL ;
    const oid delayedForward59_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,59, 0 } ;
    char delayedForward59_value[256] = { 0 } ;
    char *delayedForward59_ptr = NULL ;
    const oid delayedForward60_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,60, 0 } ;
    char delayedForward60_value[256] = { 0 } ;
    char *delayedForward60_ptr = NULL ;
    const oid delayedForward61_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,61, 0 } ;
    char delayedForward61_value[256] = { 0 } ;
    char *delayedForward61_ptr = NULL ;
    const oid delayedForward62_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,62, 0 } ;
    char delayedForward62_value[256] = { 0 } ;
    char *delayedForward62_ptr = NULL ;
    const oid delayedForward63_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,63, 0 } ;
    char delayedForward63_value[256] = { 0 } ;
    char *delayedForward63_ptr = NULL ;
    const oid delayedForward64_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,64, 0 } ;
    char delayedForward64_value[256] = { 0 } ;
    char *delayedForward64_ptr = NULL ;
    const oid delayedForward65_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,65, 0 } ;
    char delayedForward65_value[256] = { 0 } ;
    char *delayedForward65_ptr = NULL ;
    const oid delayedForward66_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,66, 0 } ;
    char delayedForward66_value[256] = { 0 } ;
    char *delayedForward66_ptr = NULL ;
    const oid delayedForward67_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,67, 0 } ;
    char delayedForward67_value[256] = { 0 } ;
    char *delayedForward67_ptr = NULL ;
    const oid delayedForward68_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,68, 0 } ;
    char delayedForward68_value[256] = { 0 } ;
    char *delayedForward68_ptr = NULL ;
    const oid delayedForward69_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,69, 0 } ;
    char delayedForward69_value[256] = { 0 } ;
    char *delayedForward69_ptr = NULL ;
    const oid delayedForward70_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,70, 0 } ;
    char delayedForward70_value[256] = { 0 } ;
    char *delayedForward70_ptr = NULL ;
    const oid delayedForward71_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,71, 0 } ;
    char delayedForward71_value[256] = { 0 } ;
    char *delayedForward71_ptr = NULL ;
    const oid delayedForward72_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,72, 0 } ;
    char delayedForward72_value[256] = { 0 } ;
    char *delayedForward72_ptr = NULL ;
    const oid delayedForward73_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,73, 0 } ;
    char delayedForward73_value[256] = { 0 } ;
    char *delayedForward73_ptr = NULL ;
    const oid delayedForward74_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,74, 0 } ;
    char delayedForward74_value[256] = { 0 } ;
    char *delayedForward74_ptr = NULL ;
    const oid delayedForward75_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,75, 0 } ;
    char delayedForward75_value[256] = { 0 } ;
    char *delayedForward75_ptr = NULL ;
    const oid delayedForward76_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,76, 0 } ;
    char delayedForward76_value[256] = { 0 } ;
    char *delayedForward76_ptr = NULL ;
    const oid delayedForward77_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,77, 0 } ;
    char delayedForward77_value[256] = { 0 } ;
    char *delayedForward77_ptr = NULL ;
    const oid delayedForward78_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,78, 0 } ;
    char delayedForward78_value[256] = { 0 } ;
    char *delayedForward78_ptr = NULL ;
    const oid delayedForward79_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,79, 0 } ;
    char delayedForward79_value[256] = { 0 } ;
    char *delayedForward79_ptr = NULL ;
    const oid delayedForward80_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,80, 0 } ;
    char delayedForward80_value[256] = { 0 } ;
    char *delayedForward80_ptr = NULL ;
    const oid delayedForward81_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,81, 0 } ;
    char delayedForward81_value[256] = { 0 } ;
    char *delayedForward81_ptr = NULL ;
    const oid delayedForward82_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,82, 0 } ;
    char delayedForward82_value[256] = { 0 } ;
    char *delayedForward82_ptr = NULL ;
    const oid delayedForward83_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,83, 0 } ;
    char delayedForward83_value[256] = { 0 } ;
    char *delayedForward83_ptr = NULL ;
    const oid delayedForward84_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,84, 0 } ;
    char delayedForward84_value[256] = { 0 } ;
    char *delayedForward84_ptr = NULL ;
    const oid delayedForward85_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,85, 0 } ;
    char delayedForward85_value[256] = { 0 } ;
    char *delayedForward85_ptr = NULL ;
    const oid delayedForward86_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,86, 0 } ;
    char delayedForward86_value[256] = { 0 } ;
    char *delayedForward86_ptr = NULL ;
    const oid delayedForward87_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,87, 0 } ;
    char delayedForward87_value[256] = { 0 } ;
    char *delayedForward87_ptr = NULL ;
    const oid delayedForward88_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,88, 0 } ;
    char delayedForward88_value[256] = { 0 } ;
    char *delayedForward88_ptr = NULL ;
    const oid delayedForward89_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,89, 0 } ;
    char delayedForward89_value[256] = { 0 } ;
    char *delayedForward89_ptr = NULL ;
    const oid delayedForward90_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,90, 0 } ;
    char delayedForward90_value[256] = { 0 } ;
    char *delayedForward90_ptr = NULL ;
    const oid delayedForward91_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,91, 0 } ;
    char delayedForward91_value[256] = { 0 } ;
    char *delayedForward91_ptr = NULL ;
    const oid delayedForward92_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,92, 0 } ;
    char delayedForward92_value[256] = { 0 } ;
    char *delayedForward92_ptr = NULL ;
    const oid delayedForward93_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,93, 0 } ;
    char delayedForward93_value[256] = { 0 } ;
    char *delayedForward93_ptr = NULL ;
    const oid delayedForward94_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,94, 0 } ;
    char delayedForward94_value[256] = { 0 } ;
    char *delayedForward94_ptr = NULL ;
    const oid delayedForward95_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,95, 0 } ;
    char delayedForward95_value[256] = { 0 } ;
    char *delayedForward95_ptr = NULL ;
    const oid delayedForward96_oid[] = { 1,3,6,1,4,1,42397,1,1,2,6,96, 0 } ;
    char delayedForward96_value[256] = { 0 } ;
    char *delayedForward96_ptr = NULL ;
    const oid temperatureSensor1_oid[] = { 1,3,6,1,4,1,42397,1,1,2,7,1, 0 } ;
    long temperatureSensor1_value = 0 ;
    const oid temperatureSensor2_oid[] = { 1,3,6,1,4,1,42397,1,1,2,7,2, 0 } ;
    long temperatureSensor2_value = 0 ;
    const oid temperatureSensor3_oid[] = { 1,3,6,1,4,1,42397,1,1,2,7,3, 0 } ;
    long temperatureSensor3_value = 0 ;
    const oid temperatureSensor4_oid[] = { 1,3,6,1,4,1,42397,1,1,2,7,4, 0 } ;
    long temperatureSensor4_value = 0 ;
    const oid temperatureSensor5_oid[] = { 1,3,6,1,4,1,42397,1,1,2,7,5, 0 } ;
    long temperatureSensor5_value = 0 ;
    const oid temperatureSensor6_oid[] = { 1,3,6,1,4,1,42397,1,1,2,7,6, 0 } ;
    long temperatureSensor6_value = 0 ;

/** Initializes the grandstream module */
void
init_grandstream(void)
{
    DEBUGMSGTL(("grandstream", "Initializing\n"));

    snmp_alarm_register( 1, /* seconds */
        SA_REPEAT,                      /* repeat */
        send_TimedTrap_notification,         /* our callback */
        NULL                            /* no callback data needed */
     );

    netsnmp_register_scalar(
        netsnmp_create_handler_registration("PartNo", handle_PartNo,
                               PartNo_oid, OID_LENGTH(PartNo_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus1", handle_hookStatus1,
                               hookStatus1_oid, OID_LENGTH(hookStatus1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus2", handle_hookStatus2,
                               hookStatus2_oid, OID_LENGTH(hookStatus2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus3", handle_hookStatus3,
                               hookStatus3_oid, OID_LENGTH(hookStatus3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus4", handle_hookStatus4,
                               hookStatus4_oid, OID_LENGTH(hookStatus4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus5", handle_hookStatus5,
                               hookStatus5_oid, OID_LENGTH(hookStatus5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus6", handle_hookStatus6,
                               hookStatus6_oid, OID_LENGTH(hookStatus6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus7", handle_hookStatus7,
                               hookStatus7_oid, OID_LENGTH(hookStatus7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus8", handle_hookStatus8,
                               hookStatus8_oid, OID_LENGTH(hookStatus8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus9", handle_hookStatus9,
                               hookStatus9_oid, OID_LENGTH(hookStatus9_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus10", handle_hookStatus10,
                               hookStatus10_oid, OID_LENGTH(hookStatus10_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus11", handle_hookStatus11,
                               hookStatus11_oid, OID_LENGTH(hookStatus11_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus12", handle_hookStatus12,
                               hookStatus12_oid, OID_LENGTH(hookStatus12_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus13", handle_hookStatus13,
                               hookStatus13_oid, OID_LENGTH(hookStatus13_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus14", handle_hookStatus14,
                               hookStatus14_oid, OID_LENGTH(hookStatus14_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus15", handle_hookStatus15,
                               hookStatus15_oid, OID_LENGTH(hookStatus15_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus16", handle_hookStatus16,
                               hookStatus16_oid, OID_LENGTH(hookStatus16_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus17", handle_hookStatus17,
                               hookStatus17_oid, OID_LENGTH(hookStatus17_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus18", handle_hookStatus18,
                               hookStatus18_oid, OID_LENGTH(hookStatus18_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus19", handle_hookStatus19,
                               hookStatus19_oid, OID_LENGTH(hookStatus19_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus20", handle_hookStatus20,
                               hookStatus20_oid, OID_LENGTH(hookStatus20_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus21", handle_hookStatus21,
                               hookStatus21_oid, OID_LENGTH(hookStatus21_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus22", handle_hookStatus22,
                               hookStatus22_oid, OID_LENGTH(hookStatus22_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus23", handle_hookStatus23,
                               hookStatus23_oid, OID_LENGTH(hookStatus23_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus24", handle_hookStatus24,
                               hookStatus24_oid, OID_LENGTH(hookStatus24_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus25", handle_hookStatus25,
                               hookStatus25_oid, OID_LENGTH(hookStatus25_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus26", handle_hookStatus26,
                               hookStatus26_oid, OID_LENGTH(hookStatus26_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus27", handle_hookStatus27,
                               hookStatus27_oid, OID_LENGTH(hookStatus27_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus28", handle_hookStatus28,
                               hookStatus28_oid, OID_LENGTH(hookStatus28_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus29", handle_hookStatus29,
                               hookStatus29_oid, OID_LENGTH(hookStatus29_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus30", handle_hookStatus30,
                               hookStatus30_oid, OID_LENGTH(hookStatus30_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus31", handle_hookStatus31,
                               hookStatus31_oid, OID_LENGTH(hookStatus31_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus32", handle_hookStatus32,
                               hookStatus32_oid, OID_LENGTH(hookStatus32_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus33", handle_hookStatus33,
                               hookStatus33_oid, OID_LENGTH(hookStatus33_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus34", handle_hookStatus34,
                               hookStatus34_oid, OID_LENGTH(hookStatus34_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus35", handle_hookStatus35,
                               hookStatus35_oid, OID_LENGTH(hookStatus35_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus36", handle_hookStatus36,
                               hookStatus36_oid, OID_LENGTH(hookStatus36_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus37", handle_hookStatus37,
                               hookStatus37_oid, OID_LENGTH(hookStatus37_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus38", handle_hookStatus38,
                               hookStatus38_oid, OID_LENGTH(hookStatus38_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus39", handle_hookStatus39,
                               hookStatus39_oid, OID_LENGTH(hookStatus39_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus40", handle_hookStatus40,
                               hookStatus40_oid, OID_LENGTH(hookStatus40_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus41", handle_hookStatus41,
                               hookStatus41_oid, OID_LENGTH(hookStatus41_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus42", handle_hookStatus42,
                               hookStatus42_oid, OID_LENGTH(hookStatus42_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus43", handle_hookStatus43,
                               hookStatus43_oid, OID_LENGTH(hookStatus43_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus44", handle_hookStatus44,
                               hookStatus44_oid, OID_LENGTH(hookStatus44_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus45", handle_hookStatus45,
                               hookStatus45_oid, OID_LENGTH(hookStatus45_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus46", handle_hookStatus46,
                               hookStatus46_oid, OID_LENGTH(hookStatus46_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus47", handle_hookStatus47,
                               hookStatus47_oid, OID_LENGTH(hookStatus47_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus48", handle_hookStatus48,
                               hookStatus48_oid, OID_LENGTH(hookStatus48_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus49", handle_hookStatus49,
                               hookStatus49_oid, OID_LENGTH(hookStatus49_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus50", handle_hookStatus50,
                               hookStatus50_oid, OID_LENGTH(hookStatus50_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus51", handle_hookStatus51,
                               hookStatus51_oid, OID_LENGTH(hookStatus51_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus52", handle_hookStatus52,
                               hookStatus52_oid, OID_LENGTH(hookStatus52_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus53", handle_hookStatus53,
                               hookStatus53_oid, OID_LENGTH(hookStatus53_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus54", handle_hookStatus54,
                               hookStatus54_oid, OID_LENGTH(hookStatus54_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus55", handle_hookStatus55,
                               hookStatus55_oid, OID_LENGTH(hookStatus55_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus56", handle_hookStatus56,
                               hookStatus56_oid, OID_LENGTH(hookStatus56_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus57", handle_hookStatus57,
                               hookStatus57_oid, OID_LENGTH(hookStatus57_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus58", handle_hookStatus58,
                               hookStatus58_oid, OID_LENGTH(hookStatus58_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus59", handle_hookStatus59,
                               hookStatus59_oid, OID_LENGTH(hookStatus59_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus60", handle_hookStatus60,
                               hookStatus60_oid, OID_LENGTH(hookStatus60_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus61", handle_hookStatus61,
                               hookStatus61_oid, OID_LENGTH(hookStatus61_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus62", handle_hookStatus62,
                               hookStatus62_oid, OID_LENGTH(hookStatus62_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus63", handle_hookStatus63,
                               hookStatus63_oid, OID_LENGTH(hookStatus63_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus64", handle_hookStatus64,
                               hookStatus64_oid, OID_LENGTH(hookStatus64_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus65", handle_hookStatus65,
                               hookStatus65_oid, OID_LENGTH(hookStatus65_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus66", handle_hookStatus66,
                               hookStatus66_oid, OID_LENGTH(hookStatus66_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus67", handle_hookStatus67,
                               hookStatus67_oid, OID_LENGTH(hookStatus67_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus68", handle_hookStatus68,
                               hookStatus68_oid, OID_LENGTH(hookStatus68_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus69", handle_hookStatus69,
                               hookStatus69_oid, OID_LENGTH(hookStatus69_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus70", handle_hookStatus70,
                               hookStatus70_oid, OID_LENGTH(hookStatus70_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus71", handle_hookStatus71,
                               hookStatus71_oid, OID_LENGTH(hookStatus71_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus72", handle_hookStatus72,
                               hookStatus72_oid, OID_LENGTH(hookStatus72_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus73", handle_hookStatus73,
                               hookStatus73_oid, OID_LENGTH(hookStatus73_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus74", handle_hookStatus74,
                               hookStatus74_oid, OID_LENGTH(hookStatus74_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus75", handle_hookStatus75,
                               hookStatus75_oid, OID_LENGTH(hookStatus75_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus76", handle_hookStatus76,
                               hookStatus76_oid, OID_LENGTH(hookStatus76_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus77", handle_hookStatus77,
                               hookStatus77_oid, OID_LENGTH(hookStatus77_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus78", handle_hookStatus78,
                               hookStatus78_oid, OID_LENGTH(hookStatus78_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus79", handle_hookStatus79,
                               hookStatus79_oid, OID_LENGTH(hookStatus79_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus80", handle_hookStatus80,
                               hookStatus80_oid, OID_LENGTH(hookStatus80_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus81", handle_hookStatus81,
                               hookStatus81_oid, OID_LENGTH(hookStatus81_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus82", handle_hookStatus82,
                               hookStatus82_oid, OID_LENGTH(hookStatus82_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus83", handle_hookStatus83,
                               hookStatus83_oid, OID_LENGTH(hookStatus83_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus84", handle_hookStatus84,
                               hookStatus84_oid, OID_LENGTH(hookStatus84_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus85", handle_hookStatus85,
                               hookStatus85_oid, OID_LENGTH(hookStatus85_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus86", handle_hookStatus86,
                               hookStatus86_oid, OID_LENGTH(hookStatus86_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus87", handle_hookStatus87,
                               hookStatus87_oid, OID_LENGTH(hookStatus87_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus88", handle_hookStatus88,
                               hookStatus88_oid, OID_LENGTH(hookStatus88_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus89", handle_hookStatus89,
                               hookStatus89_oid, OID_LENGTH(hookStatus89_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus90", handle_hookStatus90,
                               hookStatus90_oid, OID_LENGTH(hookStatus90_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus91", handle_hookStatus91,
                               hookStatus91_oid, OID_LENGTH(hookStatus91_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus92", handle_hookStatus92,
                               hookStatus92_oid, OID_LENGTH(hookStatus92_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus93", handle_hookStatus93,
                               hookStatus93_oid, OID_LENGTH(hookStatus93_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus94", handle_hookStatus94,
                               hookStatus94_oid, OID_LENGTH(hookStatus94_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus95", handle_hookStatus95,
                               hookStatus95_oid, OID_LENGTH(hookStatus95_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus96", handle_hookStatus96,
                               hookStatus96_oid, OID_LENGTH(hookStatus96_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus1", handle_regStatus1,
                               regStatus1_oid, OID_LENGTH(regStatus1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus2", handle_regStatus2,
                               regStatus2_oid, OID_LENGTH(regStatus2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus3", handle_regStatus3,
                               regStatus3_oid, OID_LENGTH(regStatus3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus4", handle_regStatus4,
                               regStatus4_oid, OID_LENGTH(regStatus4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus5", handle_regStatus5,
                               regStatus5_oid, OID_LENGTH(regStatus5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus6", handle_regStatus6,
                               regStatus6_oid, OID_LENGTH(regStatus6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus7", handle_regStatus7,
                               regStatus7_oid, OID_LENGTH(regStatus7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus8", handle_regStatus8,
                               regStatus8_oid, OID_LENGTH(regStatus8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus9", handle_regStatus9,
                               regStatus9_oid, OID_LENGTH(regStatus9_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus10", handle_regStatus10,
                               regStatus10_oid, OID_LENGTH(regStatus10_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus11", handle_regStatus11,
                               regStatus11_oid, OID_LENGTH(regStatus11_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus12", handle_regStatus12,
                               regStatus12_oid, OID_LENGTH(regStatus12_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus13", handle_regStatus13,
                               regStatus13_oid, OID_LENGTH(regStatus13_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus14", handle_regStatus14,
                               regStatus14_oid, OID_LENGTH(regStatus14_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus15", handle_regStatus15,
                               regStatus15_oid, OID_LENGTH(regStatus15_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus16", handle_regStatus16,
                               regStatus16_oid, OID_LENGTH(regStatus16_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus17", handle_regStatus17,
                               regStatus17_oid, OID_LENGTH(regStatus17_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus18", handle_regStatus18,
                               regStatus18_oid, OID_LENGTH(regStatus18_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus19", handle_regStatus19,
                               regStatus19_oid, OID_LENGTH(regStatus19_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus20", handle_regStatus20,
                               regStatus20_oid, OID_LENGTH(regStatus20_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus21", handle_regStatus21,
                               regStatus21_oid, OID_LENGTH(regStatus21_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus22", handle_regStatus22,
                               regStatus22_oid, OID_LENGTH(regStatus22_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus23", handle_regStatus23,
                               regStatus23_oid, OID_LENGTH(regStatus23_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus24", handle_regStatus24,
                               regStatus24_oid, OID_LENGTH(regStatus24_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus25", handle_regStatus25,
                               regStatus25_oid, OID_LENGTH(regStatus25_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus26", handle_regStatus26,
                               regStatus26_oid, OID_LENGTH(regStatus26_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus27", handle_regStatus27,
                               regStatus27_oid, OID_LENGTH(regStatus27_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus28", handle_regStatus28,
                               regStatus28_oid, OID_LENGTH(regStatus28_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus29", handle_regStatus29,
                               regStatus29_oid, OID_LENGTH(regStatus29_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus30", handle_regStatus30,
                               regStatus30_oid, OID_LENGTH(regStatus30_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus31", handle_regStatus31,
                               regStatus31_oid, OID_LENGTH(regStatus31_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus32", handle_regStatus32,
                               regStatus32_oid, OID_LENGTH(regStatus32_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus33", handle_regStatus33,
                               regStatus33_oid, OID_LENGTH(regStatus33_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus34", handle_regStatus34,
                               regStatus34_oid, OID_LENGTH(regStatus34_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus35", handle_regStatus35,
                               regStatus35_oid, OID_LENGTH(regStatus35_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus36", handle_regStatus36,
                               regStatus36_oid, OID_LENGTH(regStatus36_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus37", handle_regStatus37,
                               regStatus37_oid, OID_LENGTH(regStatus37_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus38", handle_regStatus38,
                               regStatus38_oid, OID_LENGTH(regStatus38_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus39", handle_regStatus39,
                               regStatus39_oid, OID_LENGTH(regStatus39_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus40", handle_regStatus40,
                               regStatus40_oid, OID_LENGTH(regStatus40_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus41", handle_regStatus41,
                               regStatus41_oid, OID_LENGTH(regStatus41_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus42", handle_regStatus42,
                               regStatus42_oid, OID_LENGTH(regStatus42_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus43", handle_regStatus43,
                               regStatus43_oid, OID_LENGTH(regStatus43_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus44", handle_regStatus44,
                               regStatus44_oid, OID_LENGTH(regStatus44_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus45", handle_regStatus45,
                               regStatus45_oid, OID_LENGTH(regStatus45_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus46", handle_regStatus46,
                               regStatus46_oid, OID_LENGTH(regStatus46_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus47", handle_regStatus47,
                               regStatus47_oid, OID_LENGTH(regStatus47_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus48", handle_regStatus48,
                               regStatus48_oid, OID_LENGTH(regStatus48_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus49", handle_regStatus49,
                               regStatus49_oid, OID_LENGTH(regStatus49_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus50", handle_regStatus50,
                               regStatus50_oid, OID_LENGTH(regStatus50_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus51", handle_regStatus51,
                               regStatus51_oid, OID_LENGTH(regStatus51_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus52", handle_regStatus52,
                               regStatus52_oid, OID_LENGTH(regStatus52_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus53", handle_regStatus53,
                               regStatus53_oid, OID_LENGTH(regStatus53_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus54", handle_regStatus54,
                               regStatus54_oid, OID_LENGTH(regStatus54_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus55", handle_regStatus55,
                               regStatus55_oid, OID_LENGTH(regStatus55_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus56", handle_regStatus56,
                               regStatus56_oid, OID_LENGTH(regStatus56_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus57", handle_regStatus57,
                               regStatus57_oid, OID_LENGTH(regStatus57_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus58", handle_regStatus58,
                               regStatus58_oid, OID_LENGTH(regStatus58_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus59", handle_regStatus59,
                               regStatus59_oid, OID_LENGTH(regStatus59_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus60", handle_regStatus60,
                               regStatus60_oid, OID_LENGTH(regStatus60_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus61", handle_regStatus61,
                               regStatus61_oid, OID_LENGTH(regStatus61_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus62", handle_regStatus62,
                               regStatus62_oid, OID_LENGTH(regStatus62_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus63", handle_regStatus63,
                               regStatus63_oid, OID_LENGTH(regStatus63_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus64", handle_regStatus64,
                               regStatus64_oid, OID_LENGTH(regStatus64_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus65", handle_regStatus65,
                               regStatus65_oid, OID_LENGTH(regStatus65_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus66", handle_regStatus66,
                               regStatus66_oid, OID_LENGTH(regStatus66_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus67", handle_regStatus67,
                               regStatus67_oid, OID_LENGTH(regStatus67_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus68", handle_regStatus68,
                               regStatus68_oid, OID_LENGTH(regStatus68_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus69", handle_regStatus69,
                               regStatus69_oid, OID_LENGTH(regStatus69_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus70", handle_regStatus70,
                               regStatus70_oid, OID_LENGTH(regStatus70_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus71", handle_regStatus71,
                               regStatus71_oid, OID_LENGTH(regStatus71_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus72", handle_regStatus72,
                               regStatus72_oid, OID_LENGTH(regStatus72_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus73", handle_regStatus73,
                               regStatus73_oid, OID_LENGTH(regStatus73_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus74", handle_regStatus74,
                               regStatus74_oid, OID_LENGTH(regStatus74_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus75", handle_regStatus75,
                               regStatus75_oid, OID_LENGTH(regStatus75_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus76", handle_regStatus76,
                               regStatus76_oid, OID_LENGTH(regStatus76_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus77", handle_regStatus77,
                               regStatus77_oid, OID_LENGTH(regStatus77_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus78", handle_regStatus78,
                               regStatus78_oid, OID_LENGTH(regStatus78_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus79", handle_regStatus79,
                               regStatus79_oid, OID_LENGTH(regStatus79_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus80", handle_regStatus80,
                               regStatus80_oid, OID_LENGTH(regStatus80_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus81", handle_regStatus81,
                               regStatus81_oid, OID_LENGTH(regStatus81_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus82", handle_regStatus82,
                               regStatus82_oid, OID_LENGTH(regStatus82_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus83", handle_regStatus83,
                               regStatus83_oid, OID_LENGTH(regStatus83_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus84", handle_regStatus84,
                               regStatus84_oid, OID_LENGTH(regStatus84_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus85", handle_regStatus85,
                               regStatus85_oid, OID_LENGTH(regStatus85_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus86", handle_regStatus86,
                               regStatus86_oid, OID_LENGTH(regStatus86_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus87", handle_regStatus87,
                               regStatus87_oid, OID_LENGTH(regStatus87_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus88", handle_regStatus88,
                               regStatus88_oid, OID_LENGTH(regStatus88_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus89", handle_regStatus89,
                               regStatus89_oid, OID_LENGTH(regStatus89_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus90", handle_regStatus90,
                               regStatus90_oid, OID_LENGTH(regStatus90_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus91", handle_regStatus91,
                               regStatus91_oid, OID_LENGTH(regStatus91_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus92", handle_regStatus92,
                               regStatus92_oid, OID_LENGTH(regStatus92_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus93", handle_regStatus93,
                               regStatus93_oid, OID_LENGTH(regStatus93_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus94", handle_regStatus94,
                               regStatus94_oid, OID_LENGTH(regStatus94_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus95", handle_regStatus95,
                               regStatus95_oid, OID_LENGTH(regStatus95_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus96", handle_regStatus96,
                               regStatus96_oid, OID_LENGTH(regStatus96_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd1", handle_dnd1,
                               dnd1_oid, OID_LENGTH(dnd1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd2", handle_dnd2,
                               dnd2_oid, OID_LENGTH(dnd2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd3", handle_dnd3,
                               dnd3_oid, OID_LENGTH(dnd3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd4", handle_dnd4,
                               dnd4_oid, OID_LENGTH(dnd4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd5", handle_dnd5,
                               dnd5_oid, OID_LENGTH(dnd5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd6", handle_dnd6,
                               dnd6_oid, OID_LENGTH(dnd6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd7", handle_dnd7,
                               dnd7_oid, OID_LENGTH(dnd7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd8", handle_dnd8,
                               dnd8_oid, OID_LENGTH(dnd8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd9", handle_dnd9,
                               dnd9_oid, OID_LENGTH(dnd9_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd10", handle_dnd10,
                               dnd10_oid, OID_LENGTH(dnd10_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd11", handle_dnd11,
                               dnd11_oid, OID_LENGTH(dnd11_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd12", handle_dnd12,
                               dnd12_oid, OID_LENGTH(dnd12_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd13", handle_dnd13,
                               dnd13_oid, OID_LENGTH(dnd13_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd14", handle_dnd14,
                               dnd14_oid, OID_LENGTH(dnd14_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd15", handle_dnd15,
                               dnd15_oid, OID_LENGTH(dnd15_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd16", handle_dnd16,
                               dnd16_oid, OID_LENGTH(dnd16_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd17", handle_dnd17,
                               dnd17_oid, OID_LENGTH(dnd17_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd18", handle_dnd18,
                               dnd18_oid, OID_LENGTH(dnd18_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd19", handle_dnd19,
                               dnd19_oid, OID_LENGTH(dnd19_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd20", handle_dnd20,
                               dnd20_oid, OID_LENGTH(dnd20_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd21", handle_dnd21,
                               dnd21_oid, OID_LENGTH(dnd21_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd22", handle_dnd22,
                               dnd22_oid, OID_LENGTH(dnd22_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd23", handle_dnd23,
                               dnd23_oid, OID_LENGTH(dnd23_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd24", handle_dnd24,
                               dnd24_oid, OID_LENGTH(dnd24_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd25", handle_dnd25,
                               dnd25_oid, OID_LENGTH(dnd25_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd26", handle_dnd26,
                               dnd26_oid, OID_LENGTH(dnd26_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd27", handle_dnd27,
                               dnd27_oid, OID_LENGTH(dnd27_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd28", handle_dnd28,
                               dnd28_oid, OID_LENGTH(dnd28_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd29", handle_dnd29,
                               dnd29_oid, OID_LENGTH(dnd29_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd30", handle_dnd30,
                               dnd30_oid, OID_LENGTH(dnd30_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd31", handle_dnd31,
                               dnd31_oid, OID_LENGTH(dnd31_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd32", handle_dnd32,
                               dnd32_oid, OID_LENGTH(dnd32_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd33", handle_dnd33,
                               dnd33_oid, OID_LENGTH(dnd33_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd34", handle_dnd34,
                               dnd34_oid, OID_LENGTH(dnd34_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd35", handle_dnd35,
                               dnd35_oid, OID_LENGTH(dnd35_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd36", handle_dnd36,
                               dnd36_oid, OID_LENGTH(dnd36_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd37", handle_dnd37,
                               dnd37_oid, OID_LENGTH(dnd37_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd38", handle_dnd38,
                               dnd38_oid, OID_LENGTH(dnd38_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd39", handle_dnd39,
                               dnd39_oid, OID_LENGTH(dnd39_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd40", handle_dnd40,
                               dnd40_oid, OID_LENGTH(dnd40_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd41", handle_dnd41,
                               dnd41_oid, OID_LENGTH(dnd41_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd42", handle_dnd42,
                               dnd42_oid, OID_LENGTH(dnd42_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd43", handle_dnd43,
                               dnd43_oid, OID_LENGTH(dnd43_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd44", handle_dnd44,
                               dnd44_oid, OID_LENGTH(dnd44_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd45", handle_dnd45,
                               dnd45_oid, OID_LENGTH(dnd45_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd46", handle_dnd46,
                               dnd46_oid, OID_LENGTH(dnd46_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd47", handle_dnd47,
                               dnd47_oid, OID_LENGTH(dnd47_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd48", handle_dnd48,
                               dnd48_oid, OID_LENGTH(dnd48_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd49", handle_dnd49,
                               dnd49_oid, OID_LENGTH(dnd49_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd50", handle_dnd50,
                               dnd50_oid, OID_LENGTH(dnd50_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd51", handle_dnd51,
                               dnd51_oid, OID_LENGTH(dnd51_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd52", handle_dnd52,
                               dnd52_oid, OID_LENGTH(dnd52_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd53", handle_dnd53,
                               dnd53_oid, OID_LENGTH(dnd53_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd54", handle_dnd54,
                               dnd54_oid, OID_LENGTH(dnd54_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd55", handle_dnd55,
                               dnd55_oid, OID_LENGTH(dnd55_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd56", handle_dnd56,
                               dnd56_oid, OID_LENGTH(dnd56_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd57", handle_dnd57,
                               dnd57_oid, OID_LENGTH(dnd57_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd58", handle_dnd58,
                               dnd58_oid, OID_LENGTH(dnd58_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd59", handle_dnd59,
                               dnd59_oid, OID_LENGTH(dnd59_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd60", handle_dnd60,
                               dnd60_oid, OID_LENGTH(dnd60_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd61", handle_dnd61,
                               dnd61_oid, OID_LENGTH(dnd61_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd62", handle_dnd62,
                               dnd62_oid, OID_LENGTH(dnd62_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd63", handle_dnd63,
                               dnd63_oid, OID_LENGTH(dnd63_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd64", handle_dnd64,
                               dnd64_oid, OID_LENGTH(dnd64_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd65", handle_dnd65,
                               dnd65_oid, OID_LENGTH(dnd65_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd66", handle_dnd66,
                               dnd66_oid, OID_LENGTH(dnd66_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd67", handle_dnd67,
                               dnd67_oid, OID_LENGTH(dnd67_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd68", handle_dnd68,
                               dnd68_oid, OID_LENGTH(dnd68_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd69", handle_dnd69,
                               dnd69_oid, OID_LENGTH(dnd69_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd70", handle_dnd70,
                               dnd70_oid, OID_LENGTH(dnd70_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd71", handle_dnd71,
                               dnd71_oid, OID_LENGTH(dnd71_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd72", handle_dnd72,
                               dnd72_oid, OID_LENGTH(dnd72_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd73", handle_dnd73,
                               dnd73_oid, OID_LENGTH(dnd73_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd74", handle_dnd74,
                               dnd74_oid, OID_LENGTH(dnd74_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd75", handle_dnd75,
                               dnd75_oid, OID_LENGTH(dnd75_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd76", handle_dnd76,
                               dnd76_oid, OID_LENGTH(dnd76_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd77", handle_dnd77,
                               dnd77_oid, OID_LENGTH(dnd77_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd78", handle_dnd78,
                               dnd78_oid, OID_LENGTH(dnd78_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd79", handle_dnd79,
                               dnd79_oid, OID_LENGTH(dnd79_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd80", handle_dnd80,
                               dnd80_oid, OID_LENGTH(dnd80_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd81", handle_dnd81,
                               dnd81_oid, OID_LENGTH(dnd81_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd82", handle_dnd82,
                               dnd82_oid, OID_LENGTH(dnd82_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd83", handle_dnd83,
                               dnd83_oid, OID_LENGTH(dnd83_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd84", handle_dnd84,
                               dnd84_oid, OID_LENGTH(dnd84_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd85", handle_dnd85,
                               dnd85_oid, OID_LENGTH(dnd85_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd86", handle_dnd86,
                               dnd86_oid, OID_LENGTH(dnd86_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd87", handle_dnd87,
                               dnd87_oid, OID_LENGTH(dnd87_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd88", handle_dnd88,
                               dnd88_oid, OID_LENGTH(dnd88_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd89", handle_dnd89,
                               dnd89_oid, OID_LENGTH(dnd89_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd90", handle_dnd90,
                               dnd90_oid, OID_LENGTH(dnd90_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd91", handle_dnd91,
                               dnd91_oid, OID_LENGTH(dnd91_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd92", handle_dnd92,
                               dnd92_oid, OID_LENGTH(dnd92_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd93", handle_dnd93,
                               dnd93_oid, OID_LENGTH(dnd93_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd94", handle_dnd94,
                               dnd94_oid, OID_LENGTH(dnd94_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd95", handle_dnd95,
                               dnd95_oid, OID_LENGTH(dnd95_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd96", handle_dnd96,
                               dnd96_oid, OID_LENGTH(dnd96_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward1", handle_forward1,
                               forward1_oid, OID_LENGTH(forward1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward2", handle_forward2,
                               forward2_oid, OID_LENGTH(forward2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward3", handle_forward3,
                               forward3_oid, OID_LENGTH(forward3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward4", handle_forward4,
                               forward4_oid, OID_LENGTH(forward4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward5", handle_forward5,
                               forward5_oid, OID_LENGTH(forward5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward6", handle_forward6,
                               forward6_oid, OID_LENGTH(forward6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward7", handle_forward7,
                               forward7_oid, OID_LENGTH(forward7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward8", handle_forward8,
                               forward8_oid, OID_LENGTH(forward8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward9", handle_forward9,
                               forward9_oid, OID_LENGTH(forward9_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward10", handle_forward10,
                               forward10_oid, OID_LENGTH(forward10_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward11", handle_forward11,
                               forward11_oid, OID_LENGTH(forward11_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward12", handle_forward12,
                               forward12_oid, OID_LENGTH(forward12_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward13", handle_forward13,
                               forward13_oid, OID_LENGTH(forward13_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward14", handle_forward14,
                               forward14_oid, OID_LENGTH(forward14_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward15", handle_forward15,
                               forward15_oid, OID_LENGTH(forward15_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward16", handle_forward16,
                               forward16_oid, OID_LENGTH(forward16_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward17", handle_forward17,
                               forward17_oid, OID_LENGTH(forward17_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward18", handle_forward18,
                               forward18_oid, OID_LENGTH(forward18_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward19", handle_forward19,
                               forward19_oid, OID_LENGTH(forward19_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward20", handle_forward20,
                               forward20_oid, OID_LENGTH(forward20_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward21", handle_forward21,
                               forward21_oid, OID_LENGTH(forward21_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward22", handle_forward22,
                               forward22_oid, OID_LENGTH(forward22_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward23", handle_forward23,
                               forward23_oid, OID_LENGTH(forward23_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward24", handle_forward24,
                               forward24_oid, OID_LENGTH(forward24_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward25", handle_forward25,
                               forward25_oid, OID_LENGTH(forward25_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward26", handle_forward26,
                               forward26_oid, OID_LENGTH(forward26_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward27", handle_forward27,
                               forward27_oid, OID_LENGTH(forward27_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward28", handle_forward28,
                               forward28_oid, OID_LENGTH(forward28_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward29", handle_forward29,
                               forward29_oid, OID_LENGTH(forward29_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward30", handle_forward30,
                               forward30_oid, OID_LENGTH(forward30_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward31", handle_forward31,
                               forward31_oid, OID_LENGTH(forward31_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward32", handle_forward32,
                               forward32_oid, OID_LENGTH(forward32_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward33", handle_forward33,
                               forward33_oid, OID_LENGTH(forward33_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward34", handle_forward34,
                               forward34_oid, OID_LENGTH(forward34_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward35", handle_forward35,
                               forward35_oid, OID_LENGTH(forward35_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward36", handle_forward36,
                               forward36_oid, OID_LENGTH(forward36_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward37", handle_forward37,
                               forward37_oid, OID_LENGTH(forward37_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward38", handle_forward38,
                               forward38_oid, OID_LENGTH(forward38_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward39", handle_forward39,
                               forward39_oid, OID_LENGTH(forward39_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward40", handle_forward40,
                               forward40_oid, OID_LENGTH(forward40_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward41", handle_forward41,
                               forward41_oid, OID_LENGTH(forward41_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward42", handle_forward42,
                               forward42_oid, OID_LENGTH(forward42_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward43", handle_forward43,
                               forward43_oid, OID_LENGTH(forward43_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward44", handle_forward44,
                               forward44_oid, OID_LENGTH(forward44_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward45", handle_forward45,
                               forward45_oid, OID_LENGTH(forward45_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward46", handle_forward46,
                               forward46_oid, OID_LENGTH(forward46_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward47", handle_forward47,
                               forward47_oid, OID_LENGTH(forward47_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward48", handle_forward48,
                               forward48_oid, OID_LENGTH(forward48_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward49", handle_forward49,
                               forward49_oid, OID_LENGTH(forward49_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward50", handle_forward50,
                               forward50_oid, OID_LENGTH(forward50_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward51", handle_forward51,
                               forward51_oid, OID_LENGTH(forward51_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward52", handle_forward52,
                               forward52_oid, OID_LENGTH(forward52_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward53", handle_forward53,
                               forward53_oid, OID_LENGTH(forward53_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward54", handle_forward54,
                               forward54_oid, OID_LENGTH(forward54_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward55", handle_forward55,
                               forward55_oid, OID_LENGTH(forward55_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward56", handle_forward56,
                               forward56_oid, OID_LENGTH(forward56_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward57", handle_forward57,
                               forward57_oid, OID_LENGTH(forward57_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward58", handle_forward58,
                               forward58_oid, OID_LENGTH(forward58_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward59", handle_forward59,
                               forward59_oid, OID_LENGTH(forward59_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward60", handle_forward60,
                               forward60_oid, OID_LENGTH(forward60_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward61", handle_forward61,
                               forward61_oid, OID_LENGTH(forward61_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward62", handle_forward62,
                               forward62_oid, OID_LENGTH(forward62_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward63", handle_forward63,
                               forward63_oid, OID_LENGTH(forward63_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward64", handle_forward64,
                               forward64_oid, OID_LENGTH(forward64_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward65", handle_forward65,
                               forward65_oid, OID_LENGTH(forward65_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward66", handle_forward66,
                               forward66_oid, OID_LENGTH(forward66_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward67", handle_forward67,
                               forward67_oid, OID_LENGTH(forward67_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward68", handle_forward68,
                               forward68_oid, OID_LENGTH(forward68_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward69", handle_forward69,
                               forward69_oid, OID_LENGTH(forward69_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward70", handle_forward70,
                               forward70_oid, OID_LENGTH(forward70_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward71", handle_forward71,
                               forward71_oid, OID_LENGTH(forward71_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward72", handle_forward72,
                               forward72_oid, OID_LENGTH(forward72_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward73", handle_forward73,
                               forward73_oid, OID_LENGTH(forward73_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward74", handle_forward74,
                               forward74_oid, OID_LENGTH(forward74_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward75", handle_forward75,
                               forward75_oid, OID_LENGTH(forward75_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward76", handle_forward76,
                               forward76_oid, OID_LENGTH(forward76_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward77", handle_forward77,
                               forward77_oid, OID_LENGTH(forward77_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward78", handle_forward78,
                               forward78_oid, OID_LENGTH(forward78_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward79", handle_forward79,
                               forward79_oid, OID_LENGTH(forward79_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward80", handle_forward80,
                               forward80_oid, OID_LENGTH(forward80_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward81", handle_forward81,
                               forward81_oid, OID_LENGTH(forward81_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward82", handle_forward82,
                               forward82_oid, OID_LENGTH(forward82_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward83", handle_forward83,
                               forward83_oid, OID_LENGTH(forward83_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward84", handle_forward84,
                               forward84_oid, OID_LENGTH(forward84_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward85", handle_forward85,
                               forward85_oid, OID_LENGTH(forward85_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward86", handle_forward86,
                               forward86_oid, OID_LENGTH(forward86_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward87", handle_forward87,
                               forward87_oid, OID_LENGTH(forward87_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward88", handle_forward88,
                               forward88_oid, OID_LENGTH(forward88_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward89", handle_forward89,
                               forward89_oid, OID_LENGTH(forward89_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward90", handle_forward90,
                               forward90_oid, OID_LENGTH(forward90_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward91", handle_forward91,
                               forward91_oid, OID_LENGTH(forward91_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward92", handle_forward92,
                               forward92_oid, OID_LENGTH(forward92_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward93", handle_forward93,
                               forward93_oid, OID_LENGTH(forward93_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward94", handle_forward94,
                               forward94_oid, OID_LENGTH(forward94_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward95", handle_forward95,
                               forward95_oid, OID_LENGTH(forward95_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward96", handle_forward96,
                               forward96_oid, OID_LENGTH(forward96_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward1", handle_busyForward1,
                               busyForward1_oid, OID_LENGTH(busyForward1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward2", handle_busyForward2,
                               busyForward2_oid, OID_LENGTH(busyForward2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward3", handle_busyForward3,
                               busyForward3_oid, OID_LENGTH(busyForward3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward4", handle_busyForward4,
                               busyForward4_oid, OID_LENGTH(busyForward4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward5", handle_busyForward5,
                               busyForward5_oid, OID_LENGTH(busyForward5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward6", handle_busyForward6,
                               busyForward6_oid, OID_LENGTH(busyForward6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward7", handle_busyForward7,
                               busyForward7_oid, OID_LENGTH(busyForward7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward8", handle_busyForward8,
                               busyForward8_oid, OID_LENGTH(busyForward8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward9", handle_busyForward9,
                               busyForward9_oid, OID_LENGTH(busyForward9_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward10", handle_busyForward10,
                               busyForward10_oid, OID_LENGTH(busyForward10_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward11", handle_busyForward11,
                               busyForward11_oid, OID_LENGTH(busyForward11_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward12", handle_busyForward12,
                               busyForward12_oid, OID_LENGTH(busyForward12_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward13", handle_busyForward13,
                               busyForward13_oid, OID_LENGTH(busyForward13_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward14", handle_busyForward14,
                               busyForward14_oid, OID_LENGTH(busyForward14_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward15", handle_busyForward15,
                               busyForward15_oid, OID_LENGTH(busyForward15_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward16", handle_busyForward16,
                               busyForward16_oid, OID_LENGTH(busyForward16_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward17", handle_busyForward17,
                               busyForward17_oid, OID_LENGTH(busyForward17_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward18", handle_busyForward18,
                               busyForward18_oid, OID_LENGTH(busyForward18_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward19", handle_busyForward19,
                               busyForward19_oid, OID_LENGTH(busyForward19_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward20", handle_busyForward20,
                               busyForward20_oid, OID_LENGTH(busyForward20_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward21", handle_busyForward21,
                               busyForward21_oid, OID_LENGTH(busyForward21_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward22", handle_busyForward22,
                               busyForward22_oid, OID_LENGTH(busyForward22_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward23", handle_busyForward23,
                               busyForward23_oid, OID_LENGTH(busyForward23_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward24", handle_busyForward24,
                               busyForward24_oid, OID_LENGTH(busyForward24_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward25", handle_busyForward25,
                               busyForward25_oid, OID_LENGTH(busyForward25_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward26", handle_busyForward26,
                               busyForward26_oid, OID_LENGTH(busyForward26_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward27", handle_busyForward27,
                               busyForward27_oid, OID_LENGTH(busyForward27_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward28", handle_busyForward28,
                               busyForward28_oid, OID_LENGTH(busyForward28_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward29", handle_busyForward29,
                               busyForward29_oid, OID_LENGTH(busyForward29_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward30", handle_busyForward30,
                               busyForward30_oid, OID_LENGTH(busyForward30_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward31", handle_busyForward31,
                               busyForward31_oid, OID_LENGTH(busyForward31_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward32", handle_busyForward32,
                               busyForward32_oid, OID_LENGTH(busyForward32_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward33", handle_busyForward33,
                               busyForward33_oid, OID_LENGTH(busyForward33_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward34", handle_busyForward34,
                               busyForward34_oid, OID_LENGTH(busyForward34_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward35", handle_busyForward35,
                               busyForward35_oid, OID_LENGTH(busyForward35_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward36", handle_busyForward36,
                               busyForward36_oid, OID_LENGTH(busyForward36_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward37", handle_busyForward37,
                               busyForward37_oid, OID_LENGTH(busyForward37_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward38", handle_busyForward38,
                               busyForward38_oid, OID_LENGTH(busyForward38_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward39", handle_busyForward39,
                               busyForward39_oid, OID_LENGTH(busyForward39_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward40", handle_busyForward40,
                               busyForward40_oid, OID_LENGTH(busyForward40_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward41", handle_busyForward41,
                               busyForward41_oid, OID_LENGTH(busyForward41_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward42", handle_busyForward42,
                               busyForward42_oid, OID_LENGTH(busyForward42_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward43", handle_busyForward43,
                               busyForward43_oid, OID_LENGTH(busyForward43_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward44", handle_busyForward44,
                               busyForward44_oid, OID_LENGTH(busyForward44_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward45", handle_busyForward45,
                               busyForward45_oid, OID_LENGTH(busyForward45_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward46", handle_busyForward46,
                               busyForward46_oid, OID_LENGTH(busyForward46_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward47", handle_busyForward47,
                               busyForward47_oid, OID_LENGTH(busyForward47_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward48", handle_busyForward48,
                               busyForward48_oid, OID_LENGTH(busyForward48_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward49", handle_busyForward49,
                               busyForward49_oid, OID_LENGTH(busyForward49_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward50", handle_busyForward50,
                               busyForward50_oid, OID_LENGTH(busyForward50_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward51", handle_busyForward51,
                               busyForward51_oid, OID_LENGTH(busyForward51_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward52", handle_busyForward52,
                               busyForward52_oid, OID_LENGTH(busyForward52_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward53", handle_busyForward53,
                               busyForward53_oid, OID_LENGTH(busyForward53_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward54", handle_busyForward54,
                               busyForward54_oid, OID_LENGTH(busyForward54_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward55", handle_busyForward55,
                               busyForward55_oid, OID_LENGTH(busyForward55_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward56", handle_busyForward56,
                               busyForward56_oid, OID_LENGTH(busyForward56_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward57", handle_busyForward57,
                               busyForward57_oid, OID_LENGTH(busyForward57_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward58", handle_busyForward58,
                               busyForward58_oid, OID_LENGTH(busyForward58_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward59", handle_busyForward59,
                               busyForward59_oid, OID_LENGTH(busyForward59_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward60", handle_busyForward60,
                               busyForward60_oid, OID_LENGTH(busyForward60_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward61", handle_busyForward61,
                               busyForward61_oid, OID_LENGTH(busyForward61_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward62", handle_busyForward62,
                               busyForward62_oid, OID_LENGTH(busyForward62_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward63", handle_busyForward63,
                               busyForward63_oid, OID_LENGTH(busyForward63_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward64", handle_busyForward64,
                               busyForward64_oid, OID_LENGTH(busyForward64_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward65", handle_busyForward65,
                               busyForward65_oid, OID_LENGTH(busyForward65_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward66", handle_busyForward66,
                               busyForward66_oid, OID_LENGTH(busyForward66_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward67", handle_busyForward67,
                               busyForward67_oid, OID_LENGTH(busyForward67_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward68", handle_busyForward68,
                               busyForward68_oid, OID_LENGTH(busyForward68_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward69", handle_busyForward69,
                               busyForward69_oid, OID_LENGTH(busyForward69_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward70", handle_busyForward70,
                               busyForward70_oid, OID_LENGTH(busyForward70_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward71", handle_busyForward71,
                               busyForward71_oid, OID_LENGTH(busyForward71_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward72", handle_busyForward72,
                               busyForward72_oid, OID_LENGTH(busyForward72_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward73", handle_busyForward73,
                               busyForward73_oid, OID_LENGTH(busyForward73_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward74", handle_busyForward74,
                               busyForward74_oid, OID_LENGTH(busyForward74_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward75", handle_busyForward75,
                               busyForward75_oid, OID_LENGTH(busyForward75_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward76", handle_busyForward76,
                               busyForward76_oid, OID_LENGTH(busyForward76_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward77", handle_busyForward77,
                               busyForward77_oid, OID_LENGTH(busyForward77_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward78", handle_busyForward78,
                               busyForward78_oid, OID_LENGTH(busyForward78_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward79", handle_busyForward79,
                               busyForward79_oid, OID_LENGTH(busyForward79_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward80", handle_busyForward80,
                               busyForward80_oid, OID_LENGTH(busyForward80_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward81", handle_busyForward81,
                               busyForward81_oid, OID_LENGTH(busyForward81_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward82", handle_busyForward82,
                               busyForward82_oid, OID_LENGTH(busyForward82_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward83", handle_busyForward83,
                               busyForward83_oid, OID_LENGTH(busyForward83_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward84", handle_busyForward84,
                               busyForward84_oid, OID_LENGTH(busyForward84_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward85", handle_busyForward85,
                               busyForward85_oid, OID_LENGTH(busyForward85_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward86", handle_busyForward86,
                               busyForward86_oid, OID_LENGTH(busyForward86_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward87", handle_busyForward87,
                               busyForward87_oid, OID_LENGTH(busyForward87_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward88", handle_busyForward88,
                               busyForward88_oid, OID_LENGTH(busyForward88_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward89", handle_busyForward89,
                               busyForward89_oid, OID_LENGTH(busyForward89_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward90", handle_busyForward90,
                               busyForward90_oid, OID_LENGTH(busyForward90_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward91", handle_busyForward91,
                               busyForward91_oid, OID_LENGTH(busyForward91_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward92", handle_busyForward92,
                               busyForward92_oid, OID_LENGTH(busyForward92_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward93", handle_busyForward93,
                               busyForward93_oid, OID_LENGTH(busyForward93_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward94", handle_busyForward94,
                               busyForward94_oid, OID_LENGTH(busyForward94_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward95", handle_busyForward95,
                               busyForward95_oid, OID_LENGTH(busyForward95_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward96", handle_busyForward96,
                               busyForward96_oid, OID_LENGTH(busyForward96_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward1", handle_delayedForward1,
                               delayedForward1_oid, OID_LENGTH(delayedForward1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward2", handle_delayedForward2,
                               delayedForward2_oid, OID_LENGTH(delayedForward2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward3", handle_delayedForward3,
                               delayedForward3_oid, OID_LENGTH(delayedForward3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward4", handle_delayedForward4,
                               delayedForward4_oid, OID_LENGTH(delayedForward4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward5", handle_delayedForward5,
                               delayedForward5_oid, OID_LENGTH(delayedForward5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward6", handle_delayedForward6,
                               delayedForward6_oid, OID_LENGTH(delayedForward6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward7", handle_delayedForward7,
                               delayedForward7_oid, OID_LENGTH(delayedForward7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward8", handle_delayedForward8,
                               delayedForward8_oid, OID_LENGTH(delayedForward8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward9", handle_delayedForward9,
                               delayedForward9_oid, OID_LENGTH(delayedForward9_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward10", handle_delayedForward10,
                               delayedForward10_oid, OID_LENGTH(delayedForward10_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward11", handle_delayedForward11,
                               delayedForward11_oid, OID_LENGTH(delayedForward11_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward12", handle_delayedForward12,
                               delayedForward12_oid, OID_LENGTH(delayedForward12_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward13", handle_delayedForward13,
                               delayedForward13_oid, OID_LENGTH(delayedForward13_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward14", handle_delayedForward14,
                               delayedForward14_oid, OID_LENGTH(delayedForward14_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward15", handle_delayedForward15,
                               delayedForward15_oid, OID_LENGTH(delayedForward15_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward16", handle_delayedForward16,
                               delayedForward16_oid, OID_LENGTH(delayedForward16_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward17", handle_delayedForward17,
                               delayedForward17_oid, OID_LENGTH(delayedForward17_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward18", handle_delayedForward18,
                               delayedForward18_oid, OID_LENGTH(delayedForward18_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward19", handle_delayedForward19,
                               delayedForward19_oid, OID_LENGTH(delayedForward19_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward20", handle_delayedForward20,
                               delayedForward20_oid, OID_LENGTH(delayedForward20_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward21", handle_delayedForward21,
                               delayedForward21_oid, OID_LENGTH(delayedForward21_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward22", handle_delayedForward22,
                               delayedForward22_oid, OID_LENGTH(delayedForward22_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward23", handle_delayedForward23,
                               delayedForward23_oid, OID_LENGTH(delayedForward23_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward24", handle_delayedForward24,
                               delayedForward24_oid, OID_LENGTH(delayedForward24_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward25", handle_delayedForward25,
                               delayedForward25_oid, OID_LENGTH(delayedForward25_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward26", handle_delayedForward26,
                               delayedForward26_oid, OID_LENGTH(delayedForward26_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward27", handle_delayedForward27,
                               delayedForward27_oid, OID_LENGTH(delayedForward27_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward28", handle_delayedForward28,
                               delayedForward28_oid, OID_LENGTH(delayedForward28_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward29", handle_delayedForward29,
                               delayedForward29_oid, OID_LENGTH(delayedForward29_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward30", handle_delayedForward30,
                               delayedForward30_oid, OID_LENGTH(delayedForward30_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward31", handle_delayedForward31,
                               delayedForward31_oid, OID_LENGTH(delayedForward31_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward32", handle_delayedForward32,
                               delayedForward32_oid, OID_LENGTH(delayedForward32_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward33", handle_delayedForward33,
                               delayedForward33_oid, OID_LENGTH(delayedForward33_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward34", handle_delayedForward34,
                               delayedForward34_oid, OID_LENGTH(delayedForward34_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward35", handle_delayedForward35,
                               delayedForward35_oid, OID_LENGTH(delayedForward35_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward36", handle_delayedForward36,
                               delayedForward36_oid, OID_LENGTH(delayedForward36_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward37", handle_delayedForward37,
                               delayedForward37_oid, OID_LENGTH(delayedForward37_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward38", handle_delayedForward38,
                               delayedForward38_oid, OID_LENGTH(delayedForward38_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward39", handle_delayedForward39,
                               delayedForward39_oid, OID_LENGTH(delayedForward39_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward40", handle_delayedForward40,
                               delayedForward40_oid, OID_LENGTH(delayedForward40_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward41", handle_delayedForward41,
                               delayedForward41_oid, OID_LENGTH(delayedForward41_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward42", handle_delayedForward42,
                               delayedForward42_oid, OID_LENGTH(delayedForward42_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward43", handle_delayedForward43,
                               delayedForward43_oid, OID_LENGTH(delayedForward43_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward44", handle_delayedForward44,
                               delayedForward44_oid, OID_LENGTH(delayedForward44_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward45", handle_delayedForward45,
                               delayedForward45_oid, OID_LENGTH(delayedForward45_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward46", handle_delayedForward46,
                               delayedForward46_oid, OID_LENGTH(delayedForward46_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward47", handle_delayedForward47,
                               delayedForward47_oid, OID_LENGTH(delayedForward47_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward48", handle_delayedForward48,
                               delayedForward48_oid, OID_LENGTH(delayedForward48_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward49", handle_delayedForward49,
                               delayedForward49_oid, OID_LENGTH(delayedForward49_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward50", handle_delayedForward50,
                               delayedForward50_oid, OID_LENGTH(delayedForward50_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward51", handle_delayedForward51,
                               delayedForward51_oid, OID_LENGTH(delayedForward51_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward52", handle_delayedForward52,
                               delayedForward52_oid, OID_LENGTH(delayedForward52_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward53", handle_delayedForward53,
                               delayedForward53_oid, OID_LENGTH(delayedForward53_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward54", handle_delayedForward54,
                               delayedForward54_oid, OID_LENGTH(delayedForward54_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward55", handle_delayedForward55,
                               delayedForward55_oid, OID_LENGTH(delayedForward55_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward56", handle_delayedForward56,
                               delayedForward56_oid, OID_LENGTH(delayedForward56_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward57", handle_delayedForward57,
                               delayedForward57_oid, OID_LENGTH(delayedForward57_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward58", handle_delayedForward58,
                               delayedForward58_oid, OID_LENGTH(delayedForward58_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward59", handle_delayedForward59,
                               delayedForward59_oid, OID_LENGTH(delayedForward59_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward60", handle_delayedForward60,
                               delayedForward60_oid, OID_LENGTH(delayedForward60_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward61", handle_delayedForward61,
                               delayedForward61_oid, OID_LENGTH(delayedForward61_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward62", handle_delayedForward62,
                               delayedForward62_oid, OID_LENGTH(delayedForward62_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward63", handle_delayedForward63,
                               delayedForward63_oid, OID_LENGTH(delayedForward63_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward64", handle_delayedForward64,
                               delayedForward64_oid, OID_LENGTH(delayedForward64_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward65", handle_delayedForward65,
                               delayedForward65_oid, OID_LENGTH(delayedForward65_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward66", handle_delayedForward66,
                               delayedForward66_oid, OID_LENGTH(delayedForward66_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward67", handle_delayedForward67,
                               delayedForward67_oid, OID_LENGTH(delayedForward67_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward68", handle_delayedForward68,
                               delayedForward68_oid, OID_LENGTH(delayedForward68_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward69", handle_delayedForward69,
                               delayedForward69_oid, OID_LENGTH(delayedForward69_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward70", handle_delayedForward70,
                               delayedForward70_oid, OID_LENGTH(delayedForward70_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward71", handle_delayedForward71,
                               delayedForward71_oid, OID_LENGTH(delayedForward71_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward72", handle_delayedForward72,
                               delayedForward72_oid, OID_LENGTH(delayedForward72_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward73", handle_delayedForward73,
                               delayedForward73_oid, OID_LENGTH(delayedForward73_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward74", handle_delayedForward74,
                               delayedForward74_oid, OID_LENGTH(delayedForward74_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward75", handle_delayedForward75,
                               delayedForward75_oid, OID_LENGTH(delayedForward75_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward76", handle_delayedForward76,
                               delayedForward76_oid, OID_LENGTH(delayedForward76_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward77", handle_delayedForward77,
                               delayedForward77_oid, OID_LENGTH(delayedForward77_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward78", handle_delayedForward78,
                               delayedForward78_oid, OID_LENGTH(delayedForward78_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward79", handle_delayedForward79,
                               delayedForward79_oid, OID_LENGTH(delayedForward79_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward80", handle_delayedForward80,
                               delayedForward80_oid, OID_LENGTH(delayedForward80_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward81", handle_delayedForward81,
                               delayedForward81_oid, OID_LENGTH(delayedForward81_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward82", handle_delayedForward82,
                               delayedForward82_oid, OID_LENGTH(delayedForward82_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward83", handle_delayedForward83,
                               delayedForward83_oid, OID_LENGTH(delayedForward83_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward84", handle_delayedForward84,
                               delayedForward84_oid, OID_LENGTH(delayedForward84_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward85", handle_delayedForward85,
                               delayedForward85_oid, OID_LENGTH(delayedForward85_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward86", handle_delayedForward86,
                               delayedForward86_oid, OID_LENGTH(delayedForward86_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward87", handle_delayedForward87,
                               delayedForward87_oid, OID_LENGTH(delayedForward87_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward88", handle_delayedForward88,
                               delayedForward88_oid, OID_LENGTH(delayedForward88_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward89", handle_delayedForward89,
                               delayedForward89_oid, OID_LENGTH(delayedForward89_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward90", handle_delayedForward90,
                               delayedForward90_oid, OID_LENGTH(delayedForward90_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward91", handle_delayedForward91,
                               delayedForward91_oid, OID_LENGTH(delayedForward91_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward92", handle_delayedForward92,
                               delayedForward92_oid, OID_LENGTH(delayedForward92_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward93", handle_delayedForward93,
                               delayedForward93_oid, OID_LENGTH(delayedForward93_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward94", handle_delayedForward94,
                               delayedForward94_oid, OID_LENGTH(delayedForward94_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward95", handle_delayedForward95,
                               delayedForward95_oid, OID_LENGTH(delayedForward95_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward96", handle_delayedForward96,
                               delayedForward96_oid, OID_LENGTH(delayedForward96_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("temperatureSensor1", handle_temperatureSensor1,
                               temperatureSensor1_oid, OID_LENGTH(temperatureSensor1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("temperatureSensor2", handle_temperatureSensor2,
                               temperatureSensor2_oid, OID_LENGTH(temperatureSensor2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("temperatureSensor3", handle_temperatureSensor3,
                               temperatureSensor3_oid, OID_LENGTH(temperatureSensor3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("temperatureSensor4", handle_temperatureSensor4,
                               temperatureSensor4_oid, OID_LENGTH(temperatureSensor4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("temperatureSensor5", handle_temperatureSensor5,
                               temperatureSensor5_oid, OID_LENGTH(temperatureSensor5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("temperatureSensor6", handle_temperatureSensor6,
                               temperatureSensor6_oid, OID_LENGTH(temperatureSensor6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("versionBoot", handle_versionBoot,
                               versionBoot_oid, OID_LENGTH(versionBoot_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("versionCore", handle_versionCore,
                               versionCore_oid, OID_LENGTH(versionCore_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("versionBase", handle_versionBase,
                               versionBase_oid, OID_LENGTH(versionBase_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("versionProg", handle_versionProg,
                               versionProg_oid, OID_LENGTH(versionProg_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("networkMode", handle_networkMode,
                               networkMode_oid, OID_LENGTH(networkMode_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("pppoeLink", handle_pppoeLink,
                               pppoeLink_oid, OID_LENGTH(pppoeLink_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("natTraversal1", handle_natTraversal1,
                               natTraversal1_oid, OID_LENGTH(natTraversal1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("natTraversal2", handle_natTraversal2,
                               natTraversal2_oid, OID_LENGTH(natTraversal2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("natTraversal3", handle_natTraversal3,
                               natTraversal3_oid, OID_LENGTH(natTraversal3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("natTraversal4", handle_natTraversal4,
                               natTraversal4_oid, OID_LENGTH(natTraversal4_oid),
                               HANDLER_CAN_RONLY
        ));
}

void
send_TimedTrap_notification( unsigned int clientreg, void *clientarg )
{
    netsnmp_variable_list  *var_list = NULL ;
    const oid TimedTrap_oid[] = { 1,3,6,1,4,1,42397,1,1,5,1 } ;
    int pvalue_empty =  0 ; 
    int v3trap = 0 ;

    oid snmptrap_oid[] = { 1, 3, 6, 1, 6, 3, 1, 1, 4, 1, 0 } ;
    size_t snmptrap_oid_len = OID_LENGTH( snmptrap_oid ) ;
    char *ptr_no_of_ports = NULL ;
    int no_of_ports = 16 ;

    /*run trap only if pvalue is set to 1*/
    char *pinterval = nvram_get( ":SNMP_trap_1" ) ; /*FILL IN pvalue*/
    if( pinterval == NULL || pinterval[0] == 0 )
            return ;
    if( atoi( pinterval ) == 1 )
        v3trap = 0;
    else if(atoi( pinterval ) == 3 )
        v3trap = 1;
    else
        return ;
    nvram_set( ":SNMP_trap_1", "0" ) ; /*FILL IN pvalue*/

    ptr_no_of_ports = nvram_get( ":base_model" ) ;
    if( ptr_no_of_ports == NULL || ptr_no_of_ports[0] == 0 || strlen( ptr_no_of_ports ) < 7 )
        no_of_ports = 16 ;
    else
    {
        no_of_ports = atoi( &ptr_no_of_ports[5] ) ;
        if( no_of_ports < 16 )
            no_of_ports = 16 ;
    }

    memset( PartNo_value, 0, 256 )  ;
    PartNo_ptr = NULL  ;
    networkMode_value = 0 ;
    pppoeLink_value = 0 ;
    natTraversal1_value = 0 ;
    natTraversal2_value = 0 ;
    natTraversal3_value = 0 ;
    natTraversal4_value = 0 ;
    memset( versionBoot_value, 0, 256 )  ;
    versionBoot_ptr = NULL  ;
    memset( versionCore_value, 0, 256 )  ;
    versionCore_ptr = NULL  ;
    memset( versionBase_value, 0, 256 )  ;
    versionBase_ptr = NULL  ;
    memset( versionProg_value, 0, 256 )  ;
    versionProg_ptr = NULL  ;
    memset( hookStatus1_value, 0, 256 )  ;
    hookStatus1_ptr = NULL  ;
    memset( hookStatus2_value, 0, 256 )  ;
    hookStatus2_ptr = NULL  ;
    memset( hookStatus3_value, 0, 256 )  ;
    hookStatus3_ptr = NULL  ;
    memset( hookStatus4_value, 0, 256 )  ;
    hookStatus4_ptr = NULL  ;
    memset( hookStatus5_value, 0, 256 )  ;
    hookStatus5_ptr = NULL  ;
    memset( hookStatus6_value, 0, 256 )  ;
    hookStatus6_ptr = NULL  ;
    memset( hookStatus7_value, 0, 256 )  ;
    hookStatus7_ptr = NULL  ;
    memset( hookStatus8_value, 0, 256 )  ;
    hookStatus8_ptr = NULL  ;
    memset( hookStatus9_value, 0, 256 )  ;
    hookStatus9_ptr = NULL  ;
    memset( hookStatus10_value, 0, 256 )  ;
    hookStatus10_ptr = NULL  ;
    memset( hookStatus11_value, 0, 256 )  ;
    hookStatus11_ptr = NULL  ;
    memset( hookStatus12_value, 0, 256 )  ;
    hookStatus12_ptr = NULL  ;
    memset( hookStatus13_value, 0, 256 )  ;
    hookStatus13_ptr = NULL  ;
    memset( hookStatus14_value, 0, 256 )  ;
    hookStatus14_ptr = NULL  ;
    memset( hookStatus15_value, 0, 256 )  ;
    hookStatus15_ptr = NULL  ;
    memset( hookStatus16_value, 0, 256 )  ;
    if( no_of_ports > 16 )
    {
    hookStatus16_ptr = NULL  ;
    memset( hookStatus17_value, 0, 256 )  ;
    hookStatus17_ptr = NULL  ;
    memset( hookStatus18_value, 0, 256 )  ;
    hookStatus18_ptr = NULL  ;
    memset( hookStatus19_value, 0, 256 )  ;
    hookStatus19_ptr = NULL  ;
    memset( hookStatus20_value, 0, 256 )  ;
    hookStatus20_ptr = NULL  ;
    memset( hookStatus21_value, 0, 256 )  ;
    hookStatus21_ptr = NULL  ;
    memset( hookStatus22_value, 0, 256 )  ;
    hookStatus22_ptr = NULL  ;
    memset( hookStatus23_value, 0, 256 )  ;
    hookStatus23_ptr = NULL  ;
    memset( hookStatus24_value, 0, 256 )  ;
    hookStatus24_ptr = NULL  ;
    if( no_of_ports > 24 )
    {
    memset( hookStatus25_value, 0, 256 )  ;
    hookStatus25_ptr = NULL  ;
    memset( hookStatus26_value, 0, 256 )  ;
    hookStatus26_ptr = NULL  ;
    memset( hookStatus27_value, 0, 256 )  ;
    hookStatus27_ptr = NULL  ;
    memset( hookStatus28_value, 0, 256 )  ;
    hookStatus28_ptr = NULL  ;
    memset( hookStatus29_value, 0, 256 )  ;
    hookStatus29_ptr = NULL  ;
    memset( hookStatus30_value, 0, 256 )  ;
    hookStatus30_ptr = NULL  ;
    memset( hookStatus31_value, 0, 256 )  ;
    hookStatus31_ptr = NULL  ;
    memset( hookStatus32_value, 0, 256 )  ;
    hookStatus32_ptr = NULL  ;
    if( no_of_ports > 32 )
    {
    memset( hookStatus33_value, 0, 256 )  ;
    hookStatus33_ptr = NULL  ;
    memset( hookStatus34_value, 0, 256 )  ;
    hookStatus34_ptr = NULL  ;
    memset( hookStatus35_value, 0, 256 )  ;
    hookStatus35_ptr = NULL  ;
    memset( hookStatus36_value, 0, 256 )  ;
    hookStatus36_ptr = NULL  ;
    memset( hookStatus37_value, 0, 256 )  ;
    hookStatus37_ptr = NULL  ;
    memset( hookStatus38_value, 0, 256 )  ;
    hookStatus38_ptr = NULL  ;
    memset( hookStatus39_value, 0, 256 )  ;
    hookStatus39_ptr = NULL  ;
    memset( hookStatus40_value, 0, 256 )  ;
    hookStatus40_ptr = NULL  ;
    memset( hookStatus41_value, 0, 256 )  ;
    hookStatus41_ptr = NULL  ;
    memset( hookStatus42_value, 0, 256 )  ;
    hookStatus42_ptr = NULL  ;
    memset( hookStatus43_value, 0, 256 )  ;
    hookStatus43_ptr = NULL  ;
    memset( hookStatus44_value, 0, 256 )  ;
    hookStatus44_ptr = NULL  ;
    memset( hookStatus45_value, 0, 256 )  ;
    hookStatus45_ptr = NULL  ;
    memset( hookStatus46_value, 0, 256 )  ;
    hookStatus46_ptr = NULL  ;
    memset( hookStatus47_value, 0, 256 )  ;
    hookStatus47_ptr = NULL  ;
    memset( hookStatus48_value, 0, 256 )  ;
    hookStatus48_ptr = NULL  ;
    if( no_of_ports > 48 )
    {
    memset( hookStatus49_value, 0, 256 )  ;
    hookStatus49_ptr = NULL  ;
    memset( hookStatus50_value, 0, 256 )  ;
    hookStatus50_ptr = NULL  ;
    memset( hookStatus51_value, 0, 256 )  ;
    hookStatus51_ptr = NULL  ;
    memset( hookStatus52_value, 0, 256 )  ;
    hookStatus52_ptr = NULL  ;
    memset( hookStatus53_value, 0, 256 )  ;
    hookStatus53_ptr = NULL  ;
    memset( hookStatus54_value, 0, 256 )  ;
    hookStatus54_ptr = NULL  ;
    memset( hookStatus55_value, 0, 256 )  ;
    hookStatus55_ptr = NULL  ;
    memset( hookStatus56_value, 0, 256 )  ;
    hookStatus56_ptr = NULL  ;
    memset( hookStatus57_value, 0, 256 )  ;
    hookStatus57_ptr = NULL  ;
    memset( hookStatus58_value, 0, 256 )  ;
    hookStatus58_ptr = NULL  ;
    memset( hookStatus59_value, 0, 256 )  ;
    hookStatus59_ptr = NULL  ;
    memset( hookStatus60_value, 0, 256 )  ;
    hookStatus60_ptr = NULL  ;
    memset( hookStatus61_value, 0, 256 )  ;
    hookStatus61_ptr = NULL  ;
    memset( hookStatus62_value, 0, 256 )  ;
    hookStatus62_ptr = NULL  ;
    memset( hookStatus63_value, 0, 256 )  ;
    hookStatus63_ptr = NULL  ;
    memset( hookStatus64_value, 0, 256 )  ;
    hookStatus64_ptr = NULL  ;
    memset( hookStatus65_value, 0, 256 )  ;
    hookStatus65_ptr = NULL  ;
    memset( hookStatus66_value, 0, 256 )  ;
    hookStatus66_ptr = NULL  ;
    memset( hookStatus67_value, 0, 256 )  ;
    hookStatus67_ptr = NULL  ;
    memset( hookStatus68_value, 0, 256 )  ;
    hookStatus68_ptr = NULL  ;
    memset( hookStatus69_value, 0, 256 )  ;
    hookStatus69_ptr = NULL  ;
    memset( hookStatus70_value, 0, 256 )  ;
    hookStatus70_ptr = NULL  ;
    memset( hookStatus71_value, 0, 256 )  ;
    hookStatus71_ptr = NULL  ;
    memset( hookStatus72_value, 0, 256 )  ;
    hookStatus72_ptr = NULL  ;
    memset( hookStatus73_value, 0, 256 )  ;
    hookStatus73_ptr = NULL  ;
    memset( hookStatus74_value, 0, 256 )  ;
    hookStatus74_ptr = NULL  ;
    memset( hookStatus75_value, 0, 256 )  ;
    hookStatus75_ptr = NULL  ;
    memset( hookStatus76_value, 0, 256 )  ;
    hookStatus76_ptr = NULL  ;
    memset( hookStatus77_value, 0, 256 )  ;
    hookStatus77_ptr = NULL  ;
    memset( hookStatus78_value, 0, 256 )  ;
    hookStatus78_ptr = NULL  ;
    memset( hookStatus79_value, 0, 256 )  ;
    hookStatus79_ptr = NULL  ;
    memset( hookStatus80_value, 0, 256 )  ;
    hookStatus80_ptr = NULL  ;
    memset( hookStatus81_value, 0, 256 )  ;
    hookStatus81_ptr = NULL  ;
    memset( hookStatus82_value, 0, 256 )  ;
    hookStatus82_ptr = NULL  ;
    memset( hookStatus83_value, 0, 256 )  ;
    hookStatus83_ptr = NULL  ;
    memset( hookStatus84_value, 0, 256 )  ;
    hookStatus84_ptr = NULL  ;
    memset( hookStatus85_value, 0, 256 )  ;
    hookStatus85_ptr = NULL  ;
    memset( hookStatus86_value, 0, 256 )  ;
    hookStatus86_ptr = NULL  ;
    memset( hookStatus87_value, 0, 256 )  ;
    hookStatus87_ptr = NULL  ;
    memset( hookStatus88_value, 0, 256 )  ;
    hookStatus88_ptr = NULL  ;
    memset( hookStatus89_value, 0, 256 )  ;
    hookStatus89_ptr = NULL  ;
    memset( hookStatus90_value, 0, 256 )  ;
    hookStatus90_ptr = NULL  ;
    memset( hookStatus91_value, 0, 256 )  ;
    hookStatus91_ptr = NULL  ;
    memset( hookStatus92_value, 0, 256 )  ;
    hookStatus92_ptr = NULL  ;
    memset( hookStatus93_value, 0, 256 )  ;
    hookStatus93_ptr = NULL  ;
    memset( hookStatus94_value, 0, 256 )  ;
    hookStatus94_ptr = NULL  ;
    memset( hookStatus95_value, 0, 256 )  ;
    hookStatus95_ptr = NULL  ;
    memset( hookStatus96_value, 0, 256 )  ;
    hookStatus96_ptr = NULL  ;
    }}}}
    memset( regStatus1_value, 0, 256 )  ;
    regStatus1_ptr = NULL  ;
    memset( regStatus2_value, 0, 256 )  ;
    regStatus2_ptr = NULL  ;
    memset( regStatus3_value, 0, 256 )  ;
    regStatus3_ptr = NULL  ;
    memset( regStatus4_value, 0, 256 )  ;
    regStatus4_ptr = NULL  ;
    memset( regStatus5_value, 0, 256 )  ;
    regStatus5_ptr = NULL  ;
    memset( regStatus6_value, 0, 256 )  ;
    regStatus6_ptr = NULL  ;
    memset( regStatus7_value, 0, 256 )  ;
    regStatus7_ptr = NULL  ;
    memset( regStatus8_value, 0, 256 )  ;
    regStatus8_ptr = NULL  ;
    memset( regStatus9_value, 0, 256 )  ;
    regStatus9_ptr = NULL  ;
    memset( regStatus10_value, 0, 256 )  ;
    regStatus10_ptr = NULL  ;
    memset( regStatus11_value, 0, 256 )  ;
    regStatus11_ptr = NULL  ;
    memset( regStatus12_value, 0, 256 )  ;
    regStatus12_ptr = NULL  ;
    memset( regStatus13_value, 0, 256 )  ;
    regStatus13_ptr = NULL  ;
    memset( regStatus14_value, 0, 256 )  ;
    regStatus14_ptr = NULL  ;
    memset( regStatus15_value, 0, 256 )  ;
    regStatus15_ptr = NULL  ;
    memset( regStatus16_value, 0, 256 )  ;
    regStatus16_ptr = NULL  ;
    if( no_of_ports > 16 )
    {
    memset( regStatus17_value, 0, 256 )  ;
    regStatus17_ptr = NULL  ;
    memset( regStatus18_value, 0, 256 )  ;
    regStatus18_ptr = NULL  ;
    memset( regStatus19_value, 0, 256 )  ;
    regStatus19_ptr = NULL  ;
    memset( regStatus20_value, 0, 256 )  ;
    regStatus20_ptr = NULL  ;
    memset( regStatus21_value, 0, 256 )  ;
    regStatus21_ptr = NULL  ;
    memset( regStatus22_value, 0, 256 )  ;
    regStatus22_ptr = NULL  ;
    memset( regStatus23_value, 0, 256 )  ;
    regStatus23_ptr = NULL  ;
    memset( regStatus24_value, 0, 256 )  ;
    regStatus24_ptr = NULL  ;
    if( no_of_ports > 24 )
    {
    memset( regStatus25_value, 0, 256 )  ;
    regStatus25_ptr = NULL  ;
    memset( regStatus26_value, 0, 256 )  ;
    regStatus26_ptr = NULL  ;
    memset( regStatus27_value, 0, 256 )  ;
    regStatus27_ptr = NULL  ;
    memset( regStatus28_value, 0, 256 )  ;
    regStatus28_ptr = NULL  ;
    memset( regStatus29_value, 0, 256 )  ;
    regStatus29_ptr = NULL  ;
    memset( regStatus30_value, 0, 256 )  ;
    regStatus30_ptr = NULL  ;
    memset( regStatus31_value, 0, 256 )  ;
    regStatus31_ptr = NULL  ;
    memset( regStatus32_value, 0, 256 )  ;
    regStatus32_ptr = NULL  ;
    if( no_of_ports > 32 )
    {
    memset( regStatus33_value, 0, 256 )  ;
    regStatus33_ptr = NULL  ;
    memset( regStatus34_value, 0, 256 )  ;
    regStatus34_ptr = NULL  ;
    memset( regStatus35_value, 0, 256 )  ;
    regStatus35_ptr = NULL  ;
    memset( regStatus36_value, 0, 256 )  ;
    regStatus36_ptr = NULL  ;
    memset( regStatus37_value, 0, 256 )  ;
    regStatus37_ptr = NULL  ;
    memset( regStatus38_value, 0, 256 )  ;
    regStatus38_ptr = NULL  ;
    memset( regStatus39_value, 0, 256 )  ;
    regStatus39_ptr = NULL  ;
    memset( regStatus40_value, 0, 256 )  ;
    regStatus40_ptr = NULL  ;
    memset( regStatus41_value, 0, 256 )  ;
    regStatus41_ptr = NULL  ;
    memset( regStatus42_value, 0, 256 )  ;
    regStatus42_ptr = NULL  ;
    memset( regStatus43_value, 0, 256 )  ;
    regStatus43_ptr = NULL  ;
    memset( regStatus44_value, 0, 256 )  ;
    regStatus44_ptr = NULL  ;
    memset( regStatus45_value, 0, 256 )  ;
    regStatus45_ptr = NULL  ;
    memset( regStatus46_value, 0, 256 )  ;
    regStatus46_ptr = NULL  ;
    memset( regStatus47_value, 0, 256 )  ;
    regStatus47_ptr = NULL  ;
    memset( regStatus48_value, 0, 256 )  ;
    regStatus48_ptr = NULL  ;
    if( no_of_ports > 48 )
    {
    memset( regStatus49_value, 0, 256 )  ;
    regStatus49_ptr = NULL  ;
    memset( regStatus50_value, 0, 256 )  ;
    regStatus50_ptr = NULL  ;
    memset( regStatus51_value, 0, 256 )  ;
    regStatus51_ptr = NULL  ;
    memset( regStatus52_value, 0, 256 )  ;
    regStatus52_ptr = NULL  ;
    memset( regStatus53_value, 0, 256 )  ;
    regStatus53_ptr = NULL  ;
    memset( regStatus54_value, 0, 256 )  ;
    regStatus54_ptr = NULL  ;
    memset( regStatus55_value, 0, 256 )  ;
    regStatus55_ptr = NULL  ;
    memset( regStatus56_value, 0, 256 )  ;
    regStatus56_ptr = NULL  ;
    memset( regStatus57_value, 0, 256 )  ;
    regStatus57_ptr = NULL  ;
    memset( regStatus58_value, 0, 256 )  ;
    regStatus58_ptr = NULL  ;
    memset( regStatus59_value, 0, 256 )  ;
    regStatus59_ptr = NULL  ;
    memset( regStatus60_value, 0, 256 )  ;
    regStatus60_ptr = NULL  ;
    memset( regStatus61_value, 0, 256 )  ;
    regStatus61_ptr = NULL  ;
    memset( regStatus62_value, 0, 256 )  ;
    regStatus62_ptr = NULL  ;
    memset( regStatus63_value, 0, 256 )  ;
    regStatus63_ptr = NULL  ;
    memset( regStatus64_value, 0, 256 )  ;
    regStatus64_ptr = NULL  ;
    memset( regStatus65_value, 0, 256 )  ;
    regStatus65_ptr = NULL  ;
    memset( regStatus66_value, 0, 256 )  ;
    regStatus66_ptr = NULL  ;
    memset( regStatus67_value, 0, 256 )  ;
    regStatus67_ptr = NULL  ;
    memset( regStatus68_value, 0, 256 )  ;
    regStatus68_ptr = NULL  ;
    memset( regStatus69_value, 0, 256 )  ;
    regStatus69_ptr = NULL  ;
    memset( regStatus70_value, 0, 256 )  ;
    regStatus70_ptr = NULL  ;
    memset( regStatus71_value, 0, 256 )  ;
    regStatus71_ptr = NULL  ;
    memset( regStatus72_value, 0, 256 )  ;
    regStatus72_ptr = NULL  ;
    memset( regStatus73_value, 0, 256 )  ;
    regStatus73_ptr = NULL  ;
    memset( regStatus74_value, 0, 256 )  ;
    regStatus74_ptr = NULL  ;
    memset( regStatus75_value, 0, 256 )  ;
    regStatus75_ptr = NULL  ;
    memset( regStatus76_value, 0, 256 )  ;
    regStatus76_ptr = NULL  ;
    memset( regStatus77_value, 0, 256 )  ;
    regStatus77_ptr = NULL  ;
    memset( regStatus78_value, 0, 256 )  ;
    regStatus78_ptr = NULL  ;
    memset( regStatus79_value, 0, 256 )  ;
    regStatus79_ptr = NULL  ;
    memset( regStatus80_value, 0, 256 )  ;
    regStatus80_ptr = NULL  ;
    memset( regStatus81_value, 0, 256 )  ;
    regStatus81_ptr = NULL  ;
    memset( regStatus82_value, 0, 256 )  ;
    regStatus82_ptr = NULL  ;
    memset( regStatus83_value, 0, 256 )  ;
    regStatus83_ptr = NULL  ;
    memset( regStatus84_value, 0, 256 )  ;
    regStatus84_ptr = NULL  ;
    memset( regStatus85_value, 0, 256 )  ;
    regStatus85_ptr = NULL  ;
    memset( regStatus86_value, 0, 256 )  ;
    regStatus86_ptr = NULL  ;
    memset( regStatus87_value, 0, 256 )  ;
    regStatus87_ptr = NULL  ;
    memset( regStatus88_value, 0, 256 )  ;
    regStatus88_ptr = NULL  ;
    memset( regStatus89_value, 0, 256 )  ;
    regStatus89_ptr = NULL  ;
    memset( regStatus90_value, 0, 256 )  ;
    regStatus90_ptr = NULL  ;
    memset( regStatus91_value, 0, 256 )  ;
    regStatus91_ptr = NULL  ;
    memset( regStatus92_value, 0, 256 )  ;
    regStatus92_ptr = NULL  ;
    memset( regStatus93_value, 0, 256 )  ;
    regStatus93_ptr = NULL  ;
    memset( regStatus94_value, 0, 256 )  ;
    regStatus94_ptr = NULL  ;
    memset( regStatus95_value, 0, 256 )  ;
    regStatus95_ptr = NULL  ;
    memset( regStatus96_value, 0, 256 )  ;
    regStatus96_ptr = NULL  ;
    }}}}
    dnd1_value = 0 ;
    dnd2_value = 0 ;
    dnd3_value = 0 ;
    dnd4_value = 0 ;
    dnd5_value = 0 ;
    dnd6_value = 0 ;
    dnd7_value = 0 ;
    dnd8_value = 0 ;
    dnd9_value = 0 ;
    dnd10_value = 0 ;
    dnd11_value = 0 ;
    dnd12_value = 0 ;
    dnd13_value = 0 ;
    dnd14_value = 0 ;
    dnd15_value = 0 ;
    dnd16_value = 0 ;
    if( no_of_ports > 16 )
    {
    dnd17_value = 0 ;
    dnd18_value = 0 ;
    dnd19_value = 0 ;
    dnd20_value = 0 ;
    dnd21_value = 0 ;
    dnd22_value = 0 ;
    dnd23_value = 0 ;
    dnd24_value = 0 ;
    if( no_of_ports > 24 )
    {
    dnd25_value = 0 ;
    dnd26_value = 0 ;
    dnd27_value = 0 ;
    dnd28_value = 0 ;
    dnd29_value = 0 ;
    dnd30_value = 0 ;
    dnd31_value = 0 ;
    dnd32_value = 0 ;
    if( no_of_ports > 32 )
    {
    dnd33_value = 0 ;
    dnd34_value = 0 ;
    dnd35_value = 0 ;
    dnd36_value = 0 ;
    dnd37_value = 0 ;
    dnd38_value = 0 ;
    dnd39_value = 0 ;
    dnd40_value = 0 ;
    dnd41_value = 0 ;
    dnd42_value = 0 ;
    dnd43_value = 0 ;
    dnd44_value = 0 ;
    dnd45_value = 0 ;
    dnd46_value = 0 ;
    dnd47_value = 0 ;
    dnd48_value = 0 ;
    if( no_of_ports > 48 )
    {
    dnd49_value = 0 ;
    dnd50_value = 0 ;
    dnd51_value = 0 ;
    dnd52_value = 0 ;
    dnd53_value = 0 ;
    dnd54_value = 0 ;
    dnd55_value = 0 ;
    dnd56_value = 0 ;
    dnd57_value = 0 ;
    dnd58_value = 0 ;
    dnd59_value = 0 ;
    dnd60_value = 0 ;
    dnd61_value = 0 ;
    dnd62_value = 0 ;
    dnd63_value = 0 ;
    dnd64_value = 0 ;
    dnd65_value = 0 ;
    dnd66_value = 0 ;
    dnd67_value = 0 ;
    dnd68_value = 0 ;
    dnd69_value = 0 ;
    dnd70_value = 0 ;
    dnd71_value = 0 ;
    dnd72_value = 0 ;
    dnd73_value = 0 ;
    dnd74_value = 0 ;
    dnd75_value = 0 ;
    dnd76_value = 0 ;
    dnd77_value = 0 ;
    dnd78_value = 0 ;
    dnd79_value = 0 ;
    dnd80_value = 0 ;
    dnd81_value = 0 ;
    dnd82_value = 0 ;
    dnd83_value = 0 ;
    dnd84_value = 0 ;
    dnd85_value = 0 ;
    dnd86_value = 0 ;
    dnd87_value = 0 ;
    dnd88_value = 0 ;
    dnd89_value = 0 ;
    dnd90_value = 0 ;
    dnd91_value = 0 ;
    dnd92_value = 0 ;
    dnd93_value = 0 ;
    dnd94_value = 0 ;
    dnd95_value = 0 ;
    dnd96_value = 0 ;
    }}}}
    memset( forward1_value, 0, 256 )  ;
    forward1_ptr = NULL  ;
    memset( forward2_value, 0, 256 )  ;
    forward2_ptr = NULL  ;
    memset( forward3_value, 0, 256 )  ;
    forward3_ptr = NULL  ;
    memset( forward4_value, 0, 256 )  ;
    forward4_ptr = NULL  ;
    memset( forward5_value, 0, 256 )  ;
    forward5_ptr = NULL  ;
    memset( forward6_value, 0, 256 )  ;
    forward6_ptr = NULL  ;
    memset( forward7_value, 0, 256 )  ;
    forward7_ptr = NULL  ;
    memset( forward8_value, 0, 256 )  ;
    forward8_ptr = NULL  ;
    memset( forward9_value, 0, 256 )  ;
    forward9_ptr = NULL  ;
    memset( forward10_value, 0, 256 )  ;
    forward10_ptr = NULL  ;
    memset( forward11_value, 0, 256 )  ;
    forward11_ptr = NULL  ;
    memset( forward12_value, 0, 256 )  ;
    forward12_ptr = NULL  ;
    memset( forward13_value, 0, 256 )  ;
    forward13_ptr = NULL  ;
    memset( forward14_value, 0, 256 )  ;
    forward14_ptr = NULL  ;
    memset( forward15_value, 0, 256 )  ;
    forward15_ptr = NULL  ;
    memset( forward16_value, 0, 256 )  ;
    forward16_ptr = NULL  ;
    if( no_of_ports > 16 )
    {
    memset( forward17_value, 0, 256 )  ;
    forward17_ptr = NULL  ;
    memset( forward18_value, 0, 256 )  ;
    forward18_ptr = NULL  ;
    memset( forward19_value, 0, 256 )  ;
    forward19_ptr = NULL  ;
    memset( forward20_value, 0, 256 )  ;
    forward20_ptr = NULL  ;
    memset( forward21_value, 0, 256 )  ;
    forward21_ptr = NULL  ;
    memset( forward22_value, 0, 256 )  ;
    forward22_ptr = NULL  ;
    memset( forward23_value, 0, 256 )  ;
    forward23_ptr = NULL  ;
    memset( forward24_value, 0, 256 )  ;
    forward24_ptr = NULL  ;
    if( no_of_ports > 24 )
    {
    memset( forward25_value, 0, 256 )  ;
    forward25_ptr = NULL  ;
    memset( forward26_value, 0, 256 )  ;
    forward26_ptr = NULL  ;
    memset( forward27_value, 0, 256 )  ;
    forward27_ptr = NULL  ;
    memset( forward28_value, 0, 256 )  ;
    forward28_ptr = NULL  ;
    memset( forward29_value, 0, 256 )  ;
    forward29_ptr = NULL  ;
    memset( forward30_value, 0, 256 )  ;
    forward30_ptr = NULL  ;
    memset( forward31_value, 0, 256 )  ;
    forward31_ptr = NULL  ;
    memset( forward32_value, 0, 256 )  ;
    forward32_ptr = NULL  ;
    if( no_of_ports > 32 )
    {
    memset( forward33_value, 0, 256 )  ;
    forward33_ptr = NULL  ;
    memset( forward34_value, 0, 256 )  ;
    forward34_ptr = NULL  ;
    memset( forward35_value, 0, 256 )  ;
    forward35_ptr = NULL  ;
    memset( forward36_value, 0, 256 )  ;
    forward36_ptr = NULL  ;
    memset( forward37_value, 0, 256 )  ;
    forward37_ptr = NULL  ;
    memset( forward38_value, 0, 256 )  ;
    forward38_ptr = NULL  ;
    memset( forward39_value, 0, 256 )  ;
    forward39_ptr = NULL  ;
    memset( forward40_value, 0, 256 )  ;
    forward40_ptr = NULL  ;
    memset( forward41_value, 0, 256 )  ;
    forward41_ptr = NULL  ;
    memset( forward42_value, 0, 256 )  ;
    forward42_ptr = NULL  ;
    memset( forward43_value, 0, 256 )  ;
    forward43_ptr = NULL  ;
    memset( forward44_value, 0, 256 )  ;
    forward44_ptr = NULL  ;
    memset( forward45_value, 0, 256 )  ;
    forward45_ptr = NULL  ;
    memset( forward46_value, 0, 256 )  ;
    forward46_ptr = NULL  ;
    memset( forward47_value, 0, 256 )  ;
    forward47_ptr = NULL  ;
    memset( forward48_value, 0, 256 )  ;
    forward48_ptr = NULL  ;
    if( no_of_ports > 48 )
    {
    memset( forward49_value, 0, 256 )  ;
    forward49_ptr = NULL  ;
    memset( forward50_value, 0, 256 )  ;
    forward50_ptr = NULL  ;
    memset( forward51_value, 0, 256 )  ;
    forward51_ptr = NULL  ;
    memset( forward52_value, 0, 256 )  ;
    forward52_ptr = NULL  ;
    memset( forward53_value, 0, 256 )  ;
    forward53_ptr = NULL  ;
    memset( forward54_value, 0, 256 )  ;
    forward54_ptr = NULL  ;
    memset( forward55_value, 0, 256 )  ;
    forward55_ptr = NULL  ;
    memset( forward56_value, 0, 256 )  ;
    forward56_ptr = NULL  ;
    memset( forward57_value, 0, 256 )  ;
    forward57_ptr = NULL  ;
    memset( forward58_value, 0, 256 )  ;
    forward58_ptr = NULL  ;
    memset( forward59_value, 0, 256 )  ;
    forward59_ptr = NULL  ;
    memset( forward60_value, 0, 256 )  ;
    forward60_ptr = NULL  ;
    memset( forward61_value, 0, 256 )  ;
    forward61_ptr = NULL  ;
    memset( forward62_value, 0, 256 )  ;
    forward62_ptr = NULL  ;
    memset( forward63_value, 0, 256 )  ;
    forward63_ptr = NULL  ;
    memset( forward64_value, 0, 256 )  ;
    forward64_ptr = NULL  ;
    memset( forward65_value, 0, 256 )  ;
    forward65_ptr = NULL  ;
    memset( forward66_value, 0, 256 )  ;
    forward66_ptr = NULL  ;
    memset( forward67_value, 0, 256 )  ;
    forward67_ptr = NULL  ;
    memset( forward68_value, 0, 256 )  ;
    forward68_ptr = NULL  ;
    memset( forward69_value, 0, 256 )  ;
    forward69_ptr = NULL  ;
    memset( forward70_value, 0, 256 )  ;
    forward70_ptr = NULL  ;
    memset( forward71_value, 0, 256 )  ;
    forward71_ptr = NULL  ;
    memset( forward72_value, 0, 256 )  ;
    forward72_ptr = NULL  ;
    memset( forward73_value, 0, 256 )  ;
    forward73_ptr = NULL  ;
    memset( forward74_value, 0, 256 )  ;
    forward74_ptr = NULL  ;
    memset( forward75_value, 0, 256 )  ;
    forward75_ptr = NULL  ;
    memset( forward76_value, 0, 256 )  ;
    forward76_ptr = NULL  ;
    memset( forward77_value, 0, 256 )  ;
    forward77_ptr = NULL  ;
    memset( forward78_value, 0, 256 )  ;
    forward78_ptr = NULL  ;
    memset( forward79_value, 0, 256 )  ;
    forward79_ptr = NULL  ;
    memset( forward80_value, 0, 256 )  ;
    forward80_ptr = NULL  ;
    memset( forward81_value, 0, 256 )  ;
    forward81_ptr = NULL  ;
    memset( forward82_value, 0, 256 )  ;
    forward82_ptr = NULL  ;
    memset( forward83_value, 0, 256 )  ;
    forward83_ptr = NULL  ;
    memset( forward84_value, 0, 256 )  ;
    forward84_ptr = NULL  ;
    memset( forward85_value, 0, 256 )  ;
    forward85_ptr = NULL  ;
    memset( forward86_value, 0, 256 )  ;
    forward86_ptr = NULL  ;
    memset( forward87_value, 0, 256 )  ;
    forward87_ptr = NULL  ;
    memset( forward88_value, 0, 256 )  ;
    forward88_ptr = NULL  ;
    memset( forward89_value, 0, 256 )  ;
    forward89_ptr = NULL  ;
    memset( forward90_value, 0, 256 )  ;
    forward90_ptr = NULL  ;
    memset( forward91_value, 0, 256 )  ;
    forward91_ptr = NULL  ;
    memset( forward92_value, 0, 256 )  ;
    forward92_ptr = NULL  ;
    memset( forward93_value, 0, 256 )  ;
    forward93_ptr = NULL  ;
    memset( forward94_value, 0, 256 )  ;
    forward94_ptr = NULL  ;
    memset( forward95_value, 0, 256 )  ;
    forward95_ptr = NULL  ;
    memset( forward96_value, 0, 256 )  ;
    forward96_ptr = NULL  ;
    }}}}
    memset( busyForward1_value, 0, 256 )  ;
    busyForward1_ptr = NULL  ;
    memset( busyForward2_value, 0, 256 )  ;
    busyForward2_ptr = NULL  ;
    memset( busyForward3_value, 0, 256 )  ;
    busyForward3_ptr = NULL  ;
    memset( busyForward4_value, 0, 256 )  ;
    busyForward4_ptr = NULL  ;
    memset( busyForward5_value, 0, 256 )  ;
    busyForward5_ptr = NULL  ;
    memset( busyForward6_value, 0, 256 )  ;
    busyForward6_ptr = NULL  ;
    memset( busyForward7_value, 0, 256 )  ;
    busyForward7_ptr = NULL  ;
    memset( busyForward8_value, 0, 256 )  ;
    busyForward8_ptr = NULL  ;
    memset( busyForward9_value, 0, 256 )  ;
    busyForward9_ptr = NULL  ;
    memset( busyForward10_value, 0, 256 )  ;
    busyForward10_ptr = NULL  ;
    memset( busyForward11_value, 0, 256 )  ;
    busyForward11_ptr = NULL  ;
    memset( busyForward12_value, 0, 256 )  ;
    busyForward12_ptr = NULL  ;
    memset( busyForward13_value, 0, 256 )  ;
    busyForward13_ptr = NULL  ;
    memset( busyForward14_value, 0, 256 )  ;
    busyForward14_ptr = NULL  ;
    memset( busyForward15_value, 0, 256 )  ;
    busyForward15_ptr = NULL  ;
    memset( busyForward16_value, 0, 256 )  ;
    busyForward16_ptr = NULL  ;
    if( no_of_ports > 16 )
    {
    memset( busyForward17_value, 0, 256 )  ;
    busyForward17_ptr = NULL  ;
    memset( busyForward18_value, 0, 256 )  ;
    busyForward18_ptr = NULL  ;
    memset( busyForward19_value, 0, 256 )  ;
    busyForward19_ptr = NULL  ;
    memset( busyForward20_value, 0, 256 )  ;
    busyForward20_ptr = NULL  ;
    memset( busyForward21_value, 0, 256 )  ;
    busyForward21_ptr = NULL  ;
    memset( busyForward22_value, 0, 256 )  ;
    busyForward22_ptr = NULL  ;
    memset( busyForward23_value, 0, 256 )  ;
    busyForward23_ptr = NULL  ;
    memset( busyForward24_value, 0, 256 )  ;
    busyForward24_ptr = NULL  ;
    if( no_of_ports > 24 )
    {
    memset( busyForward25_value, 0, 256 )  ;
    busyForward25_ptr = NULL  ;
    memset( busyForward26_value, 0, 256 )  ;
    busyForward26_ptr = NULL  ;
    memset( busyForward27_value, 0, 256 )  ;
    busyForward27_ptr = NULL  ;
    memset( busyForward28_value, 0, 256 )  ;
    busyForward28_ptr = NULL  ;
    memset( busyForward29_value, 0, 256 )  ;
    busyForward29_ptr = NULL  ;
    memset( busyForward30_value, 0, 256 )  ;
    busyForward30_ptr = NULL  ;
    memset( busyForward31_value, 0, 256 )  ;
    busyForward31_ptr = NULL  ;
    memset( busyForward32_value, 0, 256 )  ;
    busyForward32_ptr = NULL  ;
    if( no_of_ports > 32 )
    {
    memset( busyForward33_value, 0, 256 )  ;
    busyForward33_ptr = NULL  ;
    memset( busyForward34_value, 0, 256 )  ;
    busyForward34_ptr = NULL  ;
    memset( busyForward35_value, 0, 256 )  ;
    busyForward35_ptr = NULL  ;
    memset( busyForward36_value, 0, 256 )  ;
    busyForward36_ptr = NULL  ;
    memset( busyForward37_value, 0, 256 )  ;
    busyForward37_ptr = NULL  ;
    memset( busyForward38_value, 0, 256 )  ;
    busyForward38_ptr = NULL  ;
    memset( busyForward39_value, 0, 256 )  ;
    busyForward39_ptr = NULL  ;
    memset( busyForward40_value, 0, 256 )  ;
    busyForward40_ptr = NULL  ;
    memset( busyForward41_value, 0, 256 )  ;
    busyForward41_ptr = NULL  ;
    memset( busyForward42_value, 0, 256 )  ;
    busyForward42_ptr = NULL  ;
    memset( busyForward43_value, 0, 256 )  ;
    busyForward43_ptr = NULL  ;
    memset( busyForward44_value, 0, 256 )  ;
    busyForward44_ptr = NULL  ;
    memset( busyForward45_value, 0, 256 )  ;
    busyForward45_ptr = NULL  ;
    memset( busyForward46_value, 0, 256 )  ;
    busyForward46_ptr = NULL  ;
    memset( busyForward47_value, 0, 256 )  ;
    busyForward47_ptr = NULL  ;
    memset( busyForward48_value, 0, 256 )  ;
    busyForward48_ptr = NULL  ;
    if( no_of_ports > 48 )
    {
    memset( busyForward49_value, 0, 256 )  ;
    busyForward49_ptr = NULL  ;
    memset( busyForward50_value, 0, 256 )  ;
    busyForward50_ptr = NULL  ;
    memset( busyForward51_value, 0, 256 )  ;
    busyForward51_ptr = NULL  ;
    memset( busyForward52_value, 0, 256 )  ;
    busyForward52_ptr = NULL  ;
    memset( busyForward53_value, 0, 256 )  ;
    busyForward53_ptr = NULL  ;
    memset( busyForward54_value, 0, 256 )  ;
    busyForward54_ptr = NULL  ;
    memset( busyForward55_value, 0, 256 )  ;
    busyForward55_ptr = NULL  ;
    memset( busyForward56_value, 0, 256 )  ;
    busyForward56_ptr = NULL  ;
    memset( busyForward57_value, 0, 256 )  ;
    busyForward57_ptr = NULL  ;
    memset( busyForward58_value, 0, 256 )  ;
    busyForward58_ptr = NULL  ;
    memset( busyForward59_value, 0, 256 )  ;
    busyForward59_ptr = NULL  ;
    memset( busyForward60_value, 0, 256 )  ;
    busyForward60_ptr = NULL  ;
    memset( busyForward61_value, 0, 256 )  ;
    busyForward61_ptr = NULL  ;
    memset( busyForward62_value, 0, 256 )  ;
    busyForward62_ptr = NULL  ;
    memset( busyForward63_value, 0, 256 )  ;
    busyForward63_ptr = NULL  ;
    memset( busyForward64_value, 0, 256 )  ;
    busyForward64_ptr = NULL  ;
    memset( busyForward65_value, 0, 256 )  ;
    busyForward65_ptr = NULL  ;
    memset( busyForward66_value, 0, 256 )  ;
    busyForward66_ptr = NULL  ;
    memset( busyForward67_value, 0, 256 )  ;
    busyForward67_ptr = NULL  ;
    memset( busyForward68_value, 0, 256 )  ;
    busyForward68_ptr = NULL  ;
    memset( busyForward69_value, 0, 256 )  ;
    busyForward69_ptr = NULL  ;
    memset( busyForward70_value, 0, 256 )  ;
    busyForward70_ptr = NULL  ;
    memset( busyForward71_value, 0, 256 )  ;
    busyForward71_ptr = NULL  ;
    memset( busyForward72_value, 0, 256 )  ;
    busyForward72_ptr = NULL  ;
    memset( busyForward73_value, 0, 256 )  ;
    busyForward73_ptr = NULL  ;
    memset( busyForward74_value, 0, 256 )  ;
    busyForward74_ptr = NULL  ;
    memset( busyForward75_value, 0, 256 )  ;
    busyForward75_ptr = NULL  ;
    memset( busyForward76_value, 0, 256 )  ;
    busyForward76_ptr = NULL  ;
    memset( busyForward77_value, 0, 256 )  ;
    busyForward77_ptr = NULL  ;
    memset( busyForward78_value, 0, 256 )  ;
    busyForward78_ptr = NULL  ;
    memset( busyForward79_value, 0, 256 )  ;
    busyForward79_ptr = NULL  ;
    memset( busyForward80_value, 0, 256 )  ;
    busyForward80_ptr = NULL  ;
    memset( busyForward81_value, 0, 256 )  ;
    busyForward81_ptr = NULL  ;
    memset( busyForward82_value, 0, 256 )  ;
    busyForward82_ptr = NULL  ;
    memset( busyForward83_value, 0, 256 )  ;
    busyForward83_ptr = NULL  ;
    memset( busyForward84_value, 0, 256 )  ;
    busyForward84_ptr = NULL  ;
    memset( busyForward85_value, 0, 256 )  ;
    busyForward85_ptr = NULL  ;
    memset( busyForward86_value, 0, 256 )  ;
    busyForward86_ptr = NULL  ;
    memset( busyForward87_value, 0, 256 )  ;
    busyForward87_ptr = NULL  ;
    memset( busyForward88_value, 0, 256 )  ;
    busyForward88_ptr = NULL  ;
    memset( busyForward89_value, 0, 256 )  ;
    busyForward89_ptr = NULL  ;
    memset( busyForward90_value, 0, 256 )  ;
    busyForward90_ptr = NULL  ;
    memset( busyForward91_value, 0, 256 )  ;
    busyForward91_ptr = NULL  ;
    memset( busyForward92_value, 0, 256 )  ;
    busyForward92_ptr = NULL  ;
    memset( busyForward93_value, 0, 256 )  ;
    busyForward93_ptr = NULL  ;
    memset( busyForward94_value, 0, 256 )  ;
    busyForward94_ptr = NULL  ;
    memset( busyForward95_value, 0, 256 )  ;
    busyForward95_ptr = NULL  ;
    memset( busyForward96_value, 0, 256 )  ;
    busyForward96_ptr = NULL  ;
    }}}}
    memset( delayedForward1_value, 0, 256 )  ;
    delayedForward1_ptr = NULL  ;
    memset( delayedForward2_value, 0, 256 )  ;
    delayedForward2_ptr = NULL  ;
    memset( delayedForward3_value, 0, 256 )  ;
    delayedForward3_ptr = NULL  ;
    memset( delayedForward4_value, 0, 256 )  ;
    delayedForward4_ptr = NULL  ;
    memset( delayedForward5_value, 0, 256 )  ;
    delayedForward5_ptr = NULL  ;
    memset( delayedForward6_value, 0, 256 )  ;
    delayedForward6_ptr = NULL  ;
    memset( delayedForward7_value, 0, 256 )  ;
    delayedForward7_ptr = NULL  ;
    memset( delayedForward8_value, 0, 256 )  ;
    delayedForward8_ptr = NULL  ;
    memset( delayedForward9_value, 0, 256 )  ;
    delayedForward9_ptr = NULL  ;
    memset( delayedForward10_value, 0, 256 )  ;
    delayedForward10_ptr = NULL  ;
    memset( delayedForward11_value, 0, 256 )  ;
    delayedForward11_ptr = NULL  ;
    memset( delayedForward12_value, 0, 256 )  ;
    delayedForward12_ptr = NULL  ;
    memset( delayedForward13_value, 0, 256 )  ;
    delayedForward13_ptr = NULL  ;
    memset( delayedForward14_value, 0, 256 )  ;
    delayedForward14_ptr = NULL  ;
    memset( delayedForward15_value, 0, 256 )  ;
    delayedForward15_ptr = NULL  ;
    memset( delayedForward16_value, 0, 256 )  ;
    delayedForward16_ptr = NULL  ;
    if( no_of_ports > 16 )
    {
    memset( delayedForward17_value, 0, 256 )  ;
    delayedForward17_ptr = NULL  ;
    memset( delayedForward18_value, 0, 256 )  ;
    delayedForward18_ptr = NULL  ;
    memset( delayedForward19_value, 0, 256 )  ;
    delayedForward19_ptr = NULL  ;
    memset( delayedForward20_value, 0, 256 )  ;
    delayedForward20_ptr = NULL  ;
    memset( delayedForward21_value, 0, 256 )  ;
    delayedForward21_ptr = NULL  ;
    memset( delayedForward22_value, 0, 256 )  ;
    delayedForward22_ptr = NULL  ;
    memset( delayedForward23_value, 0, 256 )  ;
    delayedForward23_ptr = NULL  ;
    memset( delayedForward24_value, 0, 256 )  ;
    delayedForward24_ptr = NULL  ;
    if( no_of_ports > 24 )
    {
    memset( delayedForward25_value, 0, 256 )  ;
    delayedForward25_ptr = NULL  ;
    memset( delayedForward26_value, 0, 256 )  ;
    delayedForward26_ptr = NULL  ;
    memset( delayedForward27_value, 0, 256 )  ;
    delayedForward27_ptr = NULL  ;
    memset( delayedForward28_value, 0, 256 )  ;
    delayedForward28_ptr = NULL  ;
    memset( delayedForward29_value, 0, 256 )  ;
    delayedForward29_ptr = NULL  ;
    memset( delayedForward30_value, 0, 256 )  ;
    delayedForward30_ptr = NULL  ;
    memset( delayedForward31_value, 0, 256 )  ;
    delayedForward31_ptr = NULL  ;
    memset( delayedForward32_value, 0, 256 )  ;
    delayedForward32_ptr = NULL  ;
    if( no_of_ports > 32 )
    {
    memset( delayedForward33_value, 0, 256 )  ;
    delayedForward33_ptr = NULL  ;
    memset( delayedForward34_value, 0, 256 )  ;
    delayedForward34_ptr = NULL  ;
    memset( delayedForward35_value, 0, 256 )  ;
    delayedForward35_ptr = NULL  ;
    memset( delayedForward36_value, 0, 256 )  ;
    delayedForward36_ptr = NULL  ;
    memset( delayedForward37_value, 0, 256 )  ;
    delayedForward37_ptr = NULL  ;
    memset( delayedForward38_value, 0, 256 )  ;
    delayedForward38_ptr = NULL  ;
    memset( delayedForward39_value, 0, 256 )  ;
    delayedForward39_ptr = NULL  ;
    memset( delayedForward40_value, 0, 256 )  ;
    delayedForward40_ptr = NULL  ;
    memset( delayedForward41_value, 0, 256 )  ;
    delayedForward41_ptr = NULL  ;
    memset( delayedForward42_value, 0, 256 )  ;
    delayedForward42_ptr = NULL  ;
    memset( delayedForward43_value, 0, 256 )  ;
    delayedForward43_ptr = NULL  ;
    memset( delayedForward44_value, 0, 256 )  ;
    delayedForward44_ptr = NULL  ;
    memset( delayedForward45_value, 0, 256 )  ;
    delayedForward45_ptr = NULL  ;
    memset( delayedForward46_value, 0, 256 )  ;
    delayedForward46_ptr = NULL  ;
    memset( delayedForward47_value, 0, 256 )  ;
    delayedForward47_ptr = NULL  ;
    memset( delayedForward48_value, 0, 256 )  ;
    delayedForward48_ptr = NULL  ;
    if( no_of_ports > 48 )
    {
    memset( delayedForward49_value, 0, 256 )  ;
    delayedForward49_ptr = NULL  ;
    memset( delayedForward50_value, 0, 256 )  ;
    delayedForward50_ptr = NULL  ;
    memset( delayedForward51_value, 0, 256 )  ;
    delayedForward51_ptr = NULL  ;
    memset( delayedForward52_value, 0, 256 )  ;
    delayedForward52_ptr = NULL  ;
    memset( delayedForward53_value, 0, 256 )  ;
    delayedForward53_ptr = NULL  ;
    memset( delayedForward54_value, 0, 256 )  ;
    delayedForward54_ptr = NULL  ;
    memset( delayedForward55_value, 0, 256 )  ;
    delayedForward55_ptr = NULL  ;
    memset( delayedForward56_value, 0, 256 )  ;
    delayedForward56_ptr = NULL  ;
    memset( delayedForward57_value, 0, 256 )  ;
    delayedForward57_ptr = NULL  ;
    memset( delayedForward58_value, 0, 256 )  ;
    delayedForward58_ptr = NULL  ;
    memset( delayedForward59_value, 0, 256 )  ;
    delayedForward59_ptr = NULL  ;
    memset( delayedForward60_value, 0, 256 )  ;
    delayedForward60_ptr = NULL  ;
    memset( delayedForward61_value, 0, 256 )  ;
    delayedForward61_ptr = NULL  ;
    memset( delayedForward62_value, 0, 256 )  ;
    delayedForward62_ptr = NULL  ;
    memset( delayedForward63_value, 0, 256 )  ;
    delayedForward63_ptr = NULL  ;
    memset( delayedForward64_value, 0, 256 )  ;
    delayedForward64_ptr = NULL  ;
    memset( delayedForward65_value, 0, 256 )  ;
    delayedForward65_ptr = NULL  ;
    memset( delayedForward66_value, 0, 256 )  ;
    delayedForward66_ptr = NULL  ;
    memset( delayedForward67_value, 0, 256 )  ;
    delayedForward67_ptr = NULL  ;
    memset( delayedForward68_value, 0, 256 )  ;
    delayedForward68_ptr = NULL  ;
    memset( delayedForward69_value, 0, 256 )  ;
    delayedForward69_ptr = NULL  ;
    memset( delayedForward70_value, 0, 256 )  ;
    delayedForward70_ptr = NULL  ;
    memset( delayedForward71_value, 0, 256 )  ;
    delayedForward71_ptr = NULL  ;
    memset( delayedForward72_value, 0, 256 )  ;
    delayedForward72_ptr = NULL  ;
    memset( delayedForward73_value, 0, 256 )  ;
    delayedForward73_ptr = NULL  ;
    memset( delayedForward74_value, 0, 256 )  ;
    delayedForward74_ptr = NULL  ;
    memset( delayedForward75_value, 0, 256 )  ;
    delayedForward75_ptr = NULL  ;
    memset( delayedForward76_value, 0, 256 )  ;
    delayedForward76_ptr = NULL  ;
    memset( delayedForward77_value, 0, 256 )  ;
    delayedForward77_ptr = NULL  ;
    memset( delayedForward78_value, 0, 256 )  ;
    delayedForward78_ptr = NULL  ;
    memset( delayedForward79_value, 0, 256 )  ;
    delayedForward79_ptr = NULL  ;
    memset( delayedForward80_value, 0, 256 )  ;
    delayedForward80_ptr = NULL  ;
    memset( delayedForward81_value, 0, 256 )  ;
    delayedForward81_ptr = NULL  ;
    memset( delayedForward82_value, 0, 256 )  ;
    delayedForward82_ptr = NULL  ;
    memset( delayedForward83_value, 0, 256 )  ;
    delayedForward83_ptr = NULL  ;
    memset( delayedForward84_value, 0, 256 )  ;
    delayedForward84_ptr = NULL  ;
    memset( delayedForward85_value, 0, 256 )  ;
    delayedForward85_ptr = NULL  ;
    memset( delayedForward86_value, 0, 256 )  ;
    delayedForward86_ptr = NULL  ;
    memset( delayedForward87_value, 0, 256 )  ;
    delayedForward87_ptr = NULL  ;
    memset( delayedForward88_value, 0, 256 )  ;
    delayedForward88_ptr = NULL  ;
    memset( delayedForward89_value, 0, 256 )  ;
    delayedForward89_ptr = NULL  ;
    memset( delayedForward90_value, 0, 256 )  ;
    delayedForward90_ptr = NULL  ;
    memset( delayedForward91_value, 0, 256 )  ;
    delayedForward91_ptr = NULL  ;
    memset( delayedForward92_value, 0, 256 )  ;
    delayedForward92_ptr = NULL  ;
    memset( delayedForward93_value, 0, 256 )  ;
    delayedForward93_ptr = NULL  ;
    memset( delayedForward94_value, 0, 256 )  ;
    delayedForward94_ptr = NULL  ;
    memset( delayedForward95_value, 0, 256 )  ;
    delayedForward95_ptr = NULL  ;
    memset( delayedForward96_value, 0, 256 )  ;
    delayedForward96_ptr = NULL  ;
    }}}}
    temperatureSensor1_value = 0 ;
    temperatureSensor2_value = 0 ;
    temperatureSensor3_value = 0 ;
    temperatureSensor4_value = 0 ;
    temperatureSensor5_value = 0 ;
    temperatureSensor6_value = 0 ;

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
        snmptrap_oid, snmptrap_oid_len,
        ASN_OBJECT_ID,
        TimedTrap_oid, sizeof(TimedTrap_oid)) ;

    PartNo_ptr = nvram_get_safe( "1397", PartNo_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    networkMode_value = get_nvram_long( "8", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    pppoeLink_value = get_nvram_long( "211", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    natTraversal1_value = get_nvram_long( "52", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    natTraversal2_value = get_nvram_long( "730", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    natTraversal3_value = get_nvram_long( "630", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    natTraversal4_value = get_nvram_long( "614", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    versionBoot_ptr = nvram_get_safe( "69", versionBoot_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    versionCore_ptr = nvram_get_safe( "70", versionCore_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    versionBase_ptr = nvram_get_safe( "45", versionBase_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    versionProg_ptr = nvram_get_safe( "68", versionProg_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus1_ptr = nvram_get_safe( "4901", hookStatus1_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus2_ptr = nvram_get_safe( "4902", hookStatus2_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus3_ptr = nvram_get_safe( "4903", hookStatus3_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus4_ptr = nvram_get_safe( "4904", hookStatus4_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus5_ptr = nvram_get_safe( "4905", hookStatus5_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus6_ptr = nvram_get_safe( "4906", hookStatus6_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus7_ptr = nvram_get_safe( "4907", hookStatus7_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus8_ptr = nvram_get_safe( "4908", hookStatus8_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus9_ptr = nvram_get_safe( "4909", hookStatus9_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus10_ptr = nvram_get_safe( "4910", hookStatus10_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus11_ptr = nvram_get_safe( "4911", hookStatus11_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus12_ptr = nvram_get_safe( "4912", hookStatus12_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus13_ptr = nvram_get_safe( "4913", hookStatus13_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus14_ptr = nvram_get_safe( "4914", hookStatus14_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus15_ptr = nvram_get_safe( "4915", hookStatus15_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus16_ptr = nvram_get_safe( "4916", hookStatus16_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 16 )
    {
    hookStatus17_ptr = nvram_get_safe( "4917", hookStatus17_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus18_ptr = nvram_get_safe( "4918", hookStatus18_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus19_ptr = nvram_get_safe( "4919", hookStatus19_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus20_ptr = nvram_get_safe( "4920", hookStatus20_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus21_ptr = nvram_get_safe( "4941", hookStatus21_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus22_ptr = nvram_get_safe( "4942", hookStatus22_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus23_ptr = nvram_get_safe( "4943", hookStatus23_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus24_ptr = nvram_get_safe( "4944", hookStatus24_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 24 )
    {
    hookStatus25_ptr = nvram_get_safe( "4945", hookStatus25_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus26_ptr = nvram_get_safe( "4946", hookStatus26_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus27_ptr = nvram_get_safe( "4947", hookStatus27_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus28_ptr = nvram_get_safe( "4948", hookStatus28_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus29_ptr = nvram_get_safe( "4949", hookStatus29_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus30_ptr = nvram_get_safe( "4950", hookStatus30_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus31_ptr = nvram_get_safe( "4951", hookStatus31_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus32_ptr = nvram_get_safe( "4952", hookStatus32_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 32 )
    {
    hookStatus33_ptr = nvram_get_safe( "21704", hookStatus33_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus34_ptr = nvram_get_safe( "21705", hookStatus34_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus35_ptr = nvram_get_safe( "21706", hookStatus35_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus36_ptr = nvram_get_safe( "21707", hookStatus36_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus37_ptr = nvram_get_safe( "21708", hookStatus37_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus38_ptr = nvram_get_safe( "21709", hookStatus38_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus39_ptr = nvram_get_safe( "21710", hookStatus39_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus40_ptr = nvram_get_safe( "21711", hookStatus40_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus41_ptr = nvram_get_safe( "21712", hookStatus41_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus42_ptr = nvram_get_safe( "21713", hookStatus42_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus43_ptr = nvram_get_safe( "21714", hookStatus43_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus44_ptr = nvram_get_safe( "21715", hookStatus44_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus45_ptr = nvram_get_safe( "21716", hookStatus45_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus46_ptr = nvram_get_safe( "21717", hookStatus46_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus47_ptr = nvram_get_safe( "21718", hookStatus47_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus48_ptr = nvram_get_safe( "21719", hookStatus48_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 48 )
    {
    hookStatus49_ptr = nvram_get_safe( "21720", hookStatus49_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus50_ptr = nvram_get_safe( "21721", hookStatus50_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus51_ptr = nvram_get_safe( "21722", hookStatus51_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus52_ptr = nvram_get_safe( "21723", hookStatus52_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus53_ptr = nvram_get_safe( "21724", hookStatus53_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus54_ptr = nvram_get_safe( "21725", hookStatus54_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus55_ptr = nvram_get_safe( "21726", hookStatus55_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus56_ptr = nvram_get_safe( "21727", hookStatus56_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus57_ptr = nvram_get_safe( "21728", hookStatus57_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus58_ptr = nvram_get_safe( "21729", hookStatus58_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus59_ptr = nvram_get_safe( "21730", hookStatus59_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus60_ptr = nvram_get_safe( "21731", hookStatus60_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus61_ptr = nvram_get_safe( "21732", hookStatus61_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus62_ptr = nvram_get_safe( "21733", hookStatus62_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus63_ptr = nvram_get_safe( "21734", hookStatus63_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus64_ptr = nvram_get_safe( "21735", hookStatus64_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus65_ptr = nvram_get_safe( "21736", hookStatus65_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus66_ptr = nvram_get_safe( "21737", hookStatus66_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus67_ptr = nvram_get_safe( "21738", hookStatus67_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus68_ptr = nvram_get_safe( "21739", hookStatus68_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus69_ptr = nvram_get_safe( "21740", hookStatus69_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus70_ptr = nvram_get_safe( "21741", hookStatus70_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus71_ptr = nvram_get_safe( "21742", hookStatus71_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus72_ptr = nvram_get_safe( "21743", hookStatus72_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus73_ptr = nvram_get_safe( "21744", hookStatus73_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus74_ptr = nvram_get_safe( "21745", hookStatus74_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus75_ptr = nvram_get_safe( "21746", hookStatus75_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus76_ptr = nvram_get_safe( "21747", hookStatus76_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus77_ptr = nvram_get_safe( "21748", hookStatus77_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus78_ptr = nvram_get_safe( "21749", hookStatus78_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus79_ptr = nvram_get_safe( "21750", hookStatus79_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus80_ptr = nvram_get_safe( "21751", hookStatus80_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus81_ptr = nvram_get_safe( "21752", hookStatus81_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus82_ptr = nvram_get_safe( "21753", hookStatus82_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus83_ptr = nvram_get_safe( "21754", hookStatus83_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus84_ptr = nvram_get_safe( "21755", hookStatus84_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus85_ptr = nvram_get_safe( "21756", hookStatus85_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus86_ptr = nvram_get_safe( "21757", hookStatus86_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus87_ptr = nvram_get_safe( "21758", hookStatus87_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus88_ptr = nvram_get_safe( "21759", hookStatus88_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus89_ptr = nvram_get_safe( "21760", hookStatus89_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus90_ptr = nvram_get_safe( "21761", hookStatus90_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus91_ptr = nvram_get_safe( "21762", hookStatus91_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus92_ptr = nvram_get_safe( "21763", hookStatus92_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus93_ptr = nvram_get_safe( "21764", hookStatus93_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus94_ptr = nvram_get_safe( "21765", hookStatus94_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus95_ptr = nvram_get_safe( "21766", hookStatus95_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    hookStatus96_ptr = nvram_get_safe( "21767", hookStatus96_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    }}}}
    regStatus1_ptr = nvram_get_safe( "4921", regStatus1_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus2_ptr = nvram_get_safe( "4922", regStatus2_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus3_ptr = nvram_get_safe( "4923", regStatus3_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus4_ptr = nvram_get_safe( "4924", regStatus4_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus5_ptr = nvram_get_safe( "4925", regStatus5_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus6_ptr = nvram_get_safe( "4926", regStatus6_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus7_ptr = nvram_get_safe( "4927", regStatus7_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus8_ptr = nvram_get_safe( "4928", regStatus8_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus9_ptr = nvram_get_safe( "4929", regStatus9_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus10_ptr = nvram_get_safe( "4930", regStatus10_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus11_ptr = nvram_get_safe( "4931", regStatus11_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus12_ptr = nvram_get_safe( "4932", regStatus12_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus13_ptr = nvram_get_safe( "4933", regStatus13_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus14_ptr = nvram_get_safe( "4934", regStatus14_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus15_ptr = nvram_get_safe( "4935", regStatus15_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus16_ptr = nvram_get_safe( "4936", regStatus16_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 16 )
    {
    regStatus17_ptr = nvram_get_safe( "4937", regStatus17_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus18_ptr = nvram_get_safe( "4938", regStatus18_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus19_ptr = nvram_get_safe( "4939", regStatus19_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus20_ptr = nvram_get_safe( "4940", regStatus20_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus21_ptr = nvram_get_safe( "4953", regStatus21_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus22_ptr = nvram_get_safe( "4954", regStatus22_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus23_ptr = nvram_get_safe( "4955", regStatus23_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus24_ptr = nvram_get_safe( "4956", regStatus24_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 24 )
    {
    regStatus25_ptr = nvram_get_safe( "4957", regStatus25_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus26_ptr = nvram_get_safe( "4958", regStatus26_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus27_ptr = nvram_get_safe( "4959", regStatus27_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus28_ptr = nvram_get_safe( "4960", regStatus28_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus29_ptr = nvram_get_safe( "4961", regStatus29_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus30_ptr = nvram_get_safe( "4962", regStatus30_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus31_ptr = nvram_get_safe( "4963", regStatus31_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus32_ptr = nvram_get_safe( "4964", regStatus32_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 32 )
    {
    regStatus33_ptr = nvram_get_safe( "21768", regStatus33_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus34_ptr = nvram_get_safe( "21769", regStatus34_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus35_ptr = nvram_get_safe( "21770", regStatus35_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus36_ptr = nvram_get_safe( "21771", regStatus36_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus37_ptr = nvram_get_safe( "21772", regStatus37_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus38_ptr = nvram_get_safe( "21773", regStatus38_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus39_ptr = nvram_get_safe( "21774", regStatus39_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus40_ptr = nvram_get_safe( "21775", regStatus40_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus41_ptr = nvram_get_safe( "21776", regStatus41_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus42_ptr = nvram_get_safe( "21777", regStatus42_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus43_ptr = nvram_get_safe( "21778", regStatus43_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus44_ptr = nvram_get_safe( "21779", regStatus44_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus45_ptr = nvram_get_safe( "21780", regStatus45_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus46_ptr = nvram_get_safe( "21781", regStatus46_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus47_ptr = nvram_get_safe( "21782", regStatus47_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus48_ptr = nvram_get_safe( "21783", regStatus48_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 48 )
    {
    regStatus49_ptr = nvram_get_safe( "21784", regStatus49_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus50_ptr = nvram_get_safe( "21785", regStatus50_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus51_ptr = nvram_get_safe( "21786", regStatus51_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus52_ptr = nvram_get_safe( "21787", regStatus52_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus53_ptr = nvram_get_safe( "21788", regStatus53_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus54_ptr = nvram_get_safe( "21789", regStatus54_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus55_ptr = nvram_get_safe( "21790", regStatus55_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus56_ptr = nvram_get_safe( "21791", regStatus56_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus57_ptr = nvram_get_safe( "21792", regStatus57_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus58_ptr = nvram_get_safe( "21793", regStatus58_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus59_ptr = nvram_get_safe( "21794", regStatus59_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus60_ptr = nvram_get_safe( "21795", regStatus60_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus61_ptr = nvram_get_safe( "21796", regStatus61_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus62_ptr = nvram_get_safe( "21797", regStatus62_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus63_ptr = nvram_get_safe( "21798", regStatus63_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus64_ptr = nvram_get_safe( "21799", regStatus64_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus65_ptr = nvram_get_safe( "21800", regStatus65_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus66_ptr = nvram_get_safe( "21801", regStatus66_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus67_ptr = nvram_get_safe( "21802", regStatus67_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus68_ptr = nvram_get_safe( "21803", regStatus68_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus69_ptr = nvram_get_safe( "21804", regStatus69_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus70_ptr = nvram_get_safe( "21805", regStatus70_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus71_ptr = nvram_get_safe( "21806", regStatus71_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus72_ptr = nvram_get_safe( "21807", regStatus72_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus73_ptr = nvram_get_safe( "21808", regStatus73_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus74_ptr = nvram_get_safe( "21809", regStatus74_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus75_ptr = nvram_get_safe( "21810", regStatus75_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus76_ptr = nvram_get_safe( "21811", regStatus76_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus77_ptr = nvram_get_safe( "21812", regStatus77_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus78_ptr = nvram_get_safe( "21813", regStatus78_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus79_ptr = nvram_get_safe( "21814", regStatus79_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus80_ptr = nvram_get_safe( "21815", regStatus80_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus81_ptr = nvram_get_safe( "21816", regStatus81_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus82_ptr = nvram_get_safe( "21817", regStatus82_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus83_ptr = nvram_get_safe( "21818", regStatus83_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus84_ptr = nvram_get_safe( "21819", regStatus84_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus85_ptr = nvram_get_safe( "21820", regStatus85_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus86_ptr = nvram_get_safe( "21821", regStatus86_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus87_ptr = nvram_get_safe( "21822", regStatus87_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus88_ptr = nvram_get_safe( "21823", regStatus88_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus89_ptr = nvram_get_safe( "21824", regStatus89_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus90_ptr = nvram_get_safe( "21825", regStatus90_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus91_ptr = nvram_get_safe( "21826", regStatus91_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus92_ptr = nvram_get_safe( "21827", regStatus92_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus93_ptr = nvram_get_safe( "21828", regStatus93_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus94_ptr = nvram_get_safe( "21829", regStatus94_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus95_ptr = nvram_get_safe( "21830", regStatus95_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    regStatus96_ptr = nvram_get_safe( "21831", regStatus96_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    }}}}
    pvalue_empty = 0 ;
    dnd1_value = get_nvram_long( "dnd_0", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd2_value = get_nvram_long( "dnd_1", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd3_value = get_nvram_long( "dnd_2", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd4_value = get_nvram_long( "dnd_3", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd5_value = get_nvram_long( "dnd_4", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd6_value = get_nvram_long( "dnd_5", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd7_value = get_nvram_long( "dnd_6", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd8_value = get_nvram_long( "dnd_7", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd9_value = get_nvram_long( "dnd_8", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd10_value = get_nvram_long( "dnd_9", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd11_value = get_nvram_long( "dnd_10", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd12_value = get_nvram_long( "dnd_11", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd13_value = get_nvram_long( "dnd_12", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd14_value = get_nvram_long( "dnd_13", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd15_value = get_nvram_long( "dnd_14", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd16_value = get_nvram_long( "dnd_15", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    if( no_of_ports > 16 )
    {
    pvalue_empty = 0 ;
    dnd17_value = get_nvram_long( "dnd_16", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd18_value = get_nvram_long( "dnd_17", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd19_value = get_nvram_long( "dnd_18", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd20_value = get_nvram_long( "dnd_19", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd21_value = get_nvram_long( "dnd_20", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd22_value = get_nvram_long( "dnd_21", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd23_value = get_nvram_long( "dnd_22", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd24_value = get_nvram_long( "dnd_23", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    if( no_of_ports > 24 )
    {
    pvalue_empty = 0 ;
    dnd25_value = get_nvram_long( "dnd_24", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd26_value = get_nvram_long( "dnd_25", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd27_value = get_nvram_long( "dnd_26", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd28_value = get_nvram_long( "dnd_27", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd29_value = get_nvram_long( "dnd_28", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd30_value = get_nvram_long( "dnd_29", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd31_value = get_nvram_long( "dnd_30", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd32_value = get_nvram_long( "dnd_31", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd33_value = get_nvram_long( "dnd_32", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    if( no_of_ports > 32 )
    {
    pvalue_empty = 0 ;
    dnd34_value = get_nvram_long( "dnd_33", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd35_value = get_nvram_long( "dnd_34", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd36_value = get_nvram_long( "dnd_35", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd37_value = get_nvram_long( "dnd_36", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd38_value = get_nvram_long( "dnd_37", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd39_value = get_nvram_long( "dnd_38", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd40_value = get_nvram_long( "dnd_39", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd41_value = get_nvram_long( "dnd_40", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd42_value = get_nvram_long( "dnd_41", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd43_value = get_nvram_long( "dnd_42", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd44_value = get_nvram_long( "dnd_43", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd45_value = get_nvram_long( "dnd_44", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd46_value = get_nvram_long( "dnd_45", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd47_value = get_nvram_long( "dnd_46", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd48_value = get_nvram_long( "dnd_47", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd49_value = get_nvram_long( "dnd_48", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    if( no_of_ports > 48 )
    {
    pvalue_empty = 0 ;
    dnd50_value = get_nvram_long( "dnd_49", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd51_value = get_nvram_long( "dnd_50", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd52_value = get_nvram_long( "dnd_51", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd53_value = get_nvram_long( "dnd_52", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd54_value = get_nvram_long( "dnd_53", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd55_value = get_nvram_long( "dnd_54", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd56_value = get_nvram_long( "dnd_55", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd57_value = get_nvram_long( "dnd_56", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd58_value = get_nvram_long( "dnd_57", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd59_value = get_nvram_long( "dnd_58", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd60_value = get_nvram_long( "dnd_59", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd61_value = get_nvram_long( "dnd_60", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd62_value = get_nvram_long( "dnd_61", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd63_value = get_nvram_long( "dnd_62", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd64_value = get_nvram_long( "dnd_63", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd65_value = get_nvram_long( "dnd_64", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd66_value = get_nvram_long( "dnd_65", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd67_value = get_nvram_long( "dnd_66", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd68_value = get_nvram_long( "dnd_67", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd69_value = get_nvram_long( "dnd_68", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd70_value = get_nvram_long( "dnd_69", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd71_value = get_nvram_long( "dnd_70", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd72_value = get_nvram_long( "dnd_71", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd73_value = get_nvram_long( "dnd_72", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd74_value = get_nvram_long( "dnd_73", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd75_value = get_nvram_long( "dnd_74", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd76_value = get_nvram_long( "dnd_75", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd77_value = get_nvram_long( "dnd_76", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd78_value = get_nvram_long( "dnd_77", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd79_value = get_nvram_long( "dnd_78", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd80_value = get_nvram_long( "dnd_79", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd81_value = get_nvram_long( "dnd_80", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd82_value = get_nvram_long( "dnd_81", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd83_value = get_nvram_long( "dnd_82", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd84_value = get_nvram_long( "dnd_83", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd85_value = get_nvram_long( "dnd_84", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd86_value = get_nvram_long( "dnd_85", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd87_value = get_nvram_long( "dnd_86", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd88_value = get_nvram_long( "dnd_87", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd89_value = get_nvram_long( "dnd_88", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd90_value = get_nvram_long( "dnd_89", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd91_value = get_nvram_long( "dnd_90", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd92_value = get_nvram_long( "dnd_91", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd93_value = get_nvram_long( "dnd_92", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd94_value = get_nvram_long( "dnd_93", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd95_value = get_nvram_long( "dnd_94", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    dnd96_value = get_nvram_long( "dnd_95", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    }}}}
    forward1_ptr = nvram_get_safe( "forward_0", forward1_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward2_ptr = nvram_get_safe( "forward_1", forward2_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward3_ptr = nvram_get_safe( "forward_2", forward3_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward4_ptr = nvram_get_safe( "forward_3", forward4_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward5_ptr = nvram_get_safe( "forward_4", forward5_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward6_ptr = nvram_get_safe( "forward_5", forward6_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward7_ptr = nvram_get_safe( "forward_6", forward7_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward8_ptr = nvram_get_safe( "forward_7", forward8_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward9_ptr = nvram_get_safe( "forward_8", forward9_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward10_ptr = nvram_get_safe( "forward_9", forward10_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward11_ptr = nvram_get_safe( "forward_10", forward11_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward12_ptr = nvram_get_safe( "forward_11", forward12_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward13_ptr = nvram_get_safe( "forward_12", forward13_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward14_ptr = nvram_get_safe( "forward_13", forward14_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward15_ptr = nvram_get_safe( "forward_14", forward15_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward16_ptr = nvram_get_safe( "forward_15", forward16_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 16 )
    {
    forward17_ptr = nvram_get_safe( "forward_16", forward17_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward18_ptr = nvram_get_safe( "forward_17", forward18_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward19_ptr = nvram_get_safe( "forward_18", forward19_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward20_ptr = nvram_get_safe( "forward_19", forward20_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward21_ptr = nvram_get_safe( "forward_20", forward21_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward22_ptr = nvram_get_safe( "forward_21", forward22_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward23_ptr = nvram_get_safe( "forward_22", forward23_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward24_ptr = nvram_get_safe( "forward_23", forward24_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 24 )
    {
    forward25_ptr = nvram_get_safe( "forward_24", forward25_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward26_ptr = nvram_get_safe( "forward_25", forward26_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward27_ptr = nvram_get_safe( "forward_26", forward27_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward28_ptr = nvram_get_safe( "forward_27", forward28_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward29_ptr = nvram_get_safe( "forward_28", forward29_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward30_ptr = nvram_get_safe( "forward_29", forward30_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward31_ptr = nvram_get_safe( "forward_30", forward31_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward32_ptr = nvram_get_safe( "forward_31", forward32_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 32 )
    {
    forward33_ptr = nvram_get_safe( "forward_32", forward33_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward34_ptr = nvram_get_safe( "forward_33", forward34_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward35_ptr = nvram_get_safe( "forward_34", forward35_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward36_ptr = nvram_get_safe( "forward_35", forward36_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward37_ptr = nvram_get_safe( "forward_36", forward37_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward38_ptr = nvram_get_safe( "forward_37", forward38_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward39_ptr = nvram_get_safe( "forward_38", forward39_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward40_ptr = nvram_get_safe( "forward_39", forward40_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward41_ptr = nvram_get_safe( "forward_40", forward41_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward42_ptr = nvram_get_safe( "forward_41", forward42_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward43_ptr = nvram_get_safe( "forward_42", forward43_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward44_ptr = nvram_get_safe( "forward_43", forward44_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward45_ptr = nvram_get_safe( "forward_44", forward45_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward46_ptr = nvram_get_safe( "forward_45", forward46_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward47_ptr = nvram_get_safe( "forward_46", forward47_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward48_ptr = nvram_get_safe( "forward_47", forward48_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 48 )
    {
    forward49_ptr = nvram_get_safe( "forward_48", forward49_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward50_ptr = nvram_get_safe( "forward_49", forward50_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward51_ptr = nvram_get_safe( "forward_50", forward51_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward52_ptr = nvram_get_safe( "forward_51", forward52_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward53_ptr = nvram_get_safe( "forward_52", forward53_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward54_ptr = nvram_get_safe( "forward_53", forward54_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward55_ptr = nvram_get_safe( "forward_54", forward55_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward56_ptr = nvram_get_safe( "forward_55", forward56_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward57_ptr = nvram_get_safe( "forward_56", forward57_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward58_ptr = nvram_get_safe( "forward_57", forward58_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward59_ptr = nvram_get_safe( "forward_58", forward59_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward60_ptr = nvram_get_safe( "forward_59", forward60_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward61_ptr = nvram_get_safe( "forward_60", forward61_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward62_ptr = nvram_get_safe( "forward_61", forward62_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward63_ptr = nvram_get_safe( "forward_62", forward63_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward64_ptr = nvram_get_safe( "forward_63", forward64_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward65_ptr = nvram_get_safe( "forward_64", forward65_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward66_ptr = nvram_get_safe( "forward_65", forward66_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward67_ptr = nvram_get_safe( "forward_66", forward67_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward68_ptr = nvram_get_safe( "forward_67", forward68_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward69_ptr = nvram_get_safe( "forward_68", forward69_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward70_ptr = nvram_get_safe( "forward_69", forward70_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward71_ptr = nvram_get_safe( "forward_70", forward71_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward72_ptr = nvram_get_safe( "forward_71", forward72_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward73_ptr = nvram_get_safe( "forward_72", forward73_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward74_ptr = nvram_get_safe( "forward_73", forward74_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward75_ptr = nvram_get_safe( "forward_74", forward75_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward76_ptr = nvram_get_safe( "forward_75", forward76_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward77_ptr = nvram_get_safe( "forward_76", forward77_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward78_ptr = nvram_get_safe( "forward_77", forward78_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward79_ptr = nvram_get_safe( "forward_78", forward79_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward80_ptr = nvram_get_safe( "forward_79", forward80_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward81_ptr = nvram_get_safe( "forward_80", forward81_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward82_ptr = nvram_get_safe( "forward_81", forward82_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward83_ptr = nvram_get_safe( "forward_82", forward83_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward84_ptr = nvram_get_safe( "forward_83", forward84_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward85_ptr = nvram_get_safe( "forward_84", forward85_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward86_ptr = nvram_get_safe( "forward_85", forward86_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward87_ptr = nvram_get_safe( "forward_86", forward87_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward88_ptr = nvram_get_safe( "forward_87", forward88_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward89_ptr = nvram_get_safe( "forward_88", forward89_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward90_ptr = nvram_get_safe( "forward_89", forward90_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward91_ptr = nvram_get_safe( "forward_90", forward91_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward92_ptr = nvram_get_safe( "forward_91", forward92_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward93_ptr = nvram_get_safe( "forward_92", forward93_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward94_ptr = nvram_get_safe( "forward_93", forward94_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward95_ptr = nvram_get_safe( "forward_94", forward95_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    forward96_ptr = nvram_get_safe( "forward_95", forward96_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    }}}}
    busyForward1_ptr = nvram_get_safe( "busyForward_0", busyForward1_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward2_ptr = nvram_get_safe( "busyForward_1", busyForward2_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward3_ptr = nvram_get_safe( "busyForward_2", busyForward3_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward4_ptr = nvram_get_safe( "busyForward_3", busyForward4_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward5_ptr = nvram_get_safe( "busyForward_4", busyForward5_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward6_ptr = nvram_get_safe( "busyForward_5", busyForward6_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward7_ptr = nvram_get_safe( "busyForward_6", busyForward7_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward8_ptr = nvram_get_safe( "busyForward_7", busyForward8_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward9_ptr = nvram_get_safe( "busyForward_8", busyForward9_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward10_ptr = nvram_get_safe( "busyForward_9", busyForward10_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward11_ptr = nvram_get_safe( "busyForward_10", busyForward11_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward12_ptr = nvram_get_safe( "busyForward_11", busyForward12_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward13_ptr = nvram_get_safe( "busyForward_12", busyForward13_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward14_ptr = nvram_get_safe( "busyForward_13", busyForward14_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward15_ptr = nvram_get_safe( "busyForward_14", busyForward15_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward16_ptr = nvram_get_safe( "busyForward_15", busyForward16_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 16 )
    {
    busyForward17_ptr = nvram_get_safe( "busyForward_16", busyForward17_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward18_ptr = nvram_get_safe( "busyForward_17", busyForward18_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward19_ptr = nvram_get_safe( "busyForward_18", busyForward19_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward20_ptr = nvram_get_safe( "busyForward_19", busyForward20_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward21_ptr = nvram_get_safe( "busyForward_20", busyForward21_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward22_ptr = nvram_get_safe( "busyForward_21", busyForward22_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward23_ptr = nvram_get_safe( "busyForward_22", busyForward23_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward24_ptr = nvram_get_safe( "busyForward_23", busyForward24_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 24 )
    {
    busyForward25_ptr = nvram_get_safe( "busyForward_24", busyForward25_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward26_ptr = nvram_get_safe( "busyForward_25", busyForward26_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward27_ptr = nvram_get_safe( "busyForward_26", busyForward27_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward28_ptr = nvram_get_safe( "busyForward_27", busyForward28_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward29_ptr = nvram_get_safe( "busyForward_28", busyForward29_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward30_ptr = nvram_get_safe( "busyForward_29", busyForward30_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward31_ptr = nvram_get_safe( "busyForward_30", busyForward31_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward32_ptr = nvram_get_safe( "busyForward_31", busyForward32_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 32 )
    {
    busyForward33_ptr = nvram_get_safe( "busyForward_32", busyForward33_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward34_ptr = nvram_get_safe( "busyForward_33", busyForward34_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward35_ptr = nvram_get_safe( "busyForward_34", busyForward35_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward36_ptr = nvram_get_safe( "busyForward_35", busyForward36_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward37_ptr = nvram_get_safe( "busyForward_36", busyForward37_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward38_ptr = nvram_get_safe( "busyForward_37", busyForward38_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward39_ptr = nvram_get_safe( "busyForward_38", busyForward39_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward40_ptr = nvram_get_safe( "busyForward_39", busyForward40_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward41_ptr = nvram_get_safe( "busyForward_40", busyForward41_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward42_ptr = nvram_get_safe( "busyForward_41", busyForward42_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward43_ptr = nvram_get_safe( "busyForward_42", busyForward43_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward44_ptr = nvram_get_safe( "busyForward_43", busyForward44_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward45_ptr = nvram_get_safe( "busyForward_44", busyForward45_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward46_ptr = nvram_get_safe( "busyForward_45", busyForward46_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward47_ptr = nvram_get_safe( "busyForward_46", busyForward47_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward48_ptr = nvram_get_safe( "busyForward_47", busyForward48_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 48 )
    {
    busyForward49_ptr = nvram_get_safe( "busyForward_48", busyForward49_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward50_ptr = nvram_get_safe( "busyForward_49", busyForward50_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward51_ptr = nvram_get_safe( "busyForward_50", busyForward51_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward52_ptr = nvram_get_safe( "busyForward_51", busyForward52_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward53_ptr = nvram_get_safe( "busyForward_52", busyForward53_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward54_ptr = nvram_get_safe( "busyForward_53", busyForward54_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward55_ptr = nvram_get_safe( "busyForward_54", busyForward55_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward56_ptr = nvram_get_safe( "busyForward_55", busyForward56_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward57_ptr = nvram_get_safe( "busyForward_56", busyForward57_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward58_ptr = nvram_get_safe( "busyForward_57", busyForward58_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward59_ptr = nvram_get_safe( "busyForward_58", busyForward59_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward60_ptr = nvram_get_safe( "busyForward_59", busyForward60_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward61_ptr = nvram_get_safe( "busyForward_60", busyForward61_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward62_ptr = nvram_get_safe( "busyForward_61", busyForward62_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward63_ptr = nvram_get_safe( "busyForward_62", busyForward63_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward64_ptr = nvram_get_safe( "busyForward_63", busyForward64_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward65_ptr = nvram_get_safe( "busyForward_64", busyForward65_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward66_ptr = nvram_get_safe( "busyForward_65", busyForward66_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward67_ptr = nvram_get_safe( "busyForward_66", busyForward67_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward68_ptr = nvram_get_safe( "busyForward_67", busyForward68_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward69_ptr = nvram_get_safe( "busyForward_68", busyForward69_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward70_ptr = nvram_get_safe( "busyForward_69", busyForward70_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward71_ptr = nvram_get_safe( "busyForward_70", busyForward71_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward72_ptr = nvram_get_safe( "busyForward_71", busyForward72_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward73_ptr = nvram_get_safe( "busyForward_72", busyForward73_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward74_ptr = nvram_get_safe( "busyForward_73", busyForward74_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward75_ptr = nvram_get_safe( "busyForward_74", busyForward75_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward76_ptr = nvram_get_safe( "busyForward_75", busyForward76_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward77_ptr = nvram_get_safe( "busyForward_76", busyForward77_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward78_ptr = nvram_get_safe( "busyForward_77", busyForward78_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward79_ptr = nvram_get_safe( "busyForward_78", busyForward79_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward80_ptr = nvram_get_safe( "busyForward_79", busyForward80_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward81_ptr = nvram_get_safe( "busyForward_80", busyForward81_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward82_ptr = nvram_get_safe( "busyForward_81", busyForward82_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward83_ptr = nvram_get_safe( "busyForward_82", busyForward83_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward84_ptr = nvram_get_safe( "busyForward_83", busyForward84_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward85_ptr = nvram_get_safe( "busyForward_84", busyForward85_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward86_ptr = nvram_get_safe( "busyForward_85", busyForward86_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward87_ptr = nvram_get_safe( "busyForward_86", busyForward87_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward88_ptr = nvram_get_safe( "busyForward_87", busyForward88_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward89_ptr = nvram_get_safe( "busyForward_88", busyForward89_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward90_ptr = nvram_get_safe( "busyForward_89", busyForward90_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward91_ptr = nvram_get_safe( "busyForward_90", busyForward91_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward92_ptr = nvram_get_safe( "busyForward_91", busyForward92_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward93_ptr = nvram_get_safe( "busyForward_92", busyForward93_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward94_ptr = nvram_get_safe( "busyForward_93", busyForward94_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward95_ptr = nvram_get_safe( "busyForward_94", busyForward95_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    busyForward96_ptr = nvram_get_safe( "busyForward_95", busyForward96_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    }}}}
    delayedForward1_ptr = nvram_get_safe( "delayedForward_0", delayedForward1_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward2_ptr = nvram_get_safe( "delayedForward_1", delayedForward2_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward3_ptr = nvram_get_safe( "delayedForward_2", delayedForward3_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward4_ptr = nvram_get_safe( "delayedForward_3", delayedForward4_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward5_ptr = nvram_get_safe( "delayedForward_4", delayedForward5_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward6_ptr = nvram_get_safe( "delayedForward_5", delayedForward6_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward7_ptr = nvram_get_safe( "delayedForward_6", delayedForward7_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward8_ptr = nvram_get_safe( "delayedForward_7", delayedForward8_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward9_ptr = nvram_get_safe( "delayedForward_8", delayedForward9_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward10_ptr = nvram_get_safe( "delayedForward_9", delayedForward10_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward11_ptr = nvram_get_safe( "delayedForward_10", delayedForward11_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward12_ptr = nvram_get_safe( "delayedForward_11", delayedForward12_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward13_ptr = nvram_get_safe( "delayedForward_12", delayedForward13_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward14_ptr = nvram_get_safe( "delayedForward_13", delayedForward14_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward15_ptr = nvram_get_safe( "delayedForward_14", delayedForward15_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward16_ptr = nvram_get_safe( "delayedForward_15", delayedForward16_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 16 )
    {
    delayedForward17_ptr = nvram_get_safe( "delayedForward_16", delayedForward17_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward18_ptr = nvram_get_safe( "delayedForward_17", delayedForward18_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward19_ptr = nvram_get_safe( "delayedForward_18", delayedForward19_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward20_ptr = nvram_get_safe( "delayedForward_19", delayedForward20_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward21_ptr = nvram_get_safe( "delayedForward_20", delayedForward21_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward22_ptr = nvram_get_safe( "delayedForward_21", delayedForward22_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward23_ptr = nvram_get_safe( "delayedForward_22", delayedForward23_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward24_ptr = nvram_get_safe( "delayedForward_23", delayedForward24_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 24 )
    {
    delayedForward25_ptr = nvram_get_safe( "delayedForward_24", delayedForward25_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward26_ptr = nvram_get_safe( "delayedForward_25", delayedForward26_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward27_ptr = nvram_get_safe( "delayedForward_26", delayedForward27_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward28_ptr = nvram_get_safe( "delayedForward_27", delayedForward28_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward29_ptr = nvram_get_safe( "delayedForward_28", delayedForward29_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward30_ptr = nvram_get_safe( "delayedForward_29", delayedForward30_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward31_ptr = nvram_get_safe( "delayedForward_30", delayedForward31_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward32_ptr = nvram_get_safe( "delayedForward_31", delayedForward32_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 32 )
    {
    delayedForward33_ptr = nvram_get_safe( "delayedForward_32", delayedForward33_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward34_ptr = nvram_get_safe( "delayedForward_33", delayedForward34_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward35_ptr = nvram_get_safe( "delayedForward_34", delayedForward35_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward36_ptr = nvram_get_safe( "delayedForward_35", delayedForward36_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward37_ptr = nvram_get_safe( "delayedForward_36", delayedForward37_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward38_ptr = nvram_get_safe( "delayedForward_37", delayedForward38_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward39_ptr = nvram_get_safe( "delayedForward_38", delayedForward39_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward40_ptr = nvram_get_safe( "delayedForward_39", delayedForward40_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward41_ptr = nvram_get_safe( "delayedForward_40", delayedForward41_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward42_ptr = nvram_get_safe( "delayedForward_41", delayedForward42_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward43_ptr = nvram_get_safe( "delayedForward_42", delayedForward43_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward44_ptr = nvram_get_safe( "delayedForward_43", delayedForward44_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward45_ptr = nvram_get_safe( "delayedForward_44", delayedForward45_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward46_ptr = nvram_get_safe( "delayedForward_45", delayedForward46_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward47_ptr = nvram_get_safe( "delayedForward_46", delayedForward47_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward48_ptr = nvram_get_safe( "delayedForward_47", delayedForward48_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    if( no_of_ports > 48 )
    {
    delayedForward49_ptr = nvram_get_safe( "delayedForward_48", delayedForward49_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward50_ptr = nvram_get_safe( "delayedForward_49", delayedForward50_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward51_ptr = nvram_get_safe( "delayedForward_50", delayedForward51_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward52_ptr = nvram_get_safe( "delayedForward_51", delayedForward52_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward53_ptr = nvram_get_safe( "delayedForward_52", delayedForward53_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward54_ptr = nvram_get_safe( "delayedForward_53", delayedForward54_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward55_ptr = nvram_get_safe( "delayedForward_54", delayedForward55_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward56_ptr = nvram_get_safe( "delayedForward_55", delayedForward56_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward57_ptr = nvram_get_safe( "delayedForward_56", delayedForward57_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward58_ptr = nvram_get_safe( "delayedForward_57", delayedForward58_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward59_ptr = nvram_get_safe( "delayedForward_58", delayedForward59_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward60_ptr = nvram_get_safe( "delayedForward_59", delayedForward60_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward61_ptr = nvram_get_safe( "delayedForward_60", delayedForward61_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward62_ptr = nvram_get_safe( "delayedForward_61", delayedForward62_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward63_ptr = nvram_get_safe( "delayedForward_62", delayedForward63_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward64_ptr = nvram_get_safe( "delayedForward_63", delayedForward64_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward65_ptr = nvram_get_safe( "delayedForward_64", delayedForward65_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward66_ptr = nvram_get_safe( "delayedForward_65", delayedForward66_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward67_ptr = nvram_get_safe( "delayedForward_66", delayedForward67_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward68_ptr = nvram_get_safe( "delayedForward_67", delayedForward68_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward69_ptr = nvram_get_safe( "delayedForward_68", delayedForward69_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward70_ptr = nvram_get_safe( "delayedForward_69", delayedForward70_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward71_ptr = nvram_get_safe( "delayedForward_70", delayedForward71_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward72_ptr = nvram_get_safe( "delayedForward_71", delayedForward72_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward73_ptr = nvram_get_safe( "delayedForward_72", delayedForward73_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward74_ptr = nvram_get_safe( "delayedForward_73", delayedForward74_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward75_ptr = nvram_get_safe( "delayedForward_74", delayedForward75_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward76_ptr = nvram_get_safe( "delayedForward_75", delayedForward76_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward77_ptr = nvram_get_safe( "delayedForward_76", delayedForward77_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward78_ptr = nvram_get_safe( "delayedForward_77", delayedForward78_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward79_ptr = nvram_get_safe( "delayedForward_78", delayedForward79_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward80_ptr = nvram_get_safe( "delayedForward_79", delayedForward80_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward81_ptr = nvram_get_safe( "delayedForward_80", delayedForward81_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward82_ptr = nvram_get_safe( "delayedForward_81", delayedForward82_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward83_ptr = nvram_get_safe( "delayedForward_82", delayedForward83_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward84_ptr = nvram_get_safe( "delayedForward_83", delayedForward84_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward85_ptr = nvram_get_safe( "delayedForward_84", delayedForward85_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward86_ptr = nvram_get_safe( "delayedForward_85", delayedForward86_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward87_ptr = nvram_get_safe( "delayedForward_86", delayedForward87_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward88_ptr = nvram_get_safe( "delayedForward_87", delayedForward88_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward89_ptr = nvram_get_safe( "delayedForward_88", delayedForward89_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward90_ptr = nvram_get_safe( "delayedForward_89", delayedForward90_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward91_ptr = nvram_get_safe( "delayedForward_90", delayedForward91_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward92_ptr = nvram_get_safe( "delayedForward_91", delayedForward92_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward93_ptr = nvram_get_safe( "delayedForward_92", delayedForward93_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward94_ptr = nvram_get_safe( "delayedForward_93", delayedForward94_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward95_ptr = nvram_get_safe( "delayedForward_94", delayedForward95_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    delayedForward96_ptr = nvram_get_safe( "delayedForward_95", delayedForward96_value, 256 ) ; /* CHECK pvalue or FILL in */ 
    }}}}
    pvalue_empty = 0 ;
    temperatureSensor1_value = get_nvram_long( "temperatureSensor_0", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    if( no_of_ports > 16 )
    {
    pvalue_empty = 0 ;
    temperatureSensor2_value = get_nvram_long( "temperatureSensor_1", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    if( no_of_ports > 32 )
    {
    pvalue_empty = 0 ;
    temperatureSensor3_value = get_nvram_long( "temperatureSensor_2", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    if( no_of_ports > 48 )
    {
    pvalue_empty = 0 ;
    temperatureSensor4_value = get_nvram_long( "temperatureSensor_3", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    temperatureSensor5_value = get_nvram_long( "temperatureSensor_4", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    pvalue_empty = 0 ;
    temperatureSensor6_value = get_nvram_long( "temperatureSensor_5", &pvalue_empty ) ;/* CHECK pvalue or FILL in */ 
    }}}
    
    /*
     * Add any objects from the trap definition
     */
    if ( PartNo_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            PartNo_oid, OID_LENGTH(PartNo_oid),
            ASN_OCTET_STR,
            (u_char *)PartNo_ptr, strlen(PartNo_ptr) ) ;         
    }
    snmp_varlist_add_variable(&var_list,
        networkMode_oid, OID_LENGTH(networkMode_oid),
        ASN_INTEGER,
        (u_char *)&networkMode_value, sizeof(networkMode_value) ) ;
    snmp_varlist_add_variable(&var_list,
        pppoeLink_oid, OID_LENGTH(pppoeLink_oid),
        ASN_INTEGER,
        (u_char *)&pppoeLink_value, sizeof(pppoeLink_value) ) ;
    snmp_varlist_add_variable(&var_list,
        natTraversal1_oid, OID_LENGTH(natTraversal1_oid),
        ASN_INTEGER,
        (u_char *)&natTraversal1_value, sizeof(natTraversal1_value) ) ;
    snmp_varlist_add_variable(&var_list,
        natTraversal2_oid, OID_LENGTH(natTraversal2_oid),
        ASN_INTEGER,
        (u_char *)&natTraversal2_value, sizeof(natTraversal2_value) ) ;
    snmp_varlist_add_variable(&var_list,
        natTraversal3_oid, OID_LENGTH(natTraversal3_oid),
        ASN_INTEGER,
        (u_char *)&natTraversal3_value, sizeof(natTraversal3_value) ) ;
    snmp_varlist_add_variable(&var_list,
        natTraversal4_oid, OID_LENGTH(natTraversal4_oid),
        ASN_INTEGER,
        (u_char *)&natTraversal4_value, sizeof(natTraversal4_value) ) ;
    if ( versionBoot_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            versionBoot_oid, OID_LENGTH(versionBoot_oid),
            ASN_OCTET_STR,
            (u_char *)versionBoot_ptr, strlen(versionBoot_ptr) ) ;         
    }
    if ( versionCore_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            versionCore_oid, OID_LENGTH(versionCore_oid),
            ASN_OCTET_STR,
            (u_char *)versionCore_ptr, strlen(versionCore_ptr) ) ;         
    }
    if ( versionBase_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            versionBase_oid, OID_LENGTH(versionBase_oid),
            ASN_OCTET_STR,
            (u_char *)versionBase_ptr, strlen(versionBase_ptr) ) ;         
    }
    if ( versionProg_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            versionProg_oid, OID_LENGTH(versionProg_oid),
            ASN_OCTET_STR,
            (u_char *)versionProg_ptr, strlen(versionProg_ptr) ) ;         
    }
    if ( hookStatus1_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus1_oid, OID_LENGTH(hookStatus1_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus1_ptr, strlen(hookStatus1_ptr) ) ;         
    }
    if ( hookStatus2_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus2_oid, OID_LENGTH(hookStatus2_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus2_ptr, strlen(hookStatus2_ptr) ) ;         
    }
    if ( hookStatus3_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus3_oid, OID_LENGTH(hookStatus3_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus3_ptr, strlen(hookStatus3_ptr) ) ;         
    }
    if ( hookStatus4_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus4_oid, OID_LENGTH(hookStatus4_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus4_ptr, strlen(hookStatus4_ptr) ) ;         
    }
    if ( hookStatus5_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus5_oid, OID_LENGTH(hookStatus5_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus5_ptr, strlen(hookStatus5_ptr) ) ;         
    }
    if ( hookStatus6_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus6_oid, OID_LENGTH(hookStatus6_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus6_ptr, strlen(hookStatus6_ptr) ) ;         
    }
    if ( hookStatus7_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus7_oid, OID_LENGTH(hookStatus7_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus7_ptr, strlen(hookStatus7_ptr) ) ;         
    }
    if ( hookStatus8_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus8_oid, OID_LENGTH(hookStatus8_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus8_ptr, strlen(hookStatus8_ptr) ) ;         
    }
    if ( hookStatus9_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus9_oid, OID_LENGTH(hookStatus9_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus9_ptr, strlen(hookStatus9_ptr) ) ;         
    }
    if ( hookStatus10_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus10_oid, OID_LENGTH(hookStatus10_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus10_ptr, strlen(hookStatus10_ptr) ) ;         
    }
    if ( hookStatus11_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus11_oid, OID_LENGTH(hookStatus11_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus11_ptr, strlen(hookStatus11_ptr) ) ;         
    }
    if ( hookStatus12_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus12_oid, OID_LENGTH(hookStatus12_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus12_ptr, strlen(hookStatus12_ptr) ) ;         
    }
    if ( hookStatus13_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus13_oid, OID_LENGTH(hookStatus13_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus13_ptr, strlen(hookStatus13_ptr) ) ;         
    }
    if ( hookStatus14_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus14_oid, OID_LENGTH(hookStatus14_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus14_ptr, strlen(hookStatus14_ptr) ) ;         
    }
    if ( hookStatus15_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus15_oid, OID_LENGTH(hookStatus15_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus15_ptr, strlen(hookStatus15_ptr) ) ;         
    }
    if ( hookStatus16_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus16_oid, OID_LENGTH(hookStatus16_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus16_ptr, strlen(hookStatus16_ptr) ) ;         
    }
    if( no_of_ports > 16 )
    {
    if ( hookStatus17_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus17_oid, OID_LENGTH(hookStatus17_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus17_ptr, strlen(hookStatus17_ptr) ) ;         
    }
    if ( hookStatus18_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus18_oid, OID_LENGTH(hookStatus18_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus18_ptr, strlen(hookStatus18_ptr) ) ;         
    }
    if ( hookStatus19_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus19_oid, OID_LENGTH(hookStatus19_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus19_ptr, strlen(hookStatus19_ptr) ) ;         
    }
    if ( hookStatus20_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus20_oid, OID_LENGTH(hookStatus20_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus20_ptr, strlen(hookStatus20_ptr) ) ;         
    }
    if ( hookStatus21_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus21_oid, OID_LENGTH(hookStatus21_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus21_ptr, strlen(hookStatus21_ptr) ) ;         
    }
    if ( hookStatus22_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus22_oid, OID_LENGTH(hookStatus22_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus22_ptr, strlen(hookStatus22_ptr) ) ;         
    }
    if ( hookStatus23_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus23_oid, OID_LENGTH(hookStatus23_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus23_ptr, strlen(hookStatus23_ptr) ) ;         
    }
    if ( hookStatus24_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus24_oid, OID_LENGTH(hookStatus24_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus24_ptr, strlen(hookStatus24_ptr) ) ;         
    }
    if( no_of_ports > 24 )
    {
    if ( hookStatus25_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus25_oid, OID_LENGTH(hookStatus25_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus25_ptr, strlen(hookStatus25_ptr) ) ;         
    }
    if ( hookStatus26_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus26_oid, OID_LENGTH(hookStatus26_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus26_ptr, strlen(hookStatus26_ptr) ) ;         
    }
    if ( hookStatus27_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus27_oid, OID_LENGTH(hookStatus27_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus27_ptr, strlen(hookStatus27_ptr) ) ;         
    }
    if ( hookStatus28_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus28_oid, OID_LENGTH(hookStatus28_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus28_ptr, strlen(hookStatus28_ptr) ) ;         
    }
    if ( hookStatus29_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus29_oid, OID_LENGTH(hookStatus29_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus29_ptr, strlen(hookStatus29_ptr) ) ;         
    }
    if ( hookStatus30_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus30_oid, OID_LENGTH(hookStatus30_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus30_ptr, strlen(hookStatus30_ptr) ) ;         
    }
    if ( hookStatus31_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus31_oid, OID_LENGTH(hookStatus31_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus31_ptr, strlen(hookStatus31_ptr) ) ;         
    }
    if ( hookStatus32_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus32_oid, OID_LENGTH(hookStatus32_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus32_ptr, strlen(hookStatus32_ptr) ) ;         
    }
    if( no_of_ports > 32 )
    {
    if ( hookStatus33_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus33_oid, OID_LENGTH(hookStatus33_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus33_ptr, strlen(hookStatus33_ptr) ) ;         
    }
    if ( hookStatus34_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus34_oid, OID_LENGTH(hookStatus34_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus34_ptr, strlen(hookStatus34_ptr) ) ;         
    }
    if ( hookStatus35_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus35_oid, OID_LENGTH(hookStatus35_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus35_ptr, strlen(hookStatus35_ptr) ) ;         
    }
    if ( hookStatus36_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus36_oid, OID_LENGTH(hookStatus36_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus36_ptr, strlen(hookStatus36_ptr) ) ;         
    }
    if ( hookStatus37_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus37_oid, OID_LENGTH(hookStatus37_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus37_ptr, strlen(hookStatus37_ptr) ) ;         
    }
    if ( hookStatus38_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus38_oid, OID_LENGTH(hookStatus38_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus38_ptr, strlen(hookStatus38_ptr) ) ;         
    }
    if ( hookStatus39_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus39_oid, OID_LENGTH(hookStatus39_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus39_ptr, strlen(hookStatus39_ptr) ) ;         
    }
    if ( hookStatus40_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus40_oid, OID_LENGTH(hookStatus40_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus40_ptr, strlen(hookStatus40_ptr) ) ;         
    }
    if ( hookStatus41_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus41_oid, OID_LENGTH(hookStatus41_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus41_ptr, strlen(hookStatus41_ptr) ) ;         
    }
    if ( hookStatus42_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus42_oid, OID_LENGTH(hookStatus42_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus42_ptr, strlen(hookStatus42_ptr) ) ;         
    }
    if ( hookStatus43_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus43_oid, OID_LENGTH(hookStatus43_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus43_ptr, strlen(hookStatus43_ptr) ) ;         
    }
    if ( hookStatus44_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus44_oid, OID_LENGTH(hookStatus44_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus44_ptr, strlen(hookStatus44_ptr) ) ;         
    }
    if ( hookStatus45_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus45_oid, OID_LENGTH(hookStatus45_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus45_ptr, strlen(hookStatus45_ptr) ) ;         
    }
    if ( hookStatus46_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus46_oid, OID_LENGTH(hookStatus46_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus46_ptr, strlen(hookStatus46_ptr) ) ;         
    }
    if ( hookStatus47_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus47_oid, OID_LENGTH(hookStatus47_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus47_ptr, strlen(hookStatus47_ptr) ) ;         
    }
    if ( hookStatus48_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus48_oid, OID_LENGTH(hookStatus48_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus48_ptr, strlen(hookStatus48_ptr) ) ;         
    }
    if( no_of_ports > 48 )
    {
    if ( hookStatus49_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus49_oid, OID_LENGTH(hookStatus49_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus49_ptr, strlen(hookStatus49_ptr) ) ;         
    }
    if ( hookStatus50_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus50_oid, OID_LENGTH(hookStatus50_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus50_ptr, strlen(hookStatus50_ptr) ) ;         
    }
    if ( hookStatus51_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus51_oid, OID_LENGTH(hookStatus51_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus51_ptr, strlen(hookStatus51_ptr) ) ;         
    }
    if ( hookStatus52_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus52_oid, OID_LENGTH(hookStatus52_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus52_ptr, strlen(hookStatus52_ptr) ) ;         
    }
    if ( hookStatus53_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus53_oid, OID_LENGTH(hookStatus53_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus53_ptr, strlen(hookStatus53_ptr) ) ;         
    }
    if ( hookStatus54_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus54_oid, OID_LENGTH(hookStatus54_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus54_ptr, strlen(hookStatus54_ptr) ) ;         
    }
    if ( hookStatus55_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus55_oid, OID_LENGTH(hookStatus55_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus55_ptr, strlen(hookStatus55_ptr) ) ;         
    }
    if ( hookStatus56_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus56_oid, OID_LENGTH(hookStatus56_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus56_ptr, strlen(hookStatus56_ptr) ) ;         
    }
    if ( hookStatus57_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus57_oid, OID_LENGTH(hookStatus57_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus57_ptr, strlen(hookStatus57_ptr) ) ;         
    }
    if ( hookStatus58_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus58_oid, OID_LENGTH(hookStatus58_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus58_ptr, strlen(hookStatus58_ptr) ) ;         
    }
    if ( hookStatus59_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus59_oid, OID_LENGTH(hookStatus59_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus59_ptr, strlen(hookStatus59_ptr) ) ;         
    }
    if ( hookStatus60_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus60_oid, OID_LENGTH(hookStatus60_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus60_ptr, strlen(hookStatus60_ptr) ) ;         
    }
    if ( hookStatus61_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus61_oid, OID_LENGTH(hookStatus61_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus61_ptr, strlen(hookStatus61_ptr) ) ;         
    }
    if ( hookStatus62_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus62_oid, OID_LENGTH(hookStatus62_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus62_ptr, strlen(hookStatus62_ptr) ) ;         
    }
    if ( hookStatus63_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus63_oid, OID_LENGTH(hookStatus63_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus63_ptr, strlen(hookStatus63_ptr) ) ;         
    }
    if ( hookStatus64_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus64_oid, OID_LENGTH(hookStatus64_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus64_ptr, strlen(hookStatus64_ptr) ) ;         
    }
    if ( hookStatus65_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus65_oid, OID_LENGTH(hookStatus65_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus65_ptr, strlen(hookStatus65_ptr) ) ;         
    }
    if ( hookStatus66_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus66_oid, OID_LENGTH(hookStatus66_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus66_ptr, strlen(hookStatus66_ptr) ) ;         
    }
    if ( hookStatus67_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus67_oid, OID_LENGTH(hookStatus67_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus67_ptr, strlen(hookStatus67_ptr) ) ;         
    }
    if ( hookStatus68_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus68_oid, OID_LENGTH(hookStatus68_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus68_ptr, strlen(hookStatus68_ptr) ) ;         
    }
    if ( hookStatus69_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus69_oid, OID_LENGTH(hookStatus69_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus69_ptr, strlen(hookStatus69_ptr) ) ;         
    }
    if ( hookStatus70_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus70_oid, OID_LENGTH(hookStatus70_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus70_ptr, strlen(hookStatus70_ptr) ) ;         
    }
    if ( hookStatus71_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus71_oid, OID_LENGTH(hookStatus71_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus71_ptr, strlen(hookStatus71_ptr) ) ;         
    }
    if ( hookStatus72_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus72_oid, OID_LENGTH(hookStatus72_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus72_ptr, strlen(hookStatus72_ptr) ) ;         
    }
    if ( hookStatus73_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus73_oid, OID_LENGTH(hookStatus73_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus73_ptr, strlen(hookStatus73_ptr) ) ;         
    }
    if ( hookStatus74_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus74_oid, OID_LENGTH(hookStatus74_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus74_ptr, strlen(hookStatus74_ptr) ) ;         
    }
    if ( hookStatus75_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus75_oid, OID_LENGTH(hookStatus75_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus75_ptr, strlen(hookStatus75_ptr) ) ;         
    }
    if ( hookStatus76_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus76_oid, OID_LENGTH(hookStatus76_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus76_ptr, strlen(hookStatus76_ptr) ) ;         
    }
    if ( hookStatus77_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus77_oid, OID_LENGTH(hookStatus77_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus77_ptr, strlen(hookStatus77_ptr) ) ;         
    }
    if ( hookStatus78_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus78_oid, OID_LENGTH(hookStatus78_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus78_ptr, strlen(hookStatus78_ptr) ) ;         
    }
    if ( hookStatus79_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus79_oid, OID_LENGTH(hookStatus79_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus79_ptr, strlen(hookStatus79_ptr) ) ;         
    }
    if ( hookStatus80_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus80_oid, OID_LENGTH(hookStatus80_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus80_ptr, strlen(hookStatus80_ptr) ) ;         
    }
    if ( hookStatus81_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus81_oid, OID_LENGTH(hookStatus81_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus81_ptr, strlen(hookStatus81_ptr) ) ;         
    }
    if ( hookStatus82_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus82_oid, OID_LENGTH(hookStatus82_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus82_ptr, strlen(hookStatus82_ptr) ) ;         
    }
    if ( hookStatus83_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus83_oid, OID_LENGTH(hookStatus83_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus83_ptr, strlen(hookStatus83_ptr) ) ;         
    }
    if ( hookStatus84_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus84_oid, OID_LENGTH(hookStatus84_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus84_ptr, strlen(hookStatus84_ptr) ) ;         
    }
    if ( hookStatus85_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus85_oid, OID_LENGTH(hookStatus85_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus85_ptr, strlen(hookStatus85_ptr) ) ;         
    }
    if ( hookStatus86_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus86_oid, OID_LENGTH(hookStatus86_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus86_ptr, strlen(hookStatus86_ptr) ) ;         
    }
    if ( hookStatus87_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus87_oid, OID_LENGTH(hookStatus87_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus87_ptr, strlen(hookStatus87_ptr) ) ;         
    }
    if ( hookStatus88_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus88_oid, OID_LENGTH(hookStatus88_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus88_ptr, strlen(hookStatus88_ptr) ) ;         
    }
    if ( hookStatus89_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus89_oid, OID_LENGTH(hookStatus89_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus89_ptr, strlen(hookStatus89_ptr) ) ;         
    }
    if ( hookStatus90_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus90_oid, OID_LENGTH(hookStatus90_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus90_ptr, strlen(hookStatus90_ptr) ) ;         
    }
    if ( hookStatus91_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus91_oid, OID_LENGTH(hookStatus91_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus91_ptr, strlen(hookStatus91_ptr) ) ;         
    }
    if ( hookStatus92_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus92_oid, OID_LENGTH(hookStatus92_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus92_ptr, strlen(hookStatus92_ptr) ) ;         
    }
    if ( hookStatus93_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus93_oid, OID_LENGTH(hookStatus93_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus93_ptr, strlen(hookStatus93_ptr) ) ;         
    }
    if ( hookStatus94_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus94_oid, OID_LENGTH(hookStatus94_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus94_ptr, strlen(hookStatus94_ptr) ) ;         
    }
    if ( hookStatus95_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus95_oid, OID_LENGTH(hookStatus95_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus95_ptr, strlen(hookStatus95_ptr) ) ;         
    }
    if ( hookStatus96_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus96_oid, OID_LENGTH(hookStatus96_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus96_ptr, strlen(hookStatus96_ptr) ) ;         
    }
    }}}}
    if ( regStatus1_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus1_oid, OID_LENGTH(regStatus1_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus1_ptr, strlen(regStatus1_ptr) ) ;         
    }
    if ( regStatus2_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus2_oid, OID_LENGTH(regStatus2_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus2_ptr, strlen(regStatus2_ptr) ) ;         
    }
    if ( regStatus3_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus3_oid, OID_LENGTH(regStatus3_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus3_ptr, strlen(regStatus3_ptr) ) ;         
    }
    if ( regStatus4_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus4_oid, OID_LENGTH(regStatus4_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus4_ptr, strlen(regStatus4_ptr) ) ;         
    }
    if ( regStatus5_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus5_oid, OID_LENGTH(regStatus5_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus5_ptr, strlen(regStatus5_ptr) ) ;         
    }
    if ( regStatus6_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus6_oid, OID_LENGTH(regStatus6_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus6_ptr, strlen(regStatus6_ptr) ) ;         
    }
    if ( regStatus7_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus7_oid, OID_LENGTH(regStatus7_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus7_ptr, strlen(regStatus7_ptr) ) ;         
    }
    if ( regStatus8_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus8_oid, OID_LENGTH(regStatus8_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus8_ptr, strlen(regStatus8_ptr) ) ;         
    }
    if ( regStatus9_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus9_oid, OID_LENGTH(regStatus9_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus9_ptr, strlen(regStatus9_ptr) ) ;         
    }
    if ( regStatus10_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus10_oid, OID_LENGTH(regStatus10_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus10_ptr, strlen(regStatus10_ptr) ) ;         
    }
    if ( regStatus11_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus11_oid, OID_LENGTH(regStatus11_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus11_ptr, strlen(regStatus11_ptr) ) ;         
    }
    if ( regStatus12_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus12_oid, OID_LENGTH(regStatus12_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus12_ptr, strlen(regStatus12_ptr) ) ;         
    }
    if ( regStatus13_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus13_oid, OID_LENGTH(regStatus13_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus13_ptr, strlen(regStatus13_ptr) ) ;         
    }
    if ( regStatus14_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus14_oid, OID_LENGTH(regStatus14_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus14_ptr, strlen(regStatus14_ptr) ) ;         
    }
    if ( regStatus15_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus15_oid, OID_LENGTH(regStatus15_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus15_ptr, strlen(regStatus15_ptr) ) ;         
    }
    if ( regStatus16_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus16_oid, OID_LENGTH(regStatus16_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus16_ptr, strlen(regStatus16_ptr) ) ;         
    }
    if( no_of_ports > 16 )
    {
    if ( regStatus17_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus17_oid, OID_LENGTH(regStatus17_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus17_ptr, strlen(regStatus17_ptr) ) ;         
    }
    if ( regStatus18_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus18_oid, OID_LENGTH(regStatus18_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus18_ptr, strlen(regStatus18_ptr) ) ;         
    }
    if ( regStatus19_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus19_oid, OID_LENGTH(regStatus19_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus19_ptr, strlen(regStatus19_ptr) ) ;         
    }
    if ( regStatus20_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus20_oid, OID_LENGTH(regStatus20_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus20_ptr, strlen(regStatus20_ptr) ) ;         
    }
    if ( regStatus21_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus21_oid, OID_LENGTH(regStatus21_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus21_ptr, strlen(regStatus21_ptr) ) ;         
    }
    if ( regStatus22_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus22_oid, OID_LENGTH(regStatus22_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus22_ptr, strlen(regStatus22_ptr) ) ;         
    }
    if ( regStatus23_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus23_oid, OID_LENGTH(regStatus23_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus23_ptr, strlen(regStatus23_ptr) ) ;         
    }
    if ( regStatus24_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus24_oid, OID_LENGTH(regStatus24_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus24_ptr, strlen(regStatus24_ptr) ) ;         
    }
    if( no_of_ports > 24 )
    {
    if ( regStatus25_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus25_oid, OID_LENGTH(regStatus25_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus25_ptr, strlen(regStatus25_ptr) ) ;         
    }
    if ( regStatus26_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus26_oid, OID_LENGTH(regStatus26_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus26_ptr, strlen(regStatus26_ptr) ) ;         
    }
    if ( regStatus27_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus27_oid, OID_LENGTH(regStatus27_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus27_ptr, strlen(regStatus27_ptr) ) ;         
    }
    if ( regStatus28_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus28_oid, OID_LENGTH(regStatus28_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus28_ptr, strlen(regStatus28_ptr) ) ;         
    }
    if ( regStatus29_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus29_oid, OID_LENGTH(regStatus29_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus29_ptr, strlen(regStatus29_ptr) ) ;         
    }
    if ( regStatus30_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus30_oid, OID_LENGTH(regStatus30_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus30_ptr, strlen(regStatus30_ptr) ) ;         
    }
    if ( regStatus31_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus31_oid, OID_LENGTH(regStatus31_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus31_ptr, strlen(regStatus31_ptr) ) ;         
    }
    if ( regStatus32_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus32_oid, OID_LENGTH(regStatus32_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus32_ptr, strlen(regStatus32_ptr) ) ;         
    }
    if( no_of_ports > 32 )
    {
    if ( regStatus33_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus33_oid, OID_LENGTH(regStatus33_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus33_ptr, strlen(regStatus33_ptr) ) ;         
    }
    if ( regStatus34_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus34_oid, OID_LENGTH(regStatus34_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus34_ptr, strlen(regStatus34_ptr) ) ;         
    }
    if ( regStatus35_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus35_oid, OID_LENGTH(regStatus35_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus35_ptr, strlen(regStatus35_ptr) ) ;         
    }
    if ( regStatus36_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus36_oid, OID_LENGTH(regStatus36_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus36_ptr, strlen(regStatus36_ptr) ) ;         
    }
    if ( regStatus37_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus37_oid, OID_LENGTH(regStatus37_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus37_ptr, strlen(regStatus37_ptr) ) ;         
    }
    if ( regStatus38_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus38_oid, OID_LENGTH(regStatus38_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus38_ptr, strlen(regStatus38_ptr) ) ;         
    }
    if ( regStatus39_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus39_oid, OID_LENGTH(regStatus39_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus39_ptr, strlen(regStatus39_ptr) ) ;         
    }
    if ( regStatus40_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus40_oid, OID_LENGTH(regStatus40_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus40_ptr, strlen(regStatus40_ptr) ) ;         
    }
    if ( regStatus41_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus41_oid, OID_LENGTH(regStatus41_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus41_ptr, strlen(regStatus41_ptr) ) ;         
    }
    if ( regStatus42_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus42_oid, OID_LENGTH(regStatus42_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus42_ptr, strlen(regStatus42_ptr) ) ;         
    }
    if ( regStatus43_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus43_oid, OID_LENGTH(regStatus43_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus43_ptr, strlen(regStatus43_ptr) ) ;         
    }
    if ( regStatus44_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus44_oid, OID_LENGTH(regStatus44_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus44_ptr, strlen(regStatus44_ptr) ) ;         
    }
    if ( regStatus45_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus45_oid, OID_LENGTH(regStatus45_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus45_ptr, strlen(regStatus45_ptr) ) ;         
    }
    if ( regStatus46_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus46_oid, OID_LENGTH(regStatus46_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus46_ptr, strlen(regStatus46_ptr) ) ;         
    }
    if ( regStatus47_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus47_oid, OID_LENGTH(regStatus47_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus47_ptr, strlen(regStatus47_ptr) ) ;         
    }
    if ( regStatus48_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus48_oid, OID_LENGTH(regStatus48_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus48_ptr, strlen(regStatus48_ptr) ) ;         
    }
    if( no_of_ports > 48 )
    {
    if ( regStatus49_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus49_oid, OID_LENGTH(regStatus49_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus49_ptr, strlen(regStatus49_ptr) ) ;         
    }
    if ( regStatus50_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus50_oid, OID_LENGTH(regStatus50_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus50_ptr, strlen(regStatus50_ptr) ) ;         
    }
    if ( regStatus51_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus51_oid, OID_LENGTH(regStatus51_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus51_ptr, strlen(regStatus51_ptr) ) ;         
    }
    if ( regStatus52_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus52_oid, OID_LENGTH(regStatus52_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus52_ptr, strlen(regStatus52_ptr) ) ;         
    }
    if ( regStatus53_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus53_oid, OID_LENGTH(regStatus53_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus53_ptr, strlen(regStatus53_ptr) ) ;         
    }
    if ( regStatus54_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus54_oid, OID_LENGTH(regStatus54_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus54_ptr, strlen(regStatus54_ptr) ) ;         
    }
    if ( regStatus55_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus55_oid, OID_LENGTH(regStatus55_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus55_ptr, strlen(regStatus55_ptr) ) ;         
    }
    if ( regStatus56_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus56_oid, OID_LENGTH(regStatus56_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus56_ptr, strlen(regStatus56_ptr) ) ;         
    }
    if ( regStatus57_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus57_oid, OID_LENGTH(regStatus57_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus57_ptr, strlen(regStatus57_ptr) ) ;         
    }
    if ( regStatus58_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus58_oid, OID_LENGTH(regStatus58_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus58_ptr, strlen(regStatus58_ptr) ) ;         
    }
    if ( regStatus59_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus59_oid, OID_LENGTH(regStatus59_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus59_ptr, strlen(regStatus59_ptr) ) ;         
    }
    if ( regStatus60_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus60_oid, OID_LENGTH(regStatus60_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus60_ptr, strlen(regStatus60_ptr) ) ;         
    }
    if ( regStatus61_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus61_oid, OID_LENGTH(regStatus61_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus61_ptr, strlen(regStatus61_ptr) ) ;         
    }
    if ( regStatus62_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus62_oid, OID_LENGTH(regStatus62_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus62_ptr, strlen(regStatus62_ptr) ) ;         
    }
    if ( regStatus63_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus63_oid, OID_LENGTH(regStatus63_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus63_ptr, strlen(regStatus63_ptr) ) ;         
    }
    if ( regStatus64_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus64_oid, OID_LENGTH(regStatus64_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus64_ptr, strlen(regStatus64_ptr) ) ;         
    }
    if ( regStatus65_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus65_oid, OID_LENGTH(regStatus65_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus65_ptr, strlen(regStatus65_ptr) ) ;         
    }
    if ( regStatus66_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus66_oid, OID_LENGTH(regStatus66_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus66_ptr, strlen(regStatus66_ptr) ) ;         
    }
    if ( regStatus67_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus67_oid, OID_LENGTH(regStatus67_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus67_ptr, strlen(regStatus67_ptr) ) ;         
    }
    if ( regStatus68_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus68_oid, OID_LENGTH(regStatus68_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus68_ptr, strlen(regStatus68_ptr) ) ;         
    }
    if ( regStatus69_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus69_oid, OID_LENGTH(regStatus69_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus69_ptr, strlen(regStatus69_ptr) ) ;         
    }
    if ( regStatus70_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus70_oid, OID_LENGTH(regStatus70_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus70_ptr, strlen(regStatus70_ptr) ) ;         
    }
    if ( regStatus71_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus71_oid, OID_LENGTH(regStatus71_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus71_ptr, strlen(regStatus71_ptr) ) ;         
    }
    if ( regStatus72_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus72_oid, OID_LENGTH(regStatus72_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus72_ptr, strlen(regStatus72_ptr) ) ;         
    }
    if ( regStatus73_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus73_oid, OID_LENGTH(regStatus73_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus73_ptr, strlen(regStatus73_ptr) ) ;         
    }
    if ( regStatus74_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus74_oid, OID_LENGTH(regStatus74_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus74_ptr, strlen(regStatus74_ptr) ) ;         
    }
    if ( regStatus75_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus75_oid, OID_LENGTH(regStatus75_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus75_ptr, strlen(regStatus75_ptr) ) ;         
    }
    if ( regStatus76_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus76_oid, OID_LENGTH(regStatus76_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus76_ptr, strlen(regStatus76_ptr) ) ;         
    }
    if ( regStatus77_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus77_oid, OID_LENGTH(regStatus77_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus77_ptr, strlen(regStatus77_ptr) ) ;         
    }
    if ( regStatus78_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus78_oid, OID_LENGTH(regStatus78_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus78_ptr, strlen(regStatus78_ptr) ) ;         
    }
    if ( regStatus79_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus79_oid, OID_LENGTH(regStatus79_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus79_ptr, strlen(regStatus79_ptr) ) ;         
    }
    if ( regStatus80_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus80_oid, OID_LENGTH(regStatus80_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus80_ptr, strlen(regStatus80_ptr) ) ;         
    }
    if ( regStatus81_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus81_oid, OID_LENGTH(regStatus81_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus81_ptr, strlen(regStatus81_ptr) ) ;         
    }
    if ( regStatus82_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus82_oid, OID_LENGTH(regStatus82_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus82_ptr, strlen(regStatus82_ptr) ) ;         
    }
    if ( regStatus83_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus83_oid, OID_LENGTH(regStatus83_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus83_ptr, strlen(regStatus83_ptr) ) ;         
    }
    if ( regStatus84_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus84_oid, OID_LENGTH(regStatus84_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus84_ptr, strlen(regStatus84_ptr) ) ;         
    }
    if ( regStatus85_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus85_oid, OID_LENGTH(regStatus85_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus85_ptr, strlen(regStatus85_ptr) ) ;         
    }
    if ( regStatus86_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus86_oid, OID_LENGTH(regStatus86_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus86_ptr, strlen(regStatus86_ptr) ) ;         
    }
    if ( regStatus87_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus87_oid, OID_LENGTH(regStatus87_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus87_ptr, strlen(regStatus87_ptr) ) ;         
    }
    if ( regStatus88_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus88_oid, OID_LENGTH(regStatus88_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus88_ptr, strlen(regStatus88_ptr) ) ;         
    }
    if ( regStatus89_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus89_oid, OID_LENGTH(regStatus89_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus89_ptr, strlen(regStatus89_ptr) ) ;         
    }
    if ( regStatus90_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus90_oid, OID_LENGTH(regStatus90_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus90_ptr, strlen(regStatus90_ptr) ) ;         
    }
    if ( regStatus91_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus91_oid, OID_LENGTH(regStatus91_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus91_ptr, strlen(regStatus91_ptr) ) ;         
    }
    if ( regStatus92_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus92_oid, OID_LENGTH(regStatus92_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus92_ptr, strlen(regStatus92_ptr) ) ;         
    }
    if ( regStatus93_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus93_oid, OID_LENGTH(regStatus93_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus93_ptr, strlen(regStatus93_ptr) ) ;         
    }
    if ( regStatus94_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus94_oid, OID_LENGTH(regStatus94_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus94_ptr, strlen(regStatus94_ptr) ) ;         
    }
    if ( regStatus95_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus95_oid, OID_LENGTH(regStatus95_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus95_ptr, strlen(regStatus95_ptr) ) ;         
    }
    if ( regStatus96_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus96_oid, OID_LENGTH(regStatus96_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus96_ptr, strlen(regStatus96_ptr) ) ;         
    }
    }}}}
    snmp_varlist_add_variable(&var_list,
        dnd1_oid, OID_LENGTH(dnd1_oid),
        ASN_INTEGER,
        (u_char *)&dnd1_value, sizeof(dnd1_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd2_oid, OID_LENGTH(dnd2_oid),
        ASN_INTEGER,
        (u_char *)&dnd2_value, sizeof(dnd2_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd3_oid, OID_LENGTH(dnd3_oid),
        ASN_INTEGER,
        (u_char *)&dnd3_value, sizeof(dnd3_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd4_oid, OID_LENGTH(dnd4_oid),
        ASN_INTEGER,
        (u_char *)&dnd4_value, sizeof(dnd4_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd5_oid, OID_LENGTH(dnd5_oid),
        ASN_INTEGER,
        (u_char *)&dnd5_value, sizeof(dnd5_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd6_oid, OID_LENGTH(dnd6_oid),
        ASN_INTEGER,
        (u_char *)&dnd6_value, sizeof(dnd6_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd7_oid, OID_LENGTH(dnd7_oid),
        ASN_INTEGER,
        (u_char *)&dnd7_value, sizeof(dnd7_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd8_oid, OID_LENGTH(dnd8_oid),
        ASN_INTEGER,
        (u_char *)&dnd8_value, sizeof(dnd8_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd9_oid, OID_LENGTH(dnd9_oid),
        ASN_INTEGER,
        (u_char *)&dnd9_value, sizeof(dnd9_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd10_oid, OID_LENGTH(dnd10_oid),
        ASN_INTEGER,
        (u_char *)&dnd10_value, sizeof(dnd10_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd11_oid, OID_LENGTH(dnd11_oid),
        ASN_INTEGER,
        (u_char *)&dnd11_value, sizeof(dnd11_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd12_oid, OID_LENGTH(dnd12_oid),
        ASN_INTEGER,
        (u_char *)&dnd12_value, sizeof(dnd12_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd13_oid, OID_LENGTH(dnd13_oid),
        ASN_INTEGER,
        (u_char *)&dnd13_value, sizeof(dnd13_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd14_oid, OID_LENGTH(dnd14_oid),
        ASN_INTEGER,
        (u_char *)&dnd14_value, sizeof(dnd14_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd15_oid, OID_LENGTH(dnd15_oid),
        ASN_INTEGER,
        (u_char *)&dnd15_value, sizeof(dnd15_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd16_oid, OID_LENGTH(dnd16_oid),
        ASN_INTEGER,
        (u_char *)&dnd16_value, sizeof(dnd16_value) ) ;
    if( no_of_ports > 16 )
    {
    snmp_varlist_add_variable(&var_list,
        dnd17_oid, OID_LENGTH(dnd17_oid),
        ASN_INTEGER,
        (u_char *)&dnd17_value, sizeof(dnd17_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd18_oid, OID_LENGTH(dnd18_oid),
        ASN_INTEGER,
        (u_char *)&dnd18_value, sizeof(dnd18_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd19_oid, OID_LENGTH(dnd19_oid),
        ASN_INTEGER,
        (u_char *)&dnd19_value, sizeof(dnd19_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd20_oid, OID_LENGTH(dnd20_oid),
        ASN_INTEGER,
        (u_char *)&dnd20_value, sizeof(dnd20_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd21_oid, OID_LENGTH(dnd21_oid),
        ASN_INTEGER,
        (u_char *)&dnd21_value, sizeof(dnd21_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd22_oid, OID_LENGTH(dnd22_oid),
        ASN_INTEGER,
        (u_char *)&dnd22_value, sizeof(dnd22_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd23_oid, OID_LENGTH(dnd23_oid),
        ASN_INTEGER,
        (u_char *)&dnd23_value, sizeof(dnd23_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd24_oid, OID_LENGTH(dnd24_oid),
        ASN_INTEGER,
        (u_char *)&dnd24_value, sizeof(dnd24_value) ) ;
    if( no_of_ports > 24 )
    {
    snmp_varlist_add_variable(&var_list,
        dnd25_oid, OID_LENGTH(dnd25_oid),
        ASN_INTEGER,
        (u_char *)&dnd25_value, sizeof(dnd25_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd26_oid, OID_LENGTH(dnd26_oid),
        ASN_INTEGER,
        (u_char *)&dnd26_value, sizeof(dnd26_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd27_oid, OID_LENGTH(dnd27_oid),
        ASN_INTEGER,
        (u_char *)&dnd27_value, sizeof(dnd27_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd28_oid, OID_LENGTH(dnd28_oid),
        ASN_INTEGER,
        (u_char *)&dnd28_value, sizeof(dnd28_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd29_oid, OID_LENGTH(dnd29_oid),
        ASN_INTEGER,
        (u_char *)&dnd29_value, sizeof(dnd29_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd30_oid, OID_LENGTH(dnd30_oid),
        ASN_INTEGER,
        (u_char *)&dnd30_value, sizeof(dnd30_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd31_oid, OID_LENGTH(dnd31_oid),
        ASN_INTEGER,
        (u_char *)&dnd31_value, sizeof(dnd31_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd32_oid, OID_LENGTH(dnd32_oid),
        ASN_INTEGER,
        (u_char *)&dnd32_value, sizeof(dnd32_value) ) ;
    if( no_of_ports > 32 )
    {
    snmp_varlist_add_variable(&var_list,
        dnd33_oid, OID_LENGTH(dnd33_oid),
        ASN_INTEGER,
        (u_char *)&dnd33_value, sizeof(dnd33_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd34_oid, OID_LENGTH(dnd34_oid),
        ASN_INTEGER,
        (u_char *)&dnd34_value, sizeof(dnd34_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd35_oid, OID_LENGTH(dnd35_oid),
        ASN_INTEGER,
        (u_char *)&dnd35_value, sizeof(dnd35_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd36_oid, OID_LENGTH(dnd36_oid),
        ASN_INTEGER,
        (u_char *)&dnd36_value, sizeof(dnd36_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd37_oid, OID_LENGTH(dnd37_oid),
        ASN_INTEGER,
        (u_char *)&dnd37_value, sizeof(dnd37_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd38_oid, OID_LENGTH(dnd38_oid),
        ASN_INTEGER,
        (u_char *)&dnd38_value, sizeof(dnd38_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd39_oid, OID_LENGTH(dnd39_oid),
        ASN_INTEGER,
        (u_char *)&dnd39_value, sizeof(dnd39_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd40_oid, OID_LENGTH(dnd40_oid),
        ASN_INTEGER,
        (u_char *)&dnd40_value, sizeof(dnd40_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd41_oid, OID_LENGTH(dnd41_oid),
        ASN_INTEGER,
        (u_char *)&dnd41_value, sizeof(dnd41_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd42_oid, OID_LENGTH(dnd42_oid),
        ASN_INTEGER,
        (u_char *)&dnd42_value, sizeof(dnd42_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd43_oid, OID_LENGTH(dnd43_oid),
        ASN_INTEGER,
        (u_char *)&dnd43_value, sizeof(dnd43_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd44_oid, OID_LENGTH(dnd44_oid),
        ASN_INTEGER,
        (u_char *)&dnd44_value, sizeof(dnd44_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd45_oid, OID_LENGTH(dnd45_oid),
        ASN_INTEGER,
        (u_char *)&dnd45_value, sizeof(dnd45_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd46_oid, OID_LENGTH(dnd46_oid),
        ASN_INTEGER,
        (u_char *)&dnd46_value, sizeof(dnd46_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd47_oid, OID_LENGTH(dnd47_oid),
        ASN_INTEGER,
        (u_char *)&dnd47_value, sizeof(dnd47_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd48_oid, OID_LENGTH(dnd48_oid),
        ASN_INTEGER,
        (u_char *)&dnd48_value, sizeof(dnd48_value) ) ;
    if( no_of_ports > 48 )
    {
    snmp_varlist_add_variable(&var_list,
        dnd49_oid, OID_LENGTH(dnd49_oid),
        ASN_INTEGER,
        (u_char *)&dnd49_value, sizeof(dnd49_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd50_oid, OID_LENGTH(dnd50_oid),
        ASN_INTEGER,
        (u_char *)&dnd50_value, sizeof(dnd50_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd51_oid, OID_LENGTH(dnd51_oid),
        ASN_INTEGER,
        (u_char *)&dnd51_value, sizeof(dnd51_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd52_oid, OID_LENGTH(dnd52_oid),
        ASN_INTEGER,
        (u_char *)&dnd52_value, sizeof(dnd52_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd53_oid, OID_LENGTH(dnd53_oid),
        ASN_INTEGER,
        (u_char *)&dnd53_value, sizeof(dnd53_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd54_oid, OID_LENGTH(dnd54_oid),
        ASN_INTEGER,
        (u_char *)&dnd54_value, sizeof(dnd54_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd55_oid, OID_LENGTH(dnd55_oid),
        ASN_INTEGER,
        (u_char *)&dnd55_value, sizeof(dnd55_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd56_oid, OID_LENGTH(dnd56_oid),
        ASN_INTEGER,
        (u_char *)&dnd56_value, sizeof(dnd56_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd57_oid, OID_LENGTH(dnd57_oid),
        ASN_INTEGER,
        (u_char *)&dnd57_value, sizeof(dnd57_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd58_oid, OID_LENGTH(dnd58_oid),
        ASN_INTEGER,
        (u_char *)&dnd58_value, sizeof(dnd58_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd59_oid, OID_LENGTH(dnd59_oid),
        ASN_INTEGER,
        (u_char *)&dnd59_value, sizeof(dnd59_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd60_oid, OID_LENGTH(dnd60_oid),
        ASN_INTEGER,
        (u_char *)&dnd60_value, sizeof(dnd60_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd61_oid, OID_LENGTH(dnd61_oid),
        ASN_INTEGER,
        (u_char *)&dnd61_value, sizeof(dnd61_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd62_oid, OID_LENGTH(dnd62_oid),
        ASN_INTEGER,
        (u_char *)&dnd62_value, sizeof(dnd62_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd63_oid, OID_LENGTH(dnd63_oid),
        ASN_INTEGER,
        (u_char *)&dnd63_value, sizeof(dnd63_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd64_oid, OID_LENGTH(dnd64_oid),
        ASN_INTEGER,
        (u_char *)&dnd64_value, sizeof(dnd64_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd65_oid, OID_LENGTH(dnd65_oid),
        ASN_INTEGER,
        (u_char *)&dnd65_value, sizeof(dnd65_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd66_oid, OID_LENGTH(dnd66_oid),
        ASN_INTEGER,
        (u_char *)&dnd66_value, sizeof(dnd66_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd67_oid, OID_LENGTH(dnd67_oid),
        ASN_INTEGER,
        (u_char *)&dnd67_value, sizeof(dnd67_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd68_oid, OID_LENGTH(dnd68_oid),
        ASN_INTEGER,
        (u_char *)&dnd68_value, sizeof(dnd68_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd69_oid, OID_LENGTH(dnd69_oid),
        ASN_INTEGER,
        (u_char *)&dnd69_value, sizeof(dnd69_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd70_oid, OID_LENGTH(dnd70_oid),
        ASN_INTEGER,
        (u_char *)&dnd70_value, sizeof(dnd70_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd71_oid, OID_LENGTH(dnd71_oid),
        ASN_INTEGER,
        (u_char *)&dnd71_value, sizeof(dnd71_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd72_oid, OID_LENGTH(dnd72_oid),
        ASN_INTEGER,
        (u_char *)&dnd72_value, sizeof(dnd72_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd73_oid, OID_LENGTH(dnd73_oid),
        ASN_INTEGER,
        (u_char *)&dnd73_value, sizeof(dnd73_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd74_oid, OID_LENGTH(dnd74_oid),
        ASN_INTEGER,
        (u_char *)&dnd74_value, sizeof(dnd74_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd75_oid, OID_LENGTH(dnd75_oid),
        ASN_INTEGER,
        (u_char *)&dnd75_value, sizeof(dnd75_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd76_oid, OID_LENGTH(dnd76_oid),
        ASN_INTEGER,
        (u_char *)&dnd76_value, sizeof(dnd76_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd77_oid, OID_LENGTH(dnd77_oid),
        ASN_INTEGER,
        (u_char *)&dnd77_value, sizeof(dnd77_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd78_oid, OID_LENGTH(dnd78_oid),
        ASN_INTEGER,
        (u_char *)&dnd78_value, sizeof(dnd78_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd79_oid, OID_LENGTH(dnd79_oid),
        ASN_INTEGER,
        (u_char *)&dnd79_value, sizeof(dnd79_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd80_oid, OID_LENGTH(dnd80_oid),
        ASN_INTEGER,
        (u_char *)&dnd80_value, sizeof(dnd80_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd81_oid, OID_LENGTH(dnd81_oid),
        ASN_INTEGER,
        (u_char *)&dnd81_value, sizeof(dnd81_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd82_oid, OID_LENGTH(dnd82_oid),
        ASN_INTEGER,
        (u_char *)&dnd82_value, sizeof(dnd82_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd83_oid, OID_LENGTH(dnd83_oid),
        ASN_INTEGER,
        (u_char *)&dnd83_value, sizeof(dnd83_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd84_oid, OID_LENGTH(dnd84_oid),
        ASN_INTEGER,
        (u_char *)&dnd84_value, sizeof(dnd84_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd85_oid, OID_LENGTH(dnd85_oid),
        ASN_INTEGER,
        (u_char *)&dnd85_value, sizeof(dnd85_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd86_oid, OID_LENGTH(dnd86_oid),
        ASN_INTEGER,
        (u_char *)&dnd86_value, sizeof(dnd86_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd87_oid, OID_LENGTH(dnd87_oid),
        ASN_INTEGER,
        (u_char *)&dnd87_value, sizeof(dnd87_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd88_oid, OID_LENGTH(dnd88_oid),
        ASN_INTEGER,
        (u_char *)&dnd88_value, sizeof(dnd88_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd89_oid, OID_LENGTH(dnd89_oid),
        ASN_INTEGER,
        (u_char *)&dnd89_value, sizeof(dnd89_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd90_oid, OID_LENGTH(dnd90_oid),
        ASN_INTEGER,
        (u_char *)&dnd90_value, sizeof(dnd90_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd91_oid, OID_LENGTH(dnd91_oid),
        ASN_INTEGER,
        (u_char *)&dnd91_value, sizeof(dnd91_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd92_oid, OID_LENGTH(dnd92_oid),
        ASN_INTEGER,
        (u_char *)&dnd92_value, sizeof(dnd92_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd93_oid, OID_LENGTH(dnd93_oid),
        ASN_INTEGER,
        (u_char *)&dnd93_value, sizeof(dnd93_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd94_oid, OID_LENGTH(dnd94_oid),
        ASN_INTEGER,
        (u_char *)&dnd94_value, sizeof(dnd94_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd95_oid, OID_LENGTH(dnd95_oid),
        ASN_INTEGER,
        (u_char *)&dnd95_value, sizeof(dnd95_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd96_oid, OID_LENGTH(dnd96_oid),
        ASN_INTEGER,
        (u_char *)&dnd96_value, sizeof(dnd96_value) ) ;
    }}}}
    if ( forward1_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward1_oid, OID_LENGTH(forward1_oid),
            ASN_OCTET_STR,
            (u_char *)forward1_ptr, strlen(forward1_ptr) ) ;         
    }
    if ( forward2_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward2_oid, OID_LENGTH(forward2_oid),
            ASN_OCTET_STR,
            (u_char *)forward2_ptr, strlen(forward2_ptr) ) ;         
    }
    if ( forward3_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward3_oid, OID_LENGTH(forward3_oid),
            ASN_OCTET_STR,
            (u_char *)forward3_ptr, strlen(forward3_ptr) ) ;         
    }
    if ( forward4_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward4_oid, OID_LENGTH(forward4_oid),
            ASN_OCTET_STR,
            (u_char *)forward4_ptr, strlen(forward4_ptr) ) ;         
    }
    if ( forward5_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward5_oid, OID_LENGTH(forward5_oid),
            ASN_OCTET_STR,
            (u_char *)forward5_ptr, strlen(forward5_ptr) ) ;         
    }
    if ( forward6_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward6_oid, OID_LENGTH(forward6_oid),
            ASN_OCTET_STR,
            (u_char *)forward6_ptr, strlen(forward6_ptr) ) ;         
    }
    if ( forward7_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward7_oid, OID_LENGTH(forward7_oid),
            ASN_OCTET_STR,
            (u_char *)forward7_ptr, strlen(forward7_ptr) ) ;         
    }
    if ( forward8_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward8_oid, OID_LENGTH(forward8_oid),
            ASN_OCTET_STR,
            (u_char *)forward8_ptr, strlen(forward8_ptr) ) ;         
    }
    if ( forward9_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward9_oid, OID_LENGTH(forward9_oid),
            ASN_OCTET_STR,
            (u_char *)forward9_ptr, strlen(forward9_ptr) ) ;         
    }
    if ( forward10_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward10_oid, OID_LENGTH(forward10_oid),
            ASN_OCTET_STR,
            (u_char *)forward10_ptr, strlen(forward10_ptr) ) ;         
    }
    if ( forward11_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward11_oid, OID_LENGTH(forward11_oid),
            ASN_OCTET_STR,
            (u_char *)forward11_ptr, strlen(forward11_ptr) ) ;         
    }
    if ( forward12_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward12_oid, OID_LENGTH(forward12_oid),
            ASN_OCTET_STR,
            (u_char *)forward12_ptr, strlen(forward12_ptr) ) ;         
    }
    if ( forward13_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward13_oid, OID_LENGTH(forward13_oid),
            ASN_OCTET_STR,
            (u_char *)forward13_ptr, strlen(forward13_ptr) ) ;         
    }
    if ( forward14_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward14_oid, OID_LENGTH(forward14_oid),
            ASN_OCTET_STR,
            (u_char *)forward14_ptr, strlen(forward14_ptr) ) ;         
    }
    if ( forward15_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward15_oid, OID_LENGTH(forward15_oid),
            ASN_OCTET_STR,
            (u_char *)forward15_ptr, strlen(forward15_ptr) ) ;         
    }
    if ( forward16_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward16_oid, OID_LENGTH(forward16_oid),
            ASN_OCTET_STR,
            (u_char *)forward16_ptr, strlen(forward16_ptr) ) ;         
    }
    if( no_of_ports > 16 )
    {
    if ( forward17_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward17_oid, OID_LENGTH(forward17_oid),
            ASN_OCTET_STR,
            (u_char *)forward17_ptr, strlen(forward17_ptr) ) ;         
    }
    if ( forward18_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward18_oid, OID_LENGTH(forward18_oid),
            ASN_OCTET_STR,
            (u_char *)forward18_ptr, strlen(forward18_ptr) ) ;         
    }
    if ( forward19_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward19_oid, OID_LENGTH(forward19_oid),
            ASN_OCTET_STR,
            (u_char *)forward19_ptr, strlen(forward19_ptr) ) ;         
    }
    if ( forward20_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward20_oid, OID_LENGTH(forward20_oid),
            ASN_OCTET_STR,
            (u_char *)forward20_ptr, strlen(forward20_ptr) ) ;         
    }
    if ( forward21_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward21_oid, OID_LENGTH(forward21_oid),
            ASN_OCTET_STR,
            (u_char *)forward21_ptr, strlen(forward21_ptr) ) ;         
    }
    if ( forward22_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward22_oid, OID_LENGTH(forward22_oid),
            ASN_OCTET_STR,
            (u_char *)forward22_ptr, strlen(forward22_ptr) ) ;         
    }
    if ( forward23_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward23_oid, OID_LENGTH(forward23_oid),
            ASN_OCTET_STR,
            (u_char *)forward23_ptr, strlen(forward23_ptr) ) ;         
    }
    if ( forward24_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward24_oid, OID_LENGTH(forward24_oid),
            ASN_OCTET_STR,
            (u_char *)forward24_ptr, strlen(forward24_ptr) ) ;         
    }
    if( no_of_ports > 24 )
    {
    if ( forward25_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward25_oid, OID_LENGTH(forward25_oid),
            ASN_OCTET_STR,
            (u_char *)forward25_ptr, strlen(forward25_ptr) ) ;         
    }
    if ( forward26_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward26_oid, OID_LENGTH(forward26_oid),
            ASN_OCTET_STR,
            (u_char *)forward26_ptr, strlen(forward26_ptr) ) ;         
    }
    if ( forward27_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward27_oid, OID_LENGTH(forward27_oid),
            ASN_OCTET_STR,
            (u_char *)forward27_ptr, strlen(forward27_ptr) ) ;         
    }
    if ( forward28_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward28_oid, OID_LENGTH(forward28_oid),
            ASN_OCTET_STR,
            (u_char *)forward28_ptr, strlen(forward28_ptr) ) ;         
    }
    if ( forward29_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward29_oid, OID_LENGTH(forward29_oid),
            ASN_OCTET_STR,
            (u_char *)forward29_ptr, strlen(forward29_ptr) ) ;         
    }
    if ( forward30_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward30_oid, OID_LENGTH(forward30_oid),
            ASN_OCTET_STR,
            (u_char *)forward30_ptr, strlen(forward30_ptr) ) ;         
    }
    if ( forward31_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward31_oid, OID_LENGTH(forward31_oid),
            ASN_OCTET_STR,
            (u_char *)forward31_ptr, strlen(forward31_ptr) ) ;         
    }
    if ( forward32_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward32_oid, OID_LENGTH(forward32_oid),
            ASN_OCTET_STR,
            (u_char *)forward32_ptr, strlen(forward32_ptr) ) ;         
    }
    if( no_of_ports > 32 )
    {
    if ( forward33_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward33_oid, OID_LENGTH(forward33_oid),
            ASN_OCTET_STR,
            (u_char *)forward33_ptr, strlen(forward33_ptr) ) ;         
    }
    if ( forward34_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward34_oid, OID_LENGTH(forward34_oid),
            ASN_OCTET_STR,
            (u_char *)forward34_ptr, strlen(forward34_ptr) ) ;         
    }
    if ( forward35_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward35_oid, OID_LENGTH(forward35_oid),
            ASN_OCTET_STR,
            (u_char *)forward35_ptr, strlen(forward35_ptr) ) ;         
    }
    if ( forward36_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward36_oid, OID_LENGTH(forward36_oid),
            ASN_OCTET_STR,
            (u_char *)forward36_ptr, strlen(forward36_ptr) ) ;         
    }
    if ( forward37_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward37_oid, OID_LENGTH(forward37_oid),
            ASN_OCTET_STR,
            (u_char *)forward37_ptr, strlen(forward37_ptr) ) ;         
    }
    if ( forward38_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward38_oid, OID_LENGTH(forward38_oid),
            ASN_OCTET_STR,
            (u_char *)forward38_ptr, strlen(forward38_ptr) ) ;         
    }
    if ( forward39_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward39_oid, OID_LENGTH(forward39_oid),
            ASN_OCTET_STR,
            (u_char *)forward39_ptr, strlen(forward39_ptr) ) ;         
    }
    if ( forward40_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward40_oid, OID_LENGTH(forward40_oid),
            ASN_OCTET_STR,
            (u_char *)forward40_ptr, strlen(forward40_ptr) ) ;         
    }
    if ( forward41_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward41_oid, OID_LENGTH(forward41_oid),
            ASN_OCTET_STR,
            (u_char *)forward41_ptr, strlen(forward41_ptr) ) ;         
    }
    if ( forward42_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward42_oid, OID_LENGTH(forward42_oid),
            ASN_OCTET_STR,
            (u_char *)forward42_ptr, strlen(forward42_ptr) ) ;         
    }
    if ( forward43_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward43_oid, OID_LENGTH(forward43_oid),
            ASN_OCTET_STR,
            (u_char *)forward43_ptr, strlen(forward43_ptr) ) ;         
    }
    if ( forward44_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward44_oid, OID_LENGTH(forward44_oid),
            ASN_OCTET_STR,
            (u_char *)forward44_ptr, strlen(forward44_ptr) ) ;         
    }
    if ( forward45_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward45_oid, OID_LENGTH(forward45_oid),
            ASN_OCTET_STR,
            (u_char *)forward45_ptr, strlen(forward45_ptr) ) ;         
    }
    if ( forward46_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward46_oid, OID_LENGTH(forward46_oid),
            ASN_OCTET_STR,
            (u_char *)forward46_ptr, strlen(forward46_ptr) ) ;         
    }
    if ( forward47_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward47_oid, OID_LENGTH(forward47_oid),
            ASN_OCTET_STR,
            (u_char *)forward47_ptr, strlen(forward47_ptr) ) ;         
    }
    if ( forward48_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward48_oid, OID_LENGTH(forward48_oid),
            ASN_OCTET_STR,
            (u_char *)forward48_ptr, strlen(forward48_ptr) ) ;         
    }
    if( no_of_ports > 48 )
    {
    if ( forward49_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward49_oid, OID_LENGTH(forward49_oid),
            ASN_OCTET_STR,
            (u_char *)forward49_ptr, strlen(forward49_ptr) ) ;         
    }
    if ( forward50_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward50_oid, OID_LENGTH(forward50_oid),
            ASN_OCTET_STR,
            (u_char *)forward50_ptr, strlen(forward50_ptr) ) ;         
    }
    if ( forward51_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward51_oid, OID_LENGTH(forward51_oid),
            ASN_OCTET_STR,
            (u_char *)forward51_ptr, strlen(forward51_ptr) ) ;         
    }
    if ( forward52_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward52_oid, OID_LENGTH(forward52_oid),
            ASN_OCTET_STR,
            (u_char *)forward52_ptr, strlen(forward52_ptr) ) ;         
    }
    if ( forward53_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward53_oid, OID_LENGTH(forward53_oid),
            ASN_OCTET_STR,
            (u_char *)forward53_ptr, strlen(forward53_ptr) ) ;         
    }
    if ( forward54_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward54_oid, OID_LENGTH(forward54_oid),
            ASN_OCTET_STR,
            (u_char *)forward54_ptr, strlen(forward54_ptr) ) ;         
    }
    if ( forward55_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward55_oid, OID_LENGTH(forward55_oid),
            ASN_OCTET_STR,
            (u_char *)forward55_ptr, strlen(forward55_ptr) ) ;         
    }
    if ( forward56_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward56_oid, OID_LENGTH(forward56_oid),
            ASN_OCTET_STR,
            (u_char *)forward56_ptr, strlen(forward56_ptr) ) ;         
    }
    if ( forward57_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward57_oid, OID_LENGTH(forward57_oid),
            ASN_OCTET_STR,
            (u_char *)forward57_ptr, strlen(forward57_ptr) ) ;         
    }
    if ( forward58_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward58_oid, OID_LENGTH(forward58_oid),
            ASN_OCTET_STR,
            (u_char *)forward58_ptr, strlen(forward58_ptr) ) ;         
    }
    if ( forward59_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward59_oid, OID_LENGTH(forward59_oid),
            ASN_OCTET_STR,
            (u_char *)forward59_ptr, strlen(forward59_ptr) ) ;         
    }
    if ( forward60_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward60_oid, OID_LENGTH(forward60_oid),
            ASN_OCTET_STR,
            (u_char *)forward60_ptr, strlen(forward60_ptr) ) ;         
    }
    if ( forward61_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward61_oid, OID_LENGTH(forward61_oid),
            ASN_OCTET_STR,
            (u_char *)forward61_ptr, strlen(forward61_ptr) ) ;         
    }
    if ( forward62_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward62_oid, OID_LENGTH(forward62_oid),
            ASN_OCTET_STR,
            (u_char *)forward62_ptr, strlen(forward62_ptr) ) ;         
    }
    if ( forward63_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward63_oid, OID_LENGTH(forward63_oid),
            ASN_OCTET_STR,
            (u_char *)forward63_ptr, strlen(forward63_ptr) ) ;         
    }
    if ( forward64_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward64_oid, OID_LENGTH(forward64_oid),
            ASN_OCTET_STR,
            (u_char *)forward64_ptr, strlen(forward64_ptr) ) ;         
    }
    if ( forward65_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward65_oid, OID_LENGTH(forward65_oid),
            ASN_OCTET_STR,
            (u_char *)forward65_ptr, strlen(forward65_ptr) ) ;         
    }
    if ( forward66_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward66_oid, OID_LENGTH(forward66_oid),
            ASN_OCTET_STR,
            (u_char *)forward66_ptr, strlen(forward66_ptr) ) ;         
    }
    if ( forward67_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward67_oid, OID_LENGTH(forward67_oid),
            ASN_OCTET_STR,
            (u_char *)forward67_ptr, strlen(forward67_ptr) ) ;         
    }
    if ( forward68_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward68_oid, OID_LENGTH(forward68_oid),
            ASN_OCTET_STR,
            (u_char *)forward68_ptr, strlen(forward68_ptr) ) ;         
    }
    if ( forward69_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward69_oid, OID_LENGTH(forward69_oid),
            ASN_OCTET_STR,
            (u_char *)forward69_ptr, strlen(forward69_ptr) ) ;         
    }
    if ( forward70_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward70_oid, OID_LENGTH(forward70_oid),
            ASN_OCTET_STR,
            (u_char *)forward70_ptr, strlen(forward70_ptr) ) ;         
    }
    if ( forward71_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward71_oid, OID_LENGTH(forward71_oid),
            ASN_OCTET_STR,
            (u_char *)forward71_ptr, strlen(forward71_ptr) ) ;         
    }
    if ( forward72_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward72_oid, OID_LENGTH(forward72_oid),
            ASN_OCTET_STR,
            (u_char *)forward72_ptr, strlen(forward72_ptr) ) ;         
    }
    if ( forward73_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward73_oid, OID_LENGTH(forward73_oid),
            ASN_OCTET_STR,
            (u_char *)forward73_ptr, strlen(forward73_ptr) ) ;         
    }
    if ( forward74_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward74_oid, OID_LENGTH(forward74_oid),
            ASN_OCTET_STR,
            (u_char *)forward74_ptr, strlen(forward74_ptr) ) ;         
    }
    if ( forward75_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward75_oid, OID_LENGTH(forward75_oid),
            ASN_OCTET_STR,
            (u_char *)forward75_ptr, strlen(forward75_ptr) ) ;         
    }
    if ( forward76_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward76_oid, OID_LENGTH(forward76_oid),
            ASN_OCTET_STR,
            (u_char *)forward76_ptr, strlen(forward76_ptr) ) ;         
    }
    if ( forward77_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward77_oid, OID_LENGTH(forward77_oid),
            ASN_OCTET_STR,
            (u_char *)forward77_ptr, strlen(forward77_ptr) ) ;         
    }
    if ( forward78_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward78_oid, OID_LENGTH(forward78_oid),
            ASN_OCTET_STR,
            (u_char *)forward78_ptr, strlen(forward78_ptr) ) ;         
    }
    if ( forward79_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward79_oid, OID_LENGTH(forward79_oid),
            ASN_OCTET_STR,
            (u_char *)forward79_ptr, strlen(forward79_ptr) ) ;         
    }
    if ( forward80_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward80_oid, OID_LENGTH(forward80_oid),
            ASN_OCTET_STR,
            (u_char *)forward80_ptr, strlen(forward80_ptr) ) ;         
    }
    if ( forward81_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward81_oid, OID_LENGTH(forward81_oid),
            ASN_OCTET_STR,
            (u_char *)forward81_ptr, strlen(forward81_ptr) ) ;         
    }
    if ( forward82_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward82_oid, OID_LENGTH(forward82_oid),
            ASN_OCTET_STR,
            (u_char *)forward82_ptr, strlen(forward82_ptr) ) ;         
    }
    if ( forward83_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward83_oid, OID_LENGTH(forward83_oid),
            ASN_OCTET_STR,
            (u_char *)forward83_ptr, strlen(forward83_ptr) ) ;         
    }
    if ( forward84_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward84_oid, OID_LENGTH(forward84_oid),
            ASN_OCTET_STR,
            (u_char *)forward84_ptr, strlen(forward84_ptr) ) ;         
    }
    if ( forward85_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward85_oid, OID_LENGTH(forward85_oid),
            ASN_OCTET_STR,
            (u_char *)forward85_ptr, strlen(forward85_ptr) ) ;         
    }
    if ( forward86_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward86_oid, OID_LENGTH(forward86_oid),
            ASN_OCTET_STR,
            (u_char *)forward86_ptr, strlen(forward86_ptr) ) ;         
    }
    if ( forward87_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward87_oid, OID_LENGTH(forward87_oid),
            ASN_OCTET_STR,
            (u_char *)forward87_ptr, strlen(forward87_ptr) ) ;         
    }
    if ( forward88_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward88_oid, OID_LENGTH(forward88_oid),
            ASN_OCTET_STR,
            (u_char *)forward88_ptr, strlen(forward88_ptr) ) ;         
    }
    if ( forward89_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward89_oid, OID_LENGTH(forward89_oid),
            ASN_OCTET_STR,
            (u_char *)forward89_ptr, strlen(forward89_ptr) ) ;         
    }
    if ( forward90_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward90_oid, OID_LENGTH(forward90_oid),
            ASN_OCTET_STR,
            (u_char *)forward90_ptr, strlen(forward90_ptr) ) ;         
    }
    if ( forward91_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward91_oid, OID_LENGTH(forward91_oid),
            ASN_OCTET_STR,
            (u_char *)forward91_ptr, strlen(forward91_ptr) ) ;         
    }
    if ( forward92_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward92_oid, OID_LENGTH(forward92_oid),
            ASN_OCTET_STR,
            (u_char *)forward92_ptr, strlen(forward92_ptr) ) ;         
    }
    if ( forward93_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward93_oid, OID_LENGTH(forward93_oid),
            ASN_OCTET_STR,
            (u_char *)forward93_ptr, strlen(forward93_ptr) ) ;         
    }
    if ( forward94_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward94_oid, OID_LENGTH(forward94_oid),
            ASN_OCTET_STR,
            (u_char *)forward94_ptr, strlen(forward94_ptr) ) ;         
    }
    if ( forward95_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward95_oid, OID_LENGTH(forward95_oid),
            ASN_OCTET_STR,
            (u_char *)forward95_ptr, strlen(forward95_ptr) ) ;         
    }
    if ( forward96_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward96_oid, OID_LENGTH(forward96_oid),
            ASN_OCTET_STR,
            (u_char *)forward96_ptr, strlen(forward96_ptr) ) ;         
    }
    }}}}
    if ( busyForward1_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward1_oid, OID_LENGTH(busyForward1_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward1_ptr, strlen(busyForward1_ptr) ) ;         
    }
    if ( busyForward2_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward2_oid, OID_LENGTH(busyForward2_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward2_ptr, strlen(busyForward2_ptr) ) ;         
    }
    if ( busyForward3_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward3_oid, OID_LENGTH(busyForward3_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward3_ptr, strlen(busyForward3_ptr) ) ;         
    }
    if ( busyForward4_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward4_oid, OID_LENGTH(busyForward4_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward4_ptr, strlen(busyForward4_ptr) ) ;         
    }
    if ( busyForward5_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward5_oid, OID_LENGTH(busyForward5_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward5_ptr, strlen(busyForward5_ptr) ) ;         
    }
    if ( busyForward6_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward6_oid, OID_LENGTH(busyForward6_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward6_ptr, strlen(busyForward6_ptr) ) ;         
    }
    if ( busyForward7_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward7_oid, OID_LENGTH(busyForward7_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward7_ptr, strlen(busyForward7_ptr) ) ;         
    }
    if ( busyForward8_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward8_oid, OID_LENGTH(busyForward8_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward8_ptr, strlen(busyForward8_ptr) ) ;         
    }
    if ( busyForward9_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward9_oid, OID_LENGTH(busyForward9_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward9_ptr, strlen(busyForward9_ptr) ) ;         
    }
    if ( busyForward10_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward10_oid, OID_LENGTH(busyForward10_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward10_ptr, strlen(busyForward10_ptr) ) ;         
    }
    if ( busyForward11_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward11_oid, OID_LENGTH(busyForward11_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward11_ptr, strlen(busyForward11_ptr) ) ;         
    }
    if ( busyForward12_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward12_oid, OID_LENGTH(busyForward12_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward12_ptr, strlen(busyForward12_ptr) ) ;         
    }
    if ( busyForward13_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward13_oid, OID_LENGTH(busyForward13_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward13_ptr, strlen(busyForward13_ptr) ) ;         
    }
    if ( busyForward14_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward14_oid, OID_LENGTH(busyForward14_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward14_ptr, strlen(busyForward14_ptr) ) ;         
    }
    if ( busyForward15_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward15_oid, OID_LENGTH(busyForward15_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward15_ptr, strlen(busyForward15_ptr) ) ;         
    }
    if ( busyForward16_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward16_oid, OID_LENGTH(busyForward16_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward16_ptr, strlen(busyForward16_ptr) ) ;         
    }
    if( no_of_ports > 16 )
    {
    if ( busyForward17_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward17_oid, OID_LENGTH(busyForward17_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward17_ptr, strlen(busyForward17_ptr) ) ;         
    }
    if ( busyForward18_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward18_oid, OID_LENGTH(busyForward18_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward18_ptr, strlen(busyForward18_ptr) ) ;         
    }
    if ( busyForward19_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward19_oid, OID_LENGTH(busyForward19_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward19_ptr, strlen(busyForward19_ptr) ) ;         
    }
    if ( busyForward20_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward20_oid, OID_LENGTH(busyForward20_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward20_ptr, strlen(busyForward20_ptr) ) ;         
    }
    if ( busyForward21_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward21_oid, OID_LENGTH(busyForward21_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward21_ptr, strlen(busyForward21_ptr) ) ;         
    }
    if ( busyForward22_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward22_oid, OID_LENGTH(busyForward22_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward22_ptr, strlen(busyForward22_ptr) ) ;         
    }
    if ( busyForward23_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward23_oid, OID_LENGTH(busyForward23_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward23_ptr, strlen(busyForward23_ptr) ) ;         
    }
    if ( busyForward24_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward24_oid, OID_LENGTH(busyForward24_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward24_ptr, strlen(busyForward24_ptr) ) ;         
    }
    if( no_of_ports > 24 )
    {
    if ( busyForward25_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward25_oid, OID_LENGTH(busyForward25_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward25_ptr, strlen(busyForward25_ptr) ) ;         
    }
    if ( busyForward26_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward26_oid, OID_LENGTH(busyForward26_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward26_ptr, strlen(busyForward26_ptr) ) ;         
    }
    if ( busyForward27_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward27_oid, OID_LENGTH(busyForward27_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward27_ptr, strlen(busyForward27_ptr) ) ;         
    }
    if ( busyForward28_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward28_oid, OID_LENGTH(busyForward28_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward28_ptr, strlen(busyForward28_ptr) ) ;         
    }
    if ( busyForward29_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward29_oid, OID_LENGTH(busyForward29_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward29_ptr, strlen(busyForward29_ptr) ) ;         
    }
    if ( busyForward30_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward30_oid, OID_LENGTH(busyForward30_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward30_ptr, strlen(busyForward30_ptr) ) ;         
    }
    if ( busyForward31_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward31_oid, OID_LENGTH(busyForward31_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward31_ptr, strlen(busyForward31_ptr) ) ;         
    }
    if ( busyForward32_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward32_oid, OID_LENGTH(busyForward32_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward32_ptr, strlen(busyForward32_ptr) ) ;         
    }
    if( no_of_ports > 32 )
    {
    if ( busyForward33_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward33_oid, OID_LENGTH(busyForward33_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward33_ptr, strlen(busyForward33_ptr) ) ;         
    }
    if ( busyForward34_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward34_oid, OID_LENGTH(busyForward34_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward34_ptr, strlen(busyForward34_ptr) ) ;         
    }
    if ( busyForward35_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward35_oid, OID_LENGTH(busyForward35_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward35_ptr, strlen(busyForward35_ptr) ) ;         
    }
    if ( busyForward36_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward36_oid, OID_LENGTH(busyForward36_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward36_ptr, strlen(busyForward36_ptr) ) ;         
    }
    if ( busyForward37_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward37_oid, OID_LENGTH(busyForward37_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward37_ptr, strlen(busyForward37_ptr) ) ;         
    }
    if ( busyForward38_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward38_oid, OID_LENGTH(busyForward38_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward38_ptr, strlen(busyForward38_ptr) ) ;         
    }
    if ( busyForward39_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward39_oid, OID_LENGTH(busyForward39_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward39_ptr, strlen(busyForward39_ptr) ) ;         
    }
    if ( busyForward40_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward40_oid, OID_LENGTH(busyForward40_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward40_ptr, strlen(busyForward40_ptr) ) ;         
    }
    if ( busyForward41_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward41_oid, OID_LENGTH(busyForward41_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward41_ptr, strlen(busyForward41_ptr) ) ;         
    }
    if ( busyForward42_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward42_oid, OID_LENGTH(busyForward42_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward42_ptr, strlen(busyForward42_ptr) ) ;         
    }
    if ( busyForward43_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward43_oid, OID_LENGTH(busyForward43_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward43_ptr, strlen(busyForward43_ptr) ) ;         
    }
    if ( busyForward44_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward44_oid, OID_LENGTH(busyForward44_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward44_ptr, strlen(busyForward44_ptr) ) ;         
    }
    if ( busyForward45_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward45_oid, OID_LENGTH(busyForward45_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward45_ptr, strlen(busyForward45_ptr) ) ;         
    }
    if ( busyForward46_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward46_oid, OID_LENGTH(busyForward46_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward46_ptr, strlen(busyForward46_ptr) ) ;         
    }
    if ( busyForward47_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward47_oid, OID_LENGTH(busyForward47_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward47_ptr, strlen(busyForward47_ptr) ) ;         
    }
    if ( busyForward48_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward48_oid, OID_LENGTH(busyForward48_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward48_ptr, strlen(busyForward48_ptr) ) ;         
    }
    if( no_of_ports > 48 )
    {
    if ( busyForward49_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward49_oid, OID_LENGTH(busyForward49_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward49_ptr, strlen(busyForward49_ptr) ) ;         
    }
    if ( busyForward50_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward50_oid, OID_LENGTH(busyForward50_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward50_ptr, strlen(busyForward50_ptr) ) ;         
    }
    if ( busyForward51_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward51_oid, OID_LENGTH(busyForward51_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward51_ptr, strlen(busyForward51_ptr) ) ;         
    }
    if ( busyForward52_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward52_oid, OID_LENGTH(busyForward52_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward52_ptr, strlen(busyForward52_ptr) ) ;         
    }
    if ( busyForward53_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward53_oid, OID_LENGTH(busyForward53_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward53_ptr, strlen(busyForward53_ptr) ) ;         
    }
    if ( busyForward54_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward54_oid, OID_LENGTH(busyForward54_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward54_ptr, strlen(busyForward54_ptr) ) ;         
    }
    if ( busyForward55_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward55_oid, OID_LENGTH(busyForward55_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward55_ptr, strlen(busyForward55_ptr) ) ;         
    }
    if ( busyForward56_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward56_oid, OID_LENGTH(busyForward56_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward56_ptr, strlen(busyForward56_ptr) ) ;         
    }
    if ( busyForward57_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward57_oid, OID_LENGTH(busyForward57_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward57_ptr, strlen(busyForward57_ptr) ) ;         
    }
    if ( busyForward58_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward58_oid, OID_LENGTH(busyForward58_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward58_ptr, strlen(busyForward58_ptr) ) ;         
    }
    if ( busyForward59_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward59_oid, OID_LENGTH(busyForward59_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward59_ptr, strlen(busyForward59_ptr) ) ;         
    }
    if ( busyForward60_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward60_oid, OID_LENGTH(busyForward60_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward60_ptr, strlen(busyForward60_ptr) ) ;         
    }
    if ( busyForward61_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward61_oid, OID_LENGTH(busyForward61_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward61_ptr, strlen(busyForward61_ptr) ) ;         
    }
    if ( busyForward62_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward62_oid, OID_LENGTH(busyForward62_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward62_ptr, strlen(busyForward62_ptr) ) ;         
    }
    if ( busyForward63_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward63_oid, OID_LENGTH(busyForward63_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward63_ptr, strlen(busyForward63_ptr) ) ;         
    }
    if ( busyForward64_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward64_oid, OID_LENGTH(busyForward64_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward64_ptr, strlen(busyForward64_ptr) ) ;         
    }
    if ( busyForward65_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward65_oid, OID_LENGTH(busyForward65_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward65_ptr, strlen(busyForward65_ptr) ) ;         
    }
    if ( busyForward66_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward66_oid, OID_LENGTH(busyForward66_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward66_ptr, strlen(busyForward66_ptr) ) ;         
    }
    if ( busyForward67_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward67_oid, OID_LENGTH(busyForward67_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward67_ptr, strlen(busyForward67_ptr) ) ;         
    }
    if ( busyForward68_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward68_oid, OID_LENGTH(busyForward68_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward68_ptr, strlen(busyForward68_ptr) ) ;         
    }
    if ( busyForward69_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward69_oid, OID_LENGTH(busyForward69_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward69_ptr, strlen(busyForward69_ptr) ) ;         
    }
    if ( busyForward70_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward70_oid, OID_LENGTH(busyForward70_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward70_ptr, strlen(busyForward70_ptr) ) ;         
    }
    if ( busyForward71_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward71_oid, OID_LENGTH(busyForward71_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward71_ptr, strlen(busyForward71_ptr) ) ;         
    }
    if ( busyForward72_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward72_oid, OID_LENGTH(busyForward72_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward72_ptr, strlen(busyForward72_ptr) ) ;         
    }
    if ( busyForward73_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward73_oid, OID_LENGTH(busyForward73_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward73_ptr, strlen(busyForward73_ptr) ) ;         
    }
    if ( busyForward74_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward74_oid, OID_LENGTH(busyForward74_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward74_ptr, strlen(busyForward74_ptr) ) ;         
    }
    if ( busyForward75_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward75_oid, OID_LENGTH(busyForward75_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward75_ptr, strlen(busyForward75_ptr) ) ;         
    }
    if ( busyForward76_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward76_oid, OID_LENGTH(busyForward76_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward76_ptr, strlen(busyForward76_ptr) ) ;         
    }
    if ( busyForward77_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward77_oid, OID_LENGTH(busyForward77_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward77_ptr, strlen(busyForward77_ptr) ) ;         
    }
    if ( busyForward78_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward78_oid, OID_LENGTH(busyForward78_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward78_ptr, strlen(busyForward78_ptr) ) ;         
    }
    if ( busyForward79_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward79_oid, OID_LENGTH(busyForward79_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward79_ptr, strlen(busyForward79_ptr) ) ;         
    }
    if ( busyForward80_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward80_oid, OID_LENGTH(busyForward80_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward80_ptr, strlen(busyForward80_ptr) ) ;         
    }
    if ( busyForward81_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward81_oid, OID_LENGTH(busyForward81_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward81_ptr, strlen(busyForward81_ptr) ) ;         
    }
    if ( busyForward82_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward82_oid, OID_LENGTH(busyForward82_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward82_ptr, strlen(busyForward82_ptr) ) ;         
    }
    if ( busyForward83_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward83_oid, OID_LENGTH(busyForward83_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward83_ptr, strlen(busyForward83_ptr) ) ;         
    }
    if ( busyForward84_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward84_oid, OID_LENGTH(busyForward84_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward84_ptr, strlen(busyForward84_ptr) ) ;         
    }
    if ( busyForward85_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward85_oid, OID_LENGTH(busyForward85_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward85_ptr, strlen(busyForward85_ptr) ) ;         
    }
    if ( busyForward86_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward86_oid, OID_LENGTH(busyForward86_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward86_ptr, strlen(busyForward86_ptr) ) ;         
    }
    if ( busyForward87_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward87_oid, OID_LENGTH(busyForward87_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward87_ptr, strlen(busyForward87_ptr) ) ;         
    }
    if ( busyForward88_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward88_oid, OID_LENGTH(busyForward88_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward88_ptr, strlen(busyForward88_ptr) ) ;         
    }
    if ( busyForward89_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward89_oid, OID_LENGTH(busyForward89_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward89_ptr, strlen(busyForward89_ptr) ) ;         
    }
    if ( busyForward90_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward90_oid, OID_LENGTH(busyForward90_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward90_ptr, strlen(busyForward90_ptr) ) ;         
    }
    if ( busyForward91_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward91_oid, OID_LENGTH(busyForward91_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward91_ptr, strlen(busyForward91_ptr) ) ;         
    }
    if ( busyForward92_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward92_oid, OID_LENGTH(busyForward92_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward92_ptr, strlen(busyForward92_ptr) ) ;         
    }
    if ( busyForward93_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward93_oid, OID_LENGTH(busyForward93_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward93_ptr, strlen(busyForward93_ptr) ) ;         
    }
    if ( busyForward94_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward94_oid, OID_LENGTH(busyForward94_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward94_ptr, strlen(busyForward94_ptr) ) ;         
    }
    if ( busyForward95_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward95_oid, OID_LENGTH(busyForward95_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward95_ptr, strlen(busyForward95_ptr) ) ;         
    }
    if ( busyForward96_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward96_oid, OID_LENGTH(busyForward96_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward96_ptr, strlen(busyForward96_ptr) ) ;         
    }
    }}}}
    if ( delayedForward1_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward1_oid, OID_LENGTH(delayedForward1_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward1_ptr, strlen(delayedForward1_ptr) ) ;         
    }
    if ( delayedForward2_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward2_oid, OID_LENGTH(delayedForward2_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward2_ptr, strlen(delayedForward2_ptr) ) ;         
    }
    if ( delayedForward3_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward3_oid, OID_LENGTH(delayedForward3_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward3_ptr, strlen(delayedForward3_ptr) ) ;         
    }
    if ( delayedForward4_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward4_oid, OID_LENGTH(delayedForward4_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward4_ptr, strlen(delayedForward4_ptr) ) ;         
    }
    if ( delayedForward5_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward5_oid, OID_LENGTH(delayedForward5_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward5_ptr, strlen(delayedForward5_ptr) ) ;         
    }
    if ( delayedForward6_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward6_oid, OID_LENGTH(delayedForward6_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward6_ptr, strlen(delayedForward6_ptr) ) ;         
    }
    if ( delayedForward7_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward7_oid, OID_LENGTH(delayedForward7_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward7_ptr, strlen(delayedForward7_ptr) ) ;         
    }
    if ( delayedForward8_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward8_oid, OID_LENGTH(delayedForward8_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward8_ptr, strlen(delayedForward8_ptr) ) ;         
    }
    if ( delayedForward9_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward9_oid, OID_LENGTH(delayedForward9_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward9_ptr, strlen(delayedForward9_ptr) ) ;         
    }
    if ( delayedForward10_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward10_oid, OID_LENGTH(delayedForward10_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward10_ptr, strlen(delayedForward10_ptr) ) ;         
    }
    if ( delayedForward11_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward11_oid, OID_LENGTH(delayedForward11_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward11_ptr, strlen(delayedForward11_ptr) ) ;         
    }
    if ( delayedForward12_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward12_oid, OID_LENGTH(delayedForward12_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward12_ptr, strlen(delayedForward12_ptr) ) ;         
    }
    if ( delayedForward13_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward13_oid, OID_LENGTH(delayedForward13_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward13_ptr, strlen(delayedForward13_ptr) ) ;         
    }
    if ( delayedForward14_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward14_oid, OID_LENGTH(delayedForward14_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward14_ptr, strlen(delayedForward14_ptr) ) ;         
    }
    if ( delayedForward15_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward15_oid, OID_LENGTH(delayedForward15_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward15_ptr, strlen(delayedForward15_ptr) ) ;         
    }
    if ( delayedForward16_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward16_oid, OID_LENGTH(delayedForward16_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward16_ptr, strlen(delayedForward16_ptr) ) ;         
    }
    if( no_of_ports > 16 )
    {
    if ( delayedForward17_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward17_oid, OID_LENGTH(delayedForward17_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward17_ptr, strlen(delayedForward17_ptr) ) ;         
    }
    if ( delayedForward18_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward18_oid, OID_LENGTH(delayedForward18_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward18_ptr, strlen(delayedForward18_ptr) ) ;         
    }
    if ( delayedForward19_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward19_oid, OID_LENGTH(delayedForward19_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward19_ptr, strlen(delayedForward19_ptr) ) ;         
    }
    if ( delayedForward20_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward20_oid, OID_LENGTH(delayedForward20_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward20_ptr, strlen(delayedForward20_ptr) ) ;         
    }
    if ( delayedForward21_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward21_oid, OID_LENGTH(delayedForward21_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward21_ptr, strlen(delayedForward21_ptr) ) ;         
    }
    if ( delayedForward22_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward22_oid, OID_LENGTH(delayedForward22_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward22_ptr, strlen(delayedForward22_ptr) ) ;         
    }
    if ( delayedForward23_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward23_oid, OID_LENGTH(delayedForward23_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward23_ptr, strlen(delayedForward23_ptr) ) ;         
    }
    if ( delayedForward24_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward24_oid, OID_LENGTH(delayedForward24_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward24_ptr, strlen(delayedForward24_ptr) ) ;         
    }
    if( no_of_ports > 24 )
    {
    if ( delayedForward25_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward25_oid, OID_LENGTH(delayedForward25_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward25_ptr, strlen(delayedForward25_ptr) ) ;         
    }
    if ( delayedForward26_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward26_oid, OID_LENGTH(delayedForward26_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward26_ptr, strlen(delayedForward26_ptr) ) ;         
    }
    if ( delayedForward27_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward27_oid, OID_LENGTH(delayedForward27_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward27_ptr, strlen(delayedForward27_ptr) ) ;         
    }
    if ( delayedForward28_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward28_oid, OID_LENGTH(delayedForward28_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward28_ptr, strlen(delayedForward28_ptr) ) ;         
    }
    if ( delayedForward29_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward29_oid, OID_LENGTH(delayedForward29_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward29_ptr, strlen(delayedForward29_ptr) ) ;         
    }
    if ( delayedForward30_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward30_oid, OID_LENGTH(delayedForward30_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward30_ptr, strlen(delayedForward30_ptr) ) ;         
    }
    if ( delayedForward31_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward31_oid, OID_LENGTH(delayedForward31_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward31_ptr, strlen(delayedForward31_ptr) ) ;         
    }
    if ( delayedForward32_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward32_oid, OID_LENGTH(delayedForward32_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward32_ptr, strlen(delayedForward32_ptr) ) ;         
    }
    if( no_of_ports > 32 )
    {
    if ( delayedForward33_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward33_oid, OID_LENGTH(delayedForward33_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward33_ptr, strlen(delayedForward33_ptr) ) ;         
    }
    if ( delayedForward34_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward34_oid, OID_LENGTH(delayedForward34_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward34_ptr, strlen(delayedForward34_ptr) ) ;         
    }
    if ( delayedForward35_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward35_oid, OID_LENGTH(delayedForward35_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward35_ptr, strlen(delayedForward35_ptr) ) ;         
    }
    if ( delayedForward36_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward36_oid, OID_LENGTH(delayedForward36_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward36_ptr, strlen(delayedForward36_ptr) ) ;         
    }
    if ( delayedForward37_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward37_oid, OID_LENGTH(delayedForward37_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward37_ptr, strlen(delayedForward37_ptr) ) ;         
    }
    if ( delayedForward38_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward38_oid, OID_LENGTH(delayedForward38_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward38_ptr, strlen(delayedForward38_ptr) ) ;         
    }
    if ( delayedForward39_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward39_oid, OID_LENGTH(delayedForward39_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward39_ptr, strlen(delayedForward39_ptr) ) ;         
    }
    if ( delayedForward40_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward40_oid, OID_LENGTH(delayedForward40_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward40_ptr, strlen(delayedForward40_ptr) ) ;         
    }
    if ( delayedForward41_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward41_oid, OID_LENGTH(delayedForward41_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward41_ptr, strlen(delayedForward41_ptr) ) ;         
    }
    if ( delayedForward42_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward42_oid, OID_LENGTH(delayedForward42_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward42_ptr, strlen(delayedForward42_ptr) ) ;         
    }
    if ( delayedForward43_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward43_oid, OID_LENGTH(delayedForward43_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward43_ptr, strlen(delayedForward43_ptr) ) ;         
    }
    if ( delayedForward44_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward44_oid, OID_LENGTH(delayedForward44_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward44_ptr, strlen(delayedForward44_ptr) ) ;         
    }
    if ( delayedForward45_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward45_oid, OID_LENGTH(delayedForward45_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward45_ptr, strlen(delayedForward45_ptr) ) ;         
    }
    if ( delayedForward46_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward46_oid, OID_LENGTH(delayedForward46_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward46_ptr, strlen(delayedForward46_ptr) ) ;         
    }
    if ( delayedForward47_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward47_oid, OID_LENGTH(delayedForward47_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward47_ptr, strlen(delayedForward47_ptr) ) ;         
    }
    if ( delayedForward48_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward48_oid, OID_LENGTH(delayedForward48_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward48_ptr, strlen(delayedForward48_ptr) ) ;         
    }
    if( no_of_ports > 48 )
    {
    if ( delayedForward49_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward49_oid, OID_LENGTH(delayedForward49_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward49_ptr, strlen(delayedForward49_ptr) ) ;         
    }
    if ( delayedForward50_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward50_oid, OID_LENGTH(delayedForward50_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward50_ptr, strlen(delayedForward50_ptr) ) ;         
    }
    if ( delayedForward51_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward51_oid, OID_LENGTH(delayedForward51_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward51_ptr, strlen(delayedForward51_ptr) ) ;         
    }
    if ( delayedForward52_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward52_oid, OID_LENGTH(delayedForward52_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward52_ptr, strlen(delayedForward52_ptr) ) ;         
    }
    if ( delayedForward53_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward53_oid, OID_LENGTH(delayedForward53_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward53_ptr, strlen(delayedForward53_ptr) ) ;         
    }
    if ( delayedForward54_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward54_oid, OID_LENGTH(delayedForward54_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward54_ptr, strlen(delayedForward54_ptr) ) ;         
    }
    if ( delayedForward55_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward55_oid, OID_LENGTH(delayedForward55_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward55_ptr, strlen(delayedForward55_ptr) ) ;         
    }
    if ( delayedForward56_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward56_oid, OID_LENGTH(delayedForward56_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward56_ptr, strlen(delayedForward56_ptr) ) ;         
    }
    if ( delayedForward57_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward57_oid, OID_LENGTH(delayedForward57_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward57_ptr, strlen(delayedForward57_ptr) ) ;         
    }
    if ( delayedForward58_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward58_oid, OID_LENGTH(delayedForward58_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward58_ptr, strlen(delayedForward58_ptr) ) ;         
    }
    if ( delayedForward59_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward59_oid, OID_LENGTH(delayedForward59_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward59_ptr, strlen(delayedForward59_ptr) ) ;         
    }
    if ( delayedForward60_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward60_oid, OID_LENGTH(delayedForward60_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward60_ptr, strlen(delayedForward60_ptr) ) ;         
    }
    if ( delayedForward61_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward61_oid, OID_LENGTH(delayedForward61_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward61_ptr, strlen(delayedForward61_ptr) ) ;         
    }
    if ( delayedForward62_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward62_oid, OID_LENGTH(delayedForward62_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward62_ptr, strlen(delayedForward62_ptr) ) ;         
    }
    if ( delayedForward63_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward63_oid, OID_LENGTH(delayedForward63_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward63_ptr, strlen(delayedForward63_ptr) ) ;         
    }
    if ( delayedForward64_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward64_oid, OID_LENGTH(delayedForward64_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward64_ptr, strlen(delayedForward64_ptr) ) ;         
    }
    if ( delayedForward65_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward65_oid, OID_LENGTH(delayedForward65_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward65_ptr, strlen(delayedForward65_ptr) ) ;         
    }
    if ( delayedForward66_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward66_oid, OID_LENGTH(delayedForward66_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward66_ptr, strlen(delayedForward66_ptr) ) ;         
    }
    if ( delayedForward67_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward67_oid, OID_LENGTH(delayedForward67_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward67_ptr, strlen(delayedForward67_ptr) ) ;         
    }
    if ( delayedForward68_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward68_oid, OID_LENGTH(delayedForward68_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward68_ptr, strlen(delayedForward68_ptr) ) ;         
    }
    if ( delayedForward69_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward69_oid, OID_LENGTH(delayedForward69_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward69_ptr, strlen(delayedForward69_ptr) ) ;         
    }
    if ( delayedForward70_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward70_oid, OID_LENGTH(delayedForward70_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward70_ptr, strlen(delayedForward70_ptr) ) ;         
    }
    if ( delayedForward71_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward71_oid, OID_LENGTH(delayedForward71_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward71_ptr, strlen(delayedForward71_ptr) ) ;         
    }
    if ( delayedForward72_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward72_oid, OID_LENGTH(delayedForward72_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward72_ptr, strlen(delayedForward72_ptr) ) ;         
    }
    if ( delayedForward73_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward73_oid, OID_LENGTH(delayedForward73_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward73_ptr, strlen(delayedForward73_ptr) ) ;         
    }
    if ( delayedForward74_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward74_oid, OID_LENGTH(delayedForward74_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward74_ptr, strlen(delayedForward74_ptr) ) ;         
    }
    if ( delayedForward75_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward75_oid, OID_LENGTH(delayedForward75_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward75_ptr, strlen(delayedForward75_ptr) ) ;         
    }
    if ( delayedForward76_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward76_oid, OID_LENGTH(delayedForward76_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward76_ptr, strlen(delayedForward76_ptr) ) ;         
    }
    if ( delayedForward77_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward77_oid, OID_LENGTH(delayedForward77_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward77_ptr, strlen(delayedForward77_ptr) ) ;         
    }
    if ( delayedForward78_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward78_oid, OID_LENGTH(delayedForward78_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward78_ptr, strlen(delayedForward78_ptr) ) ;         
    }
    if ( delayedForward79_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward79_oid, OID_LENGTH(delayedForward79_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward79_ptr, strlen(delayedForward79_ptr) ) ;         
    }
    if ( delayedForward80_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward80_oid, OID_LENGTH(delayedForward80_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward80_ptr, strlen(delayedForward80_ptr) ) ;         
    }
    if ( delayedForward81_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward81_oid, OID_LENGTH(delayedForward81_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward81_ptr, strlen(delayedForward81_ptr) ) ;         
    }
    if ( delayedForward82_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward82_oid, OID_LENGTH(delayedForward82_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward82_ptr, strlen(delayedForward82_ptr) ) ;         
    }
    if ( delayedForward83_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward83_oid, OID_LENGTH(delayedForward83_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward83_ptr, strlen(delayedForward83_ptr) ) ;         
    }
    if ( delayedForward84_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward84_oid, OID_LENGTH(delayedForward84_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward84_ptr, strlen(delayedForward84_ptr) ) ;         
    }
    if ( delayedForward85_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward85_oid, OID_LENGTH(delayedForward85_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward85_ptr, strlen(delayedForward85_ptr) ) ;         
    }
    if ( delayedForward86_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward86_oid, OID_LENGTH(delayedForward86_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward86_ptr, strlen(delayedForward86_ptr) ) ;         
    }
    if ( delayedForward87_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward87_oid, OID_LENGTH(delayedForward87_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward87_ptr, strlen(delayedForward87_ptr) ) ;         
    }
    if ( delayedForward88_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward88_oid, OID_LENGTH(delayedForward88_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward88_ptr, strlen(delayedForward88_ptr) ) ;         
    }
    if ( delayedForward89_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward89_oid, OID_LENGTH(delayedForward89_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward89_ptr, strlen(delayedForward89_ptr) ) ;         
    }
    if ( delayedForward90_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward90_oid, OID_LENGTH(delayedForward90_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward90_ptr, strlen(delayedForward90_ptr) ) ;         
    }
    if ( delayedForward91_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward91_oid, OID_LENGTH(delayedForward91_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward91_ptr, strlen(delayedForward91_ptr) ) ;         
    }
    if ( delayedForward92_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward92_oid, OID_LENGTH(delayedForward92_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward92_ptr, strlen(delayedForward92_ptr) ) ;         
    }
    if ( delayedForward93_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward93_oid, OID_LENGTH(delayedForward93_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward93_ptr, strlen(delayedForward93_ptr) ) ;         
    }
    if ( delayedForward94_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward94_oid, OID_LENGTH(delayedForward94_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward94_ptr, strlen(delayedForward94_ptr) ) ;         
    }
    if ( delayedForward95_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward95_oid, OID_LENGTH(delayedForward95_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward95_ptr, strlen(delayedForward95_ptr) ) ;         
    }
    if ( delayedForward96_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward96_oid, OID_LENGTH(delayedForward96_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward96_ptr, strlen(delayedForward96_ptr) ) ;         
    }
    }}}}

    snmp_varlist_add_variable(&var_list,
        temperatureSensor1_oid, OID_LENGTH(temperatureSensor1_oid),
        ASN_INTEGER,
        (u_char *)&temperatureSensor1_value, sizeof(temperatureSensor1_value) ) ;
    if( no_of_ports > 16 )
    {
    snmp_varlist_add_variable(&var_list,
        temperatureSensor2_oid, OID_LENGTH(temperatureSensor2_oid),
        ASN_INTEGER,
        (u_char *)&temperatureSensor2_value, sizeof(temperatureSensor2_value) ) ;
    if( no_of_ports > 32 )
    {
    snmp_varlist_add_variable(&var_list,
        temperatureSensor3_oid, OID_LENGTH(temperatureSensor3_oid),
        ASN_INTEGER,
        (u_char *)&temperatureSensor3_value, sizeof(temperatureSensor3_value) ) ;
    if( no_of_ports > 48 )
    {
    snmp_varlist_add_variable(&var_list,
        temperatureSensor4_oid, OID_LENGTH(temperatureSensor4_oid),
        ASN_INTEGER,
        (u_char *)&temperatureSensor4_value, sizeof(temperatureSensor4_value) ) ;
    snmp_varlist_add_variable(&var_list,
        temperatureSensor5_oid, OID_LENGTH(temperatureSensor5_oid),
        ASN_INTEGER,
        (u_char *)&temperatureSensor5_value, sizeof(temperatureSensor5_value) ) ;
    snmp_varlist_add_variable(&var_list,
        temperatureSensor6_oid, OID_LENGTH(temperatureSensor6_oid),
        ASN_INTEGER,
        (u_char *)&temperatureSensor6_value, sizeof(temperatureSensor6_value) ) ;
    }}}

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    if ( 1 == v3trap )
        send_v3trap( var_list, NULL ) ;
    else
        send_v2trap( var_list ) ;
    snmp_free_varbind( var_list ) ;
}

int
handle_PartNo(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char PartNo_value[256] = { 0 } ;
    char *PartNo_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            PartNo_ptr = nvram_get_safe( "1397", PartNo_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( PartNo_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)PartNo_ptr, strlen(PartNo_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_PartNo\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus1_value[256] = { 0 } ;
    char *hookStatus1_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus1_ptr = nvram_get_safe( "4901", hookStatus1_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus1_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus1_ptr, strlen(hookStatus1_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus2_value[256] = { 0 } ;
    char *hookStatus2_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus2_ptr = nvram_get_safe( "4902", hookStatus2_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus2_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus2_ptr, strlen(hookStatus2_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus3_value[256] = { 0 } ;
    char *hookStatus3_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus3_ptr = nvram_get_safe( "4903", hookStatus3_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus3_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus3_ptr, strlen(hookStatus3_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus4_value[256] = { 0 } ;
    char *hookStatus4_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus4_ptr = nvram_get_safe( "4904", hookStatus4_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus4_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus4_ptr, strlen(hookStatus4_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus5_value[256] = { 0 } ;
    char *hookStatus5_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus5_ptr = nvram_get_safe( "4905", hookStatus5_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus5_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus5_ptr, strlen(hookStatus5_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus6_value[256] = { 0 } ;
    char *hookStatus6_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus6_ptr = nvram_get_safe( "4906", hookStatus6_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus6_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus6_ptr, strlen(hookStatus6_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus7_value[256] = { 0 } ;
    char *hookStatus7_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus7_ptr = nvram_get_safe( "4907", hookStatus7_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus7_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus7_ptr, strlen(hookStatus7_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus8_value[256] = { 0 } ;
    char *hookStatus8_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus8_ptr = nvram_get_safe( "4908", hookStatus8_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus8_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus8_ptr, strlen(hookStatus8_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus9(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus9_value[256] = { 0 } ;
    char *hookStatus9_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus9_ptr = nvram_get_safe( "4909", hookStatus9_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus9_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus9_ptr, strlen(hookStatus9_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus9\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus10(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus10_value[256] = { 0 } ;
    char *hookStatus10_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus10_ptr = nvram_get_safe( "4910", hookStatus10_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus10_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus10_ptr, strlen(hookStatus10_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus10\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus11(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus11_value[256] = { 0 } ;
    char *hookStatus11_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus11_ptr = nvram_get_safe( "4911", hookStatus11_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus11_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus11_ptr, strlen(hookStatus11_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus11\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus12(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus12_value[256] = { 0 } ;
    char *hookStatus12_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus12_ptr = nvram_get_safe( "4912", hookStatus12_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus12_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus12_ptr, strlen(hookStatus12_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus12\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus13(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus13_value[256] = { 0 } ;
    char *hookStatus13_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus13_ptr = nvram_get_safe( "4913", hookStatus13_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus13_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus13_ptr, strlen(hookStatus13_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus13\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus14(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus14_value[256] = { 0 } ;
    char *hookStatus14_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus14_ptr = nvram_get_safe( "4914", hookStatus14_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus14_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus14_ptr, strlen(hookStatus14_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus14\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus15(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus15_value[256] = { 0 } ;
    char *hookStatus15_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus15_ptr = nvram_get_safe( "4915", hookStatus15_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus15_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus15_ptr, strlen(hookStatus15_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus15\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus16(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus16_value[256] = { 0 } ;
    char *hookStatus16_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus16_ptr = nvram_get_safe( "4916", hookStatus16_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus16_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus16_ptr, strlen(hookStatus16_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus16\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus17(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus17_value[256] = { 0 } ;
    char *hookStatus17_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus17_ptr = nvram_get_safe( "4917", hookStatus17_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus17_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus17_ptr, strlen(hookStatus17_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus17\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus18(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus18_value[256] = { 0 } ;
    char *hookStatus18_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus18_ptr = nvram_get_safe( "4918", hookStatus18_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus18_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus18_ptr, strlen(hookStatus18_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus18\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus19(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus19_value[256] = { 0 } ;
    char *hookStatus19_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus19_ptr = nvram_get_safe( "4919", hookStatus19_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus19_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus19_ptr, strlen(hookStatus19_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus19\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus20(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus20_value[256] = { 0 } ;
    char *hookStatus20_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus20_ptr = nvram_get_safe( "4920", hookStatus20_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus20_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus20_ptr, strlen(hookStatus20_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus20\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus21(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus21_value[256] = { 0 } ;
    char *hookStatus21_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus21_ptr = nvram_get_safe( "4941", hookStatus21_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus21_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus21_ptr, strlen(hookStatus21_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus21\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus22(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus22_value[256] = { 0 } ;
    char *hookStatus22_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus22_ptr = nvram_get_safe( "4942", hookStatus22_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus22_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus22_ptr, strlen(hookStatus22_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus22\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus23(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus23_value[256] = { 0 } ;
    char *hookStatus23_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus23_ptr = nvram_get_safe( "4943", hookStatus23_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus23_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus23_ptr, strlen(hookStatus23_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus23\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus24(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus24_value[256] = { 0 } ;
    char *hookStatus24_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus24_ptr = nvram_get_safe( "4944", hookStatus24_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus24_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus24_ptr, strlen(hookStatus24_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus24\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus25(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus25_value[256] = { 0 } ;
    char *hookStatus25_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus25_ptr = nvram_get_safe( "4945", hookStatus25_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus25_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus25_ptr, strlen(hookStatus25_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus25\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus26(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus26_value[256] = { 0 } ;
    char *hookStatus26_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus26_ptr = nvram_get_safe( "4946", hookStatus26_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus26_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus26_ptr, strlen(hookStatus26_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus26\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus27(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus27_value[256] = { 0 } ;
    char *hookStatus27_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus27_ptr = nvram_get_safe( "4947", hookStatus27_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus27_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus27_ptr, strlen(hookStatus27_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus27\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus28(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus28_value[256] = { 0 } ;
    char *hookStatus28_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus28_ptr = nvram_get_safe( "4948", hookStatus28_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus28_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus28_ptr, strlen(hookStatus28_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus28\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus29(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus29_value[256] = { 0 } ;
    char *hookStatus29_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus29_ptr = nvram_get_safe( "4949", hookStatus29_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus29_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus29_ptr, strlen(hookStatus29_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus29\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus30(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus30_value[256] = { 0 } ;
    char *hookStatus30_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus30_ptr = nvram_get_safe( "4950", hookStatus30_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus30_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus30_ptr, strlen(hookStatus30_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus30\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus31(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus31_value[256] = { 0 } ;
    char *hookStatus31_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus31_ptr = nvram_get_safe( "4951", hookStatus31_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus31_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus31_ptr, strlen(hookStatus31_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus31\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus32(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus32_value[256] = { 0 } ;
    char *hookStatus32_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus32_ptr = nvram_get_safe( "4952", hookStatus32_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus32_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus32_ptr, strlen(hookStatus32_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus32\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus33(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus33_value[256] = { 0 } ;
    char *hookStatus33_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus33_ptr = nvram_get_safe( "21704", hookStatus33_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus33_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus33_ptr, strlen(hookStatus33_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus33\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus34(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus34_value[256] = { 0 } ;
    char *hookStatus34_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus34_ptr = nvram_get_safe( "21705", hookStatus34_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus34_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus34_ptr, strlen(hookStatus34_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus34\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus35(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus35_value[256] = { 0 } ;
    char *hookStatus35_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus35_ptr = nvram_get_safe( "21706", hookStatus35_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus35_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus35_ptr, strlen(hookStatus35_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus35\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus36(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus36_value[256] = { 0 } ;
    char *hookStatus36_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus36_ptr = nvram_get_safe( "21707", hookStatus36_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus36_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus36_ptr, strlen(hookStatus36_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus36\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus37(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus37_value[256] = { 0 } ;
    char *hookStatus37_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus37_ptr = nvram_get_safe( "21708", hookStatus37_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus37_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus37_ptr, strlen(hookStatus37_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus37\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus38(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus38_value[256] = { 0 } ;
    char *hookStatus38_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus38_ptr = nvram_get_safe( "21709", hookStatus38_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus38_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus38_ptr, strlen(hookStatus38_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus38\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus39(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus39_value[256] = { 0 } ;
    char *hookStatus39_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus39_ptr = nvram_get_safe( "21710", hookStatus39_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus39_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus39_ptr, strlen(hookStatus39_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus39\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus40(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus40_value[256] = { 0 } ;
    char *hookStatus40_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus40_ptr = nvram_get_safe( "21711", hookStatus40_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus40_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus40_ptr, strlen(hookStatus40_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus40\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus41(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus41_value[256] = { 0 } ;
    char *hookStatus41_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus41_ptr = nvram_get_safe( "21712", hookStatus41_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus41_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus41_ptr, strlen(hookStatus41_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus41\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus42(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus42_value[256] = { 0 } ;
    char *hookStatus42_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus42_ptr = nvram_get_safe( "21713", hookStatus42_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus42_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus42_ptr, strlen(hookStatus42_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus42\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus43(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus43_value[256] = { 0 } ;
    char *hookStatus43_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus43_ptr = nvram_get_safe( "21714", hookStatus43_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus43_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus43_ptr, strlen(hookStatus43_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus43\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus44(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus44_value[256] = { 0 } ;
    char *hookStatus44_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus44_ptr = nvram_get_safe( "21715", hookStatus44_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus44_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus44_ptr, strlen(hookStatus44_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus44\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus45(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus45_value[256] = { 0 } ;
    char *hookStatus45_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus45_ptr = nvram_get_safe( "21716", hookStatus45_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus45_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus45_ptr, strlen(hookStatus45_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus45\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus46(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus46_value[256] = { 0 } ;
    char *hookStatus46_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus46_ptr = nvram_get_safe( "21717", hookStatus46_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus46_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus46_ptr, strlen(hookStatus46_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus46\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus47(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus47_value[256] = { 0 } ;
    char *hookStatus47_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus47_ptr = nvram_get_safe( "21718", hookStatus47_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus47_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus47_ptr, strlen(hookStatus47_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus47\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus48(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus48_value[256] = { 0 } ;
    char *hookStatus48_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus48_ptr = nvram_get_safe( "21719", hookStatus48_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus48_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus48_ptr, strlen(hookStatus48_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus48\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus49(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus49_value[256] = { 0 } ;
    char *hookStatus49_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus49_ptr = nvram_get_safe( "21720", hookStatus49_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus49_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus49_ptr, strlen(hookStatus49_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus49\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus50(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus50_value[256] = { 0 } ;
    char *hookStatus50_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus50_ptr = nvram_get_safe( "21721", hookStatus50_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus50_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus50_ptr, strlen(hookStatus50_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus50\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus51(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus51_value[256] = { 0 } ;
    char *hookStatus51_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus51_ptr = nvram_get_safe( "21722", hookStatus51_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus51_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus51_ptr, strlen(hookStatus51_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus51\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus52(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus52_value[256] = { 0 } ;
    char *hookStatus52_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus52_ptr = nvram_get_safe( "21723", hookStatus52_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus52_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus52_ptr, strlen(hookStatus52_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus52\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus53(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus53_value[256] = { 0 } ;
    char *hookStatus53_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus53_ptr = nvram_get_safe( "21724", hookStatus53_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus53_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus53_ptr, strlen(hookStatus53_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus53\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus54(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus54_value[256] = { 0 } ;
    char *hookStatus54_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus54_ptr = nvram_get_safe( "21725", hookStatus54_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus54_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus54_ptr, strlen(hookStatus54_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus54\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus55(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus55_value[256] = { 0 } ;
    char *hookStatus55_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus55_ptr = nvram_get_safe( "21726", hookStatus55_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus55_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus55_ptr, strlen(hookStatus55_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus55\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus56(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus56_value[256] = { 0 } ;
    char *hookStatus56_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus56_ptr = nvram_get_safe( "21727", hookStatus56_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus56_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus56_ptr, strlen(hookStatus56_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus56\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus57(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus57_value[256] = { 0 } ;
    char *hookStatus57_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus57_ptr = nvram_get_safe( "21728", hookStatus57_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus57_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus57_ptr, strlen(hookStatus57_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus57\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus58(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus58_value[256] = { 0 } ;
    char *hookStatus58_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus58_ptr = nvram_get_safe( "21729", hookStatus58_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus58_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus58_ptr, strlen(hookStatus58_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus58\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus59(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus59_value[256] = { 0 } ;
    char *hookStatus59_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus59_ptr = nvram_get_safe( "21730", hookStatus59_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus59_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus59_ptr, strlen(hookStatus59_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus59\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus60(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus60_value[256] = { 0 } ;
    char *hookStatus60_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus60_ptr = nvram_get_safe( "21731", hookStatus60_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus60_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus60_ptr, strlen(hookStatus60_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus60\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus61(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus61_value[256] = { 0 } ;
    char *hookStatus61_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus61_ptr = nvram_get_safe( "21732", hookStatus61_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus61_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus61_ptr, strlen(hookStatus61_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus61\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus62(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus62_value[256] = { 0 } ;
    char *hookStatus62_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus62_ptr = nvram_get_safe( "21733", hookStatus62_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus62_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus62_ptr, strlen(hookStatus62_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus62\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus63(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus63_value[256] = { 0 } ;
    char *hookStatus63_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus63_ptr = nvram_get_safe( "21734", hookStatus63_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus63_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus63_ptr, strlen(hookStatus63_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus63\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus64(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus64_value[256] = { 0 } ;
    char *hookStatus64_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus64_ptr = nvram_get_safe( "21735", hookStatus64_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus64_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus64_ptr, strlen(hookStatus64_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus64\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus65(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus65_value[256] = { 0 } ;
    char *hookStatus65_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus65_ptr = nvram_get_safe( "21736", hookStatus65_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus65_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus65_ptr, strlen(hookStatus65_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus65\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus66(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus66_value[256] = { 0 } ;
    char *hookStatus66_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus66_ptr = nvram_get_safe( "21737", hookStatus66_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus66_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus66_ptr, strlen(hookStatus66_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus66\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus67(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus67_value[256] = { 0 } ;
    char *hookStatus67_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus67_ptr = nvram_get_safe( "21738", hookStatus67_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus67_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus67_ptr, strlen(hookStatus67_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus67\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus68(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus68_value[256] = { 0 } ;
    char *hookStatus68_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus68_ptr = nvram_get_safe( "21739", hookStatus68_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus68_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus68_ptr, strlen(hookStatus68_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus68\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus69(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus69_value[256] = { 0 } ;
    char *hookStatus69_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus69_ptr = nvram_get_safe( "21740", hookStatus69_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus69_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus69_ptr, strlen(hookStatus69_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus69\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus70(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus70_value[256] = { 0 } ;
    char *hookStatus70_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus70_ptr = nvram_get_safe( "21741", hookStatus70_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus70_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus70_ptr, strlen(hookStatus70_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus70\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus71(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus71_value[256] = { 0 } ;
    char *hookStatus71_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus71_ptr = nvram_get_safe( "21742", hookStatus71_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus71_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus71_ptr, strlen(hookStatus71_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus71\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus72(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus72_value[256] = { 0 } ;
    char *hookStatus72_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus72_ptr = nvram_get_safe( "21743", hookStatus72_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus72_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus72_ptr, strlen(hookStatus72_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus72\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus73(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus73_value[256] = { 0 } ;
    char *hookStatus73_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus73_ptr = nvram_get_safe( "21744", hookStatus73_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus73_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus73_ptr, strlen(hookStatus73_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus73\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus74(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus74_value[256] = { 0 } ;
    char *hookStatus74_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus74_ptr = nvram_get_safe( "21745", hookStatus74_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus74_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus74_ptr, strlen(hookStatus74_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus74\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus75(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus75_value[256] = { 0 } ;
    char *hookStatus75_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus75_ptr = nvram_get_safe( "21746", hookStatus75_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus75_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus75_ptr, strlen(hookStatus75_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus75\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus76(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus76_value[256] = { 0 } ;
    char *hookStatus76_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus76_ptr = nvram_get_safe( "21747", hookStatus76_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus76_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus76_ptr, strlen(hookStatus76_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus76\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus77(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus77_value[256] = { 0 } ;
    char *hookStatus77_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus77_ptr = nvram_get_safe( "21748", hookStatus77_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus77_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus77_ptr, strlen(hookStatus77_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus77\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus78(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus78_value[256] = { 0 } ;
    char *hookStatus78_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus78_ptr = nvram_get_safe( "21749", hookStatus78_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus78_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus78_ptr, strlen(hookStatus78_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus78\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus79(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus79_value[256] = { 0 } ;
    char *hookStatus79_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus79_ptr = nvram_get_safe( "21750", hookStatus79_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus79_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus79_ptr, strlen(hookStatus79_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus79\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus80(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus80_value[256] = { 0 } ;
    char *hookStatus80_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus80_ptr = nvram_get_safe( "21751", hookStatus80_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus80_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus80_ptr, strlen(hookStatus80_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus80\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus81(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus81_value[256] = { 0 } ;
    char *hookStatus81_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus81_ptr = nvram_get_safe( "21752", hookStatus81_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus81_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus81_ptr, strlen(hookStatus81_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus81\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus82(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus82_value[256] = { 0 } ;
    char *hookStatus82_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus82_ptr = nvram_get_safe( "21753", hookStatus82_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus82_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus82_ptr, strlen(hookStatus82_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus82\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus83(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus83_value[256] = { 0 } ;
    char *hookStatus83_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus83_ptr = nvram_get_safe( "21754", hookStatus83_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus83_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus83_ptr, strlen(hookStatus83_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus83\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus84(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus84_value[256] = { 0 } ;
    char *hookStatus84_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus84_ptr = nvram_get_safe( "21755", hookStatus84_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus84_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus84_ptr, strlen(hookStatus84_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus84\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus85(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus85_value[256] = { 0 } ;
    char *hookStatus85_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus85_ptr = nvram_get_safe( "21756", hookStatus85_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus85_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus85_ptr, strlen(hookStatus85_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus85\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus86(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus86_value[256] = { 0 } ;
    char *hookStatus86_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus86_ptr = nvram_get_safe( "21757", hookStatus86_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus86_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus86_ptr, strlen(hookStatus86_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus86\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus87(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus87_value[256] = { 0 } ;
    char *hookStatus87_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus87_ptr = nvram_get_safe( "21758", hookStatus87_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus87_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus87_ptr, strlen(hookStatus87_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus87\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus88(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus88_value[256] = { 0 } ;
    char *hookStatus88_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus88_ptr = nvram_get_safe( "21759", hookStatus88_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus88_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus88_ptr, strlen(hookStatus88_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus88\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus89(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus89_value[256] = { 0 } ;
    char *hookStatus89_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus89_ptr = nvram_get_safe( "21760", hookStatus89_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus89_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus89_ptr, strlen(hookStatus89_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus89\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus90(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus90_value[256] = { 0 } ;
    char *hookStatus90_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus90_ptr = nvram_get_safe( "21761", hookStatus90_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus90_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus90_ptr, strlen(hookStatus90_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus90\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus91(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus91_value[256] = { 0 } ;
    char *hookStatus91_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus91_ptr = nvram_get_safe( "21762", hookStatus91_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus91_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus91_ptr, strlen(hookStatus91_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus91\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus92(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus92_value[256] = { 0 } ;
    char *hookStatus92_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus92_ptr = nvram_get_safe( "21763", hookStatus92_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus92_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus92_ptr, strlen(hookStatus92_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus92\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus93(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus93_value[256] = { 0 } ;
    char *hookStatus93_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus93_ptr = nvram_get_safe( "21764", hookStatus93_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus93_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus93_ptr, strlen(hookStatus93_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus93\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus94(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus94_value[256] = { 0 } ;
    char *hookStatus94_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus94_ptr = nvram_get_safe( "21765", hookStatus94_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus94_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus94_ptr, strlen(hookStatus94_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus94\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus95(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus95_value[256] = { 0 } ;
    char *hookStatus95_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus95_ptr = nvram_get_safe( "21766", hookStatus95_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus95_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus95_ptr, strlen(hookStatus95_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus95\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus96(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char hookStatus96_value[256] = { 0 } ;
    char *hookStatus96_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus96_ptr = nvram_get_safe( "21767", hookStatus96_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus96_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus96_ptr, strlen(hookStatus96_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus96\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus1_value[256] = { 0 } ;
    char *regStatus1_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus1_ptr = nvram_get_safe( "4921", regStatus1_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus1_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus1_ptr, strlen(regStatus1_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus2_value[256] = { 0 } ;
    char *regStatus2_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus2_ptr = nvram_get_safe( "4922", regStatus2_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus2_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus2_ptr, strlen(regStatus2_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus3_value[256] = { 0 } ;
    char *regStatus3_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus3_ptr = nvram_get_safe( "4923", regStatus3_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus3_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus3_ptr, strlen(regStatus3_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus4_value[256] = { 0 } ;
    char *regStatus4_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus4_ptr = nvram_get_safe( "4924", regStatus4_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus4_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus4_ptr, strlen(regStatus4_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus5_value[256] = { 0 } ;
    char *regStatus5_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus5_ptr = nvram_get_safe( "4925", regStatus5_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus5_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus5_ptr, strlen(regStatus5_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus6_value[256] = { 0 } ;
    char *regStatus6_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus6_ptr = nvram_get_safe( "4926", regStatus6_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus6_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus6_ptr, strlen(regStatus6_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus7_value[256] = { 0 } ;
    char *regStatus7_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus7_ptr = nvram_get_safe( "4927", regStatus7_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus7_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus7_ptr, strlen(regStatus7_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus8_value[256] = { 0 } ;
    char *regStatus8_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus8_ptr = nvram_get_safe( "4928", regStatus8_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus8_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus8_ptr, strlen(regStatus8_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus9(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus9_value[256] = { 0 } ;
    char *regStatus9_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus9_ptr = nvram_get_safe( "4929", regStatus9_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus9_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus9_ptr, strlen(regStatus9_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus9\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus10(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus10_value[256] = { 0 } ;
    char *regStatus10_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus10_ptr = nvram_get_safe( "4930", regStatus10_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus10_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus10_ptr, strlen(regStatus10_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus10\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus11(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus11_value[256] = { 0 } ;
    char *regStatus11_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus11_ptr = nvram_get_safe( "4931", regStatus11_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus11_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus11_ptr, strlen(regStatus11_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus11\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus12(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus12_value[256] = { 0 } ;
    char *regStatus12_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus12_ptr = nvram_get_safe( "4932", regStatus12_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus12_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus12_ptr, strlen(regStatus12_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus12\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus13(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus13_value[256] = { 0 } ;
    char *regStatus13_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus13_ptr = nvram_get_safe( "4933", regStatus13_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus13_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus13_ptr, strlen(regStatus13_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus13\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus14(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus14_value[256] = { 0 } ;
    char *regStatus14_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus14_ptr = nvram_get_safe( "4934", regStatus14_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus14_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus14_ptr, strlen(regStatus14_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus14\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus15(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus15_value[256] = { 0 } ;
    char *regStatus15_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus15_ptr = nvram_get_safe( "4935", regStatus15_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus15_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus15_ptr, strlen(regStatus15_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus15\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus16(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus16_value[256] = { 0 } ;
    char *regStatus16_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus16_ptr = nvram_get_safe( "4936", regStatus16_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus16_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus16_ptr, strlen(regStatus16_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus16\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus17(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus17_value[256] = { 0 } ;
    char *regStatus17_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus17_ptr = nvram_get_safe( "4937", regStatus17_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus17_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus17_ptr, strlen(regStatus17_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus17\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus18(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus18_value[256] = { 0 } ;
    char *regStatus18_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus18_ptr = nvram_get_safe( "4938", regStatus18_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus18_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus18_ptr, strlen(regStatus18_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus18\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus19(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus19_value[256] = { 0 } ;
    char *regStatus19_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus19_ptr = nvram_get_safe( "4939", regStatus19_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus19_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus19_ptr, strlen(regStatus19_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus19\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus20(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus20_value[256] = { 0 } ;
    char *regStatus20_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus20_ptr = nvram_get_safe( "4940", regStatus20_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus20_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus20_ptr, strlen(regStatus20_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus20\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus21(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus21_value[256] = { 0 } ;
    char *regStatus21_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus21_ptr = nvram_get_safe( "4953", regStatus21_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus21_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus21_ptr, strlen(regStatus21_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus21\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus22(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus22_value[256] = { 0 } ;
    char *regStatus22_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus22_ptr = nvram_get_safe( "4954", regStatus22_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus22_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus22_ptr, strlen(regStatus22_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus22\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus23(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus23_value[256] = { 0 } ;
    char *regStatus23_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus23_ptr = nvram_get_safe( "4955", regStatus23_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus23_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus23_ptr, strlen(regStatus23_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus23\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus24(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus24_value[256] = { 0 } ;
    char *regStatus24_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus24_ptr = nvram_get_safe( "4956", regStatus24_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus24_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus24_ptr, strlen(regStatus24_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus24\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus25(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus25_value[256] = { 0 } ;
    char *regStatus25_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus25_ptr = nvram_get_safe( "4957", regStatus25_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus25_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus25_ptr, strlen(regStatus25_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus25\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus26(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus26_value[256] = { 0 } ;
    char *regStatus26_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus26_ptr = nvram_get_safe( "4958", regStatus26_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus26_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus26_ptr, strlen(regStatus26_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus26\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus27(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus27_value[256] = { 0 } ;
    char *regStatus27_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus27_ptr = nvram_get_safe( "4959", regStatus27_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus27_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus27_ptr, strlen(regStatus27_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus27\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus28(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus28_value[256] = { 0 } ;
    char *regStatus28_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus28_ptr = nvram_get_safe( "4960", regStatus28_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus28_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus28_ptr, strlen(regStatus28_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus28\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus29(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus29_value[256] = { 0 } ;
    char *regStatus29_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus29_ptr = nvram_get_safe( "4961", regStatus29_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus29_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus29_ptr, strlen(regStatus29_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus29\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus30(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus30_value[256] = { 0 } ;
    char *regStatus30_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus30_ptr = nvram_get_safe( "4962", regStatus30_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus30_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus30_ptr, strlen(regStatus30_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus30\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus31(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus31_value[256] = { 0 } ;
    char *regStatus31_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus31_ptr = nvram_get_safe( "4963", regStatus31_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus31_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus31_ptr, strlen(regStatus31_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus31\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus32(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus32_value[256] = { 0 } ;
    char *regStatus32_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus32_ptr = nvram_get_safe( "4964", regStatus32_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus32_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus32_ptr, strlen(regStatus32_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus32\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus33(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus33_value[256] = { 0 } ;
    char *regStatus33_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus33_ptr = nvram_get_safe( "21768", regStatus33_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus33_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus33_ptr, strlen(regStatus33_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus33\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus34(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus34_value[256] = { 0 } ;
    char *regStatus34_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus34_ptr = nvram_get_safe( "21769", regStatus34_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus34_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus34_ptr, strlen(regStatus34_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus34\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus35(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus35_value[256] = { 0 } ;
    char *regStatus35_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus35_ptr = nvram_get_safe( "21770", regStatus35_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus35_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus35_ptr, strlen(regStatus35_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus35\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus36(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus36_value[256] = { 0 } ;
    char *regStatus36_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus36_ptr = nvram_get_safe( "21771", regStatus36_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus36_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus36_ptr, strlen(regStatus36_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus36\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus37(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus37_value[256] = { 0 } ;
    char *regStatus37_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus37_ptr = nvram_get_safe( "21772", regStatus37_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus37_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus37_ptr, strlen(regStatus37_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus37\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus38(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus38_value[256] = { 0 } ;
    char *regStatus38_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus38_ptr = nvram_get_safe( "21773", regStatus38_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus38_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus38_ptr, strlen(regStatus38_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus38\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus39(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus39_value[256] = { 0 } ;
    char *regStatus39_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus39_ptr = nvram_get_safe( "21774", regStatus39_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus39_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus39_ptr, strlen(regStatus39_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus39\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus40(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus40_value[256] = { 0 } ;
    char *regStatus40_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus40_ptr = nvram_get_safe( "21775", regStatus40_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus40_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus40_ptr, strlen(regStatus40_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus40\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus41(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus41_value[256] = { 0 } ;
    char *regStatus41_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus41_ptr = nvram_get_safe( "21776", regStatus41_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus41_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus41_ptr, strlen(regStatus41_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus41\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus42(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus42_value[256] = { 0 } ;
    char *regStatus42_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus42_ptr = nvram_get_safe( "21777", regStatus42_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus42_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus42_ptr, strlen(regStatus42_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus42\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus43(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus43_value[256] = { 0 } ;
    char *regStatus43_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus43_ptr = nvram_get_safe( "21778", regStatus43_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus43_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus43_ptr, strlen(regStatus43_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus43\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus44(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus44_value[256] = { 0 } ;
    char *regStatus44_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus44_ptr = nvram_get_safe( "21779", regStatus44_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus44_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus44_ptr, strlen(regStatus44_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus44\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus45(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus45_value[256] = { 0 } ;
    char *regStatus45_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus45_ptr = nvram_get_safe( "21780", regStatus45_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus45_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus45_ptr, strlen(regStatus45_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus45\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus46(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus46_value[256] = { 0 } ;
    char *regStatus46_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus46_ptr = nvram_get_safe( "21781", regStatus46_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus46_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus46_ptr, strlen(regStatus46_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus46\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus47(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus47_value[256] = { 0 } ;
    char *regStatus47_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus47_ptr = nvram_get_safe( "21782", regStatus47_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus47_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus47_ptr, strlen(regStatus47_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus47\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus48(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus48_value[256] = { 0 } ;
    char *regStatus48_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus48_ptr = nvram_get_safe( "21783", regStatus48_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus48_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus48_ptr, strlen(regStatus48_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus48\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus49(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus49_value[256] = { 0 } ;
    char *regStatus49_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus49_ptr = nvram_get_safe( "21784", regStatus49_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus49_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus49_ptr, strlen(regStatus49_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus49\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus50(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus50_value[256] = { 0 } ;
    char *regStatus50_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus50_ptr = nvram_get_safe( "21785", regStatus50_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus50_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus50_ptr, strlen(regStatus50_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus50\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus51(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus51_value[256] = { 0 } ;
    char *regStatus51_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus51_ptr = nvram_get_safe( "21786", regStatus51_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus51_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus51_ptr, strlen(regStatus51_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus51\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus52(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus52_value[256] = { 0 } ;
    char *regStatus52_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus52_ptr = nvram_get_safe( "21787", regStatus52_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus52_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus52_ptr, strlen(regStatus52_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus52\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus53(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus53_value[256] = { 0 } ;
    char *regStatus53_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus53_ptr = nvram_get_safe( "21788", regStatus53_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus53_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus53_ptr, strlen(regStatus53_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus53\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus54(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus54_value[256] = { 0 } ;
    char *regStatus54_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus54_ptr = nvram_get_safe( "21789", regStatus54_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus54_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus54_ptr, strlen(regStatus54_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus54\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus55(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus55_value[256] = { 0 } ;
    char *regStatus55_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus55_ptr = nvram_get_safe( "21790", regStatus55_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus55_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus55_ptr, strlen(regStatus55_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus55\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus56(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus56_value[256] = { 0 } ;
    char *regStatus56_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus56_ptr = nvram_get_safe( "21791", regStatus56_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus56_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus56_ptr, strlen(regStatus56_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus56\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus57(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus57_value[256] = { 0 } ;
    char *regStatus57_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus57_ptr = nvram_get_safe( "21792", regStatus57_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus57_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus57_ptr, strlen(regStatus57_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus57\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus58(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus58_value[256] = { 0 } ;
    char *regStatus58_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus58_ptr = nvram_get_safe( "21793", regStatus58_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus58_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus58_ptr, strlen(regStatus58_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus58\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus59(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus59_value[256] = { 0 } ;
    char *regStatus59_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus59_ptr = nvram_get_safe( "21794", regStatus59_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus59_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus59_ptr, strlen(regStatus59_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus59\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus60(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus60_value[256] = { 0 } ;
    char *regStatus60_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus60_ptr = nvram_get_safe( "21795", regStatus60_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus60_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus60_ptr, strlen(regStatus60_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus60\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus61(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus61_value[256] = { 0 } ;
    char *regStatus61_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus61_ptr = nvram_get_safe( "21796", regStatus61_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus61_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus61_ptr, strlen(regStatus61_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus61\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus62(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus62_value[256] = { 0 } ;
    char *regStatus62_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus62_ptr = nvram_get_safe( "21797", regStatus62_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus62_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus62_ptr, strlen(regStatus62_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus62\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus63(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus63_value[256] = { 0 } ;
    char *regStatus63_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus63_ptr = nvram_get_safe( "21798", regStatus63_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus63_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus63_ptr, strlen(regStatus63_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus63\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus64(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus64_value[256] = { 0 } ;
    char *regStatus64_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus64_ptr = nvram_get_safe( "21799", regStatus64_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus64_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus64_ptr, strlen(regStatus64_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus64\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus65(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus65_value[256] = { 0 } ;
    char *regStatus65_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus65_ptr = nvram_get_safe( "21800", regStatus65_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus65_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus65_ptr, strlen(regStatus65_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus65\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus66(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus66_value[256] = { 0 } ;
    char *regStatus66_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus66_ptr = nvram_get_safe( "21801", regStatus66_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus66_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus66_ptr, strlen(regStatus66_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus66\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus67(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus67_value[256] = { 0 } ;
    char *regStatus67_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus67_ptr = nvram_get_safe( "21802", regStatus67_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus67_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus67_ptr, strlen(regStatus67_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus67\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus68(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus68_value[256] = { 0 } ;
    char *regStatus68_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus68_ptr = nvram_get_safe( "21803", regStatus68_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus68_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus68_ptr, strlen(regStatus68_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus68\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus69(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus69_value[256] = { 0 } ;
    char *regStatus69_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus69_ptr = nvram_get_safe( "21804", regStatus69_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus69_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus69_ptr, strlen(regStatus69_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus69\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus70(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus70_value[256] = { 0 } ;
    char *regStatus70_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus70_ptr = nvram_get_safe( "21805", regStatus70_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus70_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus70_ptr, strlen(regStatus70_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus70\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus71(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus71_value[256] = { 0 } ;
    char *regStatus71_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus71_ptr = nvram_get_safe( "21806", regStatus71_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus71_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus71_ptr, strlen(regStatus71_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus71\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus72(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus72_value[256] = { 0 } ;
    char *regStatus72_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus72_ptr = nvram_get_safe( "21807", regStatus72_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus72_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus72_ptr, strlen(regStatus72_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus72\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus73(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus73_value[256] = { 0 } ;
    char *regStatus73_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus73_ptr = nvram_get_safe( "21808", regStatus73_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus73_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus73_ptr, strlen(regStatus73_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus73\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus74(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus74_value[256] = { 0 } ;
    char *regStatus74_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus74_ptr = nvram_get_safe( "21809", regStatus74_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus74_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus74_ptr, strlen(regStatus74_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus74\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus75(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus75_value[256] = { 0 } ;
    char *regStatus75_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus75_ptr = nvram_get_safe( "21810", regStatus75_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus75_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus75_ptr, strlen(regStatus75_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus75\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus76(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus76_value[256] = { 0 } ;
    char *regStatus76_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus76_ptr = nvram_get_safe( "21811", regStatus76_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus76_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus76_ptr, strlen(regStatus76_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus76\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus77(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus77_value[256] = { 0 } ;
    char *regStatus77_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus77_ptr = nvram_get_safe( "21812", regStatus77_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus77_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus77_ptr, strlen(regStatus77_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus77\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus78(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus78_value[256] = { 0 } ;
    char *regStatus78_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus78_ptr = nvram_get_safe( "21813", regStatus78_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus78_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus78_ptr, strlen(regStatus78_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus78\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus79(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus79_value[256] = { 0 } ;
    char *regStatus79_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus79_ptr = nvram_get_safe( "21814", regStatus79_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus79_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus79_ptr, strlen(regStatus79_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus79\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus80(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus80_value[256] = { 0 } ;
    char *regStatus80_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus80_ptr = nvram_get_safe( "21815", regStatus80_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus80_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus80_ptr, strlen(regStatus80_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus80\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus81(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus81_value[256] = { 0 } ;
    char *regStatus81_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus81_ptr = nvram_get_safe( "21816", regStatus81_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus81_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus81_ptr, strlen(regStatus81_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus81\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus82(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus82_value[256] = { 0 } ;
    char *regStatus82_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus82_ptr = nvram_get_safe( "21817", regStatus82_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus82_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus82_ptr, strlen(regStatus82_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus82\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus83(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus83_value[256] = { 0 } ;
    char *regStatus83_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus83_ptr = nvram_get_safe( "21818", regStatus83_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus83_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus83_ptr, strlen(regStatus83_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus83\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus84(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus84_value[256] = { 0 } ;
    char *regStatus84_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus84_ptr = nvram_get_safe( "21819", regStatus84_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus84_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus84_ptr, strlen(regStatus84_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus84\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus85(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus85_value[256] = { 0 } ;
    char *regStatus85_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus85_ptr = nvram_get_safe( "21820", regStatus85_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus85_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus85_ptr, strlen(regStatus85_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus85\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus86(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus86_value[256] = { 0 } ;
    char *regStatus86_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus86_ptr = nvram_get_safe( "21821", regStatus86_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus86_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus86_ptr, strlen(regStatus86_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus86\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus87(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus87_value[256] = { 0 } ;
    char *regStatus87_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus87_ptr = nvram_get_safe( "21822", regStatus87_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus87_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus87_ptr, strlen(regStatus87_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus87\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus88(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus88_value[256] = { 0 } ;
    char *regStatus88_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus88_ptr = nvram_get_safe( "21823", regStatus88_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus88_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus88_ptr, strlen(regStatus88_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus88\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus89(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus89_value[256] = { 0 } ;
    char *regStatus89_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus89_ptr = nvram_get_safe( "21824", regStatus89_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus89_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus89_ptr, strlen(regStatus89_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus89\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus90(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus90_value[256] = { 0 } ;
    char *regStatus90_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus90_ptr = nvram_get_safe( "21825", regStatus90_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus90_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus90_ptr, strlen(regStatus90_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus90\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus91(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus91_value[256] = { 0 } ;
    char *regStatus91_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus91_ptr = nvram_get_safe( "21826", regStatus91_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus91_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus91_ptr, strlen(regStatus91_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus91\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus92(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus92_value[256] = { 0 } ;
    char *regStatus92_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus92_ptr = nvram_get_safe( "21827", regStatus92_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus92_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus92_ptr, strlen(regStatus92_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus92\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus93(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus93_value[256] = { 0 } ;
    char *regStatus93_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus93_ptr = nvram_get_safe( "21828", regStatus93_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus93_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus93_ptr, strlen(regStatus93_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus93\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus94(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus94_value[256] = { 0 } ;
    char *regStatus94_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus94_ptr = nvram_get_safe( "21829", regStatus94_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus94_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus94_ptr, strlen(regStatus94_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus94\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus95(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus95_value[256] = { 0 } ;
    char *regStatus95_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus95_ptr = nvram_get_safe( "21830", regStatus95_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus95_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus95_ptr, strlen(regStatus95_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus95\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus96(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char regStatus96_value[256] = { 0 } ;
    char *regStatus96_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus96_ptr = nvram_get_safe( "21831", regStatus96_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus96_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus96_ptr, strlen(regStatus96_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus96\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd1_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd1_value = get_nvram_long( "dnd_0", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd1_value, sizeof(dnd1_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd2_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd2_value = get_nvram_long( "dnd_1", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd2_value, sizeof(dnd2_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd3_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd3_value = get_nvram_long( "dnd_2", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd3_value, sizeof(dnd3_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd4_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd4_value = get_nvram_long( "dnd_3", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd4_value, sizeof(dnd4_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd5_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd5_value = get_nvram_long( "dnd_4", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd5_value, sizeof(dnd5_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd6_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd6_value = get_nvram_long( "dnd_5", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd6_value, sizeof(dnd6_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd7_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd7_value = get_nvram_long( "dnd_6", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd7_value, sizeof(dnd7_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd8_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd8_value = get_nvram_long( "dnd_7", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd8_value, sizeof(dnd8_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd9(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd9_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd9_value = get_nvram_long( "dnd_8", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd9_value, sizeof(dnd9_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd9\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd10(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd10_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd10_value = get_nvram_long( "dnd_9", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd10_value, sizeof(dnd10_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd10\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd11(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd11_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd11_value = get_nvram_long( "dnd_10", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd11_value, sizeof(dnd11_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd11\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd12(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd12_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd12_value = get_nvram_long( "dnd_11", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd12_value, sizeof(dnd12_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd12\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd13(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd13_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd13_value = get_nvram_long( "dnd_12", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd13_value, sizeof(dnd13_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd13\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd14(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd14_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd14_value = get_nvram_long( "dnd_13", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd14_value, sizeof(dnd14_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd14\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd15(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd15_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd15_value = get_nvram_long( "dnd_14", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd15_value, sizeof(dnd15_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd15\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd16(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd16_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd16_value = get_nvram_long( "dnd_15", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd16_value, sizeof(dnd16_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd16\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd17(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd17_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd17_value = get_nvram_long( "dnd_16", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd17_value, sizeof(dnd17_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd17\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd18(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd18_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd18_value = get_nvram_long( "dnd_17", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd18_value, sizeof(dnd18_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd18\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd19(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd19_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd19_value = get_nvram_long( "dnd_18", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd19_value, sizeof(dnd19_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd19\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd20(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd20_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd20_value = get_nvram_long( "dnd_19", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd20_value, sizeof(dnd20_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd20\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd21(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd21_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd21_value = get_nvram_long( "dnd_20", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd21_value, sizeof(dnd21_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd21\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd22(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd22_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd22_value = get_nvram_long( "dnd_21", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd22_value, sizeof(dnd22_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd22\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd23(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd23_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd23_value = get_nvram_long( "dnd_22", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd23_value, sizeof(dnd23_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd23\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd24(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd24_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd24_value = get_nvram_long( "dnd_23", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd24_value, sizeof(dnd24_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd24\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd25(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd25_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd25_value = get_nvram_long( "dnd_24", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd25_value, sizeof(dnd25_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd25\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd26(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd26_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd26_value = get_nvram_long( "dnd_25", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd26_value, sizeof(dnd26_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd26\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd27(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd27_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd27_value = get_nvram_long( "dnd_26", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd27_value, sizeof(dnd27_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd27\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd28(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd28_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd28_value = get_nvram_long( "dnd_27", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd28_value, sizeof(dnd28_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd28\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd29(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd29_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd29_value = get_nvram_long( "dnd_28", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd29_value, sizeof(dnd29_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd29\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd30(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd30_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd30_value = get_nvram_long( "dnd_29", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd30_value, sizeof(dnd30_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd30\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd31(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd31_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd31_value = get_nvram_long( "dnd_30", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd31_value, sizeof(dnd31_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd31\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd32(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd32_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd32_value = get_nvram_long( "dnd_31", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd32_value, sizeof(dnd32_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd32\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd33(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd33_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd33_value = get_nvram_long( "dnd_32", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd33_value, sizeof(dnd33_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd33\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd34(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd34_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd34_value = get_nvram_long( "dnd_33", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd34_value, sizeof(dnd34_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd34\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd35(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd35_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd35_value = get_nvram_long( "dnd_34", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd35_value, sizeof(dnd35_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd35\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd36(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd36_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd36_value = get_nvram_long( "dnd_35", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd36_value, sizeof(dnd36_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd36\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd37(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd37_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd37_value = get_nvram_long( "dnd_36", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd37_value, sizeof(dnd37_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd37\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd38(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd38_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd38_value = get_nvram_long( "dnd_37", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd38_value, sizeof(dnd38_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd38\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd39(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd39_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd39_value = get_nvram_long( "dnd_38", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd39_value, sizeof(dnd39_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd39\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd40(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd40_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd40_value = get_nvram_long( "dnd_39", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd40_value, sizeof(dnd40_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd40\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd41(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd41_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd41_value = get_nvram_long( "dnd_40", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd41_value, sizeof(dnd41_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd41\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd42(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd42_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd42_value = get_nvram_long( "dnd_41", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd42_value, sizeof(dnd42_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd42\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd43(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd43_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd43_value = get_nvram_long( "dnd_42", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd43_value, sizeof(dnd43_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd43\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd44(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd44_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd44_value = get_nvram_long( "dnd_43", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd44_value, sizeof(dnd44_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd44\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd45(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd45_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd45_value = get_nvram_long( "dnd_44", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd45_value, sizeof(dnd45_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd45\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd46(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd46_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd46_value = get_nvram_long( "dnd_45", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd46_value, sizeof(dnd46_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd46\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd47(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd47_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd47_value = get_nvram_long( "dnd_46", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd47_value, sizeof(dnd47_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd47\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd48(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd48_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd48_value = get_nvram_long( "dnd_47", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd48_value, sizeof(dnd48_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd48\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd49(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd49_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd49_value = get_nvram_long( "dnd_48", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd49_value, sizeof(dnd49_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd49\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd50(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd50_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd50_value = get_nvram_long( "dnd_49", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd50_value, sizeof(dnd50_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd50\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd51(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd51_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd51_value = get_nvram_long( "dnd_50", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd51_value, sizeof(dnd51_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd51\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd52(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd52_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd52_value = get_nvram_long( "dnd_51", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd52_value, sizeof(dnd52_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd52\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd53(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd53_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd53_value = get_nvram_long( "dnd_52", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd53_value, sizeof(dnd53_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd53\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd54(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd54_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd54_value = get_nvram_long( "dnd_53", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd54_value, sizeof(dnd54_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd54\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd55(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd55_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd55_value = get_nvram_long( "dnd_54", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd55_value, sizeof(dnd55_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd55\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd56(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd56_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd56_value = get_nvram_long( "dnd_55", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd56_value, sizeof(dnd56_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd56\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd57(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd57_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd57_value = get_nvram_long( "dnd_56", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd57_value, sizeof(dnd57_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd57\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd58(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd58_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd58_value = get_nvram_long( "dnd_57", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd58_value, sizeof(dnd58_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd58\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd59(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd59_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd59_value = get_nvram_long( "dnd_58", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd59_value, sizeof(dnd59_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd59\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd60(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd60_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd60_value = get_nvram_long( "dnd_59", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd60_value, sizeof(dnd60_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd60\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd61(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd61_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd61_value = get_nvram_long( "dnd_60", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd61_value, sizeof(dnd61_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd61\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd62(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd62_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd62_value = get_nvram_long( "dnd_61", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd62_value, sizeof(dnd62_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd62\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd63(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd63_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd63_value = get_nvram_long( "dnd_62", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd63_value, sizeof(dnd63_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd63\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd64(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd64_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd64_value = get_nvram_long( "dnd_63", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd64_value, sizeof(dnd64_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd64\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd65(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd65_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd65_value = get_nvram_long( "dnd_64", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd65_value, sizeof(dnd65_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd65\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd66(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd66_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd66_value = get_nvram_long( "dnd_65", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd66_value, sizeof(dnd66_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd66\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd67(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd67_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd67_value = get_nvram_long( "dnd_66", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd67_value, sizeof(dnd67_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd67\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd68(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd68_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd68_value = get_nvram_long( "dnd_67", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd68_value, sizeof(dnd68_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd68\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd69(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd69_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd69_value = get_nvram_long( "dnd_68", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd69_value, sizeof(dnd69_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd69\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd70(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd70_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd70_value = get_nvram_long( "dnd_69", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd70_value, sizeof(dnd70_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd70\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd71(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd71_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd71_value = get_nvram_long( "dnd_70", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd71_value, sizeof(dnd71_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd71\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd72(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd72_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd72_value = get_nvram_long( "dnd_71", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd72_value, sizeof(dnd72_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd72\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd73(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd73_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd73_value = get_nvram_long( "dnd_72", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd73_value, sizeof(dnd73_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd73\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd74(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd74_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd74_value = get_nvram_long( "dnd_73", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd74_value, sizeof(dnd74_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd74\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd75(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd75_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd75_value = get_nvram_long( "dnd_74", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd75_value, sizeof(dnd75_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd75\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd76(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd76_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd76_value = get_nvram_long( "dnd_75", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd76_value, sizeof(dnd76_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd76\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd77(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd77_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd77_value = get_nvram_long( "dnd_76", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd77_value, sizeof(dnd77_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd77\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd78(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd78_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd78_value = get_nvram_long( "dnd_77", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd78_value, sizeof(dnd78_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd78\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd79(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd79_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd79_value = get_nvram_long( "dnd_78", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd79_value, sizeof(dnd79_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd79\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd80(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd80_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd80_value = get_nvram_long( "dnd_79", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd80_value, sizeof(dnd80_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd80\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd81(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd81_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd81_value = get_nvram_long( "dnd_80", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd81_value, sizeof(dnd81_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd81\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd82(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd82_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd82_value = get_nvram_long( "dnd_81", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd82_value, sizeof(dnd82_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd82\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd83(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd83_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd83_value = get_nvram_long( "dnd_82", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd83_value, sizeof(dnd83_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd83\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd84(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd84_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd84_value = get_nvram_long( "dnd_83", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd84_value, sizeof(dnd84_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd84\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd85(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd85_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd85_value = get_nvram_long( "dnd_84", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd85_value, sizeof(dnd85_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd85\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd86(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd86_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd86_value = get_nvram_long( "dnd_85", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd86_value, sizeof(dnd86_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd86\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd87(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd87_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd87_value = get_nvram_long( "dnd_86", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd87_value, sizeof(dnd87_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd87\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd88(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd88_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd88_value = get_nvram_long( "dnd_87", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd88_value, sizeof(dnd88_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd88\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd89(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd89_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd89_value = get_nvram_long( "dnd_88", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd89_value, sizeof(dnd89_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd89\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd90(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd90_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd90_value = get_nvram_long( "dnd_89", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd90_value, sizeof(dnd90_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd90\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd91(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd91_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd91_value = get_nvram_long( "dnd_90", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd91_value, sizeof(dnd91_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd91\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd92(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd92_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd92_value = get_nvram_long( "dnd_91", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd92_value, sizeof(dnd92_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd92\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd93(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd93_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd93_value = get_nvram_long( "dnd_92", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd93_value, sizeof(dnd93_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd93\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd94(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd94_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd94_value = get_nvram_long( "dnd_93", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd94_value, sizeof(dnd94_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd94\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd95(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd95_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd95_value = get_nvram_long( "dnd_94", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd95_value, sizeof(dnd95_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd95\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd96(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long dnd96_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd96_value = get_nvram_long( "dnd_95", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd96_value, sizeof(dnd96_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd96\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward1_value[256] = { 0 } ;
    char *forward1_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward1_ptr = nvram_get_safe( "forward_0", forward1_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward1_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward1_ptr, strlen(forward1_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward2_value[256] = { 0 } ;
    char *forward2_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward2_ptr = nvram_get_safe( "forward_1", forward2_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward2_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward2_ptr, strlen(forward2_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward3_value[256] = { 0 } ;
    char *forward3_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward3_ptr = nvram_get_safe( "forward_2", forward3_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward3_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward3_ptr, strlen(forward3_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward4_value[256] = { 0 } ;
    char *forward4_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward4_ptr = nvram_get_safe( "forward_3", forward4_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward4_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward4_ptr, strlen(forward4_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward5_value[256] = { 0 } ;
    char *forward5_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward5_ptr = nvram_get_safe( "forward_4", forward5_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward5_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward5_ptr, strlen(forward5_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward6_value[256] = { 0 } ;
    char *forward6_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward6_ptr = nvram_get_safe( "forward_5", forward6_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward6_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward6_ptr, strlen(forward6_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward7_value[256] = { 0 } ;
    char *forward7_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward7_ptr = nvram_get_safe( "forward_6", forward7_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward7_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward7_ptr, strlen(forward7_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward8_value[256] = { 0 } ;
    char *forward8_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward8_ptr = nvram_get_safe( "forward_7", forward8_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward8_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward8_ptr, strlen(forward8_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward9(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward9_value[256] = { 0 } ;
    char *forward9_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward9_ptr = nvram_get_safe( "forward_8", forward9_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward9_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward9_ptr, strlen(forward9_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward9\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward10(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward10_value[256] = { 0 } ;
    char *forward10_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward10_ptr = nvram_get_safe( "forward_9", forward10_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward10_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward10_ptr, strlen(forward10_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward10\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward11(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward11_value[256] = { 0 } ;
    char *forward11_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward11_ptr = nvram_get_safe( "forward_10", forward11_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward11_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward11_ptr, strlen(forward11_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward11\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward12(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward12_value[256] = { 0 } ;
    char *forward12_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward12_ptr = nvram_get_safe( "forward_11", forward12_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward12_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward12_ptr, strlen(forward12_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward12\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward13(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward13_value[256] = { 0 } ;
    char *forward13_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward13_ptr = nvram_get_safe( "forward_12", forward13_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward13_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward13_ptr, strlen(forward13_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward13\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward14(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward14_value[256] = { 0 } ;
    char *forward14_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward14_ptr = nvram_get_safe( "forward_13", forward14_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward14_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward14_ptr, strlen(forward14_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward14\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward15(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward15_value[256] = { 0 } ;
    char *forward15_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward15_ptr = nvram_get_safe( "forward_14", forward15_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward15_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward15_ptr, strlen(forward15_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward15\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward16(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward16_value[256] = { 0 } ;
    char *forward16_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward16_ptr = nvram_get_safe( "forward_15", forward16_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward16_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward16_ptr, strlen(forward16_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward16\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward17(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward17_value[256] = { 0 } ;
    char *forward17_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward17_ptr = nvram_get_safe( "forward_16", forward17_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward17_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward17_ptr, strlen(forward17_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward17\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward18(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward18_value[256] = { 0 } ;
    char *forward18_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward18_ptr = nvram_get_safe( "forward_17", forward18_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward18_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward18_ptr, strlen(forward18_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward18\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward19(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward19_value[256] = { 0 } ;
    char *forward19_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward19_ptr = nvram_get_safe( "forward_18", forward19_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward19_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward19_ptr, strlen(forward19_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward19\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward20(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward20_value[256] = { 0 } ;
    char *forward20_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward20_ptr = nvram_get_safe( "forward_19", forward20_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward20_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward20_ptr, strlen(forward20_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward20\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward21(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward21_value[256] = { 0 } ;
    char *forward21_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward21_ptr = nvram_get_safe( "forward_20", forward21_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward21_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward21_ptr, strlen(forward21_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward21\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward22(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward22_value[256] = { 0 } ;
    char *forward22_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward22_ptr = nvram_get_safe( "forward_21", forward22_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward22_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward22_ptr, strlen(forward22_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward22\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward23(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward23_value[256] = { 0 } ;
    char *forward23_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward23_ptr = nvram_get_safe( "forward_22", forward23_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward23_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward23_ptr, strlen(forward23_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward23\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward24(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward24_value[256] = { 0 } ;
    char *forward24_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward24_ptr = nvram_get_safe( "forward_23", forward24_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward24_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward24_ptr, strlen(forward24_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward24\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward25(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward25_value[256] = { 0 } ;
    char *forward25_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward25_ptr = nvram_get_safe( "forward_24", forward25_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward25_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward25_ptr, strlen(forward25_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward25\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward26(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward26_value[256] = { 0 } ;
    char *forward26_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward26_ptr = nvram_get_safe( "forward_25", forward26_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward26_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward26_ptr, strlen(forward26_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward26\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward27(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward27_value[256] = { 0 } ;
    char *forward27_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward27_ptr = nvram_get_safe( "forward_26", forward27_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward27_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward27_ptr, strlen(forward27_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward27\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward28(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward28_value[256] = { 0 } ;
    char *forward28_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward28_ptr = nvram_get_safe( "forward_27", forward28_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward28_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward28_ptr, strlen(forward28_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward28\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward29(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward29_value[256] = { 0 } ;
    char *forward29_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward29_ptr = nvram_get_safe( "forward_28", forward29_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward29_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward29_ptr, strlen(forward29_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward29\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward30(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward30_value[256] = { 0 } ;
    char *forward30_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward30_ptr = nvram_get_safe( "forward_29", forward30_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward30_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward30_ptr, strlen(forward30_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward30\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward31(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward31_value[256] = { 0 } ;
    char *forward31_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward31_ptr = nvram_get_safe( "forward_30", forward31_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward31_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward31_ptr, strlen(forward31_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward31\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward32(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward32_value[256] = { 0 } ;
    char *forward32_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward32_ptr = nvram_get_safe( "forward_31", forward32_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward32_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward32_ptr, strlen(forward32_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward32\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward33(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward33_value[256] = { 0 } ;
    char *forward33_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward33_ptr = nvram_get_safe( "forward_32", forward33_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward33_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward33_ptr, strlen(forward33_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward33\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward34(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward34_value[256] = { 0 } ;
    char *forward34_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward34_ptr = nvram_get_safe( "forward_33", forward34_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward34_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward34_ptr, strlen(forward34_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward34\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward35(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward35_value[256] = { 0 } ;
    char *forward35_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward35_ptr = nvram_get_safe( "forward_34", forward35_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward35_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward35_ptr, strlen(forward35_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward35\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward36(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward36_value[256] = { 0 } ;
    char *forward36_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward36_ptr = nvram_get_safe( "forward_35", forward36_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward36_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward36_ptr, strlen(forward36_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward36\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward37(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward37_value[256] = { 0 } ;
    char *forward37_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward37_ptr = nvram_get_safe( "forward_36", forward37_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward37_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward37_ptr, strlen(forward37_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward37\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward38(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward38_value[256] = { 0 } ;
    char *forward38_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward38_ptr = nvram_get_safe( "forward_37", forward38_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward38_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward38_ptr, strlen(forward38_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward38\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward39(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward39_value[256] = { 0 } ;
    char *forward39_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward39_ptr = nvram_get_safe( "forward_38", forward39_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward39_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward39_ptr, strlen(forward39_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward39\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward40(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward40_value[256] = { 0 } ;
    char *forward40_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward40_ptr = nvram_get_safe( "forward_39", forward40_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward40_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward40_ptr, strlen(forward40_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward40\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward41(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward41_value[256] = { 0 } ;
    char *forward41_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward41_ptr = nvram_get_safe( "forward_40", forward41_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward41_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward41_ptr, strlen(forward41_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward41\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward42(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward42_value[256] = { 0 } ;
    char *forward42_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward42_ptr = nvram_get_safe( "forward_41", forward42_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward42_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward42_ptr, strlen(forward42_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward42\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward43(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward43_value[256] = { 0 } ;
    char *forward43_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward43_ptr = nvram_get_safe( "forward_42", forward43_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward43_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward43_ptr, strlen(forward43_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward43\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward44(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward44_value[256] = { 0 } ;
    char *forward44_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward44_ptr = nvram_get_safe( "forward_43", forward44_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward44_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward44_ptr, strlen(forward44_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward44\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward45(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward45_value[256] = { 0 } ;
    char *forward45_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward45_ptr = nvram_get_safe( "forward_44", forward45_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward45_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward45_ptr, strlen(forward45_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward45\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward46(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward46_value[256] = { 0 } ;
    char *forward46_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward46_ptr = nvram_get_safe( "forward_45", forward46_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward46_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward46_ptr, strlen(forward46_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward46\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward47(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward47_value[256] = { 0 } ;
    char *forward47_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward47_ptr = nvram_get_safe( "forward_46", forward47_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward47_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward47_ptr, strlen(forward47_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward47\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward48(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward48_value[256] = { 0 } ;
    char *forward48_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward48_ptr = nvram_get_safe( "forward_47", forward48_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward48_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward48_ptr, strlen(forward48_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward48\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward49(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward49_value[256] = { 0 } ;
    char *forward49_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward49_ptr = nvram_get_safe( "forward_48", forward49_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward49_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward49_ptr, strlen(forward49_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward49\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward50(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward50_value[256] = { 0 } ;
    char *forward50_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward50_ptr = nvram_get_safe( "forward_49", forward50_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward50_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward50_ptr, strlen(forward50_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward50\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward51(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward51_value[256] = { 0 } ;
    char *forward51_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward51_ptr = nvram_get_safe( "forward_50", forward51_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward51_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward51_ptr, strlen(forward51_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward51\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward52(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward52_value[256] = { 0 } ;
    char *forward52_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward52_ptr = nvram_get_safe( "forward_51", forward52_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward52_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward52_ptr, strlen(forward52_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward52\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward53(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward53_value[256] = { 0 } ;
    char *forward53_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward53_ptr = nvram_get_safe( "forward_52", forward53_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward53_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward53_ptr, strlen(forward53_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward53\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward54(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward54_value[256] = { 0 } ;
    char *forward54_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward54_ptr = nvram_get_safe( "forward_53", forward54_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward54_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward54_ptr, strlen(forward54_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward54\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward55(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward55_value[256] = { 0 } ;
    char *forward55_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward55_ptr = nvram_get_safe( "forward_54", forward55_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward55_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward55_ptr, strlen(forward55_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward55\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward56(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward56_value[256] = { 0 } ;
    char *forward56_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward56_ptr = nvram_get_safe( "forward_55", forward56_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward56_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward56_ptr, strlen(forward56_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward56\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward57(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward57_value[256] = { 0 } ;
    char *forward57_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward57_ptr = nvram_get_safe( "forward_56", forward57_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward57_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward57_ptr, strlen(forward57_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward57\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward58(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward58_value[256] = { 0 } ;
    char *forward58_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward58_ptr = nvram_get_safe( "forward_57", forward58_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward58_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward58_ptr, strlen(forward58_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward58\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward59(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward59_value[256] = { 0 } ;
    char *forward59_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward59_ptr = nvram_get_safe( "forward_58", forward59_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward59_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward59_ptr, strlen(forward59_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward59\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward60(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward60_value[256] = { 0 } ;
    char *forward60_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward60_ptr = nvram_get_safe( "forward_59", forward60_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward60_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward60_ptr, strlen(forward60_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward60\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward61(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward61_value[256] = { 0 } ;
    char *forward61_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward61_ptr = nvram_get_safe( "forward_60", forward61_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward61_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward61_ptr, strlen(forward61_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward61\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward62(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward62_value[256] = { 0 } ;
    char *forward62_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward62_ptr = nvram_get_safe( "forward_61", forward62_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward62_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward62_ptr, strlen(forward62_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward62\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward63(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward63_value[256] = { 0 } ;
    char *forward63_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward63_ptr = nvram_get_safe( "forward_62", forward63_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward63_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward63_ptr, strlen(forward63_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward63\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward64(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward64_value[256] = { 0 } ;
    char *forward64_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward64_ptr = nvram_get_safe( "forward_63", forward64_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward64_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward64_ptr, strlen(forward64_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward64\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward65(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward65_value[256] = { 0 } ;
    char *forward65_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward65_ptr = nvram_get_safe( "forward_64", forward65_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward65_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward65_ptr, strlen(forward65_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward65\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward66(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward66_value[256] = { 0 } ;
    char *forward66_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward66_ptr = nvram_get_safe( "forward_65", forward66_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward66_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward66_ptr, strlen(forward66_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward66\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward67(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward67_value[256] = { 0 } ;
    char *forward67_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward67_ptr = nvram_get_safe( "forward_66", forward67_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward67_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward67_ptr, strlen(forward67_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward67\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward68(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward68_value[256] = { 0 } ;
    char *forward68_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward68_ptr = nvram_get_safe( "forward_67", forward68_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward68_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward68_ptr, strlen(forward68_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward68\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward69(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward69_value[256] = { 0 } ;
    char *forward69_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward69_ptr = nvram_get_safe( "forward_68", forward69_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward69_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward69_ptr, strlen(forward69_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward69\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward70(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward70_value[256] = { 0 } ;
    char *forward70_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward70_ptr = nvram_get_safe( "forward_69", forward70_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward70_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward70_ptr, strlen(forward70_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward70\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward71(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward71_value[256] = { 0 } ;
    char *forward71_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward71_ptr = nvram_get_safe( "forward_70", forward71_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward71_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward71_ptr, strlen(forward71_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward71\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward72(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward72_value[256] = { 0 } ;
    char *forward72_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward72_ptr = nvram_get_safe( "forward_71", forward72_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward72_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward72_ptr, strlen(forward72_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward72\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward73(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward73_value[256] = { 0 } ;
    char *forward73_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward73_ptr = nvram_get_safe( "forward_72", forward73_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward73_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward73_ptr, strlen(forward73_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward73\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward74(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward74_value[256] = { 0 } ;
    char *forward74_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward74_ptr = nvram_get_safe( "forward_73", forward74_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward74_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward74_ptr, strlen(forward74_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward74\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward75(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward75_value[256] = { 0 } ;
    char *forward75_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward75_ptr = nvram_get_safe( "forward_74", forward75_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward75_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward75_ptr, strlen(forward75_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward75\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward76(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward76_value[256] = { 0 } ;
    char *forward76_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward76_ptr = nvram_get_safe( "forward_75", forward76_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward76_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward76_ptr, strlen(forward76_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward76\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward77(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward77_value[256] = { 0 } ;
    char *forward77_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward77_ptr = nvram_get_safe( "forward_76", forward77_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward77_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward77_ptr, strlen(forward77_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward77\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward78(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward78_value[256] = { 0 } ;
    char *forward78_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward78_ptr = nvram_get_safe( "forward_77", forward78_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward78_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward78_ptr, strlen(forward78_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward78\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward79(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward79_value[256] = { 0 } ;
    char *forward79_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward79_ptr = nvram_get_safe( "forward_78", forward79_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward79_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward79_ptr, strlen(forward79_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward79\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward80(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward80_value[256] = { 0 } ;
    char *forward80_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward80_ptr = nvram_get_safe( "forward_79", forward80_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward80_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward80_ptr, strlen(forward80_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward80\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward81(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward81_value[256] = { 0 } ;
    char *forward81_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward81_ptr = nvram_get_safe( "forward_80", forward81_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward81_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward81_ptr, strlen(forward81_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward81\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward82(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward82_value[256] = { 0 } ;
    char *forward82_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward82_ptr = nvram_get_safe( "forward_81", forward82_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward82_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward82_ptr, strlen(forward82_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward82\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward83(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward83_value[256] = { 0 } ;
    char *forward83_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward83_ptr = nvram_get_safe( "forward_82", forward83_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward83_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward83_ptr, strlen(forward83_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward83\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward84(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward84_value[256] = { 0 } ;
    char *forward84_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward84_ptr = nvram_get_safe( "forward_83", forward84_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward84_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward84_ptr, strlen(forward84_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward84\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward85(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward85_value[256] = { 0 } ;
    char *forward85_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward85_ptr = nvram_get_safe( "forward_84", forward85_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward85_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward85_ptr, strlen(forward85_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward85\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward86(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward86_value[256] = { 0 } ;
    char *forward86_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward86_ptr = nvram_get_safe( "forward_85", forward86_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward86_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward86_ptr, strlen(forward86_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward86\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward87(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward87_value[256] = { 0 } ;
    char *forward87_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward87_ptr = nvram_get_safe( "forward_86", forward87_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward87_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward87_ptr, strlen(forward87_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward87\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward88(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward88_value[256] = { 0 } ;
    char *forward88_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward88_ptr = nvram_get_safe( "forward_87", forward88_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward88_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward88_ptr, strlen(forward88_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward88\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward89(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward89_value[256] = { 0 } ;
    char *forward89_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward89_ptr = nvram_get_safe( "forward_88", forward89_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward89_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward89_ptr, strlen(forward89_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward89\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward90(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward90_value[256] = { 0 } ;
    char *forward90_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward90_ptr = nvram_get_safe( "forward_89", forward90_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward90_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward90_ptr, strlen(forward90_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward90\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward91(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward91_value[256] = { 0 } ;
    char *forward91_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward91_ptr = nvram_get_safe( "forward_90", forward91_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward91_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward91_ptr, strlen(forward91_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward91\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward92(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward92_value[256] = { 0 } ;
    char *forward92_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward92_ptr = nvram_get_safe( "forward_91", forward92_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward92_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward92_ptr, strlen(forward92_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward92\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward93(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward93_value[256] = { 0 } ;
    char *forward93_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward93_ptr = nvram_get_safe( "forward_92", forward93_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward93_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward93_ptr, strlen(forward93_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward93\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward94(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward94_value[256] = { 0 } ;
    char *forward94_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward94_ptr = nvram_get_safe( "forward_93", forward94_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward94_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward94_ptr, strlen(forward94_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward94\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward95(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward95_value[256] = { 0 } ;
    char *forward95_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward95_ptr = nvram_get_safe( "forward_94", forward95_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward95_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward95_ptr, strlen(forward95_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward95\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward96(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char forward96_value[256] = { 0 } ;
    char *forward96_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward96_ptr = nvram_get_safe( "forward_95", forward96_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward96_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward96_ptr, strlen(forward96_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward96\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward1_value[256] = { 0 } ;
    char *busyForward1_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward1_ptr = nvram_get_safe( "busyForward_0", busyForward1_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward1_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward1_ptr, strlen(busyForward1_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward2_value[256] = { 0 } ;
    char *busyForward2_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward2_ptr = nvram_get_safe( "busyForward_1", busyForward2_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward2_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward2_ptr, strlen(busyForward2_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward3_value[256] = { 0 } ;
    char *busyForward3_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward3_ptr = nvram_get_safe( "busyForward_2", busyForward3_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward3_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward3_ptr, strlen(busyForward3_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward4_value[256] = { 0 } ;
    char *busyForward4_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward4_ptr = nvram_get_safe( "busyForward_3", busyForward4_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward4_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward4_ptr, strlen(busyForward4_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward5_value[256] = { 0 } ;
    char *busyForward5_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward5_ptr = nvram_get_safe( "busyForward_4", busyForward5_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward5_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward5_ptr, strlen(busyForward5_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward6_value[256] = { 0 } ;
    char *busyForward6_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward6_ptr = nvram_get_safe( "busyForward_5", busyForward6_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward6_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward6_ptr, strlen(busyForward6_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward7_value[256] = { 0 } ;
    char *busyForward7_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward7_ptr = nvram_get_safe( "busyForward_6", busyForward7_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward7_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward7_ptr, strlen(busyForward7_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward8_value[256] = { 0 } ;
    char *busyForward8_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward8_ptr = nvram_get_safe( "busyForward_7", busyForward8_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward8_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward8_ptr, strlen(busyForward8_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward9(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward9_value[256] = { 0 } ;
    char *busyForward9_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward9_ptr = nvram_get_safe( "busyForward_8", busyForward9_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward9_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward9_ptr, strlen(busyForward9_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward9\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward10(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward10_value[256] = { 0 } ;
    char *busyForward10_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward10_ptr = nvram_get_safe( "busyForward_9", busyForward10_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward10_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward10_ptr, strlen(busyForward10_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward10\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward11(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward11_value[256] = { 0 } ;
    char *busyForward11_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward11_ptr = nvram_get_safe( "busyForward_10", busyForward11_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward11_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward11_ptr, strlen(busyForward11_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward11\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward12(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward12_value[256] = { 0 } ;
    char *busyForward12_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward12_ptr = nvram_get_safe( "busyForward_11", busyForward12_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward12_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward12_ptr, strlen(busyForward12_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward12\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward13(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward13_value[256] = { 0 } ;
    char *busyForward13_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward13_ptr = nvram_get_safe( "busyForward_12", busyForward13_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward13_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward13_ptr, strlen(busyForward13_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward13\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward14(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward14_value[256] = { 0 } ;
    char *busyForward14_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward14_ptr = nvram_get_safe( "busyForward_13", busyForward14_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward14_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward14_ptr, strlen(busyForward14_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward14\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward15(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward15_value[256] = { 0 } ;
    char *busyForward15_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward15_ptr = nvram_get_safe( "busyForward_14", busyForward15_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward15_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward15_ptr, strlen(busyForward15_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward15\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward16(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward16_value[256] = { 0 } ;
    char *busyForward16_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward16_ptr = nvram_get_safe( "busyForward_15", busyForward16_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward16_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward16_ptr, strlen(busyForward16_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward16\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward17(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward17_value[256] = { 0 } ;
    char *busyForward17_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward17_ptr = nvram_get_safe( "busyForward_16", busyForward17_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward17_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward17_ptr, strlen(busyForward17_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward17\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward18(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward18_value[256] = { 0 } ;
    char *busyForward18_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward18_ptr = nvram_get_safe( "busyForward_17", busyForward18_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward18_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward18_ptr, strlen(busyForward18_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward18\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward19(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward19_value[256] = { 0 } ;
    char *busyForward19_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward19_ptr = nvram_get_safe( "busyForward_18", busyForward19_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward19_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward19_ptr, strlen(busyForward19_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward19\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward20(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward20_value[256] = { 0 } ;
    char *busyForward20_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward20_ptr = nvram_get_safe( "busyForward_19", busyForward20_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward20_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward20_ptr, strlen(busyForward20_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward20\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward21(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward21_value[256] = { 0 } ;
    char *busyForward21_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward21_ptr = nvram_get_safe( "busyForward_20", busyForward21_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward21_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward21_ptr, strlen(busyForward21_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward21\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward22(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward22_value[256] = { 0 } ;
    char *busyForward22_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward22_ptr = nvram_get_safe( "busyForward_21", busyForward22_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward22_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward22_ptr, strlen(busyForward22_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward22\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward23(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward23_value[256] = { 0 } ;
    char *busyForward23_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward23_ptr = nvram_get_safe( "busyForward_22", busyForward23_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward23_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward23_ptr, strlen(busyForward23_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward23\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward24(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward24_value[256] = { 0 } ;
    char *busyForward24_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward24_ptr = nvram_get_safe( "busyForward_23", busyForward24_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward24_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward24_ptr, strlen(busyForward24_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward24\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward25(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward25_value[256] = { 0 } ;
    char *busyForward25_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward25_ptr = nvram_get_safe( "busyForward_24", busyForward25_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward25_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward25_ptr, strlen(busyForward25_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward25\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward26(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward26_value[256] = { 0 } ;
    char *busyForward26_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward26_ptr = nvram_get_safe( "busyForward_25", busyForward26_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward26_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward26_ptr, strlen(busyForward26_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward26\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward27(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward27_value[256] = { 0 } ;
    char *busyForward27_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward27_ptr = nvram_get_safe( "busyForward_26", busyForward27_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward27_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward27_ptr, strlen(busyForward27_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward27\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward28(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward28_value[256] = { 0 } ;
    char *busyForward28_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward28_ptr = nvram_get_safe( "busyForward_27", busyForward28_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward28_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward28_ptr, strlen(busyForward28_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward28\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward29(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward29_value[256] = { 0 } ;
    char *busyForward29_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward29_ptr = nvram_get_safe( "busyForward_28", busyForward29_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward29_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward29_ptr, strlen(busyForward29_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward29\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward30(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward30_value[256] = { 0 } ;
    char *busyForward30_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward30_ptr = nvram_get_safe( "busyForward_29", busyForward30_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward30_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward30_ptr, strlen(busyForward30_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward30\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward31(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward31_value[256] = { 0 } ;
    char *busyForward31_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward31_ptr = nvram_get_safe( "busyForward_30", busyForward31_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward31_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward31_ptr, strlen(busyForward31_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward31\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward32(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward32_value[256] = { 0 } ;
    char *busyForward32_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward32_ptr = nvram_get_safe( "busyForward_31", busyForward32_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward32_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward32_ptr, strlen(busyForward32_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward32\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward33(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward33_value[256] = { 0 } ;
    char *busyForward33_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward33_ptr = nvram_get_safe( "busyForward_32", busyForward33_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward33_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward33_ptr, strlen(busyForward33_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward33\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward34(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward34_value[256] = { 0 } ;
    char *busyForward34_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward34_ptr = nvram_get_safe( "busyForward_33", busyForward34_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward34_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward34_ptr, strlen(busyForward34_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward34\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward35(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward35_value[256] = { 0 } ;
    char *busyForward35_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward35_ptr = nvram_get_safe( "busyForward_34", busyForward35_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward35_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward35_ptr, strlen(busyForward35_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward35\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward36(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward36_value[256] = { 0 } ;
    char *busyForward36_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward36_ptr = nvram_get_safe( "busyForward_35", busyForward36_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward36_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward36_ptr, strlen(busyForward36_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward36\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward37(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward37_value[256] = { 0 } ;
    char *busyForward37_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward37_ptr = nvram_get_safe( "busyForward_36", busyForward37_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward37_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward37_ptr, strlen(busyForward37_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward37\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward38(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward38_value[256] = { 0 } ;
    char *busyForward38_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward38_ptr = nvram_get_safe( "busyForward_37", busyForward38_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward38_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward38_ptr, strlen(busyForward38_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward38\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward39(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward39_value[256] = { 0 } ;
    char *busyForward39_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward39_ptr = nvram_get_safe( "busyForward_38", busyForward39_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward39_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward39_ptr, strlen(busyForward39_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward39\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward40(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward40_value[256] = { 0 } ;
    char *busyForward40_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward40_ptr = nvram_get_safe( "busyForward_39", busyForward40_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward40_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward40_ptr, strlen(busyForward40_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward40\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward41(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward41_value[256] = { 0 } ;
    char *busyForward41_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward41_ptr = nvram_get_safe( "busyForward_40", busyForward41_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward41_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward41_ptr, strlen(busyForward41_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward41\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward42(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward42_value[256] = { 0 } ;
    char *busyForward42_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward42_ptr = nvram_get_safe( "busyForward_41", busyForward42_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward42_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward42_ptr, strlen(busyForward42_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward42\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward43(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward43_value[256] = { 0 } ;
    char *busyForward43_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward43_ptr = nvram_get_safe( "busyForward_42", busyForward43_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward43_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward43_ptr, strlen(busyForward43_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward43\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward44(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward44_value[256] = { 0 } ;
    char *busyForward44_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward44_ptr = nvram_get_safe( "busyForward_43", busyForward44_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward44_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward44_ptr, strlen(busyForward44_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward44\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward45(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward45_value[256] = { 0 } ;
    char *busyForward45_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward45_ptr = nvram_get_safe( "busyForward_44", busyForward45_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward45_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward45_ptr, strlen(busyForward45_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward45\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward46(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward46_value[256] = { 0 } ;
    char *busyForward46_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward46_ptr = nvram_get_safe( "busyForward_45", busyForward46_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward46_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward46_ptr, strlen(busyForward46_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward46\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward47(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward47_value[256] = { 0 } ;
    char *busyForward47_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward47_ptr = nvram_get_safe( "busyForward_46", busyForward47_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward47_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward47_ptr, strlen(busyForward47_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward47\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward48(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward48_value[256] = { 0 } ;
    char *busyForward48_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward48_ptr = nvram_get_safe( "busyForward_47", busyForward48_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward48_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward48_ptr, strlen(busyForward48_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward48\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward49(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward49_value[256] = { 0 } ;
    char *busyForward49_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward49_ptr = nvram_get_safe( "busyForward_48", busyForward49_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward49_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward49_ptr, strlen(busyForward49_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward49\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward50(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward50_value[256] = { 0 } ;
    char *busyForward50_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward50_ptr = nvram_get_safe( "busyForward_49", busyForward50_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward50_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward50_ptr, strlen(busyForward50_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward50\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward51(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward51_value[256] = { 0 } ;
    char *busyForward51_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward51_ptr = nvram_get_safe( "busyForward_50", busyForward51_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward51_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward51_ptr, strlen(busyForward51_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward51\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward52(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward52_value[256] = { 0 } ;
    char *busyForward52_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward52_ptr = nvram_get_safe( "busyForward_51", busyForward52_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward52_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward52_ptr, strlen(busyForward52_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward52\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward53(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward53_value[256] = { 0 } ;
    char *busyForward53_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward53_ptr = nvram_get_safe( "busyForward_52", busyForward53_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward53_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward53_ptr, strlen(busyForward53_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward53\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward54(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward54_value[256] = { 0 } ;
    char *busyForward54_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward54_ptr = nvram_get_safe( "busyForward_53", busyForward54_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward54_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward54_ptr, strlen(busyForward54_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward54\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward55(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward55_value[256] = { 0 } ;
    char *busyForward55_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward55_ptr = nvram_get_safe( "busyForward_54", busyForward55_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward55_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward55_ptr, strlen(busyForward55_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward55\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward56(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward56_value[256] = { 0 } ;
    char *busyForward56_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward56_ptr = nvram_get_safe( "busyForward_55", busyForward56_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward56_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward56_ptr, strlen(busyForward56_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward56\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward57(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward57_value[256] = { 0 } ;
    char *busyForward57_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward57_ptr = nvram_get_safe( "busyForward_56", busyForward57_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward57_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward57_ptr, strlen(busyForward57_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward57\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward58(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward58_value[256] = { 0 } ;
    char *busyForward58_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward58_ptr = nvram_get_safe( "busyForward_57", busyForward58_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward58_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward58_ptr, strlen(busyForward58_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward58\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward59(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward59_value[256] = { 0 } ;
    char *busyForward59_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward59_ptr = nvram_get_safe( "busyForward_58", busyForward59_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward59_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward59_ptr, strlen(busyForward59_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward59\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward60(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward60_value[256] = { 0 } ;
    char *busyForward60_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward60_ptr = nvram_get_safe( "busyForward_59", busyForward60_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward60_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward60_ptr, strlen(busyForward60_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward60\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward61(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward61_value[256] = { 0 } ;
    char *busyForward61_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward61_ptr = nvram_get_safe( "busyForward_60", busyForward61_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward61_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward61_ptr, strlen(busyForward61_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward61\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward62(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward62_value[256] = { 0 } ;
    char *busyForward62_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward62_ptr = nvram_get_safe( "busyForward_61", busyForward62_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward62_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward62_ptr, strlen(busyForward62_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward62\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward63(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward63_value[256] = { 0 } ;
    char *busyForward63_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward63_ptr = nvram_get_safe( "busyForward_62", busyForward63_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward63_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward63_ptr, strlen(busyForward63_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward63\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward64(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward64_value[256] = { 0 } ;
    char *busyForward64_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward64_ptr = nvram_get_safe( "busyForward_63", busyForward64_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward64_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward64_ptr, strlen(busyForward64_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward64\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward65(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward65_value[256] = { 0 } ;
    char *busyForward65_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward65_ptr = nvram_get_safe( "busyForward_64", busyForward65_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward65_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward65_ptr, strlen(busyForward65_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward65\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward66(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward66_value[256] = { 0 } ;
    char *busyForward66_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward66_ptr = nvram_get_safe( "busyForward_65", busyForward66_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward66_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward66_ptr, strlen(busyForward66_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward66\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward67(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward67_value[256] = { 0 } ;
    char *busyForward67_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward67_ptr = nvram_get_safe( "busyForward_66", busyForward67_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward67_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward67_ptr, strlen(busyForward67_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward67\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward68(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward68_value[256] = { 0 } ;
    char *busyForward68_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward68_ptr = nvram_get_safe( "busyForward_67", busyForward68_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward68_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward68_ptr, strlen(busyForward68_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward68\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward69(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward69_value[256] = { 0 } ;
    char *busyForward69_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward69_ptr = nvram_get_safe( "busyForward_68", busyForward69_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward69_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward69_ptr, strlen(busyForward69_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward69\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward70(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward70_value[256] = { 0 } ;
    char *busyForward70_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward70_ptr = nvram_get_safe( "busyForward_69", busyForward70_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward70_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward70_ptr, strlen(busyForward70_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward70\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward71(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward71_value[256] = { 0 } ;
    char *busyForward71_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward71_ptr = nvram_get_safe( "busyForward_70", busyForward71_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward71_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward71_ptr, strlen(busyForward71_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward71\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward72(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward72_value[256] = { 0 } ;
    char *busyForward72_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward72_ptr = nvram_get_safe( "busyForward_71", busyForward72_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward72_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward72_ptr, strlen(busyForward72_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward72\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward73(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward73_value[256] = { 0 } ;
    char *busyForward73_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward73_ptr = nvram_get_safe( "busyForward_72", busyForward73_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward73_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward73_ptr, strlen(busyForward73_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward73\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward74(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward74_value[256] = { 0 } ;
    char *busyForward74_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward74_ptr = nvram_get_safe( "busyForward_73", busyForward74_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward74_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward74_ptr, strlen(busyForward74_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward74\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward75(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward75_value[256] = { 0 } ;
    char *busyForward75_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward75_ptr = nvram_get_safe( "busyForward_74", busyForward75_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward75_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward75_ptr, strlen(busyForward75_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward75\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward76(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward76_value[256] = { 0 } ;
    char *busyForward76_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward76_ptr = nvram_get_safe( "busyForward_75", busyForward76_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward76_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward76_ptr, strlen(busyForward76_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward76\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward77(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward77_value[256] = { 0 } ;
    char *busyForward77_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward77_ptr = nvram_get_safe( "busyForward_76", busyForward77_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward77_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward77_ptr, strlen(busyForward77_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward77\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward78(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward78_value[256] = { 0 } ;
    char *busyForward78_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward78_ptr = nvram_get_safe( "busyForward_77", busyForward78_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward78_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward78_ptr, strlen(busyForward78_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward78\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward79(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward79_value[256] = { 0 } ;
    char *busyForward79_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward79_ptr = nvram_get_safe( "busyForward_78", busyForward79_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward79_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward79_ptr, strlen(busyForward79_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward79\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward80(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward80_value[256] = { 0 } ;
    char *busyForward80_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward80_ptr = nvram_get_safe( "busyForward_79", busyForward80_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward80_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward80_ptr, strlen(busyForward80_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward80\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward81(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward81_value[256] = { 0 } ;
    char *busyForward81_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward81_ptr = nvram_get_safe( "busyForward_80", busyForward81_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward81_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward81_ptr, strlen(busyForward81_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward81\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward82(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward82_value[256] = { 0 } ;
    char *busyForward82_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward82_ptr = nvram_get_safe( "busyForward_81", busyForward82_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward82_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward82_ptr, strlen(busyForward82_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward82\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward83(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward83_value[256] = { 0 } ;
    char *busyForward83_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward83_ptr = nvram_get_safe( "busyForward_82", busyForward83_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward83_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward83_ptr, strlen(busyForward83_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward83\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward84(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward84_value[256] = { 0 } ;
    char *busyForward84_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward84_ptr = nvram_get_safe( "busyForward_83", busyForward84_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward84_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward84_ptr, strlen(busyForward84_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward84\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward85(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward85_value[256] = { 0 } ;
    char *busyForward85_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward85_ptr = nvram_get_safe( "busyForward_84", busyForward85_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward85_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward85_ptr, strlen(busyForward85_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward85\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward86(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward86_value[256] = { 0 } ;
    char *busyForward86_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward86_ptr = nvram_get_safe( "busyForward_85", busyForward86_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward86_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward86_ptr, strlen(busyForward86_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward86\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward87(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward87_value[256] = { 0 } ;
    char *busyForward87_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward87_ptr = nvram_get_safe( "busyForward_86", busyForward87_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward87_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward87_ptr, strlen(busyForward87_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward87\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward88(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward88_value[256] = { 0 } ;
    char *busyForward88_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward88_ptr = nvram_get_safe( "busyForward_87", busyForward88_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward88_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward88_ptr, strlen(busyForward88_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward88\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward89(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward89_value[256] = { 0 } ;
    char *busyForward89_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward89_ptr = nvram_get_safe( "busyForward_88", busyForward89_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward89_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward89_ptr, strlen(busyForward89_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward89\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward90(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward90_value[256] = { 0 } ;
    char *busyForward90_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward90_ptr = nvram_get_safe( "busyForward_89", busyForward90_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward90_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward90_ptr, strlen(busyForward90_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward90\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward91(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward91_value[256] = { 0 } ;
    char *busyForward91_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward91_ptr = nvram_get_safe( "busyForward_90", busyForward91_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward91_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward91_ptr, strlen(busyForward91_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward91\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward92(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward92_value[256] = { 0 } ;
    char *busyForward92_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward92_ptr = nvram_get_safe( "busyForward_91", busyForward92_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward92_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward92_ptr, strlen(busyForward92_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward92\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward93(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward93_value[256] = { 0 } ;
    char *busyForward93_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward93_ptr = nvram_get_safe( "busyForward_92", busyForward93_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward93_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward93_ptr, strlen(busyForward93_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward93\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward94(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward94_value[256] = { 0 } ;
    char *busyForward94_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward94_ptr = nvram_get_safe( "busyForward_93", busyForward94_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward94_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward94_ptr, strlen(busyForward94_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward94\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward95(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward95_value[256] = { 0 } ;
    char *busyForward95_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward95_ptr = nvram_get_safe( "busyForward_94", busyForward95_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward95_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward95_ptr, strlen(busyForward95_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward95\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward96(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char busyForward96_value[256] = { 0 } ;
    char *busyForward96_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward96_ptr = nvram_get_safe( "busyForward_95", busyForward96_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward96_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward96_ptr, strlen(busyForward96_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward96\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward1_value[256] = { 0 } ;
    char *delayedForward1_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward1_ptr = nvram_get_safe( "delayedForward_0", delayedForward1_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward1_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward1_ptr, strlen(delayedForward1_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward2_value[256] = { 0 } ;
    char *delayedForward2_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward2_ptr = nvram_get_safe( "delayedForward_1", delayedForward2_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward2_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward2_ptr, strlen(delayedForward2_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward3_value[256] = { 0 } ;
    char *delayedForward3_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward3_ptr = nvram_get_safe( "delayedForward_2", delayedForward3_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward3_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward3_ptr, strlen(delayedForward3_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward4_value[256] = { 0 } ;
    char *delayedForward4_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward4_ptr = nvram_get_safe( "delayedForward_3", delayedForward4_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward4_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward4_ptr, strlen(delayedForward4_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward5_value[256] = { 0 } ;
    char *delayedForward5_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward5_ptr = nvram_get_safe( "delayedForward_4", delayedForward5_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward5_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward5_ptr, strlen(delayedForward5_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward6_value[256] = { 0 } ;
    char *delayedForward6_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward6_ptr = nvram_get_safe( "delayedForward_5", delayedForward6_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward6_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward6_ptr, strlen(delayedForward6_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward7_value[256] = { 0 } ;
    char *delayedForward7_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward7_ptr = nvram_get_safe( "delayedForward_6", delayedForward7_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward7_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward7_ptr, strlen(delayedForward7_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward8_value[256] = { 0 } ;
    char *delayedForward8_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward8_ptr = nvram_get_safe( "delayedForward_7", delayedForward8_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward8_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward8_ptr, strlen(delayedForward8_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward9(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward9_value[256] = { 0 } ;
    char *delayedForward9_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward9_ptr = nvram_get_safe( "delayedForward_8", delayedForward9_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward9_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward9_ptr, strlen(delayedForward9_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward9\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward10(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward10_value[256] = { 0 } ;
    char *delayedForward10_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward10_ptr = nvram_get_safe( "delayedForward_9", delayedForward10_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward10_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward10_ptr, strlen(delayedForward10_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward10\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward11(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward11_value[256] = { 0 } ;
    char *delayedForward11_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward11_ptr = nvram_get_safe( "delayedForward_10", delayedForward11_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward11_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward11_ptr, strlen(delayedForward11_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward11\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward12(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward12_value[256] = { 0 } ;
    char *delayedForward12_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward12_ptr = nvram_get_safe( "delayedForward_11", delayedForward12_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward12_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward12_ptr, strlen(delayedForward12_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward12\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward13(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward13_value[256] = { 0 } ;
    char *delayedForward13_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward13_ptr = nvram_get_safe( "delayedForward_12", delayedForward13_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward13_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward13_ptr, strlen(delayedForward13_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward13\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward14(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward14_value[256] = { 0 } ;
    char *delayedForward14_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward14_ptr = nvram_get_safe( "delayedForward_13", delayedForward14_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward14_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward14_ptr, strlen(delayedForward14_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward14\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward15(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward15_value[256] = { 0 } ;
    char *delayedForward15_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward15_ptr = nvram_get_safe( "delayedForward_14", delayedForward15_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward15_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward15_ptr, strlen(delayedForward15_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward15\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward16(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward16_value[256] = { 0 } ;
    char *delayedForward16_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward16_ptr = nvram_get_safe( "delayedForward_15", delayedForward16_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward16_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward16_ptr, strlen(delayedForward16_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward16\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward17(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward17_value[256] = { 0 } ;
    char *delayedForward17_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward17_ptr = nvram_get_safe( "delayedForward_16", delayedForward17_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward17_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward17_ptr, strlen(delayedForward17_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward17\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward18(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward18_value[256] = { 0 } ;
    char *delayedForward18_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward18_ptr = nvram_get_safe( "delayedForward_17", delayedForward18_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward18_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward18_ptr, strlen(delayedForward18_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward18\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward19(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward19_value[256] = { 0 } ;
    char *delayedForward19_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward19_ptr = nvram_get_safe( "delayedForward_18", delayedForward19_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward19_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward19_ptr, strlen(delayedForward19_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward19\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward20(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward20_value[256] = { 0 } ;
    char *delayedForward20_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward20_ptr = nvram_get_safe( "delayedForward_19", delayedForward20_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward20_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward20_ptr, strlen(delayedForward20_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward20\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward21(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward21_value[256] = { 0 } ;
    char *delayedForward21_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward21_ptr = nvram_get_safe( "delayedForward_20", delayedForward21_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward21_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward21_ptr, strlen(delayedForward21_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward21\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward22(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward22_value[256] = { 0 } ;
    char *delayedForward22_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward22_ptr = nvram_get_safe( "delayedForward_21", delayedForward22_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward22_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward22_ptr, strlen(delayedForward22_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward22\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward23(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward23_value[256] = { 0 } ;
    char *delayedForward23_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward23_ptr = nvram_get_safe( "delayedForward_22", delayedForward23_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward23_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward23_ptr, strlen(delayedForward23_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward23\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward24(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward24_value[256] = { 0 } ;
    char *delayedForward24_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward24_ptr = nvram_get_safe( "delayedForward_23", delayedForward24_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward24_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward24_ptr, strlen(delayedForward24_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward24\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward25(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward25_value[256] = { 0 } ;
    char *delayedForward25_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward25_ptr = nvram_get_safe( "delayedForward_24", delayedForward25_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward25_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward25_ptr, strlen(delayedForward25_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward25\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward26(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward26_value[256] = { 0 } ;
    char *delayedForward26_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward26_ptr = nvram_get_safe( "delayedForward_25", delayedForward26_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward26_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward26_ptr, strlen(delayedForward26_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward26\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward27(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward27_value[256] = { 0 } ;
    char *delayedForward27_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward27_ptr = nvram_get_safe( "delayedForward_26", delayedForward27_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward27_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward27_ptr, strlen(delayedForward27_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward27\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward28(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward28_value[256] = { 0 } ;
    char *delayedForward28_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward28_ptr = nvram_get_safe( "delayedForward_27", delayedForward28_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward28_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward28_ptr, strlen(delayedForward28_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward28\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward29(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward29_value[256] = { 0 } ;
    char *delayedForward29_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward29_ptr = nvram_get_safe( "delayedForward_28", delayedForward29_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward29_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward29_ptr, strlen(delayedForward29_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward29\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward30(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward30_value[256] = { 0 } ;
    char *delayedForward30_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward30_ptr = nvram_get_safe( "delayedForward_29", delayedForward30_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward30_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward30_ptr, strlen(delayedForward30_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward30\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward31(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward31_value[256] = { 0 } ;
    char *delayedForward31_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward31_ptr = nvram_get_safe( "delayedForward_30", delayedForward31_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward31_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward31_ptr, strlen(delayedForward31_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward31\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward32(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward32_value[256] = { 0 } ;
    char *delayedForward32_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward32_ptr = nvram_get_safe( "delayedForward_31", delayedForward32_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward32_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward32_ptr, strlen(delayedForward32_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward32\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward33(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward33_value[256] = { 0 } ;
    char *delayedForward33_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward33_ptr = nvram_get_safe( "delayedForward_32", delayedForward33_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward33_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward33_ptr, strlen(delayedForward33_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward33\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward34(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward34_value[256] = { 0 } ;
    char *delayedForward34_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward34_ptr = nvram_get_safe( "delayedForward_33", delayedForward34_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward34_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward34_ptr, strlen(delayedForward34_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward34\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward35(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward35_value[256] = { 0 } ;
    char *delayedForward35_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward35_ptr = nvram_get_safe( "delayedForward_34", delayedForward35_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward35_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward35_ptr, strlen(delayedForward35_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward35\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward36(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward36_value[256] = { 0 } ;
    char *delayedForward36_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward36_ptr = nvram_get_safe( "delayedForward_35", delayedForward36_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward36_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward36_ptr, strlen(delayedForward36_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward36\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward37(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward37_value[256] = { 0 } ;
    char *delayedForward37_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward37_ptr = nvram_get_safe( "delayedForward_36", delayedForward37_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward37_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward37_ptr, strlen(delayedForward37_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward37\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward38(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward38_value[256] = { 0 } ;
    char *delayedForward38_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward38_ptr = nvram_get_safe( "delayedForward_37", delayedForward38_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward38_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward38_ptr, strlen(delayedForward38_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward38\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward39(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward39_value[256] = { 0 } ;
    char *delayedForward39_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward39_ptr = nvram_get_safe( "delayedForward_38", delayedForward39_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward39_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward39_ptr, strlen(delayedForward39_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward39\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward40(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward40_value[256] = { 0 } ;
    char *delayedForward40_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward40_ptr = nvram_get_safe( "delayedForward_39", delayedForward40_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward40_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward40_ptr, strlen(delayedForward40_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward40\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward41(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward41_value[256] = { 0 } ;
    char *delayedForward41_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward41_ptr = nvram_get_safe( "delayedForward_40", delayedForward41_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward41_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward41_ptr, strlen(delayedForward41_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward41\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward42(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward42_value[256] = { 0 } ;
    char *delayedForward42_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward42_ptr = nvram_get_safe( "delayedForward_41", delayedForward42_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward42_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward42_ptr, strlen(delayedForward42_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward42\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward43(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward43_value[256] = { 0 } ;
    char *delayedForward43_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward43_ptr = nvram_get_safe( "delayedForward_42", delayedForward43_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward43_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward43_ptr, strlen(delayedForward43_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward43\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward44(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward44_value[256] = { 0 } ;
    char *delayedForward44_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward44_ptr = nvram_get_safe( "delayedForward_43", delayedForward44_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward44_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward44_ptr, strlen(delayedForward44_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward44\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward45(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward45_value[256] = { 0 } ;
    char *delayedForward45_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward45_ptr = nvram_get_safe( "delayedForward_44", delayedForward45_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward45_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward45_ptr, strlen(delayedForward45_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward45\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward46(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward46_value[256] = { 0 } ;
    char *delayedForward46_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward46_ptr = nvram_get_safe( "delayedForward_45", delayedForward46_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward46_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward46_ptr, strlen(delayedForward46_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward46\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward47(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward47_value[256] = { 0 } ;
    char *delayedForward47_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward47_ptr = nvram_get_safe( "delayedForward_46", delayedForward47_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward47_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward47_ptr, strlen(delayedForward47_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward47\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward48(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward48_value[256] = { 0 } ;
    char *delayedForward48_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward48_ptr = nvram_get_safe( "delayedForward_47", delayedForward48_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward48_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward48_ptr, strlen(delayedForward48_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward48\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward49(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward49_value[256] = { 0 } ;
    char *delayedForward49_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward49_ptr = nvram_get_safe( "delayedForward_48", delayedForward49_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward49_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward49_ptr, strlen(delayedForward49_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward49\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward50(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward50_value[256] = { 0 } ;
    char *delayedForward50_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward50_ptr = nvram_get_safe( "delayedForward_49", delayedForward50_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward50_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward50_ptr, strlen(delayedForward50_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward50\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward51(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward51_value[256] = { 0 } ;
    char *delayedForward51_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward51_ptr = nvram_get_safe( "delayedForward_50", delayedForward51_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward51_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward51_ptr, strlen(delayedForward51_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward51\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward52(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward52_value[256] = { 0 } ;
    char *delayedForward52_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward52_ptr = nvram_get_safe( "delayedForward_51", delayedForward52_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward52_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward52_ptr, strlen(delayedForward52_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward52\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward53(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward53_value[256] = { 0 } ;
    char *delayedForward53_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward53_ptr = nvram_get_safe( "delayedForward_52", delayedForward53_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward53_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward53_ptr, strlen(delayedForward53_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward53\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward54(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward54_value[256] = { 0 } ;
    char *delayedForward54_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward54_ptr = nvram_get_safe( "delayedForward_53", delayedForward54_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward54_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward54_ptr, strlen(delayedForward54_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward54\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward55(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward55_value[256] = { 0 } ;
    char *delayedForward55_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward55_ptr = nvram_get_safe( "delayedForward_54", delayedForward55_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward55_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward55_ptr, strlen(delayedForward55_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward55\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward56(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward56_value[256] = { 0 } ;
    char *delayedForward56_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward56_ptr = nvram_get_safe( "delayedForward_55", delayedForward56_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward56_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward56_ptr, strlen(delayedForward56_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward56\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward57(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward57_value[256] = { 0 } ;
    char *delayedForward57_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward57_ptr = nvram_get_safe( "delayedForward_56", delayedForward57_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward57_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward57_ptr, strlen(delayedForward57_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward57\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward58(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward58_value[256] = { 0 } ;
    char *delayedForward58_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward58_ptr = nvram_get_safe( "delayedForward_57", delayedForward58_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward58_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward58_ptr, strlen(delayedForward58_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward58\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward59(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward59_value[256] = { 0 } ;
    char *delayedForward59_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward59_ptr = nvram_get_safe( "delayedForward_58", delayedForward59_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward59_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward59_ptr, strlen(delayedForward59_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward59\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward60(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward60_value[256] = { 0 } ;
    char *delayedForward60_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward60_ptr = nvram_get_safe( "delayedForward_59", delayedForward60_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward60_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward60_ptr, strlen(delayedForward60_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward60\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward61(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward61_value[256] = { 0 } ;
    char *delayedForward61_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward61_ptr = nvram_get_safe( "delayedForward_60", delayedForward61_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward61_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward61_ptr, strlen(delayedForward61_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward61\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward62(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward62_value[256] = { 0 } ;
    char *delayedForward62_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward62_ptr = nvram_get_safe( "delayedForward_61", delayedForward62_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward62_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward62_ptr, strlen(delayedForward62_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward62\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward63(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward63_value[256] = { 0 } ;
    char *delayedForward63_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward63_ptr = nvram_get_safe( "delayedForward_62", delayedForward63_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward63_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward63_ptr, strlen(delayedForward63_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward63\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward64(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward64_value[256] = { 0 } ;
    char *delayedForward64_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward64_ptr = nvram_get_safe( "delayedForward_63", delayedForward64_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward64_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward64_ptr, strlen(delayedForward64_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward64\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward65(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward65_value[256] = { 0 } ;
    char *delayedForward65_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward65_ptr = nvram_get_safe( "delayedForward_64", delayedForward65_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward65_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward65_ptr, strlen(delayedForward65_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward65\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward66(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward66_value[256] = { 0 } ;
    char *delayedForward66_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward66_ptr = nvram_get_safe( "delayedForward_65", delayedForward66_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward66_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward66_ptr, strlen(delayedForward66_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward66\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward67(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward67_value[256] = { 0 } ;
    char *delayedForward67_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward67_ptr = nvram_get_safe( "delayedForward_66", delayedForward67_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward67_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward67_ptr, strlen(delayedForward67_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward67\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward68(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward68_value[256] = { 0 } ;
    char *delayedForward68_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward68_ptr = nvram_get_safe( "delayedForward_67", delayedForward68_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward68_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward68_ptr, strlen(delayedForward68_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward68\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward69(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward69_value[256] = { 0 } ;
    char *delayedForward69_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward69_ptr = nvram_get_safe( "delayedForward_68", delayedForward69_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward69_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward69_ptr, strlen(delayedForward69_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward69\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward70(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward70_value[256] = { 0 } ;
    char *delayedForward70_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward70_ptr = nvram_get_safe( "delayedForward_69", delayedForward70_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward70_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward70_ptr, strlen(delayedForward70_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward70\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward71(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward71_value[256] = { 0 } ;
    char *delayedForward71_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward71_ptr = nvram_get_safe( "delayedForward_70", delayedForward71_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward71_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward71_ptr, strlen(delayedForward71_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward71\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward72(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward72_value[256] = { 0 } ;
    char *delayedForward72_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward72_ptr = nvram_get_safe( "delayedForward_71", delayedForward72_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward72_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward72_ptr, strlen(delayedForward72_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward72\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward73(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward73_value[256] = { 0 } ;
    char *delayedForward73_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward73_ptr = nvram_get_safe( "delayedForward_72", delayedForward73_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward73_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward73_ptr, strlen(delayedForward73_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward73\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward74(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward74_value[256] = { 0 } ;
    char *delayedForward74_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward74_ptr = nvram_get_safe( "delayedForward_73", delayedForward74_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward74_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward74_ptr, strlen(delayedForward74_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward74\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward75(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward75_value[256] = { 0 } ;
    char *delayedForward75_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward75_ptr = nvram_get_safe( "delayedForward_74", delayedForward75_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward75_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward75_ptr, strlen(delayedForward75_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward75\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward76(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward76_value[256] = { 0 } ;
    char *delayedForward76_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward76_ptr = nvram_get_safe( "delayedForward_75", delayedForward76_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward76_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward76_ptr, strlen(delayedForward76_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward76\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward77(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward77_value[256] = { 0 } ;
    char *delayedForward77_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward77_ptr = nvram_get_safe( "delayedForward_76", delayedForward77_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward77_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward77_ptr, strlen(delayedForward77_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward77\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward78(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward78_value[256] = { 0 } ;
    char *delayedForward78_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward78_ptr = nvram_get_safe( "delayedForward_77", delayedForward78_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward78_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward78_ptr, strlen(delayedForward78_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward78\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward79(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward79_value[256] = { 0 } ;
    char *delayedForward79_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward79_ptr = nvram_get_safe( "delayedForward_78", delayedForward79_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward79_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward79_ptr, strlen(delayedForward79_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward79\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward80(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward80_value[256] = { 0 } ;
    char *delayedForward80_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward80_ptr = nvram_get_safe( "delayedForward_79", delayedForward80_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward80_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward80_ptr, strlen(delayedForward80_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward80\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward81(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward81_value[256] = { 0 } ;
    char *delayedForward81_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward81_ptr = nvram_get_safe( "delayedForward_80", delayedForward81_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward81_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward81_ptr, strlen(delayedForward81_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward81\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward82(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward82_value[256] = { 0 } ;
    char *delayedForward82_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward82_ptr = nvram_get_safe( "delayedForward_81", delayedForward82_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward82_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward82_ptr, strlen(delayedForward82_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward82\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward83(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward83_value[256] = { 0 } ;
    char *delayedForward83_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward83_ptr = nvram_get_safe( "delayedForward_82", delayedForward83_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward83_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward83_ptr, strlen(delayedForward83_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward83\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward84(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward84_value[256] = { 0 } ;
    char *delayedForward84_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward84_ptr = nvram_get_safe( "delayedForward_83", delayedForward84_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward84_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward84_ptr, strlen(delayedForward84_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward84\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward85(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward85_value[256] = { 0 } ;
    char *delayedForward85_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward85_ptr = nvram_get_safe( "delayedForward_84", delayedForward85_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward85_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward85_ptr, strlen(delayedForward85_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward85\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward86(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward86_value[256] = { 0 } ;
    char *delayedForward86_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward86_ptr = nvram_get_safe( "delayedForward_85", delayedForward86_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward86_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward86_ptr, strlen(delayedForward86_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward86\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward87(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward87_value[256] = { 0 } ;
    char *delayedForward87_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward87_ptr = nvram_get_safe( "delayedForward_86", delayedForward87_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward87_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward87_ptr, strlen(delayedForward87_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward87\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward88(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward88_value[256] = { 0 } ;
    char *delayedForward88_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward88_ptr = nvram_get_safe( "delayedForward_87", delayedForward88_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward88_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward88_ptr, strlen(delayedForward88_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward88\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward89(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward89_value[256] = { 0 } ;
    char *delayedForward89_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward89_ptr = nvram_get_safe( "delayedForward_88", delayedForward89_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward89_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward89_ptr, strlen(delayedForward89_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward89\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward90(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward90_value[256] = { 0 } ;
    char *delayedForward90_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward90_ptr = nvram_get_safe( "delayedForward_89", delayedForward90_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward90_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward90_ptr, strlen(delayedForward90_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward90\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward91(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward91_value[256] = { 0 } ;
    char *delayedForward91_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward91_ptr = nvram_get_safe( "delayedForward_90", delayedForward91_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward91_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward91_ptr, strlen(delayedForward91_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward91\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward92(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward92_value[256] = { 0 } ;
    char *delayedForward92_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward92_ptr = nvram_get_safe( "delayedForward_91", delayedForward92_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward92_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward92_ptr, strlen(delayedForward92_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward92\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward93(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward93_value[256] = { 0 } ;
    char *delayedForward93_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward93_ptr = nvram_get_safe( "delayedForward_92", delayedForward93_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward93_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward93_ptr, strlen(delayedForward93_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward93\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward94(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward94_value[256] = { 0 } ;
    char *delayedForward94_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward94_ptr = nvram_get_safe( "delayedForward_93", delayedForward94_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward94_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward94_ptr, strlen(delayedForward94_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward94\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward95(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward95_value[256] = { 0 } ;
    char *delayedForward95_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward95_ptr = nvram_get_safe( "delayedForward_94", delayedForward95_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward95_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward95_ptr, strlen(delayedForward95_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward95\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward96(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char delayedForward96_value[256] = { 0 } ;
    char *delayedForward96_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward96_ptr = nvram_get_safe( "delayedForward_95", delayedForward96_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward96_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward96_ptr, strlen(delayedForward96_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward96\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_temperatureSensor1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long temperatureSensor1_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            temperatureSensor1_value = get_nvram_long( "temperatureSensor_0", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&temperatureSensor1_value, sizeof(temperatureSensor1_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_temperatureSensor1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_temperatureSensor2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long temperatureSensor2_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            temperatureSensor2_value = get_nvram_long( "temperatureSensor_1", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&temperatureSensor2_value, sizeof(temperatureSensor2_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_temperatureSensor2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_temperatureSensor3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long temperatureSensor3_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            temperatureSensor3_value = get_nvram_long( "temperatureSensor_2", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&temperatureSensor3_value, sizeof(temperatureSensor3_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_temperatureSensor3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_temperatureSensor4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long temperatureSensor4_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            temperatureSensor4_value = get_nvram_long( "temperatureSensor_3", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&temperatureSensor4_value, sizeof(temperatureSensor4_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_temperatureSensor4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_temperatureSensor5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long temperatureSensor5_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            temperatureSensor5_value = get_nvram_long( "temperatureSensor_4", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&temperatureSensor5_value, sizeof(temperatureSensor5_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_temperatureSensor5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_temperatureSensor6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long temperatureSensor6_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            temperatureSensor6_value = get_nvram_long( "temperatureSensor_5", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&temperatureSensor6_value, sizeof(temperatureSensor6_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_temperatureSensor6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_versionBoot(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char versionBoot_value[256] = { 0 } ;
    char *versionBoot_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            versionBoot_ptr = nvram_get_safe( "69", versionBoot_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( versionBoot_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)versionBoot_ptr, strlen(versionBoot_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_versionBoot\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_versionCore(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char versionCore_value[256] = { 0 } ;
    char *versionCore_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            versionCore_ptr = nvram_get_safe( "70", versionCore_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( versionCore_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)versionCore_ptr, strlen(versionCore_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_versionCore\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_versionBase(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char versionBase_value[256] = { 0 } ;
    char *versionBase_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            versionBase_ptr = nvram_get_safe( "45", versionBase_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( versionBase_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)versionBase_ptr, strlen(versionBase_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_versionBase\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_versionProg(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    char versionProg_value[256] = { 0 } ;
    char *versionProg_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            versionProg_ptr = nvram_get_safe( "68", versionProg_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( versionProg_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)versionProg_ptr, strlen(versionProg_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_versionProg\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_networkMode(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long networkMode_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            networkMode_value = get_nvram_long( "8", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&networkMode_value, sizeof(networkMode_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_networkMode\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_pppoeLink(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long pppoeLink_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            pppoeLink_value = get_nvram_long( "211", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&pppoeLink_value, sizeof(pppoeLink_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_pppoeLink\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_natTraversal1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long natTraversal1_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            natTraversal1_value = get_nvram_long( "52", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&natTraversal1_value, sizeof(natTraversal1_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_natTraversal1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_natTraversal2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long natTraversal2_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            natTraversal2_value = get_nvram_long( "730", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&natTraversal2_value, sizeof(natTraversal2_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_natTraversal2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_natTraversal3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long natTraversal3_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            natTraversal3_value = get_nvram_long( "630", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&natTraversal3_value, sizeof(natTraversal3_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_natTraversal3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_natTraversal4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

	int pvalue_empty =  0 ;

    long natTraversal4_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            natTraversal4_value = get_nvram_long( "614", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&natTraversal4_value, sizeof(natTraversal4_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_natTraversal4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
